﻿Imports System.Math

Module Module4
    Dim TerrainModifier, AttackingInfantry, AttackingCavalry, AttackFactor As Integer
    Dim DefendingCavalry, FortificationModifier, DefendingInfantry As Integer


    Function GetProvincialMilitia(ByVal ProvinceNum As Integer) As Integer
        Dim Strength As Integer = 0
        Dim FreePeasants As Integer = 0
        Dim Militia As Integer = 0
        Dim LocalNobles As Integer = 0
        'Dim CitizenMilitia As Integer = 0
        Dim Serfs As Integer = 0

        Militia = Province(ProvinceNum).Townspeople \ CHARTERED_TOWN_SIZE

        FreePeasants = Province(ProvinceNum).Peasants - ((PEASANTS_PER_BENEFICE * Province(ProvinceNum).Nobles) + (PEASANTS_PER_BENEFICE * Province(ProvinceNum).Clergy))
        If FreePeasants < PEASANTS_PER_BENEFICE Then ' if residual unfree, don't count them as free
            FreePeasants = 0
        End If

        Militia = FreePeasants \ WARRIOR_RATIO

        'Militia += (Province(ProvinceNum).Peasants - FreePeasants) \ (PEASANTS_PER_BENEFICE * 4) ' WARRIOR_RATIO)



        ' need to insure that there's at least one defender, and if there are no local nobles, it's the local militia
        ' No, there should always be at least some foot soldiers
        If Militia <= 0 Then ' And Province(ProvinceNum).Nobles = 0 Then
            Militia = 3 + Province(ProvinceNum).Loyalty
        End If

        Return Militia

    End Function

    Function GetLocalKnights(ByVal ProvinceNum As Integer) As Integer ' NOTE that this returns 10x the number in standard game units (so 6 = .6)
        Dim LocalKnights As Integer

        LocalKnights = 10 * Province(ProvinceNum).Nobles / WARRIOR_RATIO 'SHOULDN'T THIS BE \, NOT *?? '* 30 \ WARRIOR_RATIO

        ' need to insure that there's at least one defender, and if there are any local nobles, it'll be them
        If LocalKnights = 0 And Province(ProvinceNum).Nobles > 0 Then
            LocalKnights = 1
        End If

        Return LocalKnights

    End Function

    Sub Attack(ByVal Base As Integer, ByVal Target As Integer)
        Dim DieRoll1 As Integer = 0
        Dim DieRoll2 As Integer = 0
        'Dim DieRoll3 As Integer
        Dim DiceRoll As Integer = 0
        'Dim Modifiers As Integer
        Dim AttackFactor As Integer = 0
        Dim DefenseFactor As Integer = 0
        Dim PlayerDefending As Boolean = False
        Dim DefendingGeneralship As Integer = 0
        Dim DefendingGovernment As Integer = 0
        Dim DefendingArmyState As Integer = 0
        Dim Random10 As Integer = 0
        Dim DiceRoll2Decimal As Integer = 0
        Dim VictoryThreshhold As Integer
        Dim Rand As New Random
        Dim MsgStr As String = ""
        Dim AI_Thinking As Boolean = False 'so when calc AF and DF knows to report it
        Dim DefenderEliminated As Boolean = False 'needed so autonomous provinces will be handled correctly below
        Dim TitleStr As String = ""


        PlayerDefending = False 'so don't carry over 

        Randomize()

        AttackFactor = CalculateAttackFactor(Base, Target, AI_Thinking)

        If ActiveGovernment = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then

            MsgStr = Government(ActiveGovernment).Name & " Attacks "
            If DefendingGovernment <> LOCAL_CONTROL Then
                MsgStr &= Government(DefendingGovernment).Name & " in "
            End If
            MsgStr &= Province(Target).Name & " from " & Province(Base).Name & "!" & DOUBLE_SPACE
            MsgStr &= SPACER_STR


            MsgStr &= "The Attackers have " & AttackingInfantry & "000 Infantry and " & AttackingCavalry & "00 Cavalry led by a " _
                & GetAbilityNames(Government(ActiveGovernment).Generalship) & " General." & DOUBLE_SPACE
            If Government(ActiveGovernment).ArmyState < 0 Then
                MsgStr &= "The Attackers' Morale is Low." & DOUBLE_SPACE
            ElseIf Government(ActiveGovernment).ArmyState > 0 Then
                MsgStr &= "The Attackers' Morale is High." & DOUBLE_SPACE
            End If
            If TerrainModifier > 1 And AttackingCavalry > 0 Then
                MsgStr &= "Difficult Terrain Hinders the Attacking Cavalry." & DOUBLE_SPACE
            End If
            If Province(Base).SocialState < 0 Then
                MsgStr &= "The Attackers' Base is in Disarray. " & DOUBLE_SPACE
            End If
            MsgStr &= SPACER_STR
            'MsgBox(MsgStr)
        End If

        DefendingGovernment = Province(Target).PoliticalAffiliation

        Government(DefendingGovernment).DiplomaticRelations(ActiveGovernment) = MIN_RELATES

        If DefendingGovernment > 0 Then
            'PlayerDefending = Rand.Next(0, 2) ' can be variable later
            PlayerDefending = True
        End If

        If PlayerDefending Then
            DefendingGeneralship = Government(DefendingGovernment).Generalship
            DefendingArmyState = Government(DefendingGovernment).ArmyState
        Else
            If (Province(Target).Language >= GERMANIC) And (Province(Target).Language < GREEK) Then ' becaause Germans so warlike 
                DefendingGeneralship = Rand.Next(1, 3)
                DefendingArmyState = Rand.Next(1, 3)
            Else
                DefendingGeneralship = Rand.Next(0, 5) - 2
                DefendingArmyState = Rand.Next(0, 5) - 2
            End If
        End If

        DefenseFactor = CalculateDefenseFactor(Target, PlayerDefending, DefendingGeneralship, DefendingArmyState, AI_Thinking)

        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
            MsgStr &= "The Defenders have " & DefendingInfantry & ",000 Infantry and " & DefendingCavalry & "00 Cavalry led by a " _
                & GetAbilityNames(DefendingGeneralship) & " General." & DOUBLE_SPACE
            If DefendingArmyState < 0 Then
                MsgStr &= "The Defenders' Morale is Low." & DOUBLE_SPACE
            ElseIf DefendingArmyState > 0 Then
                MsgStr &= "The Defenders' Morale is High." & DOUBLE_SPACE
            End If
            If TerrainModifier > 1 And DefendingInfantry > 0 Then
                MsgStr &= "The Terrain Favors the Defending Infantry." & DOUBLE_SPACE
            End If
            If FortificationModifier > 0 And DefendingInfantry > 0 Then
                MsgStr &= "The Province's Fortifications aid the Defending Infantry." & DOUBLE_SPACE
            End If
            If Province(Target).SocialState < 0 Then
                MsgStr &= " The Province itself is in Disarray. " & DOUBLE_SPACE
            End If
            'MsgBox(MsgStr)
            MsgStr &= SPACER_STR
        End If

        VictoryThreshhold = ApplyCombatModifiers(AttackFactor, DefenseFactor, Target, Base, DefendingGeneralship, DefendingArmyState)

        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
            If VictoryThreshhold < 10 Then

                MsgStr &= "The Attacker has a " & VictoryThreshhold & "0% chance of Winning." & DOUBLE_SPACE
            Else
                MsgStr &= "The Attacker's Power is Overwhelming! " & DOUBLE_SPACE
            End If

            MsgBox(MsgStr, MsgBoxStyle.OkOnly, "Attack!")

            'Else
            '    MsgBox(MsgStr)
            'End If
            'Else
            'MsgStr = ""
        End If

            Random10 = Rand.Next(1, 11)

        If Random10 <= VictoryThreshhold Then ' Defender Retreats
            If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                MsgStr &= SPACER_STR & SPACER_STR
                If VictoryThreshhold < 10 Then

                    MsgStr = MsgStr & " The Attack Succeeds! " & DOUBLE_SPACE

                    'Else
                    '    MsgStr = "The Attacking forces are overwhelming! " & vbCrLf
                End If
            End If ' is player's concern
            If Province(Target).ID < 68 Or Province(Target).ID > 78 Then ' Filter out "anomolous off-map campaigns ( *** until can fix logic that produces them ! *** )
                MsgStr = MsgStr & Government(ActiveGovernment).Name & " takes " & Province(Target).Name & "!" & DOUBLE_SPACE
                MsgBox(MsgStr)
            End If
            'MsgBox(MsgStr, TitleStr)

            'ProvinceChangesHands(Target)

            IncrementArmyState(ActiveGovernment)
            IncrementSocialState(Base, PROSPEROUS)

            If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                MsgStr &= SPACER_STR
                MsgStr &= " The Attacking Army's Morale improves to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & "." & DOUBLE_SPACE _
                                & "The Social State of " & Province(PlayerBase).Name & " rises to " & DescribeSocialState(Province(PlayerBase).SocialState) & "." & DOUBLE_SPACE
            End If
            ' Check if this was the last province the defender controlled
            If DefendingGovernment > LOCAL_CONTROL Then 'don't worry about this if autonomous province
                DefenderEliminated = CheckIfGovernmentEliminated(DefendingGovernment)
            End If ' Defender is a state

            If DefenderEliminated = False Then
                DecrementArmyState(DefendingGovernment)
                If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                    MsgStr &= SPACER_STR & vbCrLf
                    MsgStr &= "The Defending Army's Morale declines to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "."
                Else
                    MsgStr &= ""
                End If
            Else 'Defender Was Eliminated
                MsgStr &= SPACER_STR & DOUBLE_SPACE
                MsgStr &= Government(DefendingGovernment).Name & " has been eliminated."
                ClearOutLoser(DefendingGovernment)
            End If ' if defender NOT eliminated

            If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                MsgBox(MsgStr, MsgBoxStyle.OkOnly, "Campaign Results")
            End If

            ProvinceChangesHands(Target)

        Else 'Defender Holds
            'If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
            '    'If VictoryThreshhold > 0 Then
            '    '    MsgStr = MsgStr & "The result is " & Random10 & "! " & vbCrLf
            '    'End If
            'End If
            If Province(Target).ID < 68 Or Province(Target).ID > 78 Then ' filter out anomolous off-map campaigns ( *** until can fix logic producing them ***)
                MsgStr = MsgStr & Government(ActiveGovernment).Name & " failed to take " & Province(Target).Name & "!" & DOUBLE_SPACE
            End If
            IncrementArmyState(Government(DefendingGovernment).ID)
            If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                MsgStr &= "The Defending Army's Morale improves to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "!" & DOUBLE_SPACE
                'Else
                '    MsgStr = ""
            End If
            DecrementArmyState(Government(ActiveGovernment).ID)
            DecrementSocialState(Province(Base).ID, CHAOS)
            If ActiveGovernment = PlayerSide Then
                DecrementSocialVPs(Province(Base).SocialState)
                'SocialVPs -= SOCIAL_STATE_VP_VALUE
                'RefreshSocialStateVP_Display()
            End If
            If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
                'MsgBox(MsgStr)
                MsgStr &= "The Attacking Army's Morale declines to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & "." & DOUBLE_SPACE
                MsgStr &= "The Social State of " & Province(PlayerBase).Name & " drops to " & DescribeSocialState(Province(PlayerBase).SocialState) & "."
                'MsgBox(MsgStr)
            End If
            If Target < 68 Or Target > 78 Then
                MsgBox(MsgStr)
            End If
        End If

            ConcludeAction() '(DefendingGovernment)

    End Sub

    Function CalculateAttackFactor(ByVal Base As Integer, ByVal Target As Integer, ByVal AI_Thinking As Boolean) As Integer
        'Dim TerrainModifier, AttackingInfantry, AttackingCavalry, AttackFactor As Integer
        Dim AttackFactor As Integer
        Dim AttackingCavalryValue, AttackingInfantryValue As Integer
        'Dim MsgStr As String

        TerrainModifier = Province(Target).Topography + 1

        AttackingInfantry = GetProvincialMilitia(Base) + Government(ActiveGovernment).Infantry
        AttackingInfantryValue = AttackingInfantry
        AttackingCavalry = (Government(ActiveGovernment).Cavalary) 'check on the effects of the multiplication
        AttackingCavalryValue = AttackingCavalry \ TerrainModifier 'check on the effects of the multiplication
        If AttackingCavalryValue < 1 Then AttackingCavalryValue = 1 'so at least 1 to avoid divide by 0 error
        AttackFactor = AttackingInfantryValue + AttackingCavalryValue

        'If AI_Thinking = False Then
        '    If ActiveGovernment = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
        '        MsgStr = "Attacking force: " & AttackingInfantry & "000 Infantry and " & AttackingCavalry & "00 Cavalry led by a " _
        '            & GetAbilityNames(Government(ActiveGovernment).Generalship) & " General." & vbCrLf
        '        If Government(ActiveGovernment).ArmyState < 0 Then
        '            MsgStr = MsgStr & "The Attackers' morale is low." & vbCrLf
        '        ElseIf Government(ActiveGovernment).ArmyState > 0 Then
        '            MsgStr = MsgStr & "The Attackers' morale is high." & vbCrLf
        '        End If
        '        If TerrainModifier > 1 And AttackingCavalry > 0 Then
        '            MsgStr = MsgStr & "Difficult terrain hinders the attacking Cavalry." & vbCrLf
        '        End If
        '        If Province(Base).SocialState < 0 Then
        '            MsgStr = MsgStr & "The Attackers' Base is in disarray. "
        '        End If
        '        MsgBox(MsgStr)
        '    End If
        'End If ' AI thinking?

        Return AttackFactor

    End Function

    Function CalculateDefenseFactor(ByVal Target As Integer, ByVal PlayerDef As Boolean, ByVal DefendingGen As Integer, _
                                ByVal DefendingArmyVal As Integer, AI_Thinking As Boolean) As Integer
        Dim DefendingGovernment, RoyalInfantry As Integer
        'Dim DefendingCavalry, FortificationModifier, DefenseFactor, DefendingInfantry As Integer
        Dim DefenseFactor As Integer
        Dim DefendingCavalryValue, DefendingInfantryValue As Integer
        'Dim MsgStr As String

        TerrainModifier = Province(Target).Topography + 1

        If PlayerDef Then
            DefendingGovernment = Province(Target).PoliticalAffiliation
            RoyalInfantry = Government(DefendingGovernment).Infantry
            DefendingCavalry = (Government(DefendingGovernment).Cavalary)
            DefendingCavalryValue = DefendingCavalry \ TerrainModifier
        Else
            DefendingCavalry = GetLocalKnights(Target)
            DefendingCavalryValue = DefendingCavalry \ TerrainModifier
            RoyalInfantry = 0
        End If
        If DefendingCavalryValue < 1 Then DefendingCavalryValue = 1 ' avoid divide by 0

        FortificationModifier = 0 'Province(PlayerTarget).Fortifications ' needs to be added in!!!

        DefendingInfantry = (GetProvincialMilitia(Target) + RoyalInfantry)
        DefendingInfantryValue = DefendingInfantry * (TerrainModifier + FortificationModifier)

        DefenseFactor = DefendingCavalryValue + DefendingInfantryValue

        'If AI_Thinking = False Then
        '    If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
        '        MsgStr = "Defending force: " & DefendingInfantry & "000 Infantry and " & DefendingCavalry & "00 Cavalry led by a " _
        '            & GetAbilityNames(DefendingGen) & " General." & vbCrLf
        '        If DefendingArmyVal < 0 Then
        '            MsgStr = MsgStr & "The Defenders' morale is low." & vbCrLf
        '        ElseIf DefendingArmyVal > 0 Then
        '            MsgStr = MsgStr & "The Defenders' morale is high." & vbCrLf
        '        End If
        '        If TerrainModifier > 1 And DefendingInfantry > 0 Then
        '            MsgStr = MsgStr & "The Terrain favors the defending Infantry." & vbCrLf
        '        End If
        '        If FortificationModifier > 0 And DefendingInfantry > 0 Then
        '            MsgStr = MsgStr & "The Province's Fortifications aid the defending Infantry." & vbCrLf
        '        End If
        '        If Province(Target).SocialState < 0 Then
        '            MsgStr = MsgStr & " The Province itself is in disarray. "
        '        End If
        '        MsgBox(MsgStr)
        '    End If
        'End If 'is AI thinking

        Return DefenseFactor

    End Function

    Function ApplyCombatModifiers(ByVal AttackFactor As Integer, ByVal DefenseFactor As Integer, ByVal Target As Integer, _
                              ByVal Base As Integer, ByVal DefendingGen As Integer, ByVal DefendingArmyVal As Integer) As Integer
        Dim VictoryThreshhold, ForceRatio As Integer

        VictoryThreshhold = 5

        If AttackFactor >= DefenseFactor Then
            ForceRatio = AttackFactor \ DefenseFactor
            ForceRatio -= 1 'so 1:1 = no modifier up or down
        Else
            If AttackFactor < 1 Then
                AttackFactor = 1
            End If
            ForceRatio = -1 * (DefenseFactor \ AttackFactor)
            ForceRatio += 1 ' ditto
        End If

        VictoryThreshhold += ForceRatio

        VictoryThreshhold += Government(ActiveGovernment).Generalship - DefendingGen

        'DiceRoll += WeatherByArea(Province(Target).Climate) ' seems questionable as well as well as unnecessarily complicating

        VictoryThreshhold += Province(Base).SocialState - Province(Target).SocialState

        VictoryThreshhold += Government(ActiveGovernment).ArmyState - DefendingArmyVal

        If Province(Target).Farmland \ BASE_PROVINCE_SIZE > 1 Then ' if target area is huge
            VictoryThreshhold -= (Province(Target).Farmland \ BASE_PROVINCE_SIZE - 1)
        End If

        If VictoryThreshhold < 1 Then
            VictoryThreshhold = 1
        ElseIf VictoryThreshhold > 10 Then
            VictoryThreshhold = 10
        End If

        Return VictoryThreshhold

    End Function

    Sub ProvinceChangesHands(Target As Integer)
        Dim ProvinceNum As Integer = -1
        Dim PopulationTransferred As Integer = 0
        Dim TotalTransferred As Integer = 0
        Dim TransferSources As Integer = 0
        Dim SourceProvinces() As Integer
        Dim Benefices As Integer = 0
        Dim OpenBenefices As Integer = 0
        Dim Treasure As Integer = 0
        Dim Decision As MsgBoxResult = MsgBoxResult.No '= vbNo
        Dim rand As New Random
        Dim CoinFlip As Integer = 0
        Dim MsgStr As String = ""

        Randomize()

        ' Loser loses local knights from target province
        Government(Province(Target).PoliticalAffiliation).Cavalary -= GetLocalKnights(Target)

        If ActiveGovernment = PlayerSide Then
            IncrementConquestVPs(Target)
        Else
            If Province(Target).PoliticalAffiliation = PlayerSide Then
                DecrementConquestVPs(Target)
            End If
        End If

        Province(Target).PoliticalAffiliation = ActiveGovernment
        Province(Target).ControlLevel = SUBORDINATE

        'Loyalty will be the inverse of what it was before; the more it liked the old regime, the less it will like the new, and vice versa
        Province(Target).Loyalty = -1 * Province(Target).Loyalty

        If ActiveGovernment <> PlayerSide Then 'have to set target's textbox since player didn't click on it
            SetTargetTextbox(Target)
        End If

        ChangeTextboxAffiliation(ActiveGovernment)

        If ActiveGovernment = PlayerSide Then
            DecideHowHandleTreasure(Target)
            DecideHowHandleBenefices(Target)
            'Else
            'MsgBox("Need to set up whether non-player side pillages or transfers benefices.")
        End If

        For ProvinceNum = 0 To TotalProvinces - 1
            PopulationTransferred = 0
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment And ProvinceNum <> Target And Province(ProvinceNum).SurplusPopulation > 0 Then
                If Province(Target).Peasants < Province(Target).Farmland Then
                    While Province(ProvinceNum).SurplusPopulation > 0 And Province(Target).Peasants < Province(Target).Farmland
                        Province(ProvinceNum).SurplusPopulation -= 1
                        Province(Target).Peasants += 1
                        PopulationTransferred += 1
                    End While
                    TransferSources += 1
                    ReDim Preserve SourceProvinces(TransferSources)
                    SourceProvinces(TransferSources - 1) = ProvinceNum
                    TotalTransferred += PopulationTransferred
                    'If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
                    '    MsgBox(CStr(PopulationTransferred) & ",000 people have migrated from " & Province(SourceProvinces(TransferSources - 1)).Name _
                    '               & " to " & Province(Target).Name & ".  Total who've migrated is " & CStr(TotalTransferred) & ".")
                    'End If
                End If ' Target Province has space for immigrants
            End If ' This province is the player's and has surplus population
        Next

        If TotalTransferred > 0 And Province(Target).PoliticalAffiliation = PlayerSide Then
            MsgStr = "A total of " & CStr(TotalTransferred) & ",000 land-hungry " & Government(PlayerSide).Name & " have moved to " & Province(Target).Name & " from "
            For i = 0 To TransferSources - 1
                If i > 0 Then
                    MsgStr &= ", "
                    If i = TransferSources - 1 Then
                        MsgStr &= "and "
                    End If
                End If
                Try
                    MsgStr &= Province(SourceProvinces(i)).Name
                Catch
                    MsgBox("ERROR: Problem with List of Provinces people moving From")
                End Try
            Next
            MsgStr &= "."
            MsgBox(MsgStr)
        End If


        For ProvinceNum = 0 To TotalProvinces - 1
            PopulationTransferred = 0
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment And ProvinceNum <> Target And Province(ProvinceNum).SurplusPopulation > 0 Then
                If Province(ProvinceNum).SurplusPopulation > 0 Then ' this isn't done as "else" because also used for "spillover" from peaceful transfer, above
                    PopulationTransferred = 0
                    If ActiveGovernment = PlayerSide Then
                        MsgStr = (Province(ProvinceNum).SurplusPopulation) & ",000 people in " & Province(ProvinceNum).Name & " need land, but there is no room in "
                        MsgStr &= Province(Target).Name & ".  Therefore, letting them move in will displace some locals and anger the rest. "
                        MsgStr &= "However, if your people can't move somewhere eventually, many will starve, conditions in " & Province(ProvinceNum).Name & " will deteriorate, "
                        MsgStr &= "and support for your government there will decline. " & DOUBLE_SPACE & SPACER_STR
                        MsgStr &= "The Social State of " & Province(ProvinceNum).Name & " is currently " & DescribeSocialState(Province(ProvinceNum).SocialState)
                        MsgStr &= ", while its Loyalty to you is " & NameLoyaltyLevel(Province(ProvinceNum).Loyalty) & "." & DOUBLE_SPACE
                        MsgStr &= "The Social State of " & Province(Target).Name & " is currently " & DescribeSocialState(Province(Target).SocialState)
                        MsgStr &= ", while its Loyalty to you is " & NameLoyaltyLevel(Province(Target).Loyalty) & "." & DOUBLE_SPACE & SPACER_STR
                        MsgStr &= "DO YOU WANT TO ALLOW THE MIGRATION?"
                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Displace Locals?")
                    Else
                        CoinFlip = rand.Next(0, 2)
                        If CoinFlip = 1 Then
                            Decision = MsgBoxResult.Yes
                        Else
                            Decision = MsgBoxResult.No
                        End If
                    End If ' the player is active

                    If Decision = MsgBoxResult.Yes Then
                        While Province(ProvinceNum).SurplusPopulation > 0
                            Province(ProvinceNum).SurplusPopulation -= 1
                            Province(Target).SurplusPopulation += 1
                            PopulationTransferred += 1
                        End While
                        DecrementSocialState(Target, CHAOS)
                        DecrementProvincialLoyalty(Target)
                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
                            MsgStr = CStr(PopulationTransferred) & ",000 people have migrated from " & Province(ProvinceNum).Name _
                                        & " to " & Province(Target).Name & ", displacing an equal number of locals. " & DOUBLE_SPACE
                            MsgStr &= "Conditions in " & Province(Target).Name & " have become " & DescribeSocialState(Province(Target).SocialState)
                            MsgStr &= ", while Loyalty there has declined to " & NameLoyaltyLevel(Province(Target).Loyalty) & "."
                            If MsgStr = "" Then
                                MsgStr = "The problem of the empty message box is in the ProvinceChangesHand routine."
                            End If
                            MsgBox(MsgStr)
                        End If ' player cares
                End If ' player goes ahead and transfers population to the target
            End If ' if the province (still) has surplus population
            End If ' This province is the player's and has surplus population
        Next

        'If ActiveGovernment = PlayerSide Then
        '    DecideHowHandleBenefices(Target)
        'Else
        '    'MsgBox("Need to set up how non-player side handles land.")
        'End If

        ' Winner gets local knights if has their support
        If Province(Target).Loyalty > 0 Then
            Government(ActiveGovernment).Cavalary += GetLocalKnights(Target)
            If Province(Target).PoliticalAffiliation = PlayerSide Then
                MsgBox("The Local Nobles will fight with the Royal Army!")
            End If ' Player cares
        End If

    End Sub

    Function CheckIfGovernmentEliminated(ByVal WhichGvt As Integer) As Boolean
        Dim Eliminated As Boolean = True 'hypothesize it was eliminated; now test to see if any provinces affiliated
        Dim i As Integer

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = WhichGvt Then
                Eliminated = False
                Exit For
            End If
        Next

        Return Eliminated
    End Function

    Sub DecrementArmyState(ByVal GovernmentNum As Integer)
        If Government(GovernmentNum).ArmyState > INEFFECTUAL Then
            Government(GovernmentNum).ArmyState -= 1
        End If
    End Sub

    Sub IncrementArmyState(ByVal GovernmentNum As Integer)
        If Government(GovernmentNum).ArmyState < FANATICAL Then
            Government(GovernmentNum).ArmyState += 1
        End If
    End Sub

    Function CalculateLosses(ByVal ForceSize As Integer, ByVal LossPercent As Integer)
        Dim ActualLosses As Integer

        ActualLosses = ForceSize * LossPercent \ 100

        Return ActualLosses

    End Function

    Sub DecideHowHandleTreasure(ByVal ProvinceID As Integer)
        Dim Decision As MsgBoxResult = vbNo
        Dim TownspeopleKilled As Integer = 0
        Dim LootGained As Integer = 0
        Dim MsgStr As String = ""

        MsgStr = "The townspeople of " & Province(ProvinceID).Name & " have " & CStr(Province(ProvinceID).Townspeople) _
                          & ",000 " & CurrencyStr & " worth of Movable Wealth. " & DOUBLE_SPACE
        MsgStr &= "You can seize it, which will enrich your Treasury and please your Followers, "
        MsgStr &= "but this will damage the Local Economy and Alienate the Local Population.  "
        MsgStr &= "Sparing them will keep the Province productive and make you Popular with your New Subjects, "
        MsgStr &= "but disappoint your Army and your Treasurer." & DOUBLE_SPACE
        MsgStr &= "If you want to seize the Wealth, you can let your men Loot, which will get all of it but devastate the Towns,"
        MsgStr &= "or you can extort Tribute from the Townspeople, which will lessen the Damage but also yield less Profit and Enthusiasm from your Men."
        MsgStr &= DOUBLE_SPACE & SPACER_STR

        MsgStr &= Province(ProvinceID).Name & " is currently " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & " toward you, "
        MsgStr &= "while its Social State is " & DescribeSocialState(Province(ProvinceID).SocialState) & "." & DOUBLE_SPACE

        MsgStr &= "You currently have " & CStr(Government(PlayerSide).Treasury) & ",000 " & CurrencyStr & " in your Treasury, "
        MsgStr &= "while your Army's Morale is " & DescribeArmyState(Government(PlayerSide).ArmyState) & "."
        MsgStr &= DOUBLE_SPACE

        MsgStr &= "IF YOU LOOT the Towns, you will gain " & CStr(Province(ProvinceID).Townspeople) & ",000 " & CurrencyStr & ", and your Army's Morale will "
        If Government(PlayerSide).ArmyState < FANATICAL Then
            MsgStr &= "Rise to " & DescribeArmyState(Government(PlayerSide).ArmyState + 1) & ".  "
        Else
            MsgStr &= "Remain " & DescribeArmyState(FANATICAL) & ".  "
        End If
        'MsgStr &= DOUBLE_SPACE

        MsgStr &= "However, " & Province(ProvinceID).Name & "'s Loyalty will "
        If Province(ProvinceID).Loyalty > REBELLIOUS Then
            MsgStr &= "Fall to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty - 1) & ", "
        Else
            MsgStr &= "Remain the Same, "
        End If

        MsgStr &= "its Social State will "
        If Province(ProvinceID).SocialState > CHAOS Then
            MsgStr &= "Fall to " & DescribeSocialState(Province(ProvinceID).SocialState - 1) & ", and "
        Else
            MsgStr &= "Remain the Same, and "
        End If
        If Province(ProvinceID).Townspeople > 1 Then
            MsgStr &= CStr(Province(ProvinceID).Townspeople \ 2)
        Else
            MsgStr &= "1"
        End If
        MsgStr &= ",000 People will Die."

        MsgStr &= DOUBLE_SPACE

        MsgStr &= "IF YOU DEMAND TRIBUTE from the Towns, they will offer you "
        If Province(ProvinceID).Townspeople > 1 Then
            MsgStr &= CStr(Province(ProvinceID).Townspeople \ 2) & ",000 " & CurrencyStr & ",  "
        Else
            If Province(ProvinceID).Loyalty >= INDIFFERENT Then
                MsgStr &= "1,000 " & CurrencyStr & ".  "
            Else
                MsgStr &= "Nothing.  "
            End If
        End If
        MsgStr &= "the Province will remain " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & " to you, "
        MsgStr &= "the Social State will remain " & DescribeSocialState(Province(ProvinceID).SocialState) & ", "
        MsgStr &= "and your Army's Morale will remain " & DescribeArmyState(Government(PlayerSide).ArmyState) & "."
        MsgStr &= DOUBLE_SPACE

        MsgStr &= "IF YOU SPARE " & Province(ProvinceID).Name & "'s Towns entirely, its Loyalty will "
        If Province(ProvinceID).Loyalty < ENTHUSIASTIC Then
            MsgStr &= "Rise to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty + 1) & ".  "
        Else
            MsgStr &= "Remain the Same.  "
        End If
        'MsgStr &= "while its Social State will Remain the Same."
        'If Province(ProvinceID).SocialState < BOOMING Then
        '    MsgStr &= "Rise to " & DescribeSocialState(Province(ProvinceID).SocialState + 1) & "."
        'Else
        '    MsgStr &= "Remain the Same."
        'End If
        ' MsgStr &= DOUBLE_SPACE

        MsgStr &= "On the Other Hand, you will gain no Wealth, and your Army's Morale will "
        If Government(PlayerSide).ArmyState > INEFFECTUAL Then
            MsgStr &= "Decline to " & DescribeArmyState(Government(PlayerSide).ArmyState - 1) & "."
        Else
            MsgStr &= "Remain Ineffectual."
        End If
        MsgStr &= DOUBLE_SPACE & SPACER_STR

        MsgStr &= "To LOOT the Towns, Click YES." & vbCrLf
        MsgStr &= "To DEMAND TRIBUTE from the Towns, Click NO." & vbCrLf
        MsgStr &= "To SPARE THE TOWNS, Click CANCEL."

        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Loot, Extort, or Spare the Towns?")

        Select Case Decision
            Case MsgBoxResult.Yes
                Government(ActiveGovernment).Treasury += Province(ProvinceID).Townspeople
                IncrementArmyState(PlayerSide)
                DecrementSocialState(ProvinceID, CHAOS)
                DecrementProvincialLoyalty(ProvinceID)
                MsgStr = "By Looting the Province's Towns, you gained " & Province(ProvinceID).Townspeople & ",000 " & CurrencyStr
                MsgStr &= " and your Army's Morale Rose to " & DescribeArmyState(Government(PlayerSide).ArmyState) & "." & DOUBLE_SPACE
                TownspeopleKilled = Province(ProvinceID).Townspeople \ 2
                If TownspeopleKilled = 0 Then
                    TownspeopleKilled = 1
                End If
                Province(ProvinceID).Townspeople -= TownspeopleKilled
                MsgStr &= CStr(TownspeopleKilled) & ",000 Townspeople died, "
                MsgStr &= Province(ProvinceID).Name & "'s Loyalty to you Declined to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty)
                MsgStr &= ", and its Social State Declined to " & DescribeSocialState(Province(ProvinceID).SocialState) & "."
                MsgBox(MsgStr)
                If MsgStr = "" Then
                    MsgStr = "There's a problem in Deciding how to Handle Treasure."
                End If
                Province(ProvinceID).TimesTaxed += HIGH_TAX
            Case MsgBoxResult.No
                If Province(ProvinceID).Townspeople > 1 Then
                    LootGained = Province(ProvinceID).Townspeople \ 2
                Else
                    If Province(ProvinceID).Loyalty >= INDIFFERENT Then
                        LootGained = 1
                    Else
                        LootGained = 0
                    End If
                End If
                Government(ActiveGovernment).Treasury += LootGained
                MsgBox("You gained " & CStr(LootGained) & ",000 " & CurrencyStr & " in Tribute from the Towns of " & Province(ProvinceID).Name & ".")
                Province(ProvinceID).TimesTaxed += LOW_TAX
            Case MsgBoxResult.Cancel
                IncrementProvincialLoyalty(ProvinceID)
                DecrementArmyState(ActiveGovernment)
                MsgBox(Province(ProvinceID).Name & "'s Loyalty to You has Increased to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & _
                       ", while your Army's Morale has Decreased to " & DescribeArmyState(ActiveGovernment) & ".")
        End Select

    End Sub

    Sub DecideHowHandleBenefices(ByVal ProvinceID As Integer)
        Dim Benefices As Integer = 0
        'Dim OpenBenefices As Integer = 0
        Dim LocalNobles As Integer = 0
        Dim LocalClergy As Integer = 0
        Dim FreePeasants As Integer = 0
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim MsgStr As String = ""
        Dim GovernmentID As Integer = 0
        Dim OtherProvince As Integer = 0
        Dim i As Integer = 0
        Dim FinishedRedistributing As Boolean = False
        Dim PeasLandDone As Boolean = False
        Dim NobLandDone As Boolean = False
        Dim ChurchLandDone As Boolean = False
        Dim SelectedGroup As Integer = 0
        Dim StartingArmyState As Integer = UNCERTAIN
        Dim Offer As Integer = 0
        'Dim SupportRatio As Integer = 1


        Benefices = (CalculateTotalBenefices(ProvinceID))
        FreePeasants = Benefices - (Province(ProvinceID).Nobles + Province(ProvinceID).Clergy) '* PEASANTS_PER_BENEFICE ' check this out; NO! shouldn't it be adjusted by Peas_per_ben?

        If Benefices > 0 Then
            'Do While FinishedRedistributing = False
            LocalNobles = Province(ProvinceID).Nobles
            LocalClergy = Province(ProvinceID).Clergy

            'SupportRatio = PEASANTS_PER_BENEFICE \ Province(ProvinceID).AgricultureLevel
            'If SupportRatio < 1 Then SupportRatio = 1

            MsgStr &= "It takes approximately " & CStr(PEASANTS_PER_BENEFICE) & " Peasant Farmers to support 1 Noble or 1 Member or the Clergy." ' with " & DOUBLE_SPACE
            ' & Province(ProvinceID).Name & "'s current Agricultural technology and techniques." & DOUBLE_SPACE
            MsgStr &= "This support is in the form of Food and Labor given as Rent to the Nobles and Clergy who own the Land the Peasants work." & DOUBLE_SPACE
            MsgStr &= Province(ProvinceID).Name & " contains enough Peasant Farmers to support " & CStr(Benefices) & ",000 Nobles and/or Clergy.  " & DOUBLE_SPACE
            MsgStr &= "Currently, they support " & CStr(LocalNobles) & ",000 Nobles and "
            MsgStr &= CStr(LocalClergy) & ",000 Clergy. The " & CStr(LocalNobles) & ",000 Nobles include " & CStr(LocalNobles \ WARRIOR_RATIO) & _
                ",000 Men who serve as Cavalry, which you can use to Defend or Attack from Any of your Provinces."
            If FreePeasants > 0 Then
                MsgStr &= DOUBLE_SPACE & "The remainder of the Land is farmed by Free Peasants. These Free Peasants include " & _
                    GetProvincialMilitia(ProvinceID) & ",000 Men who serve as Militia Infantry, " & _
                    "who help Defend this Province and can help Attack neighboring ones."
            End If
            MsgStr &= DOUBLE_SPACE & SPACER_STR
            MsgStr &= "Now that you control " & Province(ProvinceID).Name & " you can take Land from any of these groups and give it to your Followers. "
            MsgStr &= "If you redistribute land, you will Please your Followers, but you will Alienate the People of " & _
                Province(ProvinceID).Name & " who you take it from."
            If FreePeasants > 0 Then
                MsgStr &= "  Also, if you give the Free Peasants' Land to your Followers, it will Increase your Cavalry forces, "
                MsgStr &= "but reduce the Province's Militia Infantry."
            End If
            MsgStr &= DOUBLE_SPACE
            MsgStr &= "If you don't Reward your Followers with Land, though, you will seriously Disappoint them. " & DOUBLE_SPACE & SPACER_STR
            MsgStr &= "Your Army's Morale is currently " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & "." & DOUBLE_SPACE
            MsgStr &= "Loyalty in " & Province(ProvinceID).Name & " is currently " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "." & DOUBLE_SPACE & SPACER_STR

            MsgStr &= "You can give ALL the Land to your Followers, which will give your Army's Morale the Biggest Boost, but will totally Alienate the People of " & Province(ProvinceID).Name & ";" & DOUBLE_SPACE
            MsgStr &= "You can give NO Land to your Followers, which will make them very Unhappy with you, but will Please People in " & Province(ProvinceID).Name & ";" & DOUBLE_SPACE
            MsgStr &= "or You can give SOME Land to your Followers, and only Alienate the People of " & Province(ProvinceID).Name & " whose Land you take." & DOUBLE_SPACE

            MsgStr &= "To Give your Followers ALL Available Land, Click YES." & vbCrLf
            MsgStr &= "To Give them NO Land, Click NO." & vbCrLf
            MsgStr &= "To Give them SOME Land, Click CANCEL"

            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Redistribute Land?")

            If Decision = MsgBoxResult.No Then
                Decision = MsgBox("Your Chief Lieutenants report that their Men are Extremely Angry over your Refusal to grant them any of the Conquered Land " _
                       & "urge you to Reconsider!" & DOUBLE_SPACE & "WILL YOU CHANGE YOUR MIND?", MsgBoxStyle.YesNo, "Reconsider?")
                If Decision = MsgBoxResult.No Then
                    For i = 1 To 2
                        DecrementArmyState(ActiveGovernment)
                    Next
                    If FreePeasants > 0 Then
                        DecrementArmyState(ActiveGovernment)
                    End If

                    For i = 0 To TotalProvinces - 1
                        If Province(i).PoliticalAffiliation = ActiveGovernment Then
                            DecrementProvincialLoyalty(i)
                        End If
                    Next

                    IncrementProvincialLoyalty(ProvinceID)
                    MsgBox("Loyalty to you in " & Province(ProvinceID).Name & " has Increased to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) _
                           & " but your Army's Morale has Declined to " & DescribeArmyState(Government(PlayerSide).ArmyState) & " and Loyalty to your " _
                           & " Government has Decreased in your other Provinces.")
 
                    'Maybe want to have consequences in home territories
                End If
            End If

            If Decision = MsgBoxResult.Yes Then
                Offer = (LocalNobles + LocalClergy)
                If Offer < 1 Then Offer = 1
                MsgStr = "Representatives of " & Province(ProvinceID).Name & " beg you Reconsider and offer their Loyal Service and Tribute worth "
                MsgStr &= CStr(Offer) & ",000 " & CurrencyStr & " if you will leave them their Land." & DOUBLE_SPACE
                MsgStr &= "However, your Followers will only grudgingly accept their Share of 1/2 the Tribute in place of the Land." & DOUBLE_SPACE
                MsgStr &= "WILL YOU ACCEPT THE OFFER?"
                Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Reconsider?")
                If Decision = MsgBoxResult.Yes Then
                    If Province(ProvinceID).Loyalty < SUPPORTIVE Then
                        Province(ProvinceID).Loyalty = SUPPORTIVE
                    End If
                    If Offer > 1 Then Offer = Offer \ 2
                    Government(ActiveGovernment).Treasury += Offer
                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " is now " & NameLoyaltyLevel(SUPPORTIVE) _
                           & " and you Gained " & CStr(Offer) & ",000 " & CurrencyStr & "." _
                           & DOUBLE_SPACE & "Your Army remains " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & ".")
                Else
                    If FreePeasants > 0 Then
                        IncrementArmyState(Government(ActiveGovernment).ArmyState)
                    End If
                    Province(ProvinceID).Nobles += FreePeasants
                    FreePeasants = 0
                    IncrementArmyState(Government(ActiveGovernment).ArmyState)
                    ReactToTakeChurchLand(ProvinceID) 'Results Msg is contained in this
                End If
            End If

            If Decision = MsgBoxResult.Cancel Then
                Do While FinishedRedistributing = False     'Topography	0	Integer

                    MsgStr = "You can deal with the different Groups in " & Province(ProvinceID).Name & " in whatever order you choose." & DOUBLE_SPACE

                    If FreePeasants > 0 Then
                        'If ChurchLandDone = False Or PeasLandDone = False Then
                        If NobLandDone = False Then
                            MsgStr &= "Click YES to deal with the Nobles." & vbCrLf
                        Else
                            MsgStr &= "You've already dealt with the Nobles' Land." & vbCrLf
                        End If
                        'Else
                        '    Decision = MsgBoxResult.Yes ' Do Nobles if only option left
                        'End If

                        'If NobLandDone = False Or PeasLandDone = False Then
                        If ChurchLandDone = False Then
                            MsgStr &= "Click NO to deal with the Clergy." & vbCrLf
                        Else
                            MsgStr &= "You've already dealt with the Clergy's Land." & vbCrLf
                        End If
                        'Else
                        '    Decision = MsgBoxResult.No ' Do Church directly if only option left
                        'End If

                        'If NobLandDone = False Or ChurchLandDone = False Then
                        If PeasLandDone = False Then
                            MsgStr &= "Click CANCEL to deal with the Free Peasants."
                        Else
                            MsgStr &= "You've already dealt with the Peasants' Land."
                        End If

                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Choose Group")

                        'Else
                        '    Decision = MsgBoxResult.Cancel 'if Peasants = only option left, go directly to them
                        'End If
                        Select Case Decision
                            Case MsgBoxResult.Yes
                                SelectedGroup = 2
                                'NobLandDone = True
                            Case MsgBoxResult.No
                                SelectedGroup = 1
                                'ChurchLandDone = True
                            Case MsgBoxResult.Cancel
                                SelectedGroup = 3
                                'PeasLandDone = True
                        End Select
                    Else
                        If NobLandDone = False And ChurchLandDone = False Then
                            MsgStr &= "Click YES to deal with the Nobles." & vbCrLf
                            MsgStr &= "Click NO to deal with the Clergy."
                            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Choose Group")
                        Else
                            If NobLandDone = True Then
                                Decision = MsgBoxResult.No ' if Nobles done, go directly to Clergy
                            Else
                                Decision = MsgBoxResult.Yes ' and vice versa
                            End If
                        End If

                        Select Case Decision
                            Case MsgBoxResult.Yes
                                SelectedGroup = 2
                                'NobLandDone = True
                            Case MsgBoxResult.No
                                SelectedGroup = 1
                                'ChurchLandDone = True
                        End Select
                        PeasLandDone = True 'so won't create unbreakable loop when test for everyone done at end
                    End If

                        Select Case SelectedGroup
                        Case 3
                            If PeasLandDone = False Then
                                'If FreePeasants > 0 Then
                                MsgStr = "There are " & CStr(FreePeasants * PEASANTS_PER_BENEFICE) & ",000 Free Peasants in " & Province(ProvinceID).Name & "." & DOUBLE_SPACE
                                MsgStr &= "Taking their Land will Anger them and Eliminate the " & CStr(GetProvincialMilitia(ProvinceID)) & ",000 Militia Infantry "
                                MsgStr &= "they provide." & DOUBLE_SPACE
                                MsgStr &= "However, taking it will Please your Warriors and add "
                                MsgStr &= CStr((FreePeasants * 10) \ WARRIOR_RATIO) & "00 Cavalry to your Army." & DOUBLE_SPACE
                                MsgStr &= "Representatives of the Free Peasants' have pleaded with you to leave them their Land, and Promised that they will "
                                MsgStr &= "Serve you Loyaly as Militia Infantry if you do." & DOUBLE_SPACE
                                MsgStr &= Province(ProvinceID).Name & "'s Loyalty is currently " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & DOUBLE_SPACE
                                MsgStr &= "Your Army currently has " & CStr(Government(ActiveGovernment).Cavalary) & "00 Cavalry, and its Morale is "
                                MsgStr &= DescribeArmyState(Government(ActiveGovernment).ArmyState) & "." & DOUBLE_SPACE
                                MsgStr &= "DO YOU WANT TO ACCEPT THE PEASANTS' OFFER?" & DOUBLE_SPACE
                                MsgStr &= "Click YES to Leave the Free Peasants their Land." & vbCrLf
                                MsgStr &= "Click NO to Give the Land to your Warriors."
                                'MsgStr &= "Click CANCEL to Stop Redistributing Land altogether."
                                Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Take Peasants' Land?")
                                If Decision = MsgBoxResult.No Then
                                    Province(ProvinceID).Nobles += FreePeasants '\ PEASANTS_PER_BENEFICE
                                    DecrementProvincialLoyalty(ProvinceID)
                                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
                                    Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
                                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " declined to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) _
                                           & ", while your Army's Morale Increased to " & DescribeArmyState(ActiveGovernment))
                                Else
                                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if take it below max value for now
                                    IncrementProvincialLoyalty(ProvinceID)
                                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " Rose to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) _
                                           & ", but Your Army's Morale Decreased to " & DescribeArmyState(ActiveGovernment) & ".")
                                    'DecrementSupportForGovernment(ActiveGovernment)
                                End If
                            Else
                                MsgBox("You already dealt with the Peasants")
                            End If

                            PeasLandDone = True
                            'End If 'if there are Free Peasants

                        Case 2 ' Nobles
                            If NobLandDone = False Then
                                If LocalNobles > 0 Then
                                    Offer = Province(ProvinceID).Nobles
                                    MsgStr = "If you take Ownership of the Nobles' Land in " & Province(ProvinceID).Name & " and give it to your Followers it will "
                                    MsgStr &= "please them but increase Local opposition to your Rule." & DOUBLE_SPACE
                                    MsgStr &= "The Local Nobles offer protest that they were but doing their duty serving in their Province's forces, but offer you tribute of " & CStr(Offer)
                                    MsgStr &= ",000 " & CurrencyStr & " and promise to serve in your Cavalry loyally if you will leave them their Lands." & DOUBLE_SPACE
                                    MsgStr &= "However, your Warriors' share of 1/2 the Tribute will satisfy them less than if you refuse the offer and give Them the Land." & DOUBLE_SPACE
                                    MsgStr &= "DO YOU WANT TO ACCEPT THE LOCAL NOBLES' OFFER?" & vbCrLf
                                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Accept Nobles' Counteroffer?")
                                    'If Decision = MsgBoxResult.Yes Then
                                    If Decision = MsgBoxResult.Yes Then
                                        Province(ProvinceID).Loyalty = SUPPORTIVE
                                        If Offer > 1 Then Offer = Offer \ 1
                                        Government(ActiveGovernment).Treasury += Offer
                                        MsgBox("You gained " & CStr(Offer) & ",000 " & CurrencyStr & "; " & Province(ProvinceID).Name & "'s Loyalty remains " _
                                               & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "; while your Army's Morale remains " & DescribeArmyState(Government(PlayerSide).ArmyState) & ".")
                                        Province(ProvinceID).TimesTaxed += LOW_TAX
                                        'Government(ActiveGovernment).Cavalary += GetLocalKnights(PlayerTarget)
                                        'MsgBox("The local nobles have joined your army!")
                                    Else
                                        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
                                        DecrementProvincialLoyalty(ProvinceID)
                                        MsgBox("Your Army's Morale has Increased, while " & Province(ProvinceID).Name & "'s Loyalty to you Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
                                    End If
                                    'DecrememtProvincialLoyalty(PlayerTarget)
                                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
                                    'Else
                                    '    Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
                                    '    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
                                    '    'DecrementSupportForGovernment(ActiveGovernment)
                                    'End If
                                Else
                                    MsgBox("There are no Nobles in " & Province(ProvinceID).Name & ".")
                                End If ' if are local nobles
                            Else
                                MsgBox("You've already dealt with the Nobles' Land.")
                            End If
                            NobLandDone = True
                        Case 1
                            If ChurchLandDone = False Then
                                If LocalClergy > 0 Then
                                    Offer = Province(ProvinceID).Clergy
                                    MsgStr = "If you take Church lands, you will please your Followers and be able to support more Cavalry, but you will "
                                    MsgStr &= "alienate the People of the Province as well as offend other Christian peoples." & DOUBLE_SPACE
                                    MsgStr &= "If you don't seize the Land, the Church Leaders in " & Province(ProvinceID).Name & " will support you, "
                                    MsgStr &= "but your Followers will be sorely Disappointed." & DOUBLE_SPACE
                                    MsgStr &= "You can demand Tribute of " & CStr(Offer) & ",000 " & CurrencyStr & " from the Church, but Church Leaders will regard "
                                    MsgStr &= "you with Suspicion, while your Followers will only grudgingly accept their portion of 1/2 the Tribute." & DOUBLE_SPACE
                                    MsgStr &= "Click YES to seize the Church Land" & vbCrLf
                                    MsgStr &= "Click NO to leave the Church Land alone." & vbCrLf
                                    MsgStr &= "Click CANCEL to take Tribute from the Church in place of the Land."
                                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Take Church Land?")
                                    Select Case Decision
                                        Case MsgBoxResult.Yes
                                            ReactToTakeChurchLand(ProvinceID)
                                        Case MsgBoxResult.No
                                            Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
                                            IncrementProvincialLoyalty(ProvinceID)
                                            MsgBox("Loyalty to you in " & Province(ProvinceID).Name & " has increased to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & ", " _
                                                   & "but at a cost to your Army's Morale.") ' to " & DescribeArmyState(ActiveGovernment))
                                        Case MsgBoxResult.Cancel
                                            If Offer > 1 Then Offer = Offer \ 2 ' Cut offer in half; other half to Warriors
                                            Government(ActiveGovernment).Treasury += Offer
                                            MsgBox("You gained " & CStr(Offer) & ", 000 " & CurrencyStr & "; " & Province(ProvinceID).Name & "'s Loyalty remains " _
                                                   & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "; while your Army's Morale remains " & DescribeArmyState(Government(PlayerSide).ArmyState) & ".")
                                            Province(ProvinceID).TimesTaxed += LOW_TAX
                                    End Select
                                    'If Decision = MsgBoxResult.No Then
                                    'Else
                                    '    '    End If
                                    '    'Else
                                    '    '    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
                                    '    '    'DecrementSupportForGovernment(ActiveGovernment)
                                    'End If 'take church land
                                Else
                                    MsgBox("There are no Clergy in " & Province(ProvinceID).Name & ".")
                                End If 'there is church land
                            Else
                                MsgBox("You already dealt with the Church Land.")
                            End If
                            ChurchLandDone = True
                    End Select
                        If NobLandDone = True And ChurchLandDone = True And PeasLandDone = True Then ' check and see if all done so finish doing land
                            FinishedRedistributing = True
                        End If
                Loop ' While FinishedRedistributing = False
                If Government(ActiveGovernment).ArmyState > FANATICAL Then 'adjunst Army state back within limits
                    Government(ActiveGovernment).ArmyState = FANATICAL         ' will have to do this with any support index affected
                ElseIf Government(ActiveGovernment).ArmyState < INEFFECTUAL Then
                    Government(ActiveGovernment).ArmyState = INEFFECTUAL
                End If

            End If ' take any land
        End If 'is land to take

    End Sub

    Sub ReactToTakeChurchLand(Prov As Integer)
        Dim OtherProvince As Integer = 0

        Province(Prov).Loyalty = REBELLIOUS
        Province(Prov).SocialState = CHAOS
        Province(Prov).Nobles += Province(Prov).Clergy
        Province(Prov).Clergy = 0
        For OtherProvince = 0 To TotalProvinces - 1
            If OtherProvince <> Prov Then
                If Province(OtherProvince).PoliticalAffiliation = ActiveGovernment Then
                    If Province(OtherProvince).Religion = CATHOLIC Then
                        DecrementProvincialLoyalty(OtherProvince)
                        MsgBox("Because you seized Land from the Church in " & Province(Prov).Name & _
                               " support for your Government has decreased in Catholic " & Province(OtherProvince).Name)
                    End If ' province is Catholic 'WILL NEED TO GENERALIZE THIS FOR ALL RELIGIONS
                End If ' province is controlled by this government
            End If 'this isn't the province itself
        Next
        For GovernmentID = 1 To TotalGovernments - 1
            If GovernmentID <> ActiveGovernment Then
                If Government(GovernmentID).Religion = CATHOLIC Then ' Or Government(GovernmentID).Religion = ARIAN Then
                    MsgBox("The " & Government(GovernmentID).Name & " vow to avenge this affront to the Church.")
                End If 'Government is Catholic or Arian
            End If 'Government isn't this one
        Next

        'Decrememt Church support or excommunicate
        'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it

        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
        MsgBox(Province(Prov).Name & " has become " & NameLoyaltyLevel(REBELLIOUS) & _
               " and the Province has become " & DescribeSocialState(CHAOS) & "." & DOUBLE_SPACE & _
               "Your Army's Morale has Increased to " & DescribeArmyState(ActiveGovernment))

    End Sub

    Sub ChangeTextboxAffiliation(ByVal ActiveGov As Integer)

        If frmMapScreen.rbnAutonomy.Checked Then
            TargetBox.BackColor = GetGovernmentColor(ActiveGov) ' should be active player's color !!!!! - set up to be 2/6
            TargetBox.Refresh()
        End If

        If frmMapScreen.rbnAffiliation.Checked Then
            TargetBox.Text = Government(ActiveGov).Name
            TargetBox.Refresh()
        End If

    End Sub


    Sub AttackAI(ByVal ActiveGov As Integer)
        Dim ProvinceNum, PotentialTarget, CurrentTarget, CurrentTargetValue, CurrentVictoryPotential, PotentialTargetArea As Integer
        Dim TerrainModifier, AttackFactor, CurrentBase, PotentialBase As Integer
        Dim DefendingGovernment, DefendingGeneralship, DefendingArmyState, PlayerDefend, DefenseFactor As Integer
        Dim VictoryPotential, TreasureValue, LandValue, RentValue As Integer
        Dim PeopleToResettle As Integer
        Dim AI_Thinking = True
        Dim ProvinceOwner As Integer = -1
        Dim RelatesWithOwner As Integer = -100
        Dim i, j As Integer
        Dim PotentialConnectingSeaArea As Integer = -1
        Dim PotentialConnectingSea As Integer = -1
        Dim PotentialTargetName As String = "" 'only needed for debug box in Sea movement logic

        PotentialTarget = -1
        PotentialTargetArea = -1
        CurrentTarget = -1
        CurrentTargetValue = 0
        CurrentVictoryPotential = 0
        PeopleToResettle = 0
        CurrentBase = -1
        PotentialBase = -1

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
                PeopleToResettle += Province(ProvinceNum).SurplusPopulation
            End If
        Next

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
                PotentialBase = ProvinceNum
                For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move 
                    If Province(PotentialBase).Connectors(i) >= RIVER Then ' if neighbor is land connection
                        PotentialTargetArea = Province(PotentialBase).Neighbors(i)
                        PotentialTarget = Area(PotentialTargetArea).Province
                        If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then

                            TerrainModifier = Province(PotentialTarget).Topography + 1

                            AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

                            DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

                            If DefendingGovernment > 0 Then
                                'PlayerDefending = Rand.Next(0, 2) ' can be variable later
                                PlayerDefend = True
                            Else
                                PlayerDefend = False
                            End If

                            If PlayerDefend Then
                                DefendingGeneralship = Government(DefendingGovernment).Generalship
                                DefendingArmyState = Government(DefendingGovernment).ArmyState
                            Else
                                DefendingGeneralship = 0
                                DefendingArmyState = 0
                            End If

                            DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

                            VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

                            If PeopleToResettle > 0 Then
                                LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
                                If LandValue > CurrentTargetValue Then
                                    If VictoryPotential >= CurrentVictoryPotential Then
                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                        If ProvinceOwner = 0 Then 'if is an independent province
                                            CurrentTarget = PotentialTarget
                                            CurrentTargetValue = LandValue
                                            CurrentVictoryPotential = VictoryPotential
                                            CurrentBase = PotentialBase
                                        Else 'Province belongs to a Kingdom
                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                            If RelatesWithOwner = MIN_RELATES Then
                                                CurrentTarget = PotentialTarget
                                                CurrentTargetValue = LandValue
                                                CurrentVictoryPotential = VictoryPotential
                                                CurrentBase = PotentialBase
                                            Else ' if isn't actively belligerant
                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                    MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                               & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                End If ' Player is involved
                                            End If '  actively belligerant
                                        End If 'Belongs to a Kingdom
                                    End If ' is currently most attractive target
                                Else
                                    If LandValue = CurrentTargetValue Then
                                        If VictoryPotential > CurrentVictoryPotential Then
                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                            If ProvinceOwner = 0 Then 'if is an independent province
                                                CurrentTarget = PotentialTarget
                                                CurrentTargetValue = LandValue
                                                CurrentVictoryPotential = VictoryPotential
                                                CurrentBase = PotentialBase
                                            Else 'Province belongs to a Kingdom
                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                If RelatesWithOwner = MIN_RELATES Then
                                                    CurrentTarget = PotentialTarget
                                                    CurrentTargetValue = LandValue
                                                    CurrentVictoryPotential = VictoryPotential
                                                    CurrentBase = PotentialBase
                                                Else ' if isn't actively belligerant
                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                        MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                               & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                    End If ' Player is involved
                                                End If '  actively belligerant
                                            End If 'Belongs to a Kingdom
                                            'CurrentTarget = PotentialTarget
                                            'CurrentTargetValue = LandValue
                                            'CurrentVictoryPotential = VictoryPotential
                                            'CurrentBase = PotentialBase
                                        End If
                                    End If
                                End If
                            Else ' no people to resettle
                                If VictoryPotential > 5 Then
                                    TreasureValue = Province(PotentialTarget).Townspeople
                                    RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
                                    If TreasureValue >= RentValue Then
                                        If TreasureValue > CurrentTargetValue Then
                                            If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
                                                ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                If ProvinceOwner = 0 Then 'if is an independent province
                                                    CurrentTarget = PotentialTarget
                                                    CurrentTargetValue = LandValue
                                                    CurrentVictoryPotential = VictoryPotential
                                                    CurrentBase = PotentialBase
                                                Else 'Province belongs to a Kingdom
                                                    RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                    If RelatesWithOwner = MIN_RELATES Then
                                                        CurrentTarget = PotentialTarget
                                                        CurrentTargetValue = LandValue
                                                        CurrentVictoryPotential = VictoryPotential
                                                        CurrentBase = PotentialBase
                                                    Else ' if isn't actively belligerant
                                                        RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                        AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                        If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                            MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                               & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                        End If ' Player is involved
                                                    End If '  actively belligerant
                                                End If 'Belongs to a Kingdom
                                                'CurrentTarget = PotentialTarget
                                                'CurrentTargetValue = TreasureValue
                                                'CurrentVictoryPotential = VictoryPotential
                                                'CurrentBase = PotentialBase
                                            End If
                                        End If
                                    Else ' if rents more valuable than treasure
                                        If RentValue > CurrentTargetValue Then
                                            If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
                                                ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                If ProvinceOwner = 0 Then 'if is an independent province
                                                    CurrentTarget = PotentialTarget
                                                    CurrentTargetValue = LandValue
                                                    CurrentVictoryPotential = VictoryPotential
                                                    CurrentBase = PotentialBase
                                                Else 'Province belongs to a Kingdom
                                                    RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                    If RelatesWithOwner = MIN_RELATES Then
                                                        CurrentTarget = PotentialTarget
                                                        CurrentTargetValue = LandValue
                                                        CurrentVictoryPotential = VictoryPotential
                                                        CurrentBase = PotentialBase
                                                    Else ' if isn't actively belligerant
                                                        RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                        AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                        If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                            MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                               & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                        End If ' Player is involved
                                                    End If '  actively belligerant
                                                End If 'Belongs to a Kingdom
                                                'CurrentTarget = PotentialTarget
                                                'CurrentTargetValue = RentValue
                                                'CurrentVictoryPotential = VictoryPotential
                                                'CurrentBase = PotentialBase
                                            End If
                                        End If 'Rents here > current target
                                    End If 'treasure > rents
                                End If ' half a chance of victory
                            End If ' have people to resettle

                        End If ' isn't one of own provinces
                    Else 'if is a Sea connection
                        If Province(PotentialBase).Connectors(i) = SEALANE Then
                            If Government(ActiveGov).NavalCapability > 0 Then
                                PotentialConnectingSeaArea = Province(PotentialBase).Neighbors(i)
                                PotentialConnectingSea = Area(PotentialConnectingSeaArea).Province
                                If Sea(PotentialConnectingSea).Topography >= -(Government(ActiveGov).NavalCapability) Then
                                    For j = 0 To MAX_NEIGHBORS_SEA - 1
                                        If Sea(PotentialConnectingSea).Neighbors(j) >= 0 Then
                                            PotentialTargetArea = Sea(PotentialConnectingSea).Neighbors(j)
                                            If Area(PotentialTargetArea).Type >= LAND Then
                                                PotentialTarget = Area(PotentialTargetArea).Province
                                                If Province(PotentialTarget).ID <> Province(PotentialBase).ID Then 'if not trying to invade itself
                                                    If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then
                                                        TerrainModifier = Province(PotentialTarget).Topography + 1

                                                        AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

                                                        DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

                                                        If DefendingGovernment > 0 Then
                                                            'PlayerDefending = Rand.Next(0, 2) ' can be variable later
                                                            PlayerDefend = True
                                                        Else
                                                            PlayerDefend = False
                                                        End If

                                                        If PlayerDefend Then
                                                            DefendingGeneralship = Government(DefendingGovernment).Generalship
                                                            DefendingArmyState = Government(DefendingGovernment).ArmyState
                                                        Else
                                                            DefendingGeneralship = 0
                                                            DefendingArmyState = 0
                                                        End If

                                                        DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

                                                        VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

                                                        If PeopleToResettle > 0 Then
                                                            LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
                                                            If LandValue > CurrentTargetValue Then
                                                                If VictoryPotential >= CurrentVictoryPotential Then
                                                                    ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                                    If ProvinceOwner = 0 Then 'if is an independent province
                                                                        CurrentTarget = PotentialTarget
                                                                        CurrentTargetValue = LandValue
                                                                        CurrentVictoryPotential = VictoryPotential
                                                                        CurrentBase = PotentialBase
                                                                    Else 'Province belongs to a Kingdom
                                                                        RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                                        If RelatesWithOwner = MIN_RELATES Then
                                                                            CurrentTarget = PotentialTarget
                                                                            CurrentTargetValue = LandValue
                                                                            CurrentVictoryPotential = VictoryPotential
                                                                            CurrentBase = PotentialBase
                                                                        Else ' if isn't actively belligerant
                                                                            RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                                            AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                                            If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                                                MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                                            End If ' Player is involved
                                                                        End If '  actively belligerant
                                                                    End If 'Belongs to a Kingdom
                                                                End If ' is currently most attractive target
                                                            Else
                                                                If LandValue = CurrentTargetValue Then
                                                                    If VictoryPotential > CurrentVictoryPotential Then
                                                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                                        If ProvinceOwner = 0 Then 'if is an independent province
                                                                            CurrentTarget = PotentialTarget
                                                                            CurrentTargetValue = LandValue
                                                                            CurrentVictoryPotential = VictoryPotential
                                                                            CurrentBase = PotentialBase
                                                                        Else 'Province belongs to a Kingdom
                                                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                                            If RelatesWithOwner = MIN_RELATES Then
                                                                                CurrentTarget = PotentialTarget
                                                                                CurrentTargetValue = LandValue
                                                                                CurrentVictoryPotential = VictoryPotential
                                                                                CurrentBase = PotentialBase
                                                                            Else ' if isn't actively belligerant
                                                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                                                    MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                                                End If ' Player is involved
                                                                            End If '  actively belligerant
                                                                        End If 'Belongs to a Kingdom
                                                                        'CurrentTarget = PotentialTarget
                                                                        'CurrentTargetValue = LandValue
                                                                        'CurrentVictoryPotential = VictoryPotential
                                                                        'CurrentBase = PotentialBase
                                                                    End If
                                                                End If
                                                            End If
                                                        Else ' no people to resettle
                                                            If VictoryPotential > 5 Then
                                                                TreasureValue = Province(PotentialTarget).Townspeople
                                                                RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
                                                                If TreasureValue >= RentValue Then
                                                                    If TreasureValue > CurrentTargetValue Then
                                                                        If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
                                                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                                            If ProvinceOwner = 0 Then 'if is an independent province
                                                                                CurrentTarget = PotentialTarget
                                                                                CurrentTargetValue = LandValue
                                                                                CurrentVictoryPotential = VictoryPotential
                                                                                CurrentBase = PotentialBase
                                                                            Else 'Province belongs to a Kingdom
                                                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                                                If RelatesWithOwner = MIN_RELATES Then
                                                                                    CurrentTarget = PotentialTarget
                                                                                    CurrentTargetValue = LandValue
                                                                                    CurrentVictoryPotential = VictoryPotential
                                                                                    CurrentBase = PotentialBase
                                                                                Else ' if isn't actively belligerant
                                                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                                                        MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                                                    End If ' Player is involved
                                                                                End If '  actively belligerant
                                                                            End If 'Belongs to a Kingdom
                                                                            'CurrentTarget = PotentialTarget
                                                                            'CurrentTargetValue = TreasureValue
                                                                            'CurrentVictoryPotential = VictoryPotential
                                                                            'CurrentBase = PotentialBase
                                                                        End If
                                                                    End If
                                                                Else ' if rents more valuable than treasure
                                                                    If RentValue > CurrentTargetValue Then
                                                                        If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
                                                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
                                                                            If ProvinceOwner = 0 Then 'if is an independent province
                                                                                CurrentTarget = PotentialTarget
                                                                                CurrentTargetValue = LandValue
                                                                                CurrentVictoryPotential = VictoryPotential
                                                                                CurrentBase = PotentialBase
                                                                            Else 'Province belongs to a Kingdom
                                                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
                                                                                If RelatesWithOwner = MIN_RELATES Then
                                                                                    CurrentTarget = PotentialTarget
                                                                                    CurrentTargetValue = LandValue
                                                                                    CurrentVictoryPotential = VictoryPotential
                                                                                    CurrentBase = PotentialBase
                                                                                Else ' if isn't actively belligerant
                                                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
                                                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
                                                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
                                                                                        MsgBox("Spies report that " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
                                                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
                                                                                    End If ' Player is involved
                                                                                End If '  actively belligerant
                                                                            End If 'Belongs to a Kingdom
                                                                            'CurrentTarget = PotentialTarget
                                                                            'CurrentTargetValue = RentValue
                                                                            'CurrentVictoryPotential = VictoryPotential
                                                                            'CurrentBase = PotentialBase
                                                                        End If
                                                                    End If 'Rents here > current target
                                                                End If 'treasure > rents
                                                            End If ' half a chance of victory
                                                        End If ' have people to resettle

                                                    End If ' not owned by Active Government 
                                                End If 'not self
                                                'Else ' if neighbor = -1, ie, no more neighbors 'no, this would stop consideration if has sea connect to sea, even if possibly other land beyond
                                                'Exit For
                                            End If ' Land Neighbor to sea zone 
                                        End If ' this possibility is a Province or sea
                                    Next 'next Neighbor of Potential Connecting Sea
                                End If ' if Naval Capable of operation in this type of sea
                            End If ' Government has Naval Capability
                        End If 'Connector is a Sealane (since already checked if Land Connection, only thing left would be -1, no connector
                    End If ' if Neighbor is land connection
                Next ' i/Neighbor
            End If ' province is active government's (so can act as base)
        Next

        If CurrentTarget > -1 Then
            PlayerAction = ATTACKING
            PlayerTarget = CurrentTarget
            PlayerBase = CurrentBase
            If Province(PlayerTarget).PoliticalAffiliation = PlayerSide Then
                MsgBox(Government(ActiveGov).Name & " is attacking " & Province(PlayerTarget).Name & " from " _
                       & Province(PlayerBase).Name)
            End If
            'Else
            'NegotiateAI(ActiveGov)   SPIES !!!!!!
            'MsgBox("The " & GetGovernmentName(ActiveGov) & " will not attack this round. ") ' don't need to know this
        End If

    End Sub

    Sub IncrementConquestVPs(ByVal Province As Integer)
        'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
        ConquestVPs += PROVINCE_VP_VALUE
        RefreshConquestVP_Display()
        AdjustTotalVPs()
        RefreshTotalVP_Display()
        MsgBox(Government(ActiveGovernment).Name & " just gained 1 Victory Point for gaining Control of a Province.")
    End Sub

    Sub DecrementConquestVPs(ByVal Province As Integer)
        'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
        ConquestVPs -= PROVINCE_VP_VALUE
        RefreshConquestVP_Display()
        AdjustTotalVPs()
        RefreshTotalVP_Display()
        MsgBox(Government(PlayerSide).Name & " just lost 1 Victory Point for losing Control of a Province.")
    End Sub

    Sub DetermineNavalValue(ByVal ProvID As Integer)

        'MsgBox("Naval Value Determination Under Construction")
        ' NOTE: if turn this into a function, then need to update Populate Province Info to reflect this
    End Sub


End Module
