﻿Imports System.Math

Module Module3

    Sub AutoTurn()
        Dim ActionLoop As Integer = 0


        For ActionLoop = CurrentAction To TotalActions - 1
            CurrentAction += 1
            ActiveGovernment = ActionQueue(ActionLoop)
            If ActiveGovernment = PlayerSide Then
                frmPlayerControls.ShowDialog()
                Exit For
            Else
                'MsgBox("The " & GetGovernmentName(ActiveGovernment) & " now active: " & CStr(TurnDate) & ", action " & CStr(CurrentAction) & " of " & CStr(TotalActions))
                AttackAI(ActiveGovernment)
                If PlayerTarget > -1 Then
                    Attack(PlayerBase, PlayerTarget)
                    'MsgBox("The " & GetGovernmentName(ActiveGovernment) & " have decided to attack " & Province(PlayerTarget).Name & " from " & Province(PlayerBase).Name)
                Else
                    NegotiateAI(ActiveGovernment)
                End If
            End If

        Next

        If CurrentAction = TotalActions Then
            Try
                WrapUpTurn()
                If TurnDate < ScenarioEndDate - TURN_INTERVAL Then
                    frmBeginTurn.ShowDialog()
                Else
                    EndGame()
                End If
            Catch
                MsgBox("Problem Advancing Turn")
            End Try

        End If

    End Sub


    Sub WrapUpTurn()
        Dim ProvinceNum As Integer
        Dim NameString As String
        Dim StrLength As Integer
        Dim IsLastProvince As Boolean = False
        Dim Rand As New Random
        Dim DieRoll As Integer = -1
        'Dim Size As Integer
        Dim i As Integer = 0
        Dim AdminLoad(TotalGovernments - 1) As Integer

        For i = 1 To TotalGovernments - 1
            AdminLoad(i) = TotalProvincesControlled(i)
        Next

        Randomize()

        For ProvinceNum = 0 To TotalProvinces - 1

            If Province(ProvinceNum).SurplusPopulation > 0 Then

                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                    MsgBox("Famine in " & Province(ProvinceNum).Name & "!  " & Province(ProvinceNum).SurplusPopulation & ",000 people died.")
                End If 'player knows

                Province(ProvinceNum).SurplusPopulation = 0
                DecrementSocialState(ProvinceNum, CHAOS)
                If Province(ProvinceNum).PoliticalAffiliation > LOCAL_CONTROL Then
                    NameString = Government(Province(ProvinceNum).PoliticalAffiliation).Name
                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                        MsgBox("Support for the " & NameString & " Government has declined in " _
                               & Province(ProvinceNum).Name & " because of its inability to secure new lands for its people.")
                    End If 'is player's concern
                    DecrementProvincialLoyalty(ProvinceNum)
                End If
            End If

            If Province(ProvinceNum).Language \ 100 <> 1 And Province(ProvinceNum).Language \ 100 <> 3 Then 'if people aren't Latin speakers or Greek (ie, not used to civ)
                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    DieRoll = Rand.Next(0, 3)
                    If DieRoll > AdminLoad(Province(ProvinceNum).PoliticalAffiliation) Then
                        DecrementProvincialLoyalty(ProvinceNum)
                    End If
                End If

                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    If Government(Province(ProvinceNum).PoliticalAffiliation).Name <> AVARS_STR Then
                        DieRoll = Rand.Next(0, 6)
                        If DieRoll < (Province(ProvinceNum).Farmland \ BASE_PROVINCE_SIZE) \ 2 Then
                            DecrementProvincialLoyalty(ProvinceNum)
                        End If
                    End If
                End If

                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    DieRoll = Rand.Next(0, 6)
                    If DieRoll >= Province(ProvinceNum).Loyalty + 2 Then
                        DecrementProvincialLoyalty(ProvinceNum)
                    End If
                End If
            End If

            If Province(ProvinceNum).Loyalty = REBELLIOUS Then
                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                    NameString = Government(Province(ProvinceNum).PoliticalAffiliation).Name
                    StrLength = NameString.Length
                    MsgBox(Province(ProvinceNum).Name & " has broken free from " & NameString) '.Substring(4, StrLength - 4))
                    DecrementConquestVPs(ProvinceNum)
                    'ConquestVPs -= PROVINCE_VP_VALUE
                    'RefreshConquestVP_Display()
                End If 'player cares
                DecrementSocialState(ProvinceNum, CHAOS)

                If Province(ProvinceNum).PoliticalAffiliation > LOCAL_CONTROL Then
                    IsLastProvince = CheckIfGovernmentEliminated(Province(ProvinceNum).PoliticalAffiliation)
                    If IsLastProvince Then
                        ClearOutLoser(Province(ProvinceNum).PoliticalAffiliation)
                    End If
                    Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL
                End If

            End If ' is rebellious

        Next 'Province

        Autosave()

    End Sub

    Function CreateActionQueue() As Integer
        Dim GovernmentNum As Integer = 0
        Dim Rand As New Random
        'Dim DieRoll As Integer = 0
        Dim Actions(TotalGovernments - 1) As Integer
        Dim TotalActions As Integer = 0
        Dim ActionRound As Integer = 0
        Dim MostActions As Integer = 0
        Dim ActionNumber As Integer = 0
        Dim DieRoll1 As Integer = -1
        Dim DieRoll2 As Integer = -1

        Randomize()

        Actions(0) = 0 'make sure first value in array is 0 because it's the Local gvts

        For GovernmentNum = 1 To TotalGovernments - 1 ' don't do 0 because that's Locals
 
            DieRoll2 = Rand.Next(1, 4) ' was 5) but decreased to avoid > 11 and run off action queue building range (not use 10 and 11)

            Actions(GovernmentNum) = DieRoll2 + Government(GovernmentNum).LeadershipState * 3 'reduced from 4 for same reason; alternative is revise lookup table to include 12
 
            TotalActions += Actions(GovernmentNum)
            Try
                If Actions(GovernmentNum) > MostActions Then
                    MostActions = Actions(GovernmentNum)
                End If
            Catch
                MsgBox("Problem Setting Up Action Sequence")
            End Try
        Next

        ReDim ActionQueue(TotalActions - 1)
        ActionNumber = 0

        If MostActions > 0 Then
            For ActionRound = 1 To MostActions
                For GovernmentNum = 1 To TotalGovernments - 1
                    If CheckIfActs(ActionRound, MostActions, Actions(GovernmentNum)) Then
                        ActionQueue(ActionNumber) = GovernmentNum
                        ActionNumber += 1
                    End If

                Next
            Next
        Else
            MsgBox("No state stable enough to undertake significant actions.")
        End If

        'MsgBox("Action Queue Created")


        Return TotalActions

    End Function

    Function CheckIfActs(ByVal Round As Integer, ByVal TotalRounds As Integer, ByVal TotalGvtActions As Integer) As Boolean
        Dim Acts As Boolean = False

        Select Case Round
            Case 1
                Select Case TotalRounds
                    Case 1
                        If TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 2
                        If TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions <= 7 And TotalGvtActions >= 4 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions <= 8 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions <= 10 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions <= 11 And TotalGvtActions >= 6 Then
                            Acts = True
                        End If
                End Select
            Case 2
                Select Case TotalRounds
                    Case 1
                    Case 2
                        If TotalGvtActions = 2 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 3
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                End Select
            Case 4 ' Current Round of
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                End Select
            Case 5 'current round of 
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 6
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                End Select
            Case 7
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                        If TotalGvtActions <= 7 And TotalGvtActions >= 4 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 8
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                        If TotalGvtActions <= 8 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                End Select
            Case 9
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                End Select
            Case 10
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                    Case 10
                        If TotalGvtActions <= 10 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 11 ' current round, it's the highest, so only possibility
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                    Case 10
                    Case 11
                        If TotalGvtActions <= 11 And TotalGvtActions >= 6 Then
                            Acts = True
                        End If
                End Select
        End Select

        Return Acts

    End Function


    'Function GetGovernmentName(GovernmentID As Integer) As String ' shouldn't need this since Name is a field in record of Governments
    '    Dim GovernmentName As String = ""

    '    Select Case GovernmentID

    '        Case LOCAL_CONTROL
    '            Return "Local" '/" & Province(ProvinceNum).Name.Substring(0, 3)
    '            'Return "0" & CStr(LOCAL_CONTROL) & ": " & "Local" '/" & Province(ProvinceNum).Name.Substring(0, 3)

    '        Case FRANKISH
    '            Return FRANKISH_STRING
    '            'Return "0" & CStr(FRANKISH) & ": " & FRANKISH_STRING

    '        Case VISIGOTHIC
    '            Return VISIGOTHIC_STRING
    '            'Return "0" & CStr(VISIGOTHIC) & ": " & VISIGOTHIC_STRING

    '        Case BURGUNDIAN
    '            Return BURGUNDIAN_STRING
    '            'Return "0" & CStr(BURGUNDIAN) & ": " & BURGUNDIAN_STRING

    '        Case OSTROGOTHS
    '            Return OSTROGOTH_STRING
    '            'Return "0" & CStr(OSTROGOTHS) & ": " & OSTROGOTH_STRING

    '        Case VANDALS
    '            Return VANDAL_STRING
    '            'Return "0" & CStr(VANDALS) & ": " & VANDAL_STRING

    '        Case BYZANTINE
    '            Return BYZANTINE_STRING
    '            'Return "0" & CStr(BYZANTINE) & ": " & BYZANTINE_STRING

    '        Case BASQUES
    '            Return BASQUE_STRING
    '            'Return "0" & CStr(BASQUES) & ": " & BASQUE_STRING

    '        Case ALEMANNI
    '            Return ALEMANNI_STRING
    '            'Return "0" & CStr(ALEMANNI) & ": " & ALEMANNI_STRING

    '        Case SYAGRIAN
    '            Return SYAGRIAN_STRING
    '            'Return "0" & CStr(SYAGRIAN) & ": " & SYAGRIAN_STRING

    '        Case SUEVI ' at this point, into double digits so done't need leading 0
    '            Return SUEVI_STRING
    '            'Return CStr(SUEVI) & ": " & SUEVI_STRING

    '        Case Else
    '            Return OTHER_CONTROLLER_STRING
    '            'Return "4+: " & OTHER_CONTROLLER_STRING
    '    End Select

    'End Function

    'Function GetGovernmentColor(GovernmentID As Integer) As System.Drawing.Color
    '    Dim GovernmentColor As System.Drawing.Color

    '    Select Case GovernmentID

    '        Case 0
    '            GovernmentColor = LOCAL_CONTROL_COLOR

    '        Case POWER_1
    '            GovernmentColor = POWER_1_COLOR

    '        Case POWER_2
    '            GovernmentColor = POWER_2_COLOR

    '        Case POWER_3
    '            GovernmentColor = POWER_3_COLOR

    '        Case POWER_4
    '            GovernmentColor = POWER_4_COLOR

    '        Case POWER_5
    '            GovernmentColor = POWER_5_COLOR

    '        Case POWER_6
    '            GovernmentColor = POWER_6_COLOR

    '        Case POWER_7
    '            GovernmentColor = POWER_7_COLOR

    '        Case POWER_8
    '            GovernmentColor = POWER_8_COLOR

    '        Case POWER_9
    '            GovernmentColor = POWER_9_COLOR

    '        Case POWER_10
    '            GovernmentColor = POWER_10_COLOR

    '        Case POWER_11
    '            GovernmentColor = POWER_11_COLOR

    '        Case POWER_12
    '            GovernmentColor = POWER_12_COLOR

    '        Case POWER_13
    '            GovernmentColor = POWER_13_COLOR

    '        Case POWER_14
    '            GovernmentColor = POWER_14_COLOR

    '        Case Else
    '            GovernmentColor = LOCAL_CONTROL_COLOR
    '    End Select

    '    Return GovernmentColor

    'End Function

    'Function GetAbilityNames(AbilityLevel As Integer) As String
    '    Dim AbilityName As String = ""

    '    Select Case AbilityLevel

    '        Case GENIUS
    '            Return GENIUS_STR

    '        Case TALENTED
    '            Return TALENTED_STR

    '        Case MEDIOCRE
    '            Return MEDIOCRE_STR

    '        Case INEPT
    '            Return INEPT_STR

    '        Case DISASTROUS
    '            Return DISASTROUS_STR

    '        Case UNDEFINED
    '            Return UNDEFINED_STR

    '        Case Else
    '            Return "Problem finding word"
    '    End Select

    'End Function

    Function CalculateTotalBenefices(ByVal ProvinceNumber As Integer) As Integer
        Dim TotalBenefices As Integer = 0

        TotalBenefices = Province(ProvinceNumber).Peasants \ PEASANTS_PER_BENEFICE

        Return TotalBenefices

    End Function

    Function CalculateRoyalEstates(ByVal ProvinceNumber As Integer)
        Dim RoyalEstates As Integer = 0

        RoyalEstates = CalculateTotalBenefices(ProvinceNumber) = Province(ProvinceNumber).Nobles + Province(ProvinceNumber).Clergy

        Return RoyalEstates

    End Function

    Sub CalcGovernmentResources()
        Dim ProvinceNum As Integer = 0
        Dim Suzarien As Integer = 0

        For Suzarien = 0 To TotalGovernments - 1
            If Government(Suzarien).Name <> ELIMINATED_POWER_STRING Then
                Government(Suzarien).TotalBenefices = 0
                Government(Suzarien).RoyalEstates = 0
                Government(Suzarien).Cavalary = 1
            End If
        Next

        For ProvinceNum = 0 To TotalProvinces - 1

            Suzarien = Province(ProvinceNum).PoliticalAffiliation

            If Suzarien > 0 Then
                Government(Suzarien).Treasury += Province(ProvinceNum).Townspeople
                Government(Suzarien).TotalBenefices += CalculateTotalBenefices(ProvinceNum)
                Government(Suzarien).RoyalEstates += CalculateRoyalEstates(ProvinceNum)
                Government(Suzarien).Cavalary += GetLocalKnights(ProvinceNum)
                'Government(Suzarien).Infantry += Government(Suzarien).TotalBenefices - Province(ProvinceNum).Nobles + Province(ProvinceNum).Peasants Mod 25
            End If

        Next

    End Sub

    Sub DetermineLeadershipStates()
        Dim GovernmentNum As Integer = 0
        Dim DieRoll1 As Integer = 0
        Dim DieRoll2 As Integer = 0
        Dim Rand As New Random
        Dim SpecialLeader As Integer = UNDEFINED
        Dim SpecialGeneral As Integer = UNDEFINED
        Dim SpecialPolitician As Integer = UNDEFINED
        Dim SpecialPatron As Integer = UNDEFINED

        Randomize()

        For GovernmentNum = 1 To TotalGovernments - 1

            SpecialLeader = DetermineIfSpecialLeader(GovernmentNum)
            If SpecialLeader = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 11)
                Select Case DieRoll1
                    Case 1, 2, 3, 4
                        Government(GovernmentNum).LeadershipState = DISARRAY
                    Case 5, 6, 7, 8, 9
                        Government(GovernmentNum).LeadershipState = LACKLUSTER
                    Case 10
                        Government(GovernmentNum).LeadershipState = VIGOROUS
                        'Case Else
                        '    Government(GovernmentNum).LeadershipState = 3 ' this is in case add bonus for develop bureaucracy

                        ' or can add even more, or make 1, 2, 3 = Dim BaseLeadershipState = 0, BaseLeadershipState + 1
                End Select
            Else
                Government(GovernmentNum).LeadershipState = SpecialLeader
            End If

            SpecialGeneral = DetermineIfSpecialGeneral(GovernmentNum)
            If SpecialGeneral = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    Case 1
                        Government(GovernmentNum).Generalship = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).Generalship = INEPT
                    Case 5, 6, 7, 8, 9, 10
                        Government(GovernmentNum).Generalship = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).Generalship = TALENTED
                    Case 14
                        Government(GovernmentNum).Generalship = GENIUS
                End Select
            Else
                Government(GovernmentNum).Generalship = SpecialGeneral
            End If

            SpecialPolitician = DetermineIfSpecialPolitician(GovernmentNum)
            If SpecialPolitician = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    Case 1
                        Government(GovernmentNum).PoliticalSavvy = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).PoliticalSavvy = INEPT
                    Case 5, 6, 7, 8, 9, 10
                        Government(GovernmentNum).PoliticalSavvy = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).PoliticalSavvy = TALENTED
                    Case 14
                        Government(GovernmentNum).PoliticalSavvy = GENIUS
                End Select
            Else
                Government(GovernmentNum).PoliticalSavvy = SpecialPolitician
            End If


            'STILL NEED TO PUT "TASTE" INTO GOVERNMENT DATA STRUCTURE; Activate this when do!

            'SpecialPatron = DetermineIfSpecialPatron(GovernmentNum) 

            'If SpecialGeneral = UNDEFINED Then
            '    DieRoll1 = Rand.Next(1, 15)
            '    Select Case DieRoll1
            '        Case 1
            '            Government(GovernmentNum).LeadershipState = DISASTROUS
            '        Case 2, 3, 4
            '            Government(GovernmentNum).LeadershipState = INEPT
            '        Case 5, 6, 7, 8, 9, 10
            '            Government(GovernmentNum).LeadershipState = MEDIOCRE
            '        Case 11, 12, 13
            '            Government(GovernmentNum).LeadershipState = TALENTED
            '        Case 14
            '            Government(GovernmentNum).LeadershipState = GENIUS
            '    End Select
            'Else
            '    Government(GovernmentNum).Generalship = SpecialGeneral
            'End If

        Next

    End Sub

    Function DetermineIfSpecialLeader(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate
            Case 500
                If GovNum = FranksID Then 'Clovis continued
                    IsSpecial = VIGOROUS
                End If
                If GovNum = EasternEmpireID Then 'E Empire stirs
                    IsSpecial = LACKLUSTER
                End If
            Case 520
                If GovNum = FranksID Then 'Clovis' sons, who cooperated, beat Burgundians (keep from being disarray)
                    IsSpecial = LACKLUSTER
                End If
                If GovNum = EasternEmpireID Then 'Justinian
                    IsSpecial = VIGOROUS
                End If
            Case 540
                If GovNum = EasternEmpireID Then 'Justinian
                    IsSpecial = VIGOROUS
                End If
            Case 560
                If GovNum = FranksID Then
                    IsSpecial = DISARRAY
                End If
        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialGeneral(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate
            Case 500 'Clovis
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
                If GovNum = EasternEmpireID Then
                    IsSpecial = TALENTED
                End If
            Case 520 'Clovis's sons
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = TALENTED
                End If
                If GovNum = EasternEmpireID Then
                    IsSpecial = GENIUS
                End If
            Case 540
                If GovNum = EasternEmpireID Then
                    IsSpecial = GENIUS
                End If
            Case 720 'Charles Martel
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 720 'Charles Martel
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 760 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 780 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 800 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialPolitician(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate
            Case 500
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = TALENTED
                End If
            Case 520
                If GovNum = EasternEmpireID Then
                    IsSpecial = GENIUS
                End If
            Case 720 'Charles Martel
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 740 'Pepin the Younger
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 760 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 780 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 800 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialPatron(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate
            Case 760 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 780 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
            Case 800 'Charlemagne
                If Government(GovNum).Name = FrankishStr Then
                    IsSpecial = GENIUS
                End If
                'Case 500
                'If GovNum = FRANKISH Then
                '    IsSpecial = True
                'End If
        End Select

        Return IsSpecial

    End Function

    'Function GetProvincialMilitia(ByVal ProvinceNum As Integer) As Integer
    '    Dim Strength As Integer = 0
    '    Dim FreePeasants As Integer = 0
    '    Dim Militia As Integer = 0
    '    Dim LocalNobles As Integer = 0

    '    FreePeasants = Province(ProvinceNum).Peasants - ((PEASANTS_PER_BENEFICE * Province(ProvinceNum).Nobles) + (PEASANTS_PER_BENEFICE * Province(ProvinceNum).Clergy))
    '    If FreePeasants < PEASANTS_PER_BENEFICE Then ' if residual unfree, don't count them as free
    '        FreePeasants = 0
    '    End If

    '    Militia = FreePeasants \ WARRIOR_RATIO

    '    ' need to insure that there's at least one defender, and if there are no local nobles, it's the local militia
    '    If Militia = 0 And Province(ProvinceNum).Nobles = 0 Then
    '        Militia = 1
    '    End If

    '    Return Militia

    'End Function

    'Function GetLocalKnights(ByVal ProvinceNum As Integer) As Integer ' NOTE that this returns 10x the number in standard game units (so 6 = .6)
    '    Dim LocalKnights As Integer

    '    LocalKnights = 10 * Province(ProvinceNum).Nobles / WARRIOR_RATIO 'SHOULDN'T THIS BE \, NOT *?? '* 30 \ WARRIOR_RATIO

    '    ' need to insure that there's at least one defender, and if there are any local nobles, it'll be them
    '    If LocalKnights = 0 And Province(ProvinceNum).Nobles > 0 Then
    '        LocalKnights = 1
    '    End If

    '    Return LocalKnights

    'End Function

    Sub SetActionTarget(sender As Object)
        Dim Decision As Microsoft.VisualBasic.MsgBoxResult
        Dim TargetTextbox As System.Windows.Forms.TextBox
        'Dim CurrentFont As System.Drawing.Font
        Dim Relations As Integer = UNDEFINED
        Dim MsgStr As String = ""
        Dim Rand As New Random
        Dim DieRoll As Integer = 0
        Dim OtherPower As Integer = 0

        Select Case PlayerAction

            Case ATTACKING
                Select Case ActionPhase

                    Case DESIGNATE_ACTION_TARGET
                        If SelectedType = LAND Then
                            If Province(SelectedArea).PoliticalAffiliation <> ActiveGovernment Then
                                If SeeIfNeighbor(SelectedArea, ActiveGovernment) Then
                                    OtherPower = Province(SelectedArea).PoliticalAffiliation
                                    Relations = Government(ActiveGovernment).DiplomaticRelations(OtherPower)
                                    If Relations > HOSTILE Then
                                        MsgStr = "Your relations with " & Government(OtherPower).Name & _
                                            " are currently " & DescribeDiploRelations(ActiveGovernment, OtherPower) & vbCrLf & vbCrLf
                                        MsgStr &= "If you attack when Relations are better than Hostile, you will damage your Reputation, making it harder to come to agreements with other Powers in the future, "
                                        MsgStr &= "and possibly strengthen the resolve of the " & Government(OtherPower).Name & " army." & vbCrLf & vbCrLf
                                        MsgStr &= "To avoid this, you can create a Dispute that will reduce your Relations to Hostile, but it will delay your Attack." & vbCrLf & vbCrLf
                                        MsgStr &= "DO YOU WANT TO SWITCH FROM ATTACKING TO CREATING A DISPUTE?" & vbCrLf & vbCrLf
                                        MsgStr &= "Click YES to Create a Dispute instead of Attacking; click NO to continue with the Attack; click Cancel to do something else entirely."
                                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Betray the " & Government(Province(SelectedArea).PoliticalAffiliation).Name & "?")
                                        Select Case Decision
                                            Case MsgBoxResult.Yes
                                                AdjustDiploRelates(ActiveGovernment, OtherPower, HOSTILE)
                                                MsgBox("Your provocations have worked; relations between the " & Government(ActiveGovernment).Name & " and the " & Government(OtherPower).Name & _
                                                       " have become Hostile.")
                                                ConcludeAction()
                                                Exit Sub
                                            Case MsgBoxResult.No
                                                Randomize()
                                                DieRoll = Rand.Next(0, Relations + 2) 'NOTE that this assumes 3 levels of relations only; will have to be adjusted for 5
                                                If DieRoll > 0 Then
                                                    IncrementArmyState(OtherPower)
                                                End If
                                                DecrementReputation(ActiveGovernment, Relations - HOSTILE)
                                                AdjustDiploRelates(ActiveGovernment, OtherPower, HOSTILE)
                                            Case MsgBoxResult.Cancel
                                                CancelAction()
                                                Exit Sub
                                        End Select
                                    End If
                                    PlayerTarget = SelectedArea
                                    TargetBox = sender
                                    TargetTextbox = TargetBox
                                    'TargetTextbox.ForeColor = Color.Red
                                    TargetTextbox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Bold)
                                    ActionPhase = 2
                                    frmMapScreen.lblCurrentPhase.Text = SELECT_BASE_STRING
                                    frmMapScreen.lblCurrentPhase.Refresh()
                                    If TurnDate = ScenarioStartDate And CurrentAction < (TotalActions / 2) Then
                                        MsgBox("Now Click on the Province you want to attack FROM.")
                                    Else
                                        If PromptSelectBase = True Then
                                            MsgStr = "Now Click on the Province you want to attack FROM!" & DOUBLE_SPACE
                                            MsgStr &= "(Click OK to Go On Now and Continue Showing this Prompt in the Future, " & vbCrLf & "or CANCEL to Go On but Stop Showing This Prompt.)"
                                            Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Prompt Select Target")
                                            If Decision = MsgBoxResult.Cancel Then
                                                Decision = MsgBox("Warning: Once you stop Showing the Prompt, you can't get it back.  You should only Stop it When you're Certain you'll know what you need to do at this Point in Future Attack Actions.  You can always Stop it Later.  Are you Sure you want to Stop It Now?  ", MsgBoxStyle.YesNo, "Confirm Stop Prompt")
                                                If Decision = MsgBoxResult.Yes Then
                                                    PromptSelectBase = False
                                                End If
                                            End If ' If want stop showingSelectBasePrompt
                                        End If ' If ShowSelectBase is True
                                    End If
                                Else
                                    MsgBox("You can't attack that Province; you need to control an adjacent Province to Attack from")

                                End If 'is neighbor
                                Else
                                    MsgBox("You can't Attack your own Province; try Ruling instead.")
                                End If
                            'Else
                            '    MsgBox("You can't attack water")
                        End If
                    Case DESIGNATE_ATTACK_BASE
                        If SelectedType = LAND Then
                            If Province(SelectedArea).PoliticalAffiliation = ActiveGovernment Then
                                If SeeIfNeighbor(SelectedArea, PlayerTarget) Then
                                    PlayerBase = SelectedArea
                                    BaseBox = sender
                                    ActionPhase = 3
                                    'Decision = MsgBox("Are you sure you want to attack " & Province(PlayerTarget).Name & " from " & Province(PlayerBase).Name _
                                    '                      , MsgBoxStyle.YesNo, "Confirm Attack")
                                    'If Decision = Microsoft.VisualBasic.MsgBoxResult.Yes Then

                                    Attack(PlayerBase, PlayerTarget)

                                    'Else
                                    '    CancelAction()
                                    'End If

                                Else
                                    MsgBox("You can't Attack from that Province because it's not adjacent to the target.")
                                End If
                            Else
                                MsgBox("You can't Attack from a Province you don't Control.")
                            End If
                            'Else
                            '    MsgBox("You can't attack water")
                        End If
                    Case Else
                        MsgBox("Action Phase too high")

                End Select

            Case Else
                MsgBox("Action under construction")

        End Select



    End Sub

    Function SeeIfNeighbor(ProvinceOfInterest As Integer, TargetValue As Integer) As Boolean
        Dim PotentialTarget As Integer = -1
        Dim PotentialTargetArea As Integer = -1
        Dim i As Integer = 0
        Dim IsNeighbor As Boolean = False
        Dim PotentialTargetValue As Integer

        IsNeighbor = False

        For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move by land
            If Province(ProvinceOfInterest).Connectors(i) >= RIVER Then ' if neighbor is land connection
                PotentialTargetArea = Province(ProvinceOfInterest).Neighbors(i)
                PotentialTarget = Area(PotentialTargetArea).Province
                Select Case ActionPhase
                    Case DESIGNATE_ACTION_TARGET
                        PotentialTargetValue = Province(PotentialTarget).PoliticalAffiliation
                    Case DESIGNATE_ATTACK_BASE
                        PotentialTargetValue = Province(PotentialTarget).ID
                End Select

                If PotentialTargetValue = TargetValue Then
                    IsNeighbor = True
                    Exit For
                End If ' is one of your provinces
            Else ' check about sea

            End If ' is land connection
        Next

        'Need to put in check if by sea

        Return IsNeighbor ' if don't find a neighbor belonging to player

    End Function

    Sub CancelAction()

        MsgBox("Action Cancelled. Select a New One.")
        Try
            If PlayerTarget >= 0 Then
                TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
            End If
        Catch
        End Try

        If PlayerAction = RULING Then
            ToggleRuleControls(True) 'these'll go off since this saying they're currently on
        End If
        PlayerAction = NO_ACTION
        frmMapScreen.lblPlayerAction.Text = NO_SELECTION_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhase.Text = NO_SELECTION_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhaselbl.Text = ATTACK_PHASE_LBL
        frmMapScreen.lblCurrentPhaselbl.Refresh()
        ActionPhase = 0
        PlayerTarget = -1
        PlayerBase = -1

    End Sub

    'Sub Attack(ByVal Base As Integer, ByVal Target As Integer)
    '    Dim DieRoll1 As Integer = 0
    '    Dim DieRoll2 As Integer = 0
    '    'Dim DieRoll3 As Integer
    '    Dim DiceRoll As Integer = 0
    '    'Dim Modifiers As Integer
    '    Dim AttackFactor As Integer = 0
    '    Dim DefenseFactor As Integer = 0
    '    Dim PlayerDefending As Boolean = False
    '    Dim DefendingGeneralship As Integer = 0
    '    Dim DefendingGovernment As Integer = 0
    '    Dim DefendingArmyState As Integer = 0
    '    Dim Random10 As Integer = 0
    '    Dim DiceRoll2Decimal As Integer = 0
    '    Dim VictoryThreshhold As Integer
    '    Dim Rand As New Random
    '    Dim MsgStr As String
    '    Dim AI_Thinking As Boolean = False 'so when calc AF and DF knows to report it
    '    Dim DefenderEliminated As Boolean = False 'needed so autonomous provinces will be handled correctly below


    '    PlayerDefending = False 'so don't carry over 

    '    Randomize()

    '    AttackFactor = CalculateAttackFactor(Base, Target, AI_Thinking)

    '    DefendingGovernment = Province(Target).PoliticalAffiliation

    '    Government(DefendingGovernment).DiplomaticRelations(ActiveGovernment) = MIN_RELATES

    '    If DefendingGovernment > 0 Then
    '        'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '        PlayerDefending = True
    '    End If

    '    If PlayerDefending Then
    '        DefendingGeneralship = Government(DefendingGovernment).Generalship
    '        DefendingArmyState = Government(DefendingGovernment).ArmyState
    '    Else
    '        If (Province(Target).Language >= GERMANIC) And (Province(Target).Language < GREEK) Then ' becaause Germans so warlike 
    '            DefendingGeneralship = Rand.Next(1, 3)
    '            DefendingArmyState = Rand.Next(1, 3)
    '        Else
    '            DefendingGeneralship = Rand.Next(0, 5) - 2
    '            DefendingArmyState = Rand.Next(0, 5) - 2
    '        End If
    '    End If

    '    DefenseFactor = CalculateDefenseFactor(Target, PlayerDefending, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '    VictoryThreshhold = ApplyCombatModifiers(AttackFactor, DefenseFactor, Target, Base, DefendingGeneralship, DefendingArmyState)

    '    If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '        If VictoryThreshhold < 10 Then
    '            MsgStr = "The Attacker has a " & VictoryThreshhold & "0% chance of winning."
    '            MsgBox(MsgStr)
    '        Else
    '            MsgStr = ""
    '        End If
    '    Else
    '        MsgStr = ""
    '    End If

    '    Random10 = Rand.Next(1, 11)

    '    If Random10 <= VictoryThreshhold Then ' Defender Retreats
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            If VictoryThreshhold < 10 Then
    '                MsgStr = MsgStr & vbCrLf & vbCrLf & " The Attack Succeeded! " & vbCrLf & vbCrLf
    '                'Else
    '                '    MsgStr = "The Attacking forces are overwhelming! " & vbCrLf
    '            End If
    '        End If ' is player's concern
    '        MsgStr = MsgStr & "The " & Government(ActiveGovernment).Name & " take " & Province(Target).Name & vbCrLf
    '        MsgBox(MsgStr)

    '        ProvinceChangesHands(Target)

    '        ' Check if this was the last province the defender controlled
    '        If DefendingGovernment > LOCAL_CONTROL Then 'don't worry about this if autonomous province
    '            DefenderEliminated = CheckIfGovernmentEliminated(DefendingGovernment)
    '        End If ' Defender is a state

    '        If DefenderEliminated = False Then
    '            DecrementArmyState(DefendingGovernment)
    '            If PlayerDefending Then
    '                MsgStr = "The Defending Army's Morale declines to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "." & vbCrLf & vbCrLf
    '            Else
    '                MsgStr = ""
    '            End If
    '        Else 'Defender Was Eliminated
    '            MsgStr = "The " & Government(DefendingGovernment).Name & " have been eliminated." & vbCrLf & vbCrLf
    '            ClearOutLoser(DefendingGovernment)
    '        End If ' if defender NOT eliminated

    '        IncrementArmyState(ActiveGovernment)
    '        IncrementSocialState(Base, PROSPEROUS)

    '        MsgStr &= " The Attacking Army's Morale improved to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", " & vbCrLf _
    '                        & "and the Social State of " & Province(PlayerBase).Name & " rose to " & DescribeSocialState(Province(PlayerBase).SocialState) & "."
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgBox(MsgStr)
    '        End If

    '    Else 'Defender Holds
    '        'If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '        '    'If VictoryThreshhold > 0 Then
    '        '    '    MsgStr = MsgStr & "The result is " & Random10 & "! " & vbCrLf
    '        '    'End If
    '        'End If
    '        MsgStr = MsgStr & "The " & Government(ActiveGovernment).Name & " failed to take " & Province(Target).Name & "!" & vbCrLf & vbCrLf
    '        MsgBox(MsgStr)
    '        IncrementArmyState(Government(DefendingGovernment).ID)
    '        If PlayerDefending Then
    '            MsgStr = "The Defending Army's Morale improves to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "!" & vbCrLf
    '        Else
    '            MsgStr = ""
    '        End If
    '        DecrementArmyState(Government(ActiveGovernment).ID)
    '        DecrementSocialState(Province(Base).ID, CHAOS)
    '        If ActiveGovernment = PlayerSide Then
    '            DecrementSocialVPs(Province(Base).SocialState)
    '            'SocialVPs -= SOCIAL_STATE_VP_VALUE
    '            'RefreshSocialStateVP_Display()
    '        End If
    '        MsgStr = MsgStr & "the Attacking Army's Morale declines to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", " _
    '            & "and the Social State of " & Province(PlayerBase).Name & " drops to " & DescribeSocialState(Province(PlayerBase).SocialState) & "."
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgBox(MsgStr)
    '        End If
    '    End If

    '    ConcludeAction() '(DefendingGovernment)

    'End Sub

    'Function CalculateAttackFactor(ByVal Base As Integer, ByVal Target As Integer, ByVal AI_Thinking As Boolean) As Integer
    '    Dim TerrainModifier, AttackingInfantry, AttackingCavalry, AttackFactor As Integer
    '    Dim AttackingCavalryValue, AttackingInfantryValue As Integer
    '    Dim MsgStr As String

    '    TerrainModifier = Province(Target).Topography + 1

    '    AttackingInfantry = GetProvincialMilitia(Base) + Government(ActiveGovernment).Infantry
    '    AttackingInfantryValue = AttackingInfantry
    '    AttackingCavalry = (Government(ActiveGovernment).Cavalary) 'check on the effects of the multiplication
    '    AttackingCavalryValue = AttackingCavalry \ TerrainModifier 'check on the effects of the multiplication
    '    If AttackingCavalryValue < 1 Then AttackingCavalryValue = 1 'so at least 1 to avoid divide by 0 error
    '    AttackFactor = AttackingInfantryValue + AttackingCavalryValue

    '    If AI_Thinking = False Then
    '        If ActiveGovernment = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '            MsgStr = "Attacking force: " & AttackingInfantry & "000 Infantry and " & AttackingCavalry & "00 Cavalry led by a " _
    '                & GetAbilityNames(Government(ActiveGovernment).Generalship) & " General." & vbCrLf
    '            If Government(ActiveGovernment).ArmyState < 0 Then
    '                MsgStr = MsgStr & "The Attackers' morale is low." & vbCrLf
    '            ElseIf Government(ActiveGovernment).ArmyState > 0 Then
    '                MsgStr = MsgStr & "The Attackers' morale is high." & vbCrLf
    '            End If
    '            If TerrainModifier > 1 And AttackingCavalry > 0 Then
    '                MsgStr = MsgStr & "Difficult terrain hinders the attacking Cavalry." & vbCrLf
    '            End If
    '            If Province(Base).SocialState < 0 Then
    '                MsgStr = MsgStr & "The Attackers' Base is in disarray. "
    '            End If
    '            MsgBox(MsgStr)
    '        End If
    '    End If ' AI thinking?

    '    Return AttackFactor

    'End Function

    'Function CalculateDefenseFactor(ByVal Target As Integer, ByVal PlayerDef As Boolean, ByVal DefendingGen As Integer, _
    '                                ByVal DefendingArmyVal As Integer, AI_Thinking As Boolean) As Integer
    '    Dim DefendingGovernment, RoyalInfantry, TerrainModifier As Integer
    '    Dim DefendingCavalry, FortificationModifier, DefenseFactor, DefendingInfantry As Integer
    '    Dim DefendingCavalryValue, DefendingInfantryValue As Integer
    '    Dim MsgStr As String

    '    TerrainModifier = Province(Target).Topography + 1

    '    If PlayerDef Then
    '        DefendingGovernment = Province(Target).PoliticalAffiliation
    '        RoyalInfantry = Government(DefendingGovernment).Infantry
    '        DefendingCavalry = (Government(DefendingGovernment).Cavalary)
    '        DefendingCavalryValue = DefendingCavalry \ TerrainModifier
    '    Else
    '        DefendingCavalry = GetLocalKnights(Target)
    '        DefendingCavalryValue = DefendingCavalry \ TerrainModifier
    '        RoyalInfantry = 0
    '    End If
    '    If DefendingCavalryValue < 1 Then DefendingCavalryValue = 1 ' avoid divide by 0

    '    FortificationModifier = 0 'Province(PlayerTarget).Fortifications ' needs to be added in!!!

    '    DefendingInfantry = (GetProvincialMilitia(Target) + RoyalInfantry)
    '    DefendingInfantryValue = DefendingInfantry * (TerrainModifier + FortificationModifier)

    '    DefenseFactor = DefendingCavalryValue + DefendingInfantryValue

    '    If AI_Thinking = False Then
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgStr = "Defending force: " & DefendingInfantry & "000 Infantry and " & DefendingCavalry & "00 Cavalry led by a " _
    '                & GetAbilityNames(DefendingGen) & " General." & vbCrLf
    '            If DefendingArmyVal < 0 Then
    '                MsgStr = MsgStr & "The Defenders' morale is low." & vbCrLf
    '            ElseIf DefendingArmyVal > 0 Then
    '                MsgStr = MsgStr & "The Defenders' morale is high." & vbCrLf
    '            End If
    '            If TerrainModifier > 1 And DefendingInfantry > 0 Then
    '                MsgStr = MsgStr & "The Terrain favors the defending Infantry." & vbCrLf
    '            End If
    '            If FortificationModifier > 0 And DefendingInfantry > 0 Then
    '                MsgStr = MsgStr & "The Province's Fortifications aid the defending Infantry." & vbCrLf
    '            End If
    '            If Province(Target).SocialState < 0 Then
    '                MsgStr = MsgStr & " The Province itself is in disarray. "
    '            End If
    '            MsgBox(MsgStr)
    '        End If
    '    End If 'is AI thinking

    '    Return DefenseFactor

    'End Function

    'Function ApplyCombatModifiers(ByVal AttackFactor As Integer, ByVal DefenseFactor As Integer, ByVal Target As Integer, _
    '                              ByVal Base As Integer, ByVal DefendingGen As Integer, ByVal DefendingArmyVal As Integer) As Integer
    '    Dim VictoryThreshhold, ForceRatio As Integer

    '    VictoryThreshhold = 5

    '    If AttackFactor >= DefenseFactor Then
    '        ForceRatio = AttackFactor \ DefenseFactor
    '        ForceRatio -= 1 'so 1:1 = no modifier up or down
    '    Else
    '        If AttackFactor < 1 Then
    '            AttackFactor = 1
    '        End If
    '        ForceRatio = -1 * (DefenseFactor \ AttackFactor)
    '        ForceRatio += 1 ' ditto
    '        End If

    '        VictoryThreshhold += ForceRatio

    '        VictoryThreshhold += Government(ActiveGovernment).Generalship - DefendingGen

    '        'DiceRoll += WeatherByArea(Province(Target).Climate) ' seems questionable as well as well as unnecessarily complicating

    '        VictoryThreshhold += Province(Base).SocialState - Province(Target).SocialState

    '        VictoryThreshhold += Government(ActiveGovernment).ArmyState - DefendingArmyVal

    '        If Province(Target).Farmland \ BASE_PROVINCE_SIZE > 1 Then ' if target area is huge
    '            VictoryThreshhold -= (Province(Target).Farmland \ BASE_PROVINCE_SIZE - 1)
    '        End If

    '        If VictoryThreshhold < 1 Then
    '            VictoryThreshhold = 1
    '        ElseIf VictoryThreshhold > 10 Then
    '            VictoryThreshhold = 10
    '        End If

    '        Return VictoryThreshhold

    'End Function

    'Sub ProvinceChangesHands(Target As Integer)
    '    Dim ProvinceNum As Integer = -1
    '    Dim PopulationTransferred As Integer = 0
    '    Dim Benefices As Integer = 0
    '    Dim OpenBenefices As Integer = 0
    '    Dim Treasure As Integer = 0
    '    Dim Decision As MsgBoxResult '= vbNo
    '    Dim rand As New Random
    '    Dim CoinFlip As Integer

    '    Randomize()

    '    ' Loser loses local knights from target province
    '    Government(Province(Target).PoliticalAffiliation).Cavalary -= GetLocalKnights(Target)

    '    If ActiveGovernment = PlayerSide Then
    '        IncrementConquestVPs(Target)
    '        'ConquestVPs += PROVINCE_VP_VALUE
    '        'RefreshConquestVP_Display()
    '    Else
    '        If Province(Target).PoliticalAffiliation = PlayerSide Then
    '            DecrementConquestVPs(Target)
    '            'ConquestVPs -= PROVINCE_VP_VALUE
    '            'RefreshConquestVP_Display()
    '        End If
    '    End If

    '    Province(Target).PoliticalAffiliation = ActiveGovernment

    '    'Loyalty will be the inverse of what it was before; the stronger it liked the old regime, the less it will like the new, and vice versa
    '    Province(Target).Loyalty = -1 * Province(Target).Loyalty

    '    If ActiveGovernment <> PlayerSide Then 'have to set target's textbox since player didn't click on it
    '        SetTargetTextbox(Target)
    '        'For Each frmMapScreen.ctrl In frmMapScreen.Controls
    '        '    If frmMapScreen.ctrl.Name = Area(Province(Target).AreaNumber).MapElement Then
    '        '        TargetBox = frmMapScreen.ctrl
    '        '        Exit For
    '        '    End If
    '        'Next
    '    End If

    '    ChangeTextboxAffiliation(ActiveGovernment)

    '    If ActiveGovernment = PlayerSide Then
    '        DecideHowHandleTreasure(Target)
    '    Else
    '        'MsgBox("Need to set up whether non-player side pillages.")
    '    End If

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        PopulationTransferred = 0
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment And ProvinceNum <> Target And Province(ProvinceNum).SurplusPopulation > 0 Then
    '            If Province(Target).Peasants < Province(Target).Farmland Then
    '                While Province(ProvinceNum).SurplusPopulation > 0 And Province(Target).Peasants < Province(Target).Farmland
    '                    Province(ProvinceNum).SurplusPopulation -= 1
    '                    Province(Target).Peasants += 1
    '                    PopulationTransferred += 1
    '                End While
    '                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '                    MsgBox(CStr(PopulationTransferred) & ",000 people have migrated from " & Province(ProvinceNum).Name _
    '                               & " to " & Province(Target).Name)
    '                End If
    '            End If ' Target Province has space for immigrants

    '            PopulationTransferred = 0

    '            If Province(ProvinceNum).SurplusPopulation > 0 Then ' this isn't done as "else" because also used for "spillover" from peaceful transfer, above
    '                PopulationTransferred = 0
    '                If ActiveGovernment = PlayerSide Then
    '                    Decision = MsgBox(CStr(Province(ProvinceNum).SurplusPopulation) & " people in " & Province(ProvinceNum).Name _
    '                        & " need land, but there is no room in " & Province(Target).Name & ", so letting them move in will displace some locals and anger the rest. " _
    '                        & "However, if your people can't move somewhere eventually, support for your government will decline. " & vbCrLf _
    '                        & "DO YOU WANT TO ALLOW THE MIGRATION?", MsgBoxStyle.YesNo, "Displace Locals?")
    '                Else
    '                    CoinFlip = rand.Next(0, 2)
    '                    If CoinFlip = 1 Then
    '                        Decision = vbYes
    '                    Else
    '                        Decision = vbNo
    '                    End If
    '                End If ' the player is active

    '                If Decision = vbYes Then
    '                    While Province(ProvinceNum).SurplusPopulation > 0
    '                        Province(ProvinceNum).SurplusPopulation -= 1
    '                        Province(Target).SurplusPopulation += 1
    '                        DecrementSocialState(Target, CHAOS)
    '                        PopulationTransferred += 1
    '                    End While

    '                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '                        MsgBox(CStr(PopulationTransferred) & ",000 people have migrated from " & Province(ProvinceNum).Name _
    '                                    & " to " & Province(Target).Name & ", displacing an equal number of locals.")
    '                        If Province(Target).SocialState < 0 Then
    '                            MsgBox("Conditions in " & Province(Target).Name & " have become " & DescribeSocialState(Province(Target).SocialState))
    '                        End If
    '                    End If ' player cares
    '                End If ' player goes ahead and transfers population to the target
    '            End If ' if the province (still) has surplus population
    '        End If ' This province is the player's and has surplus population
    '    Next

    '    If ActiveGovernment = PlayerSide Then
    '        DecideHowHandleBenefices(Target)
    '    Else
    '        'MsgBox("Need to set up how non-player side handles land.")
    '    End If

    '    ' Winner gets local knights if has their support
    '    If Province(Target).Loyalty > 0 Then
    '        Government(ActiveGovernment).Cavalary += GetLocalKnights(Target)
    '        If Province(Target).PoliticalAffiliation = PlayerSide Then
    '            MsgBox("The local nobles have joined the " & Government(ActiveGovernment).Name & " army!")
    '        End If ' Player cares
    '    End If

    'End Sub

    'Function CheckIfGovernmentEliminated(ByVal WhichGvt As Integer) As Boolean
    '    Dim Eliminated As Boolean = True 'hypothesize it was eliminated; now test to see if any provinces affiliated
    '    Dim i As Integer

    '    For i = 0 To TotalProvinces - 1
    '        If Province(i).PoliticalAffiliation = WhichGvt Then
    '            Eliminated = False
    '            Exit For
    '        End If
    '    Next

    '    Return Eliminated
    'End Function

    'Sub DecrementArmyState(ByVal GovernmentNum As Integer)
    '    If Government(GovernmentNum).ArmyState > INEFFECTUAL Then
    '        Government(GovernmentNum).ArmyState -= 1
    '    End If
    'End Sub

    'Sub IncrementArmyState(ByVal GovernmentNum As Integer)
    '    If Government(GovernmentNum).ArmyState < FANATICAL Then
    '        Government(GovernmentNum).ArmyState += 1
    '    End If
    'End Sub

    Sub DecrementSupportForGovernment(ByVal GovernmentNum As Integer)
        If Government(GovernmentNum).Support > REBELLIOUS Then
            Government(GovernmentNum).Support -= 1
        End If
    End Sub

    Sub IncrementSupportForGovernment(ByVal GovernmentNum As Integer)
        If Government(GovernmentNum).Support < ENTHUSIASTIC Then
            Government(GovernmentNum).Support += 1
        End If
    End Sub

    Sub DecrementProvincialLoyalty(ByVal ProvinceNum As Integer)
        If Province(ProvinceNum).Loyalty > REBELLIOUS Then
            Province(ProvinceNum).Loyalty -= 1
        End If
        'MsgBox("Loyalty of " & Province(ProvinceNum).Name & " Decremented to " & CStr(Province(ProvinceNum).Loyalty))
    End Sub

    Sub IncrementProvincialLoyalty(ByVal ProvinceNum As Integer)
        If Province(ProvinceNum).Loyalty < ENTHUSIASTIC Then
            Province(ProvinceNum).Loyalty += 1
        End If
        'MsgBox("Loyalty of " & Province(ProvinceNum).Name & " Incremented to " & CStr(Province(ProvinceNum).Loyalty))
    End Sub

    'Function CalculateLosses(ByVal ForceSize As Integer, ByVal LossPercent As Integer)
    '    Dim ActualLosses As Integer

    '    ActualLosses = ForceSize * LossPercent \ 100

    '    Return ActualLosses

    'End Function

    Sub ConcludeAction() '(ByVal Defender As Integer)
        'Dim Decision As MsgBoxResult '= vbNo
        'Dim ProvinceNum As Integer '= 0
        'Dim rand As New Random
        'Dim CoinFlip As Integer

        'If CurrentAction = ATTACKING Then
        '    TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
        'End If

        'Randomize()

        ' SURRENDER / COLLAPSE REMOVED BECAUSE HAPPENS TOO EASILY; IT'S A GOOD IDEA, BUT NEEDS TO BE REFINED
        'If Government(Defender).ArmyState = INEFFECTUAL And _
        '    Government(Defender).Cavalary < Government(ActiveGovernment).Cavalary Then

        '    'If Government(Defender).Support > INDIFFERENT Then
        '    If ActiveGovernment = PlayerSide Then
        '        Decision = MsgBox("The " & Government(Defender).Name & " have been broken! They are suing for Peace. " _
        '               & " If you accept their Surrender, their Provinces will become Yours, their Forces will fight for you, and you will gain their central Treasury, " _
        '               & "but you will have to forgo extorting the wealth and seizing the land in their Provinces. If you spurn their overtures, you will have to fight the " _
        '               & "remnants of their forces in each Province, but you can then give them to your Followers as you will. WILL YOU ACCEPT THEIR SURRENDER?", _
        '               MsgBoxStyle.YesNo, "Accept Surrender?")
        '    Else
        '        CoinFlip = rand.Next(0, 2)
        '        If CoinFlip = 1 Then
        '            Decision = vbYes
        '            MsgBox("The " & Government(Defender).Name & " have surendered to the " & GetGovernmentName(ActiveGovernment))
        '            'Else
        '            '    Decision = vbNo
        '            '    MsgBox("The " & Government(Defender).Name & " have collapsed.")
        '        End If
        '    End If
        '    'Else
        '    '    Decision = vbNo
        '    '    MsgBox("The " & Government(Defender).Name & " have collapsed.")
        '    'End If

        '    If Decision = vbYes Then
        '        For ProvinceNum = 0 To TotalProvinces - 1
        '            If Province(ProvinceNum).PoliticalAffiliation = Defender Then
        '                Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment
        '                Government(ActiveGovernment).Cavalary += GetLocalKnights(ProvinceNum)
        '                Government(ActiveGovernment).Infantry += Government(Defender).Infantry
        '                Government(ActiveGovernment).TotalBenefices += CalculateTotalBenefices(ProvinceNum)
        '                'Else
        '                '    Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL
        '                For Each frmMapScreen.ctrl In frmMapScreen.Controls
        '                    If frmMapScreen.ctrl.Name = Area(Province(ProvinceNum).AreaNumber).MapElement Then
        '                        TargetBox = frmMapScreen.ctrl
        '                        ChangeTextboxAffiliation(Province(ProvinceNum).PoliticalAffiliation)
        '                        Exit For
        '                    End If
        '                Next
        '            End If
        '        Next
        '    End If


        'frmMapScreen.Refresh()
        'Government(Defender).Cavalary = 0
        'Government(Defender).Infantry = 0
        'Government(Defender).Support = 0
        'Government(Defender).LeadershipState = -1
        'Government(ActiveGovernment).Treasury += Government(Defender).Treasury
        'Government(Defender).Treasury = 0
        'Government(Defender).TotalBenefices = 0
        'End If


        SelectedArea = NO_SELECTION
        Try
            If PlayerTarget >= 0 Then
                TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
            End If
        Catch

        End Try



        SelectedType = NO_SELECTION
        PlayerTarget = NO_SELECTION

        If PlayerAction = RULING Then
            ToggleRuleControls(True) 'these'll go off since this saying they're currently on
        End If
        PlayerBase = NO_SELECTION

        PlayerAction = NO_SELECTION
        ActionPhase = NO_SELECTION
        frmMapScreen.lblPlayerAction.Text = NO_SELECTION_STRING
        frmMapScreen.lblCurrentPhase.Text = NO_PHASE_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhase.Refresh()
        frmMapScreen.btnAffiliation.PerformClick()

        If TurnDate = ScenarioStartDate And CurrentAction = WHEN_SHOW_CONTROLS Then
            frmMapScreen.txtAttackOnly.Visible = False
            frmMapScreen.btnNegotiate.Visible = True
            frmMapScreen.btnRule.Visible = True
        End If

        If ActiveGovernment = PlayerSide Then

            AutoTurn()
        End If
    End Sub

    'Sub DecideHowHandleTreasure(ByVal ProvinceID As Integer)
    '    Dim Decision As MsgBoxResult = vbNo
    '    Dim TownspeopleKilled As Integer = 0
    '    Dim LootGained As Integer = 0

    '    Decision = MsgBox("The townspeople of " & Province(ProvinceID).Name & " have " & CStr(Province(ProvinceID).Townspeople) _
    '                      & ",000 " & CurrencyStr & " worth of treasure. " & vbCrLf & vbCrLf _
    '                      & "You can take some or all of it.  Taking it will damage the local economy, but enrich " _
    '                      & " your treasury and buy the continued support of your followers." & vbCrLf _
    '                      & "Sparing them will make you popular with your new subjects." & vbCrLf & vbCrLf _
    '                      & "DO YOU WANT TO SEIZE SOME?", vbYesNo, "Seize Wealth?")
    '    If Decision = vbYes Then
    '        Decision = MsgBox("You can let your men loot, which will make them happy and enrich you but inflict considerable harm on the locals.  " _
    '                          & "  Or you can extort protection money from the townspeople, which will net you about half the benefits, but inflict about half the pain." & vbCrLf _
    '                          & "DO YOU WANT TO LET YOUR MEN LOOT?", vbYesNo, "Loot?")
    '        If Decision = vbYes Then
    '            TownspeopleKilled = Province(ProvinceID).Townspeople \ 2
    '            If TownspeopleKilled = 0 Then
    '                TownspeopleKilled = 1
    '            End If
    '            Province(ProvinceID).Townspeople -= TownspeopleKilled
    '            MsgBox("You gained " & Province(ProvinceID).Townspeople & ",000 " & CurrencyStr & " in treasure and your Warriors are pleased.  " & vbCrLf _
    '                   & CStr(TownspeopleKilled) & ",000 Townspeople died, " & Province(ProvinceID).Name & " is in chaos and support for you in the Province declined.")
    '            Government(ActiveGovernment).Treasury += Province(ProvinceID).Townspeople
    '            'IncrementPoliticalSupport(PlayerSide)
    '            Province(ProvinceID).SocialState = CHAOS
    '            'Loyalty of Target Province goes down
    '        Else
    '            LootGained = Province(ProvinceID).Townspeople \ 2
    '            If LootGained < 1 Then
    '                LootGained = 1
    '            End If
    '            Government(ActiveGovernment).Treasury += LootGained
    '            MsgBox("You gained " & CStr(LootGained) & ",000 " & CurrencyStr & " in treasure.")
    '        End If
    '    Else
    '        'popularity with province goes up
    '        IncrementProvincialLoyalty(ProvinceID)
    '        'popularity with own supporters goes down
    '        DecrementArmyState(ActiveGovernment)
    '        MsgBox("Your army's commitment to your cause has Decreased to " & DescribeArmyState(ActiveGovernment))
    '    End If

    'End Sub

    'Sub DecideHowHandleBenefices(ByVal ProvinceID As Integer)
    '    Dim Benefices As Integer = 0
    '    'Dim OpenBenefices As Integer = 0
    '    Dim LocalNobles As Integer = 0
    '    Dim LocalClergy As Integer = 0
    '    Dim FreePeasants As Integer = 0
    '    Dim Decision As MsgBoxResult
    '    Dim GovernmentID As Integer = 0
    '    Dim OtherProvince As Integer = 0

    '    Benefices = (CalculateTotalBenefices(ProvinceID))
    '    FreePeasants = Benefices - (Province(ProvinceID).Nobles + Province(ProvinceID).Clergy)

    '    If Benefices > 0 Then
    '        LocalNobles = Province(ProvinceID).Nobles
    '        LocalClergy = Province(ProvinceID).Clergy

    '        Decision = MsgBox(Province(ProvinceID).Name & " contains enough land for " & CStr(Benefices) & " benefices.  " & vbCrLf _
    '         & CStr(LocalNobles) & " are occupied by Nobles, " & CStr(LocalClergy) & " are occupied by Clergy, and " _
    '         & CStr(FreePeasants) & " are owned by the Peasants themselves." & vbCrLf _
    '         & "If you redistribute land, you will please those you give it to, but you will alienate those you take it from." & vbCrLf _
    '         & "If you don't redistribute land, you will alienate your followers. " & vbCrLf _
    '         & "DO YOU WANT TO REDISTRIBUTE ANY LAND?", MsgBoxStyle.YesNo, "Seize Land?")
    '        If Decision = vbYes Then
    '            If FreePeasants > 0 Then
    '                Decision = MsgBox(" Some of the land is held by Free Peasants.  Taking it will alienate them but please your followers. " & vbCrLf _
    '                                  & "Do you want to reward your followers with control of the Free Peasants' land?", MsgBoxStyle.YesNo, "Take Peasants' Land?")
    '                If Decision = vbYes Then
    '                    Province(ProvinceID).Nobles += FreePeasants
    '                    DecrementProvincialLoyalty(ProvinceID)

    '                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                    Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " declined to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "," & vbCrLf _
    '                           & "while your army's commitment to your cause Increased to " & DescribeArmyState(ActiveGovernment))
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if take it below max value for now
    '                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " remained " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "," & vbCrLf _
    '                           & "while your army's commitment to your cause Decreased to " & DescribeArmyState(ActiveGovernment) & ".")
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If
    '            End If 'if there are Free Peasants
    '            If LocalNobles > 0 Then
    '                Decision = MsgBox("Do you want to reward your followers with Local Nobles' land?", MsgBoxStyle.YesNo, "Take Nobles' Land?")
    '                If Decision = vbYes Then
    '                    Decision = MsgBox("The Local Nobles offer you tribute of " & CStr(Province(ProvinceID).Nobles) & _
    '                                      ",000 Dinari and their loyalty if you will leave them their lands." & vbCrLf _
    '                                      & "The tribute will satisfy your followers less than the land." & vbCrLf _
    '                                      & "DO YOU WANT TO ACCEPT THE NOBLES' OFFER?", vbYesNo, "Spare the Local Nobles?")
    '                    If Decision = vbYes Then
    '                        Province(ProvinceID).Loyalty = SUPPORTIVE
    '                        Government(ActiveGovernment).Treasury += Province(ProvinceID).Nobles
    '                        'Government(ActiveGovernment).Cavalary += GetLocalKnights(PlayerTarget)
    '                        'MsgBox("The local nobles have joined your army!")
    '                    Else
    '                        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                        DecrementProvincialLoyalty(ProvinceID)
    '                        MsgBox("Your army's commitment to your cause has Increased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    End If
    '                    'DecrememtProvincialLoyalty(PlayerTarget)
    '                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If
    '            End If ' if are local nobles
    '            If LocalClergy > 0 Then
    '                Decision = MsgBox("Do you want to reward your followers with Church land?", MsgBoxStyle.YesNo, "Take Church Land?")
    '                If Decision = vbYes Then
    '                    Decision = MsgBox("If you take Church lands, you will be able to support more warriors, but you will " & _
    '                                      "alienate the people of the province as well as offend other Christian peoples." & vbCrLf & vbCrLf _
    '                                      & "DO YOU WANT TO REWARD YOUR FOLLOWERS WITH CHURCH LAND?", vbYesNo, "REally take Church Land?")
    '                    If Decision = vbYes Then
    '                        Province(ProvinceID).Loyalty = REBELLIOUS
    '                        Province(ProvinceID).SocialState = CHAOS
    '                        Province(ProvinceID).Nobles += Province(PlayerTarget).Clergy
    '                        Province(ProvinceID).Clergy = 0
    '                        For OtherProvince = 0 To TotalProvinces - 1
    '                            If OtherProvince <> ProvinceID Then
    '                                If Province(OtherProvince).PoliticalAffiliation = ActiveGovernment Then
    '                                    If Province(OtherProvince).Religion = CATHOLIC Then
    '                                        DecrementProvincialLoyalty(OtherProvince)
    '                                        MsgBox("Support for your government has decreased in " & Province(OtherProvince).Name)
    '                                    End If ' province is Catholic 'WILL NEED TO GENERALIZE THIS FOR ALL RELIGIONS
    '                                End If ' province is controlled by this government
    '                            End If 'this isn't the province itself
    '                        Next
    '                        For GovernmentID = 1 To TotalGovernments - 1
    '                            If GovernmentID <> ActiveGovernment Then
    '                                If Government(GovernmentID).Religion = CATHOLIC Or Government(GovernmentID).Religion = ARIAN Then
    '                                    MsgBox("The " & Government(GovernmentID).Name & " vow to avenge this affront to the Church.")
    '                                End If 'Government is Catholic or Arian
    '                            End If 'Government isn't this one
    '                        Next
    '                        'Decrememt Church support or excommunicate
    '                        'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                        Province(ProvinceID).Clergy = 0
    '                        Province(ProvinceID).Nobles += LocalClergy
    '                        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                        MsgBox("Your army's commitment to your cause has Increased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    Else
    '                        Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                        MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    End If
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If 'take church land
    '            End If 'there is church land
    '            If Government(ActiveGovernment).ArmyState > FANATICAL Then 'adjunst Army state back within limits
    '                Government(ActiveGovernment).ArmyState = FANATICAL         ' will have to do this with any support index affected
    '            ElseIf Government(ActiveGovernment).ArmyState < INEFFECTUAL Then
    '                Government(ActiveGovernment).ArmyState = INEFFECTUAL
    '            End If

    '            'frmPatronize.ShowDialog()
    '        End If ' take any land
    '    End If 'is land to take

    'End Sub

    'Sub ChangeTextboxAffiliation(ByVal ActiveGov As Integer)

    '    If frmMapScreen.rbnAutonomy.Checked Then
    '        TargetBox.BackColor = GetGovernmentColor(ActiveGov) ' should be active player's color !!!!! - set up to be 2/6
    '        TargetBox.Refresh()
    '    End If

    '    If frmMapScreen.rbnAffiliation.Checked Then
    '        TargetBox.Text = Government(ActiveGov).Name
    '        TargetBox.Refresh()
    '    End If

    'End Sub

    Sub ChangeTextboxSocialState(ByVal ProvID As Integer)

        ' NEED TO GET TEXTBOX TO SET COLOR !!
        If frmMapScreen.rbnSocialStateColor.Checked Then
            TargetBox.BackColor = GetSocialStateColor(Province(ProvID).SocialState) ' should be active player's color !!!!! - set up to be 2/6
            TargetBox.Refresh()
        End If

        If frmMapScreen.rbnSocialStateText.Checked Then
            TargetBox.Text = DescribeSocialState(Province(ProvID).SocialState)
            TargetBox.Refresh()
        End If

    End Sub

    'Sub AttackAI(ByVal ActiveGov As Integer)
    '    Dim ProvinceNum, PotentialTarget, CurrentTarget, CurrentTargetValue, CurrentVictoryPotential, PotentialTargetArea As Integer
    '    Dim TerrainModifier, AttackFactor, CurrentBase, PotentialBase As Integer
    '    Dim DefendingGovernment, DefendingGeneralship, DefendingArmyState, PlayerDefend, DefenseFactor As Integer
    '    Dim VictoryPotential, TreasureValue, LandValue, RentValue As Integer
    '    Dim PeopleToResettle As Integer
    '    Dim AI_Thinking = True
    '    Dim ProvinceOwner As Integer = -1
    '    Dim RelatesWithOwner As Integer = -100
    '    Dim i, j As Integer
    '    Dim PotentialConnectingSeaArea As Integer = -1
    '    Dim PotentialConnectingSea As Integer = -1
    '    Dim PotentialTargetName As String = "" 'only needed for debug box in Sea movement logic

    '    PotentialTarget = -1
    '    PotentialTargetArea = -1
    '    CurrentTarget = -1
    '    CurrentTargetValue = 0
    '    CurrentVictoryPotential = 0
    '    PeopleToResettle = 0
    '    CurrentBase = -1
    '    PotentialBase = -1

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
    '            PeopleToResettle += Province(ProvinceNum).SurplusPopulation
    '        End If
    '    Next

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
    '            PotentialBase = ProvinceNum
    '            For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move 
    '                If Province(PotentialBase).Connectors(i) >= RIVER Then ' if neighbor is land connection
    '                    PotentialTargetArea = Province(PotentialBase).Neighbors(i)
    '                    PotentialTarget = Area(PotentialTargetArea).Province
    '                    If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then

    '                        TerrainModifier = Province(PotentialTarget).Topography + 1

    '                        AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

    '                        DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

    '                        If DefendingGovernment > 0 Then
    '                            'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '                            PlayerDefend = True
    '                        Else
    '                            PlayerDefend = False
    '                        End If

    '                        If PlayerDefend Then
    '                            DefendingGeneralship = Government(DefendingGovernment).Generalship
    '                            DefendingArmyState = Government(DefendingGovernment).ArmyState
    '                        Else
    '                            DefendingGeneralship = 0
    '                            DefendingArmyState = 0
    '                        End If

    '                        DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '                        VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

    '                        If PeopleToResettle > 0 Then
    '                            LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
    '                            If LandValue > CurrentTargetValue Then
    '                                If VictoryPotential >= CurrentVictoryPotential Then
    '                                    ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                    If ProvinceOwner = 0 Then 'if is an independent province
    '                                        CurrentTarget = PotentialTarget
    '                                        CurrentTargetValue = LandValue
    '                                        CurrentVictoryPotential = VictoryPotential
    '                                        CurrentBase = PotentialBase
    '                                    Else 'Province belongs to a Kingdom
    '                                        RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                        If RelatesWithOwner = MIN_RELATES Then
    '                                            CurrentTarget = PotentialTarget
    '                                            CurrentTargetValue = LandValue
    '                                            CurrentVictoryPotential = VictoryPotential
    '                                            CurrentBase = PotentialBase
    '                                        Else ' if isn't actively belligerant
    '                                            RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                            AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                            If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                            End If ' Player is involved
    '                                        End If '  actively belligerant
    '                                    End If 'Belongs to a Kingdom
    '                                End If ' is currently most attractive target
    '                            Else
    '                                If LandValue = CurrentTargetValue Then
    '                                    If VictoryPotential > CurrentVictoryPotential Then
    '                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                            CurrentTarget = PotentialTarget
    '                                            CurrentTargetValue = LandValue
    '                                            CurrentVictoryPotential = VictoryPotential
    '                                            CurrentBase = PotentialBase
    '                                        Else 'Province belongs to a Kingdom
    '                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else ' if isn't actively belligerant
    '                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                    MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                End If ' Player is involved
    '                                            End If '  actively belligerant
    '                                        End If 'Belongs to a Kingdom
    '                                        'CurrentTarget = PotentialTarget
    '                                        'CurrentTargetValue = LandValue
    '                                        'CurrentVictoryPotential = VictoryPotential
    '                                        'CurrentBase = PotentialBase
    '                                    End If
    '                                End If
    '                            End If
    '                        Else ' no people to resettle
    '                            If VictoryPotential > 5 Then
    '                                TreasureValue = Province(PotentialTarget).Townspeople
    '                                RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
    '                                If TreasureValue >= RentValue Then
    '                                    If TreasureValue > CurrentTargetValue Then
    '                                        If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
    '                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                            If ProvinceOwner = 0 Then 'if is an independent province
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else 'Province belongs to a Kingdom
    '                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                If RelatesWithOwner = MIN_RELATES Then
    '                                                    CurrentTarget = PotentialTarget
    '                                                    CurrentTargetValue = LandValue
    '                                                    CurrentVictoryPotential = VictoryPotential
    '                                                    CurrentBase = PotentialBase
    '                                                Else ' if isn't actively belligerant
    '                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                        MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                    End If ' Player is involved
    '                                                End If '  actively belligerant
    '                                            End If 'Belongs to a Kingdom
    '                                            'CurrentTarget = PotentialTarget
    '                                            'CurrentTargetValue = TreasureValue
    '                                            'CurrentVictoryPotential = VictoryPotential
    '                                            'CurrentBase = PotentialBase
    '                                        End If
    '                                    End If
    '                                Else ' if rents more valuable than treasure
    '                                    If RentValue > CurrentTargetValue Then
    '                                        If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
    '                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                            If ProvinceOwner = 0 Then 'if is an independent province
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else 'Province belongs to a Kingdom
    '                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                If RelatesWithOwner = MIN_RELATES Then
    '                                                    CurrentTarget = PotentialTarget
    '                                                    CurrentTargetValue = LandValue
    '                                                    CurrentVictoryPotential = VictoryPotential
    '                                                    CurrentBase = PotentialBase
    '                                                Else ' if isn't actively belligerant
    '                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                        MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                    End If ' Player is involved
    '                                                End If '  actively belligerant
    '                                            End If 'Belongs to a Kingdom
    '                                            'CurrentTarget = PotentialTarget
    '                                            'CurrentTargetValue = RentValue
    '                                            'CurrentVictoryPotential = VictoryPotential
    '                                            'CurrentBase = PotentialBase
    '                                        End If
    '                                    End If 'Rents here > current target
    '                                End If 'treasure > rents
    '                            End If ' half a chance of victory
    '                        End If ' have people to resettle

    '                    End If ' isn't one of own provinces
    '                Else 'if is a Sea connection
    '                    If Province(PotentialBase).Connectors(i) = SEALANE Then
    '                        If Government(ActiveGov).NavalCapability > 0 Then
    '                            PotentialConnectingSeaArea = Province(PotentialBase).Neighbors(i)
    '                            PotentialConnectingSea = Area(PotentialConnectingSeaArea).Province
    '                            If Sea(PotentialConnectingSea).Topography >= -(Government(ActiveGov).NavalCapability) Then
    '                                For j = 0 To MAX_NEIGHBORS_SEA - 1
    '                                    If Sea(PotentialConnectingSea).Neighbors(j) >= 0 Then
    '                                        PotentialTargetArea = Sea(PotentialConnectingSea).Neighbors(j)
    '                                        If Area(PotentialTargetArea).Type >= LAND Then
    '                                            PotentialTarget = Area(PotentialTargetArea).Province
    '                                            If Province(PotentialTarget).ID <> Province(PotentialBase).ID Then 'if not trying to invade itself
    '                                                If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then
    '                                                    TerrainModifier = Province(PotentialTarget).Topography + 1

    '                                                    AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

    '                                                    DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

    '                                                    If DefendingGovernment > 0 Then
    '                                                        'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '                                                        PlayerDefend = True
    '                                                    Else
    '                                                        PlayerDefend = False
    '                                                    End If

    '                                                    If PlayerDefend Then
    '                                                        DefendingGeneralship = Government(DefendingGovernment).Generalship
    '                                                        DefendingArmyState = Government(DefendingGovernment).ArmyState
    '                                                    Else
    '                                                        DefendingGeneralship = 0
    '                                                        DefendingArmyState = 0
    '                                                    End If

    '                                                    DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '                                                    VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

    '                                                    If PeopleToResettle > 0 Then
    '                                                        LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
    '                                                        If LandValue > CurrentTargetValue Then
    '                                                            If VictoryPotential >= CurrentVictoryPotential Then
    '                                                                ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                    CurrentTarget = PotentialTarget
    '                                                                    CurrentTargetValue = LandValue
    '                                                                    CurrentVictoryPotential = VictoryPotential
    '                                                                    CurrentBase = PotentialBase
    '                                                                Else 'Province belongs to a Kingdom
    '                                                                    RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                    If RelatesWithOwner = MIN_RELATES Then
    '                                                                        CurrentTarget = PotentialTarget
    '                                                                        CurrentTargetValue = LandValue
    '                                                                        CurrentVictoryPotential = VictoryPotential
    '                                                                        CurrentBase = PotentialBase
    '                                                                    Else ' if isn't actively belligerant
    '                                                                        RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                        AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                        If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                            MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                        End If ' Player is involved
    '                                                                    End If '  actively belligerant
    '                                                                End If 'Belongs to a Kingdom
    '                                                            End If ' is currently most attractive target
    '                                                        Else
    '                                                            If LandValue = CurrentTargetValue Then
    '                                                                If VictoryPotential > CurrentVictoryPotential Then
    '                                                                    ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                    If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                        CurrentTarget = PotentialTarget
    '                                                                        CurrentTargetValue = LandValue
    '                                                                        CurrentVictoryPotential = VictoryPotential
    '                                                                        CurrentBase = PotentialBase
    '                                                                    Else 'Province belongs to a Kingdom
    '                                                                        RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                        If RelatesWithOwner = MIN_RELATES Then
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else ' if isn't actively belligerant
    '                                                                            RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                            AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                            If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                            End If ' Player is involved
    '                                                                        End If '  actively belligerant
    '                                                                    End If 'Belongs to a Kingdom
    '                                                                    'CurrentTarget = PotentialTarget
    '                                                                    'CurrentTargetValue = LandValue
    '                                                                    'CurrentVictoryPotential = VictoryPotential
    '                                                                    'CurrentBase = PotentialBase
    '                                                                End If
    '                                                            End If
    '                                                        End If
    '                                                    Else ' no people to resettle
    '                                                        If VictoryPotential > 5 Then
    '                                                            TreasureValue = Province(PotentialTarget).Townspeople
    '                                                            RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
    '                                                            If TreasureValue >= RentValue Then
    '                                                                If TreasureValue > CurrentTargetValue Then
    '                                                                    If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
    '                                                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else 'Province belongs to a Kingdom
    '                                                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                                                CurrentTarget = PotentialTarget
    '                                                                                CurrentTargetValue = LandValue
    '                                                                                CurrentVictoryPotential = VictoryPotential
    '                                                                                CurrentBase = PotentialBase
    '                                                                            Else ' if isn't actively belligerant
    '                                                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                    MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                                End If ' Player is involved
    '                                                                            End If '  actively belligerant
    '                                                                        End If 'Belongs to a Kingdom
    '                                                                        'CurrentTarget = PotentialTarget
    '                                                                        'CurrentTargetValue = TreasureValue
    '                                                                        'CurrentVictoryPotential = VictoryPotential
    '                                                                        'CurrentBase = PotentialBase
    '                                                                    End If
    '                                                                End If
    '                                                            Else ' if rents more valuable than treasure
    '                                                                If RentValue > CurrentTargetValue Then
    '                                                                    If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
    '                                                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else 'Province belongs to a Kingdom
    '                                                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                                                CurrentTarget = PotentialTarget
    '                                                                                CurrentTargetValue = LandValue
    '                                                                                CurrentVictoryPotential = VictoryPotential
    '                                                                                CurrentBase = PotentialBase
    '                                                                            Else ' if isn't actively belligerant
    '                                                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                    MsgBox("Spys report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                                End If ' Player is involved
    '                                                                            End If '  actively belligerant
    '                                                                        End If 'Belongs to a Kingdom
    '                                                                        'CurrentTarget = PotentialTarget
    '                                                                        'CurrentTargetValue = RentValue
    '                                                                        'CurrentVictoryPotential = VictoryPotential
    '                                                                        'CurrentBase = PotentialBase
    '                                                                    End If
    '                                                                End If 'Rents here > current target
    '                                                            End If 'treasure > rents
    '                                                        End If ' half a chance of victory
    '                                                    End If ' have people to resettle

    '                                                End If ' not owned by Active Government 
    '                                            End If 'not self
    '                                            'Else ' if neighbor = -1, ie, no more neighbors 'no, this would stop consideration if has sea connect to sea, even if possibly other land beyond
    '                                            'Exit For
    '                                        End If ' Land Neighbor to sea zone 
    '                                    End If ' this possibility is a Province or sea
    '                                Next 'next Neighbor of Potential Connecting Sea
    '                            End If ' if Naval Capable of operation in this type of sea
    '                        End If ' Government has Naval Capability
    '                    End If 'Connector is a Sealane (since already checked if Land Connection, only thing left would be -1, no connector
    '                End If ' if Neighbor is land connection
    '            Next ' i/Neighbor
    '        End If ' province is active government's (so can act as base)
    '    Next

    '    If CurrentTarget > -1 Then
    '        PlayerAction = ATTACKING
    '        PlayerTarget = CurrentTarget
    '        PlayerBase = CurrentBase
    '        If Province(PlayerTarget).PoliticalAffiliation = PlayerSide Then
    '            MsgBox("The " & Government(ActiveGov).Name & " are attacking " & Province(PlayerTarget).Name & " from " _
    '                   & Province(PlayerBase).Name)
    '        End If
    '        'Else
    '        'NegotiateAI(ActiveGov)
    '        'MsgBox("The " & GetGovernmentName(ActiveGov) & " will not attack this round. ") ' don't need to know this
    '    End If

    'End Sub

    Sub NegotiateAI(ByVal ActiveGmt As Integer)
        Dim OtherGmt As Integer = 0
        Dim IsContiguous As Boolean = False
        Dim Relationship As Integer = -100
        Dim NegotiatingPartner As Integer = -1
        Dim ThreatLevel As Integer = -100
        Dim ThreatPower As Integer = 0
        Dim PowerRatio As Integer = -100
        Dim Rand As New Random
        Dim RandomNum As Integer = -100
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Randomize()

        For OtherGmt = 1 To TotalGovernments - 1
            If OtherGmt <> ActiveGmt Then ' if not looking at self
                If OtherGmt <> PlayerSide Or ((OtherGmt = PlayerSide) And (Government(PlayerSide).Reputation > DISHONEST)) Then
                    IsContiguous = DetermineIfGovernmentsContiguous(ActiveGmt, OtherGmt)
                    If IsContiguous = True Then
                        Relationship = Government(ActiveGmt).DiplomaticRelations(OtherGmt)
                        If Relationship < MAX_RELATES Then ' at moment, won't do anything if it's at max; if change this, can make <> into = (or add else)
                            If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                                NegotiatingPartner = OtherGmt
                                ThreatLevel = Relationship 'MIN_RELATES 'shouldn't this be 0
                                ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                            Else ' if is a current potential negotiating partner
                                If Relationship < ThreatLevel Then ' if relations with this Kingdom are worse than with current prospect, this trumps it
                                    NegotiatingPartner = OtherGmt
                                    ThreatLevel = Relationship 'MIN_RELATES
                                    ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                                Else 'if relations are the same level
                                    If Relationship = ThreatLevel Then
                                        PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                                        If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                                            NegotiatingPartner = OtherGmt
                                            ThreatPower = PowerRatio
                                        Else
                                            If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                                                If Rand.Next(0, 2) = 1 Then
                                                    NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                                                End If
                                            End If 'if this threat is same
                                        End If 'if this threat is worse than current threat
                                    End If ' if this relationship is same as potential partner's
                                End If 'if this relationship is worse than potential partner's
                            End If 'if no current potential partner
                        End If 'is already at Max
                        'Select Case Relationship
                        '    Case MIN_RELATES 'at this point, hostile
                        '        If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                        '            NegotiatingPartner = OtherGmt
                        '            ThreatLevel = MIN_RELATES
                        '            ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                        '        Else ' if there is a current potential partner
                        '            If ThreatLevel = MIN_RELATES Then ' if current partner is also as hostile as can be
                        '                PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                        '                If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                        '                    NegotiatingPartner = OtherGmt
                        '                    ThreatPower = PowerRatio
                        '                Else
                        '                    If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                        '                        If Rand.Next(0, 2) = 1 Then
                        '                            NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                        '                        End If
                        '                    End If
                        '                End If
                        '            Else 'otherwise this trumps it
                        '                NegotiatingPartner = OtherGmt
                        '                ThreatLevel = MIN_RELATES
                        '                ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                        '            End If
                        '        End If
                        '    Case MAX_RELATES ' at this point, friendly
                        '        ' nothing to do for the moment
                        '    Case Else ' at this point, is Neutral
                        '        If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                        '            NegotiatingPartner = OtherGmt
                        '            ThreatLevel = MIN_RELATES
                        '            ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                        '        Else ' if is a current potential negotiating partner
                        '            If Relationship < ThreatLevel Then ' if relations with this Kingdom are worse than with current prospect, this trumps it
                        '                NegotiatingPartner = OtherGmt
                        '                ThreatLevel = MIN_RELATES
                        '                ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                        '            Else 'if relations are the same level
                        '                If Relationship = ThreatLevel Then
                        '                    PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                        '                    If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                        '                        NegotiatingPartner = OtherGmt
                        '                        ThreatPower = PowerRatio
                        '                    Else
                        '                        If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                        '                            If Rand.Next(0, 2) = 1 Then
                        '                                NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                        '                            End If
                        '                        End If
                        '                    End If
                        '                End If
                        '            End If
                        '        End If
                        'End Select
                    End If ' is contiguous
                End If 'isn't player or is player but player's reputation > Dishonest
            End If ' isn't self
        Next

        If NegotiatingPartner > -1 Then
            PlayerAction = PARLEYING

            If NegotiatingPartner = PlayerSide Then
                If Government(ActiveGmt).DiplomaticRelations(PlayerSide) < MAX_RELATES Then ' to avoid initiating neg. only to find it's as good as it gets
                    If Government(PlayerSide).Reputation > DISHONEST Then
                        MsgBox("The " & Government(ActiveGmt).Name & " want to Negotiate with you.")
                        'Decision = MsgBox("The " & Government(ActiveGmt).Name & " want to Negotiate with You." & vbCrLf & vbCrLf _
                        '                  & "Will you receive their Ambassador?", MsgBoxStyle.YesNo, "Receive Ambassador from " & GetGovernmentName(ActiveGmt) & "?")
                        'If Decision = MsgBoxResult.Yes Then
                        Negotiate(NegotiatingPartner, ActiveGmt) 'reversed so PLayer become active gvt in actual negotiations
                    End If ' if AI will trust player
                End If 'not already at max
            Else
                Relationship = IncrementDiploRelates(ThreatLevel)
                AdjustDiploRelates(ActiveGmt, NegotiatingPartner, Relationship)
                RandomNum = Rand.Next(0, 2)
                If RandomNum = 1 Then
                    MsgBox("Spys report that the relationship between the " & Government(ActiveGmt).Name & " and the " _
                           & Government(NegotiatingPartner).Name & " have improved to " & DescribeDiploRelations(ActiveGmt, NegotiatingPartner) & ".")
                End If
            End If
            ConcludeAction()
        Else
                ConcludeAction()
                'Relationship = IncrementDiploRelates(ThreatLevel)
                'AdjustDiploRelates(ActiveGmt, NegotiatingPartner, Relationship)
                'MsgBox("Spys report that the relationship between the " & GetGovernmentName(ActiveGmt) & " and the " _
                '       & GetGovernmentName(NegotiatingPartner) & " have improved to " & DescribeDiploRelations(ActiveGmt, NegotiatingPartner) & ".")
        End If


    End Sub

    Sub AdministerProvince(ByVal ThisProvince As Integer, ByVal Ruler As Integer, ByVal ProvincesAdministering As Integer)
        Dim SuccessThreshhold As Integer = 5
        Dim Decision As MsgBoxResult
        Dim MsgStr As String = ""
        Dim LanguageDifferential As Integer = 0
        Dim ReligiousDifferential As Integer = 0
        Dim Rand As New Random
        Dim DieRoll As Integer = 0
        Dim CostToHelp As Integer = 0

        Randomize()

        SuccessThreshhold += Government(Ruler).PoliticalSavvy ' Success Threshhold initialized at 5

        SuccessThreshhold += Government(Ruler).ArmyState

        SuccessThreshhold += Government(Ruler).Support

        SuccessThreshhold += Province(ThisProvince).Loyalty

        SuccessThreshhold += Government(Ruler).LawCode

        ReligiousDifferential = CalculateReligiousDifferential(Government(Ruler).Religion, Province(ThisProvince).Religion)
        SuccessThreshhold -= ReligiousDifferential

        LanguageDifferential = CalculateLanguageDifference(Government(Ruler).Language, Province(ThisProvince).Language)
        SuccessThreshhold -= LanguageDifferential

        If Province(ThisProvince).SurplusPopulation Then
            SuccessThreshhold -= 1 + Province(ThisProvince).SurplusPopulation \ 10 'also arbrary; see below
        End If

        SuccessThreshhold -= ProvincesAdministering \ 10 ' 10 is arbitrary, but embodies that the more provinces to admin, the more difficult

        'If Province(ProvinceID).Religion = CATHOLIC Then
        '    SuccessThreshhold += Province(ProvinceID).Clergy \ (3 - Government(Ruler).PapalRelations 'activate once add in Papal Relations
        'End 

        If SuccessThreshhold < 0 Then
            SuccessThreshhold = 0
        Else
            If SuccessThreshhold > 10 Then
                SuccessThreshhold = 10
            End If
        End If


        MsgStr &= "The Social State of " & Province(ThisProvince).Name & " is currently " & DescribeSocialState(Province(ThisProvince).SocialState) & "." & vbCrLf & vbCrLf

        MsgStr &= "Your efforts to administer it currently have " & DescribeChanceOfSuccess(SuccessThreshhold) & " of improving things." & vbCrLf & vbCrLf

        MsgStr &= "Your Leaders' political skill is  " & GetAbilityNames(Government(Ruler).PoliticalSavvy) & "." & vbCrLf & vbCrLf

        MsgStr &= "Your Army is " & DescribeArmyState(Government(Ruler).ArmyState) & "." & vbCrLf & vbCrLf

        MsgStr &= "The level of support for your government overall is " & NameLoyaltyLevel(Government(Ruler).Support)

        MsgStr &= ", while the level of support in " & Province(ThisProvince).Name & " itself is " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "." & vbCrLf & vbCrLf

        If Government(Ruler).LawCode > 0 Then
            MsgStr &= "You have Codified your Laws." & vbCrLf & vbCrLf
        End If

        If ReligiousDifferential > 0 Then
            MsgStr &= "The fact that your government is " & NameReligion(Government(Ruler).Religion) & " while the people of "

            MsgStr &= Province(ThisProvince).Name & " are " & NameReligion(Province(ThisProvince).Religion) & " makes the situation "

            If ReligiousDifferential = 2 Then
                MsgStr &= "much "
            End If

            MsgStr &= "more difficult." & vbCrLf & vbCrLf
        End If

        If LanguageDifferential > 0 Then
            MsgStr &= "The fact that your government speaks a different "

            If LanguageDifferential = 1 Then
                MsgStr &= "dialect "
            Else
                MsgStr &= "language "
            End If
            MsgStr &= "than the people of " & Province(ThisProvince).Name & " makes the situation "

            If LanguageDifferential = 2 Then
                MsgStr &= "much "
            End If

            MsgStr &= "more difficult." & vbCrLf & vbCrLf
        End If

        If Province(ThisProvince).SurplusPopulation > 0 Then
            MsgStr &= "There is "
            If Province(ThisProvince).SurplusPopulation > 10 Then
                MsgStr &= "famine "
            Else
                MsgStr &= "hunger "
            End If
            MsgStr &= "in the land, and desperate people roam the countryside." & vbCrLf & vbCrLf
        End If

        If ProvincesAdministering > ADMINISTRATIVE_LOAD_THRESHHOLD Then
            MsgStr &= "The number of provinces you have to administer also limits the amount of attention that can be paid to each." & vbCrLf & vbCrLf
        End If

        If SuccessThreshhold < 10 Then
            CostToHelp = Province(ThisProvince).Peasants \ PEASANTS_PER_BENEFICE
            If Government(Ruler).Treasury >= CostToHelp Then
                'CostToHelp = Province(ThisProvince).Peasants \ PEASANTS_PER_BENEFICE
                MsgStr &= "You have " & CStr(Government(Ruler).Treasury) & " " & CurrencyStr & " in your Treasury." & vbCrLf
                Decision = MsgBox(MsgStr & vbCrLf & "You can improve your chances of success by spending " & CostToHelp & " " & CurrencyStr & ". DO YOU WANT TO SPEND THE MONEY?", _
                              MsgBoxStyle.YesNo, "Administer " & Province(ThisProvince).Name)
                If Decision = vbYes Then

                    Government(Ruler).Treasury -= CostToHelp
                    SuccessThreshhold += 1
                End If ' money committed
            Else
                MsgBox(MsgStr & vbCrLf & "There are not enough " & CurrencyStr & " in your Treasury to influnce the outcome.")
            End If 'have enough money

            If ActiveGovernment = PlayerSide Then
                If SuccessThreshhold < 10 Then
                    MsgStr = "You have a " & CStr(SuccessThreshhold) & "0% chance of success ... "
                    MsgBox(MsgStr)
                    MsgStr &= vbCrLf
                Else
                    MsgStr = ""
                End If
            Else
                MsgStr = ""
            End If

            DieRoll = Rand.Next(1, 11)

            'If ActiveGovernment = PlayerSide Then
            '    If SuccessThreshhold < 10 Then
            '        MsgStr = MsgStr & "The result is " & CStr(DieRoll) & "! " & vbCrLf
            '    End If
            'End If ' is player's concern


            If DieRoll <= SuccessThreshhold Then
                If Province(ThisProvince).SocialState < BOOMING Then
                    IncrementSocialState(ThisProvince, BOOMING)
                    'MsgStr = MsgStr & vbCrLf
                    MsgStr = MsgStr & "Your Activities were a success! Social conditions in " & Province(ThisProvince).Name & " improved!" '& CStr(Province(ThisProvince).SocialState) & "."
                    MsgBox(MsgStr)
                    SetTargetTextbox(ThisProvince)
                    ChangeTextboxSocialState(ThisProvince)
                    IncrementProvincialLoyalty(ThisProvince)
                    IncrementSocialVPs(Province(ThisProvince).SocialState)
                    'SocialVPs += SOCIAL_STATE_VP_VALUE
                    'RefreshSocialStateVP_Display()
                Else
                    MsgBox("Your Activities were a success! Social conditions in " & Province(ThisProvince).Name & " remain " & BOOMING_STR & "!")
                End If
                'SetActionTarget()
            Else
                If DieRoll > SuccessThreshhold * 2 Then
                    If Province(ThisProvince).SocialState > CHAOS Then
                        DecrementSocialState(ThisProvince, CHAOS)
                        MsgStr &= vbCrLf
                        MsgBox(MsgStr & "Your activities in " & Province(ThisProvince).Name & " provoked resistance. Social Conditions there deteriorated.") '  to " & DescribeSocialState(ThisProvince) & ".")
                        SetTargetTextbox(ThisProvince)
                        ChangeTextboxSocialState(ThisProvince)
                        DecrementProvincialLoyalty(ThisProvince)
                        DecrementSocialVPs(Province(ThisProvince).SocialState)
                        'SocialVPs -= SOCIAL_STATE_VP_VALUE
                        'RefreshSocialStateVP_Display()
                    Else
                        MsgStr &= "Conditions remain Chaotic in " & Province(ThisProvince).Name & "."
                        MsgBox(MsgStr)
                    End If
                Else
                    MsgBox(MsgStr & vbCrLf & "Reactions to your rule in " & Province(ThisProvince).Name & " were mixed. Social Conditions remain unchanged.") ' & DescribeSocialState(ThisProvince) & ".")
                End If
            End If

        Else
            IncrementSocialState(ThisProvince, BOOMING)
            'MsgStr = MsgStr & vbCrLf
            MsgStr = MsgStr & "Your Activities were a success! Social conditions in " & Province(ThisProvince).Name & " improved!" '& CStr(Province(ThisProvince).SocialState) & "."
            MsgBox(MsgStr)
            SetTargetTextbox(ThisProvince)
            ChangeTextboxSocialState(ThisProvince)
            IncrementProvincialLoyalty(ThisProvince)
            IncrementSocialVPs(Province(ThisProvince).SocialState)
            'SocialVPs += SOCIAL_STATE_VP_VALUE
            'RefreshSocialStateVP_Display()
        End If ' success not assured

    End Sub

    Function CalculatePoliticalSupport(ByVal GovernmentID As Integer) As Integer
        Dim ProvinceNum As Integer
        Dim ProvincesControlled As Integer = 0
        Dim TotalSupport As Integer = 0

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment Then
                ProvincesControlled += 1
                TotalSupport += Province(ProvinceNum).Loyalty
            End If
        Next
        If ProvincesControlled > 0 Then
            Government(GovernmentID).Support = CInt(CDec(TotalSupport) / CDec(ProvincesControlled))
        Else
            Government(GovernmentID).Support = UNDEFINED
        End If

        Return ProvincesControlled

    End Function

    Function TotalProvincesControlled(ByVal GovernmentID As Integer) As Integer
        Dim ProvinceNum As Integer
        Dim ProvincesControlled As Integer = 0

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = GovernmentID Then
                ProvincesControlled += 1
            End If
        Next

        Return ProvincesControlled

    End Function

    Function CalculateReligiousDifferential(ByVal Religion1 As Integer, ByVal Religion2 As Integer) As Integer
        Dim ReligiousDifferential As Integer = 0

        If Religion1 <> Religion2 Then
            If Abs(Religion1 - Religion2) > MAX_CHRISTIAN_SECTS Then
                ReligiousDifferential = 2
            Else
                ReligiousDifferential = 1
            End If
        End If 'no else needed because ReligiousDifferential initialized to 0, no difference

        Return ReligiousDifferential

    End Function

    Function CalculateLanguageDifference(ByVal Language1 As Integer, ByVal Language2 As Integer) As Integer
        Dim LanguageDifference As Integer = 0
        Dim Str1 As String = ""
        Dim Str2 As String = ""
        Dim FirstDigit1 As Char = "0"
        Dim FirstDigit2 As Char = "0"

        If Abs(Language1 - Language2) > MINOR_LINGUISTIC_THRESHHOLD Then
            Str1 = CStr(Language1)
            Str2 = CStr(Language2)
            FirstDigit1 = Str1.Chars(0)
            FirstDigit2 = Str2.Chars(0)
            If FirstDigit1 = FirstDigit2 Then ' if difference within family
                LanguageDifference = 1
            Else ' difference between families
                LanguageDifference = 2
            End If ' no need to change LanguageDifference if Languages the same because initialized to 0
        End If

        Return LanguageDifference
    End Function

    'Function DescribeChanceOfSuccess(ByVal Probability As Integer) As String
    '    Dim ProbabilityStr As String = ""

    '    Select Case Probability
    '        Case 10
    '            ProbabilityStr = " an Overwhelming Chance "

    '        Case 7, 8, 9
    '            ProbabilityStr = " a Good Chance "

    '        Case 4, 5, 6
    '            ProbabilityStr = " a Moderate Chance "

    '        Case 1, 2, 3
    '            ProbabilityStr = " a Marginal Chance "

    '        Case 0
    '            ProbabilityStr = " No Chance "

    '        Case Else
    '            ProbabilityStr = " Bad Probability Estimate Lookup "

    '    End Select

    '    Return ProbabilityStr

    'End Function

    Public Sub ToggleRuleControls(ByVal CurrentState As Boolean)
        Dim StateToBecome As Boolean

        If CurrentState = True Then
            StateToBecome = False
        Else
            StateToBecome = True
        End If

        frmMapScreen.lblHowRule.Visible = StateToBecome
        frmMapScreen.lblHowRule.Refresh()
        frmMapScreen.btnAdminister.Visible = StateToBecome
        frmMapScreen.btnAdminister.Refresh()
        frmMapScreen.btnConvert.Visible = StateToBecome
        frmMapScreen.btnConvert.Refresh()
        frmMapScreen.btnLawCode.Visible = StateToBecome
        frmMapScreen.btnLawCode.Refresh()

    End Sub

    Sub ConversionReaction(ByVal Resistance As Integer)
        Dim i As Integer = 0
        Dim Resist As Integer = 0

        Do While Resist < Resistance
            DecrementArmyState(PlayerSide)
            Resist += 1
        Loop
        MsgBox("The morale of the Frankish warriors has declined to " & DescribeArmyState(Government(PlayerSide).ArmyState) & ".")

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = PlayerSide Then
                If Province(i).Religion = PAGAN Then
                    Resist = 0
                    Do While Resist < Resistance
                        DecrementProvincialLoyalty(i)
                        Resist += 1
                    Loop
                    If Province(i).Loyalty = REBELLIOUS Then
                        Province(i).PoliticalAffiliation = LOCAL_CONTROL
                        DecrementSocialState(i, CHAOS)
                        MsgBox("Pagan " & Province(i).Name & " has rebelled against you!")
                        DecrementConquestVPs(i)
                        'ConquestVPs -= PROVINCE_VP_VALUE
                        'RefreshConquestVP_Display()
                    Else
                        MsgBox("Support for your government has decreased in Pagan " & Province(i).Name & ".")
                    End If
                Else
                    'If Government(PlayerSide).Religion = CATHOLIC Then ' COMMENTED OUT THINGS ARE VESTIGES OF ARRIAN VS. CATHOLIC THING
                    If Province(i).Religion = CATHOLIC Then
                        IncrementProvincialLoyalty(i)
                        MsgBox("Support for your government has increased in Catholic " & Province(i).Name & ".")
                        'Else
                        '    MsgBox("The people of " & NameReligion(Province(i).Religion) & " " & Province(i).Name & " are indifferent to your conversion.")
                    End If
                    'Else
                    'If Province(i).Religion = CATHOLIC Or Province(i).Religion = ORTHADOX Then
                    '    DecrementProvincialLoyalty(i)
                    '    If Province(i).Loyalty = REBELLIOUS Then
                    '        Province(i).PoliticalAffiliation = LOCAL_CONTROL
                    '        DecrementSocialState(i, CHAOS)
                    '        MsgBox(NameReligion(Province(i).Religion) & " " & Province(i).Name & " has rebelled against you!")
                    '    Else
                    '        MsgBox("Support for your government has decreased in " & Province(i).Name & NameReligion(Province(i).Religion) & " " & ".")
                    '    End If

                End If 'Province is Pagan
                '    End If 'Franks Became Catholic (else Arian)
                'End If 'Province is Pagan (else other)
            End If 'province is controlled by Franks
        Next

        'Now do Government Reactions ' ALSO A VESTAGE OF ARIAN VS. CATHOLIC THING
        'For i = 1 To TotalGovernments - 1
        '    If i <> PlayerSide Then
        '        If Government(PlayerSide).Religion = CATHOLIC Then
        '            If Government(i).Religion = CATHOLIC Then
        '                MsgBox("The " & GetGovernmentName(i) & " applaud your conversion to the One True Faith, and swear to cooperate more closely in the future.")
        '                ' Increment This government's attitude toward Franks
        '            Else
        '                If Government(i).Religion = ARIAN Then
        '                    MsgBox("The " & GetGovernmentName(i) & " scorn your conversion this false faith, and want nothing to do with you.")
        '                    ' decrement this government's attitude toward Franks
        '                    ' possibly break alliance or whatever, once diplomatic system in 
        '                End If
        '            End If 'other Government is Catholic (else Arian)
        '        Else ' converted to Arian
        '            If Government(i).Religion = ARIAN Then
        '                MsgBox("The " & GetGovernmentName(i) & " applaud your conversion to the One True Faith, and swear to cooperate more closely in the future.")
        '                ' Increment This government's attitude toward Franks
        '            Else
        '                If Government(i).Religion = CATHOLIC Then
        '                    MsgBox("The " & GetGovernmentName(i) & " scorn your conversion this false faith, and want nothing to do with you.")
        '                    ' decrement this government's attitude toward Franks
        '                    ' possibly break alliance or whatever, once diplomatic system in 
        '                End If
        '            End If 'other Government is Catholic (else Arian)

        '        End If ' Player converted to Catholicism (else Arian)

        '    End If 'Government isn't this one
        'Next


        'MsgBox("Determine Reaction to Conversion here.")
    End Sub

    Sub AdjustDiploRelates(ByVal Country1 As Integer, ByVal Country2 As Integer, ByVal NewRelationship As Integer)
        Dim MsgStr As String
        Try
            Government(Country1).DiplomaticRelations(Country2) = NewRelationship
            Government(Country2).DiplomaticRelations(Country1) = NewRelationship
        Catch
            MsgStr = "Problem adjusting Diplomatic Relations: "
            MsgStr &= "Country(1 = " & CStr(Country1) & vbCrLf
            MsgStr &= "Country 2 = " & CStr(Country2) & vbCrLf
            MsgStr &= "New Relationship = " & NewRelationship
            MsgBox(MsgStr)
        End Try

    End Sub

    Sub Negotiate(ByVal ActiveGov As Integer, ByVal Other As Integer)
        Dim MsgStr As String = ""
        Dim CurrentRelates As Integer = -100
        Dim StrongerPower As Integer = -1
        Dim PowerRatio As Integer = -1
        Dim i As Integer = 0
        Dim YesOrNo As MsgBoxResult = MsgBoxResult.No
        Dim ProbabilityOfAccord As Integer = MAXIMUM_ACCORD_PROBABILITY / 2
        Dim SavvyBalance As Integer = 0
        Dim Rand As New Random
        Dim ProbabilityOfAccordPercent As Integer = (MAXIMUM_ACCORD_PROBABILITY / 2) * 5 ' NOTE: x5 may depend of MAX... being 20 specifically
        Dim ProbabilityOfAccordPercentStr As String = ""
        Dim TributeCap As Integer = 1
        Dim Tribute As Integer = 0
        Dim TributeDemand As Integer = 0
        Dim TributeStr As String = ""
        Dim TributeDemandStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        Dim DecisionValue As Integer = -1
        Dim NewRelates As Integer = -100
        Dim Random20 As Integer = -1
        Dim CounterOffer As Integer = -1
        Dim j As Integer = 0
        Dim TributeCapacity As Integer = 0

        CurrentRelates = Government(ActiveGov).DiplomaticRelations(Other)

        'First see if should continue
        If CurrentRelates = FRIENDLY Then  ' ALLIED Then 'NOTE, will need to be switched back to ALLIED when diplomcacy made more complex
            MsgBox("You are already Friendly with the " & Government(Other).Name & ".  It doesn't get any better than this.")
            Exit Sub
        Else
            If CurrentRelates = SELF Then
                MsgBox("ERROR: You're trying to negotiate with yourself; something's wrong here.")
                Exit Sub
            Else
                If CurrentRelates = NO_POWER Then
                    MsgBox("ERROR: Can't Negotiate with a Provincial government yet; this form of Diplomacy to be added later.")
                    Exit Sub
                End If
            End If
        End If

        Randomize()

        PowerRatio = CalculatePowerRatio(ActiveGov, Other)

        If PowerRatio > 0 Then
            StrongerPower = ActiveGov
        ElseIf PowerRatio < 0 Then
            StrongerPower = Other
        Else ' if ratio is 0, neither is stronger, so 
            StrongerPower = EQUAL_POWER ' neither
        End If

        ProbabilityOfAccord += PowerRatio

        ' Add in effect of current relationship
        ProbabilityOfAccord += CurrentRelates

        MsgStr = "Your relations with the " & Government(Other).Name & " are currently " & DescribeDiploRelations(ActiveGov, Other) & _
               ". " & vbCrLf & vbCrLf & "You are "

        If Abs(PowerRatio) > 3 Then
            MsgStr &= "much "
        End If

        If StrongerPower = ActiveGov Then
            MsgStr &= "more powerful." & vbCrLf & vbCrLf
        Else
            If StrongerPower = Other Then
                MsgStr &= "less powerful." & vbCrLf & vbCrLf
            Else
                MsgStr &= "about equally powerful." & vbCrLf & vbCrLf
            End If
        End If


        'ProbabilityOfAccord += PowerRatio ' moved this up to be with calculations

        SavvyBalance = Government(ActiveGov).PoliticalSavvy - Government(Other).PoliticalSavvy

        MsgStr &= "Your King is a"

        If Abs(SavvyBalance) > 2 Then
            MsgStr &= " much "
        End If

        If SavvyBalance > 0 Then
            MsgStr &= " more skilled negotiator than the "
        Else
            If SavvyBalance < 0 Then
                MsgStr &= " more skilled negotiator than the "
            Else
                MsgStr &= "n equally skilled negotiator as the "
            End If
        End If

        MsgStr &= Government(Other).Name & "'s. " & DOUBLE_SPACE

        ProbabilityOfAccord += SavvyBalance

        MsgStr &= "Your " & NameReputation(Government(PlayerSide).Reputation) & " reputation "

        Select Case Government(PlayerSide).Reputation
            Case HONEST
                MsgStr &= "helps "
            Case DISHONEST
                MsgStr &= "hurts "
            Case UNCERTAIN
                MsgStr &= "neither helps nor hurts "
        End Select

        MsgStr &= "your chances of reaching an accord." & DOUBLE_SPACE

        ProbabilityOfAccord += Government(PlayerSide).Reputation


        ' Keep Probability of accord within bounds 
        If ProbabilityOfAccord > MAXIMUM_ACCORD_PROBABILITY Then
            ProbabilityOfAccord = MAXIMUM_ACCORD_PROBABILITY
        Else
            If ProbabilityOfAccord < 0 Then
                ProbabilityOfAccord = 0
            End If
        End If

        MsgStr &= "The probability of "

        If CurrentRelates = ENEMY Then
            MsgStr &= "making peace "
        Else
            MsgStr &= "improving relations "
        End If

        ProbabilityOfAccordPercent = ProbabilityOfAccord * 5 ' NOTE: this multiplier may depend on MAX_ACCORD_PROBABILITY being 20 specifically !!
        ProbabilityOfAccordPercentStr = CStr(ProbabilityOfAccordPercent)
        MsgStr &= "is " & ProbabilityOfAccordPercentStr & "%." & vbCrLf & vbCrLf

        If ProbabilityOfAccord = MAXIMUM_ACCORD_PROBABILITY Then
            NewRelates = IncrementDiploRelates(CurrentRelates)
            AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
            MsgStr &= "Therefore the " & Government(Other).Name & " are ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
            MsgStr &= "Do you want to Accept their offer?"
            Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
            If Decision = MsgBoxResult.No Then
                AdjustDiploRelates(ActiveGov, Other, CurrentRelates)
            End If
            Exit Sub
        Else
            If Government(ActiveGov).Treasury > 0 Then
                Tribute = Government(ActiveGov).Treasury \ 10
                If Tribute = 0 Then Tribute = 1
                TributeStr = CStr(Tribute)
                MsgStr &= "You have " & CStr(Government(ActiveGov).Treasury) & ",000 " & CurrencyStr & ". "
                MsgStr &= "You can increase your chances of improving relations by offering to pay some of this to the " & Government(Other).Name & "." & vbCrLf & vbCrLf
            Else
                MsgStr &= "Unfortunately, you have no money, so you can't supplement your king's negotiating skills with any payments."
            End If
            If PowerRatio >= 0 Then
                'TributeCap = PowerRatio + 1
                'If TributeCap > 5 Then
                '    TributeCap = 5
                ' End If
                Try
                    TributeCapacity = 0 ' find 
                    For j = 0 To TotalProvinces - 1
                        If Province(j).PoliticalAffiliation = Other Then
                            TributeCapacity += Province(j).Townspeople
                        End If
                    Next
                Catch
                    MsgBox("Problem figuring Tribute request.")
                End Try
                TributeCap = PowerRatio + 1
                If TributeCap > 5 Then
                    TributeCap = 5
                End If
                If TributeCap > TributeCapacity Then
                    TributeCap = TributeCapacity - 1
                End If
                TributeDemand = TributeCapacity \ (6 - TributeCap)
                TributeDemandStr = CStr(TributeDemand)
                MsgStr &= "You have the power to demand that the " & Government(Other).Name & " pay you, although this will reduce the chances of improving relations somewhat."
                MsgStr &= vbCrLf & vbCrLf
            End If

            If Tribute > 0 And PowerRatio >= 0 Then ' have money to offer, but also are in a position to demand tribute
                MsgStr &= "To Offer a Payment of " & TributeStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                MsgStr &= "To Demand a Payment of " & TributeDemandStr & ",000 " & CurrencyStr & ", Click NO" & vbCrLf
                MsgStr &= "To Continue the Negotiations Without Offering or Demanding any Payment, Click CANCEL"
                Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate")
                Select Case Decision
                    Case MsgBoxResult.Yes
                        DecisionValue = 1
                    Case MsgBoxResult.No
                        DecisionValue = 2
                    Case MsgBoxResult.Cancel
                        DecisionValue = 3
                End Select
            Else
                If Tribute = 0 And PowerRatio >= 0 Then 'don't have money to offer, but have power to ask for it
                    MsgStr &= "To Demand a Payment of " & TributeDemandStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                    MsgStr &= "To Continue the Negotiations Without Demanding any Payment, Click NO"
                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate")
                    If Decision = MsgBoxResult.Yes Then
                        DecisionValue = 2
                    Else
                        DecisionValue = 3
                    End If
                Else
                    If Tribute > 0 And PowerRatio < 0 Then ' have money but are weaker, so can offer tribute but not demand it
                        MsgStr &= "To Offer a Payment of " & TributeStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                        MsgStr &= "To Continue the Negotiations Without Offering any Payment, Click NO"
                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate")
                        If Decision = MsgBoxResult.Yes Then
                            DecisionValue = 1
                        Else
                            DecisionValue = 3
                        End If
                    Else 'no money and weaker so can't offer or demand tribute
                        MsgBox(MsgStr)
                        DecisionValue = 3
                    End If
                End If
            End If

            Select Case DecisionValue
                Case 1 'meaning of integer value above, = are offering money
                    ProbabilityOfAccord += 1
                    Random20 = Rand.Next(1, 21)

                    If Random20 < ProbabilityOfAccord Then
                        Government(ActiveGov).Treasury -= Tribute
                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * Tribute) '-1 says you paid

                    Else 'if random num was greater than Probability of Accord
                        If PowerRatio <= 0 Then ' in this case, equal powers will look for money, not just superior ones (
                            TributeCap = -1 * PowerRatio + 1
                            If TributeCap > 5 Then
                                TributeCap = 5
                            End If
                            Try
                                CounterOffer = (Government(ActiveGov).Treasury / (6 - TributeCap))
                            Catch
                                MsgBox("Problem figuring Tribute request.")
                            End Try
                            If CounterOffer > Tribute Then
                                Decision = MsgBox("The " & Government(Other).Name & " reject your offer, but will accept " & CStr(CounterOffer) & ",000 " & CurrencyStr & "." _
                                                   & vbCrLf & vbCrLf & "This will leave you with " & CStr(Government(ActiveGov).Treasury - CounterOffer) & ",000." _
                                                   & vbCrLf & vbCrLf _
                                                  & "Will you pay that amount?", MsgBoxStyle.YesNo, "Accept Counteroffer?") 'note this code copied below; changes must be made twice
                                If Decision = MsgBoxResult.Yes Then
                                    Government(ActiveGov).Treasury -= CounterOffer
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * CounterOffer) '-1 says you paid
                                Else
                                    If CurrentRelates > ENEMY Then
                                        If Rand.Next(0, 2) = 1 Then ' chance you pissed them off
                                            NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                        Else
                                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                        End If
                                    Else ' if relations already as low as can go
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    End If
                                End If
                            Else 'you offered more than they would demand
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If ' They mull a counter offer

                        Else 'you're stronger than them and you offered money and they still spurned you
                            If Rand.Next(0, 2) = 1 Then
                                CounterOffer = 2 * Tribute
                                Decision = MsgBox("The " & Government(Other).Name & " reject your offer, but will accept " & CStr(CounterOffer) & ",000 " _
                                                   & CurrencyStr & ".  This will leave you with " & CStr(Government(ActiveGov).Treasury - CounterOffer) & ",000." _
                                                   & vbCrLf & vbCrLf _
                                                   & "Will you pay that amount?", MsgBoxStyle.YesNo, "Accept Counteroffer?") 'note this code copied above; changes must be made twice
                                If Decision = MsgBoxResult.Yes Then
                                    Government(ActiveGov).Treasury -= CounterOffer
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * CounterOffer) '-1 signals you paid
                                Else
                                    If CurrentRelates > ENEMY Then
                                        If Rand.Next(0, 2) = 1 Then ' chance you pissed them off
                                            NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                        Else
                                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                        End If
                                    Else ' if relations already as low as can go
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    End If
                                End If

                            Else ' if they don't randomly ask for twice your offer"
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If ' if they randomly ask for more than you offer or not
                        End If 'they're equal or stronger than you or are weaker

                    End If 'Random num was lower or higher than Probabilty threshhold
                Case 2 ' meaning defined above; means decided to demand tribute

                    ProbabilityOfAccord -= Rand.Next(1, TributeCap)
                    Random20 = Rand.Next(1, 21)

                    If Random20 < ProbabilityOfAccord Then
                        Government(ActiveGov).Treasury += TributeDemand
                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, TributeDemand)
                    Else 'if random num was greater than Probability of Accord Percent
                        If Random20 <= ProbabilityOfAccord * 2 Then ' they bargain
                            CounterOffer = TributeDemand \ (6 - TributeCap)
                            Decision = MsgBox("The " & Government(Other).Name & " protest that they cannot pay " & TributeDemandStr & ",000 " _
                                   & CurrencyStr & ".  They offer to pay " & CStr(CounterOffer) & ",000 instead." & vbCrLf & vbCrLf _
                                   & "Will you accept their counteroffer?", MsgBoxStyle.YesNo, "Accept Counteroffer?")
                            If Decision = MsgBoxResult.Yes Then
                                Government(ActiveGov).Treasury += CounterOffer
                                NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, CounterOffer)
                            Else ' player doesn't accept counteroffer
                                Select Case Rand.Next(0, 3)
                                    Case 0
                                        Government(ActiveGov).Treasury += TributeDemand
                                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, TributeDemand)
                                    Case 1
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    Case 2
                                        NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                End Select
                            End If
                        Else 'they refuse to bargain
                            If Rand.Next(0, 2) = 1 Then
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            Else
                                NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                            End If
                        End If ' if random > PoA
                    End If 'random is less or more than Probability of Accord
                Case Else 'Cancel or DecisionValue = 3; no payment either way selected

                    If PowerRatio < 0 Then
                        TributeCap = -1 * PowerRatio
                        If TributeCap > 4 Then
                            TributeCap = 4
                        End If
                        Try
                            Tribute = (Government(ActiveGov).Treasury / (5 - TributeCap))
                        Catch
                            MsgBox("Problem figuring Tribute request.")
                        End Try
                        TributeStr = CStr(Tribute)
                        Decision = MsgBox("The " & Government(Other).Name & " demand that you pay tribute of " & TributeStr & ",000 " _
                                          & CurrencyStr & ". This will leave you " & CStr(Government(ActiveGov).Treasury - Tribute) _
                                           & ",000." & vbCrLf & vbCrLf & _
                                          "Will you pay?", MsgBoxStyle.YesNo, "Pay tribute?")
                        If Decision = vbYes Then
                            Government(ActiveGov).Treasury -= Tribute
                            NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * Tribute) ' -1 signals you paid
                        Else ' won't pay 
                            ProbabilityOfAccord -= 1
                            If ProbabilityOfAccord < 0 Then ProbabilityOfAccord = 0

                            Random20 = Rand.Next(1, 21)

                            If Random20 < ProbabilityOfAccord Then
                                NewRelates = IncrementDiploRelates(CurrentRelates)
                                AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
                                MsgStr = "The " & Government(Other).Name & " are ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
                                MsgStr &= "Do you want to Accept their Offer?"
                                Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
                                AdjustDiploRelates(ActiveGov, Other, CurrentRelates) ' go back to current 
                                If Decision = MsgBoxResult.Yes Then
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, 0)
                                End If
                            Else
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If

                        End If 'will pay 

                    Else ' Power Ratio 0 or greater

                        Random20 = Rand.Next(1, 21)

                        If Random20 < ProbabilityOfAccord Then
                            NewRelates = IncrementDiploRelates(CurrentRelates)
                            AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
                            MsgStr = "The " & Government(Other).Name & " are ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
                            MsgStr &= "Do you want to Accept their Offer?"
                            Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
                            AdjustDiploRelates(ActiveGov, Other, CurrentRelates) ' go back to current
                            If Decision = MsgBoxResult.Yes Then
                                NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, 0)
                            End If
                        Else
                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                        End If
                    End If 'Power Ratio < 0
            End Select ' end case other: 

        End If 'not a sure thing

    End Sub

    Function CalculatePowerRatio(ByVal ActiveGov As Integer, ByVal OtherGov As Integer) As Integer
        Dim PwrRatio As Integer = -100
        Dim ActiveArmySize, OtherArmySize, ArmySizeDifferential, Fortifications, LeadershipDifferential, MoraleDifferential As Integer

        ActiveArmySize = Government(ActiveGov).Cavalary + Government(ActiveGov).Infantry
        OtherArmySize = Government(OtherGov).Cavalary + Government(OtherGov).Infantry

        If ActiveArmySize > OtherArmySize Then
            'For i = 0 To TotalProvinces
            '    If Province(i).PoliticalAffiliation = Other Then
            '        Fortifications += Province(i).Forts
            '    End If
            'Next
            ArmySizeDifferential = ActiveArmySize / (OtherArmySize + Fortifications)
        Else
            'For i = 0 To TotalProvinces
            '    If Province(i).PoliticalAffiliation = ActiveGovernment Then
            '        Fortifications += Province(i).Forts
            '    End If
            'Next
            ArmySizeDifferential = -(OtherArmySize / (ActiveArmySize + Fortifications))
        End If
        LeadershipDifferential = (Government(ActiveGov).Generalship - Government(OtherGov).Generalship) \ 2
        MoraleDifferential = (Government(ActiveGov).ArmyState - Government(OtherGov).ArmyState) \ 2

        PwrRatio = ArmySizeDifferential + LeadershipDifferential + MoraleDifferential

        Return PwrRatio

    End Function

    Function NegotiationsSucceed(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = IncrementDiploRelates(RelatesNow)
        AdjustDiploRelates(ActGov, OtherPower, NewRel)
        MsgStr = "The Negotiations succeeded; the " & Government(OtherPower).Name & " have become " & DescribeDiploRelations(ActGov, OtherPower) & " towards you."
        If Trib > 0 Then
            MsgStr &= vbCrLf & vbCrLf & "They paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= " You paid them " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function NegotiationsFail(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = RelatesNow
        MsgStr = "The Negotiations failed, and your relationship with the " & Government(OtherPower).Name & " remains " & DescribeDiploRelations(ActGov, OtherPower) & "."
        If Trib > 0 Then
            MsgStr &= " They paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= vbCrLf & vbCrLf & " You paid them " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function NegotiationsBackfire(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = DecrementDiploRelates(RelatesNow)
        AdjustDiploRelates(ActGov, OtherPower, NewRel)
        MsgStr = "The Negotiations angered the " & Government(OtherPower).Name & ", and they are now " & DescribeDiploRelations(ActGov, OtherPower) & " towards you."
        If Trib > 0 Then
            MsgStr &= " They paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= vbCrLf & vbCrLf & " You paid them " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function IncrementDiploRelates(ByVal StartingRelates As Integer) As Integer
        Dim EndingRelates As Integer = -100

        If StartingRelates < FRIENDLY Then
            EndingRelates = StartingRelates + 1
        Else
            EndingRelates = StartingRelates
        End If

        Return EndingRelates

    End Function

    Function DecrementDiploRelates(ByVal StartingRelates As Integer) As Integer
        Dim EndingRelates As Integer = -100

        If StartingRelates > HOSTILE Then
            EndingRelates = StartingRelates - 1
        Else
            EndingRelates = StartingRelates
        End If

        Return EndingRelates

    End Function

    Function DetermineIfGovernmentsContiguous(ByVal Gvt1 As Integer, ByVal Gvt2 As Integer) As Boolean
        Dim AreContiguous As Boolean = False
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim PotentialContiguousArea As Integer = -1
        Dim PotentialContiguousProvince As Integer = -1

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = Gvt1 Then
                For j = 0 To MAX_NEIGHBORS_LAND - 1
                    If Province(i).Connectors(j) >= RIVER Then ' if neighbor is land connection
                        PotentialContiguousArea = Province(i).Neighbors(j)
                        PotentialContiguousProvince = Area(PotentialContiguousArea).Province
                        If Province(PotentialContiguousProvince).PoliticalAffiliation = Gvt2 Then
                            AreContiguous = True
                            Exit For
                        End If
                    End If
                Next
                If AreContiguous = True Then
                    Exit For
                End If
            End If
        Next

        Return AreContiguous

    End Function

    Sub ClearOutLoser(ByVal EliminatedGovernment As Integer)
        Dim i As Integer

        Government(EliminatedGovernment).Name = ELIMINATED_POWER_STRING
        Government(EliminatedGovernment).Infantry = 0
        Government(EliminatedGovernment).Cavalary = 0
        Government(EliminatedGovernment).Language = NO_LANGUAGE
        Government(EliminatedGovernment).Religion = NO_RELIGION
        Government(EliminatedGovernment).Generalship = UNDEFINED
        Government(EliminatedGovernment).ArmyState = UNDEFINED
        Government(EliminatedGovernment).LeadershipState = UNDEFINED
        Government(EliminatedGovernment).PoliticalSavvy = UNDEFINED
        Government(EliminatedGovernment).RoyalEstates = 0
        Government(EliminatedGovernment).Support = UNDEFINED
        Government(EliminatedGovernment).Treasury = 0
        Government(EliminatedGovernment).TotalBenefices = 0

        For i = 0 To TotalGovernments - 1
            Government(EliminatedGovernment).DiplomaticRelations(i) = UNDEFINED
        Next

    End Sub

    Sub NewPeoples()
        Dim GovNum As Integer = NO_POWER
        Select Case TurnDate
            Case 560
                GovNum = FindFreeGovNum()
                SetUpAvars(GovNum)
        End Select
    End Sub

    Function FindFreeGovNum()
        Dim FreeNum As Integer = NO_POWER
        For i = 1 To TotalGovernments - 1
            If Government(i).Name = ELIMINATED_POWER_STRING Then
                FreeNum = i
                Exit For
            End If
        Next
        If FreeNum < 0 Then
            If TotalGovernments < MAX_GOVERNMENTS Then
                FreeNum = TotalGovernments
                TotalGovernments += 1
            Else
                MsgBox("Error: too many governments already to add another")
            End If
        End If
        Return FreeNum

    End Function

 
    'Sub IncrementConquestVPs(ByVal Province As Integer)
    '    'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
    '    ConquestVPs += PROVINCE_VP_VALUE
    '    RefreshConquestVP_Display()
    '    AdjustTotalVPs()
    'End Sub

    'Sub DecrementConquestVPs(ByVal Province As Integer)
    '    'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
    '    ConquestVPs -= PROVINCE_VP_VALUE
    '    RefreshConquestVP_Display()
    '    AdjustTotalVPs()
    'End Sub

    Sub IncrementSocialVPs(ByVal EndState As Integer)
        ' end state is in case want to give greater values for Golden Age / Chaos
        SocialVPs += SOCIAL_STATE_VP_VALUE
        RefreshSocialStateVP_Display()
        AdjustTotalVPs()
    End Sub

    Sub DecrementSocialVPs(ByVal EndState As Integer)
        ' end state is in case want to give greater values for Golden Age / Chaos
        SocialVPs -= SOCIAL_STATE_VP_VALUE
        RefreshSocialStateVP_Display()
        AdjustTotalVPs()
    End Sub

    Sub IncrementCulturalVPs(ByVal Amount As Integer)

        CulturalVPs += Amount
        RefreshCulturalVP_Display()
        AdjustTotalVPs()
    End Sub

    Sub DecrementCulturalVPs(ByVal Amount As Integer)

        CulturalVPs -= Amount
        RefreshCulturalVP_Display()
        AdjustTotalVPs()
    End Sub

    Sub AdjustTotalVPs()

        TotalVPs = ConquestVPs + SocialVPs + CulturalVPs
        RefreshTotalVP_Display()

    End Sub

    Sub IncrementReputation(ByVal Power As Integer, ByVal Amount As Integer)
        Dim i As Integer = 0

        For i = 1 To Amount
            If Government(Power).Reputation < MAX_REPUTE Then
                Government(Power).Reputation += 1
            End If
        Next

    End Sub

    Sub DecrementReputation(ByVal Power As Integer, ByVal Amount As Integer)
        Dim i As Integer = 0

        For i = 1 To Amount
            If Government(Power).Reputation > MIN_REPUTE Then
                Government(Power).Reputation -= 1
            End If
        Next

    End Sub

End Module
