﻿Public Class frmGovernmentInfo

    Dim TextboxChanged As Boolean = False
    Dim RecordChanged As Boolean = False
    Dim ShowNames As Boolean = False

    Private Sub frmGovernmentInfo_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        PopulateGovernmentDisplay(SelectedGovernment)
        ColorBoxes(SelectedGovernment)
        TextboxChanged = False
        RecordChanged = False

        If Playing = vbYes Then
            Me.btnRecord.Hide()
            Me.btnRestoreData.Hide()
            Me.btnSave.Hide()
        End If


    End Sub

    Private Sub btnNextGovernment_Click(sender As System.Object, e As System.EventArgs) Handles btnNextGovernment.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then ' whenver Record Changes, Textbox change set to false, so this test shouldn't be needed.
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedGovernment < TotalGovernments - 1 Then
            SelectedGovernment += 1
        Else
            SelectedGovernment = 1
        End If

        PopulateGovernmentDisplay(SelectedGovernment) '(Area(SelectedArea).Province)
        TextboxChanged = False
        ColorBoxes(SelectedGovernment)

        Me.Refresh()

    End Sub

    Private Sub btnCloseGovernmentInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnCloseGovernmentInfo.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        If RecordChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        Close()


    End Sub

    Private Sub btnPreviousGovernment_Click(sender As System.Object, e As System.EventArgs) Handles btnPreviousGovernment.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then 'see above
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedGovernment > 1 Then
            SelectedGovernment -= 1
        Else
            SelectedGovernment = TotalGovernments - 1
        End If

        PopulateGovernmentDisplay(SelectedGovernment) '(Area(SelectedArea).Province)
        ColorBoxes(SelectedGovernment)
        TextboxChanged = False

        Me.Refresh()


    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If RecordChanged = False Then
            MsgBox("No Information Updated; No reason to Save")
            Exit Sub
        End If

        If TextboxChanged = True Then
            MsgBox("Recent Change(s) Unrecorded. Save Without Them?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        MsgBoxResult = MsgBox("Update Permanent Record?", MsgBoxStyle.YesNo, "Failsafe")
        If MsgBoxResult = vbYes Then
            SaveGovernments(PLAYER_SAVE)
            RecordChanged = False
        End If



    End Sub

    Private Sub btnRecord_Click(sender As System.Object, e As System.EventArgs) Handles btnRecord.Click
        'So can Backup existing values in case of problem
        Dim Arm, Cav, Gen, Inf, LS, Rel, Roy, Sup, TB, Tres, La, PS, LC As Integer
        Dim Na As String

        Arm = Government(SelectedGovernment).ArmyState
        Cav = Government(SelectedGovernment).Cavalary
        Gen = Government(SelectedGovernment).Generalship
        Inf = Government(SelectedGovernment).Infantry
        LS = Government(SelectedGovernment).LeadershipState
        Rel = Government(SelectedGovernment).Religion
        Roy = Government(SelectedGovernment).RoyalEstates
        Sup = Government(SelectedGovernment).Support
        TB = Government(SelectedGovernment).TotalBenefices
        Tres = Government(SelectedGovernment).Treasury
        Na = Government(SelectedGovernment).Name
        La = Government(SelectedGovernment).Language
        PS = Government(SelectedGovernment).PoliticalSavvy
        LC = Government(SelectedGovernment).LawCode

        If TextboxChanged = False Then
            MsgBox("No Information Updated; No reason to Record")
            Exit Sub
        End If

        Try
            Government(SelectedGovernment).ArmyState = CInt(Me.txtArmyState.Text)
            Government(SelectedGovernment).Cavalary = CInt(Me.txtCavalry.Text)
            Government(SelectedGovernment).Generalship = CInt(Me.txtGeneralship.Text)
            Government(SelectedGovernment).Infantry = CInt(Me.txtInfantry.Text)
            Government(SelectedGovernment).LawCode = CInt(Me.txtLawCode.Text)
            Government(SelectedGovernment).LeadershipState = CInt(Me.txtLeadershipState.Text)
            Government(SelectedGovernment).Name = Me.txtName.Text
            Government(SelectedGovernment).Language = CInt(Me.txtLanguage.Text)
            Government(SelectedGovernment).PoliticalSavvy = CInt(Me.txtPoliticalSavvy.Text)
            Government(SelectedGovernment).Religion = CInt(Me.txtReligion.Text)
            Government(SelectedGovernment).RoyalEstates = CInt(Me.txtRoyalEstates.Text)
            Government(SelectedGovernment).Support = CInt(Me.txtSupport.Text)
            Government(SelectedGovernment).TotalBenefices = CInt(Me.txtTotalBenefices.Text)

            AdjustDiploRelates(SelectedGovernment, 1, CInt(Me.txtKingdom1.Text))
            AdjustDiploRelates(SelectedGovernment, 2, CInt(Me.txtKingdom2.Text))
            AdjustDiploRelates(SelectedGovernment, 3, CInt(Me.txtKingdom3.Text))
            AdjustDiploRelates(SelectedGovernment, 4, CInt(Me.txtKingdom4.Text))
            AdjustDiploRelates(SelectedGovernment, 5, CInt(Me.txtKingdom5.Text))
            AdjustDiploRelates(SelectedGovernment, 6, CInt(Me.txtKingdom6.Text))
            AdjustDiploRelates(SelectedGovernment, 7, CInt(Me.txtKingdom7.Text))
            AdjustDiploRelates(SelectedGovernment, 8, CInt(Me.txtKingdom8.Text))
            AdjustDiploRelates(SelectedGovernment, 9, CInt(Me.txtKingdom9.Text))
            AdjustDiploRelates(SelectedGovernment, 10, CInt(Me.txtKingdom10.Text))
            'Government(SelectedGovernment).DiplomaticRelations(1) = CInt(Me.txtKingdom1.Text)
            'Government(SelectedGovernment).DiplomaticRelations(2) = CInt(Me.txtKingdom2.Text)
            'Government(SelectedGovernment).DiplomaticRelations(3) = CInt(Me.txtKingdom3.Text)
            'Government(SelectedGovernment).DiplomaticRelations(4) = CInt(Me.txtKingdom4.Text)
            'Government(SelectedGovernment).DiplomaticRelations(5) = CInt(Me.txtKingdom5.Text)
            'Government(SelectedGovernment).DiplomaticRelations(6) = CInt(Me.txtKingdom6.Text)
            'Government(SelectedGovernment).DiplomaticRelations(7) = CInt(Me.txtKingdom7.Text)
            'Government(SelectedGovernment).DiplomaticRelations(8) = CInt(Me.txtKingdom8.Text)
            'Government(SelectedGovernment).DiplomaticRelations(9) = CInt(Me.txtKingdom9.Text)
            'Government(SelectedGovernment).DiplomaticRelations(10) = CInt(Me.txtKingdom10.Text)
            RecordChanged = True
            TextboxChanged = False

        Catch
            MsgBox("Invalid Value in a Textbox (A Blank?)")
            Government(SelectedGovernment).ArmyState = Arm
            Government(SelectedGovernment).Cavalary = Cav
            Government(SelectedGovernment).Generalship = Gen
            Government(SelectedGovernment).Infantry = Inf
            Government(SelectedGovernment).LawCode = LC
            Government(SelectedGovernment).LeadershipState = LS
            Government(SelectedGovernment).Language = La
            Government(SelectedGovernment).Name = Na
            Government(SelectedGovernment).PoliticalSavvy = PS
            Government(SelectedGovernment).Religion = Rel
            Government(SelectedGovernment).RoyalEstates = Roy
            Government(SelectedGovernment).Support = Sup
            Government(SelectedGovernment).TotalBenefices = TB
            Government(SelectedGovernment).Treasury = Tres
        End Try
    End Sub

    Private Sub txtName_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtName.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom5_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom5.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtArmyState_TextChanged(sender As Object, e As System.EventArgs) Handles txtArmyState.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom1_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom1.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub txtKingdom2_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom2.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom3_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom3.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom4_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom4.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom6_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom6.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom7_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom7.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom8_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom8.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom9_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom9.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtKingdom10_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtKingdom10.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub ColorBoxes(ByVal SelGov As Integer)
        Me.txtName.BackColor = GetGovernmentColor(SelGov)

        Me.txtKingdom1.BackColor = POWER_1_COLOR
        Me.txtKingdom2.BackColor = POWER_2_COLOR
        Me.txtKingdom3.BackColor = POWER_3_COLOR
        Me.txtKingdom4.BackColor = POWER_4_COLOR
        Me.txtKingdom5.BackColor = POWER_5_COLOR
        Me.txtKingdom6.BackColor = POWER_6_COLOR
        Me.txtKingdom7.BackColor = POWER_7_COLOR
        Me.txtKingdom8.BackColor = POWER_8_COLOR
        Me.txtKingdom9.BackColor = POWER_9_COLOR
        Me.txtKingdom10.BackColor = POWER_10_COLOR

        Me.txtReligion.BackColor = GetReligionColor(Government(SelGov).Religion)
        Me.txtLanguage.BackColor = GetLanguageColor(Government(SelGov).Language)
        Me.txtSupport.BackColor = GetLoyaltyColor(Government(SelGov).Support)
    End Sub

    Private Sub txtCavalry_TextChanged(sender As Object, e As System.EventArgs) Handles txtCavalry.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtGeneralship_TextChanged(sender As Object, e As System.EventArgs) Handles txtGeneralship.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtID_TextChanged(sender As Object, e As System.EventArgs) Handles txtID.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtInfantry_TextChanged(sender As Object, e As System.EventArgs) Handles txtInfantry.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtLanguage_TextChanged(sender As Object, e As System.EventArgs) Handles txtLanguage.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtLawCode_TextChanged(sender As Object, e As System.EventArgs) Handles txtLawCode.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtLeadershipState_TextChanged(sender As Object, e As System.EventArgs) Handles txtLeadershipState.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtNavalCapability_TextChanged(sender As Object, e As System.EventArgs) Handles txtNavalCapability.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtPoliticalSavvy_TextChanged(sender As Object, e As System.EventArgs) Handles txtPoliticalSavvy.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtReligion_TextChanged(sender As Object, e As System.EventArgs) Handles txtReligion.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtReputation_TextChanged(sender As Object, e As System.EventArgs) Handles txtReputation.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtRoyalEstates_TextChanged(sender As Object, e As System.EventArgs) Handles txtRoyalEstates.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtSupport_TextChanged(sender As Object, e As System.EventArgs) Handles txtSupport.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTotalBenefices_TextChanged(sender As Object, e As System.EventArgs) Handles txtTotalBenefices.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTreasury_TextChanged(sender As Object, e As System.EventArgs) Handles txtTreasury.TextChanged
        TextboxChanged = True

    End Sub
End Class