﻿Imports System.IO

Public Class frmMapScreen
    'Option Infer Off

    Public CanSeeControls As Boolean = True
    Public CanSeeMap As Boolean = False
    Public ShowingNames As Boolean = True
    Public ctrl As Control
    Public DieRoll As Integer = 0
    Public Climates As Integer()
    Public Affiliations As Integer()
    Public Loyalties As Integer()
    Public Religions As Integer()


    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim GovernmentID As Integer = 0
        'Dim Play As MsgBoxResult = vbYes ' commented out because made into a global variable
        Dim GameToLoad As Integer = NEW_GAME
        Dim WantsNewGame As MsgBoxResult = vbYes
        Dim Type As String 'System.Type
        Dim Instance As TextBox
        Dim SavedGameExists As Boolean = True
        Dim StartDateStr As String = ""
        Dim StartTimeStr As String = ""
        'Dim TopActionButtonLocation As System.Drawing.Point

        'Autosave()

        Me.Left = 0
        Me.Top = 0
        Me.Width = 1366
        Me.Height = 768

        Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
        CanSeeMap = True

        Try
            ImportProvinces(SAVED_GAME) ' test and see if saved game exists
        Catch
            SavedGameExists = False ' if error, no game exists, then set up to skip ask to player if wants new or saved game
        End Try

        If SavedGameExists = True Then
            WantsNewGame = MsgBox("Do you want to Resume your Saved Game?" & vbCrLf & vbCrLf _
                                  & "Click YES to do so; click NO to Start a New Game", MsgBoxStyle.YesNo, "Play New or Saved Game?")
            If WantsNewGame = MsgBoxResult.Yes Then
                GameToLoad = SAVED_GAME
            Else
                StartDateStr = DateString
                StartTimeStr = TimeString
                StartDateTimeStr = GetDateTimeIntStr(StartDateStr, StartTimeStr)
            End If
        Else
            StartDateStr = DateString
            StartTimeStr = TimeString
            StartDateTimeStr = GetDateTimeIntStr(StartDateStr, StartTimeStr)
        End If

        'Load Data 
        Try
            ImportAreas() 'These aren't changed during play

        Catch
            MsgBox("Area Info Missing")
        End Try

        Try
            ImportProvinces(GameToLoad)
        Catch
            MsgBox("Province Info Missing")
        End Try

        Try
            ImportSeas(GameToLoad)
        Catch
            MsgBox("Sea Info Missing")
        End Try

        Try
            ImportConnectors(GameToLoad)
        Catch
            MsgBox("Connector Info Missing")
        End Try

        Try
            ImportGovernments(GameToLoad)
        Catch
            MsgBox("Government Info Missing")
        End Try

        If GameToLoad = SAVED_GAME Then
            Try
                ImportGlobals()
            Catch
                MsgBox("Global Info Missing")
            End Try
        Else
            TurnDate = ScenarioStartDate
        End If

        'Set up Graphics
        'Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
        'CanSeeMap = True

        Me.lblDate.Text = DATE_LBL_BASE & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & " C.E."
        RefreshConquestVP_Display()
        RefreshSocialStateVP_Display()
        RefreshCulturalVP_Display()
        AdjustTotalVPs()
        Me.gbxVPs.Text &= CStr(VictoryPointGoal)

        SetUpAffliationColors() ' remember this may need to be moved if governments becomes dynamic as it should

        Playing = MsgBox("Do you want to play?", MsgBoxStyle.YesNo) ' this put in so can just enter data if want to 'vbYes 'put this in to avoid data entry option


        If Playing = vbYes Then ' if Msgbox commented out, will default to vbYes, play (not data entry) because Play initialized to yes above.
            For Each Me.ctrl In Controls
                Type = Me.ctrl.Name.Substring(0, 3)
                If Type = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shouldn't be needed now that Date is a label
                    Instance = Me.ctrl
                    Instance.ReadOnly = True
                End If
            Next
        End If
        If GameToLoad = NEW_GAME Then
            frmBeginGame.ShowDialog()
            CurrentAction = INTRODUCTION
            'frmHelpDisplay.ShowDialog()
            frmIntroDisplay.ShowDialog()
            btnStartGame.Location = btnAttack.Location
        Else
            UpdateTextboxes() ' may have to change this around since moved game start to StartGame button
            AutoTurn()
        End If


    End Sub

    Private Sub SetUpAffliationColors()
        ReDim AffiliationColors(MaxAffiliationColors)

        'Set up Neighbor Color array
        AffiliationColors(LOCAL_CONTROL) = LOCAL_CONTROL_COLOR
        AffiliationColors(POWER_1) = POWER_1_COLOR
        AffiliationColors(POWER_2) = POWER_2_COLOR
        AffiliationColors(POWER_3) = POWER_3_COLOR
        AffiliationColors(POWER_4) = POWER_4_COLOR
        AffiliationColors(POWER_5) = POWER_5_COLOR
        AffiliationColors(POWER_6) = POWER_6_COLOR
        AffiliationColors(POWER_7) = POWER_7_COLOR
        AffiliationColors(POWER_8) = POWER_8_COLOR
        AffiliationColors(POWER_9) = POWER_9_COLOR
        AffiliationColors(POWER_10) = POWER_10_COLOR
        AffiliationColors(POWER_11) = POWER_11_COLOR
        AffiliationColors(POWER_12) = POWER_12_COLOR
        AffiliationColors(POWER_13) = POWER_13_COLOR
        AffiliationColors(POWER_14) = POWER_14_COLOR
        AffiliationColors(OTHER_CONTROLLER) = DISTANT_KINGDOM_COLOR

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles btnToggleControls.Click

        If CanSeeControls = True Then
            ShapeContainer1.Visible = False
            CanSeeControls = False
        Else
            ShapeContainer1.Visible = True
            CanSeeControls = True
        End If

    End Sub

    Private Sub btnShowProvinceInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnShowProvinceInfo.Click

        SelectedArea = 0

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub btnEnd_Click(sender As System.Object, e As System.EventArgs) Handles btnEnd.Click
        Dim Decision As MsgBoxResult

        Decision = MsgBox("Are you sure you want to stop playing?", vbYesNo, "Exit?")
        If Decision = vbYes Then
            End
        End If

    End Sub

    Private Sub btnToggleMap_Click(sender As System.Object, e As System.EventArgs) Handles btnToggleMap.Click
        If CanSeeMap = False Then
            Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
            CanSeeMap = True

        Else
            Me.BackgroundImage = Nothing 'EternalFrance1.My.Resources.Resources.Nothing
            CanSeeMap = False

        End If


    End Sub

    Private Sub btnCreateDatabase_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateDatabase.Click
        'Creates the Geography Database: Provinces and Seas

        Dim AreaNumber As Integer = 0
        Dim ProvinceNumber As Integer = 0
        Dim SeaZone As Integer = 0
        Dim ConnectorNumber As Integer = 0
        Dim NumConnectors As Integer = 0
        Dim ControlIndicator As String
        Dim Neighbor As Integer = 0
        Dim LineToSave As String = ""
        Dim SavePlace As String = ""
        Dim NumProvinces As Integer = 0
        Dim NumSeas As Integer = 0
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult


        If rbnName.Checked = False Then
            MsgBox("Building now will corrupt names")
            Exit Sub
        End If

        If rbnTerrain.Checked = False Then
            MsgBox("Building now will corrupt terrains")
            Exit Sub
        End If

        MsgBoxResult = MsgBox("Do you really want to rebuild the Database?", MsgBoxStyle.YesNo, "Failsafe")
        If MsgBoxResult = vbNo Then
            Exit Sub
        End If

        PreserveDynamicProvinceInfo()


        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shouldn't be needed now that Date is a label
                ReDim Preserve Area(AreaNumber)
                Area(AreaNumber).Name = Me.ctrl.Text
                Area(AreaNumber).ID = AreaNumber
                Area(AreaNumber).MapElement = Me.ctrl.Name

                Select Case Me.ctrl.BackColor
                    Case OCEAN_COLOR
                        Area(AreaNumber).Type = WATER
                        Area(AreaNumber).Topography = OCEAN
                    Case COASTAL_COLOR
                        Area(AreaNumber).Type = WATER
                        Area(AreaNumber).Topography = COASTAL
                    Case FLATLAND_COLOR
                        Area(AreaNumber).Type = LAND
                        Area(AreaNumber).Topography = FLATLAND
                    Case RUGGED_COLOR
                        Area(AreaNumber).Type = LAND
                        Area(AreaNumber).Topography = RUGGED
                    Case MOUNTAIN_COLOR
                        Area(AreaNumber).Type = LAND
                        Area(AreaNumber).Topography = MOUNTAINS
                End Select

                If Area(AreaNumber).Type = LAND Then
                    'Province(ProvinceNumber).AreaNumber = AreaNumber
                    Area(AreaNumber).Province = ProvinceNumber 'make backward connection so can link from Area to Province for neighbors
                    NumProvinces += 1
                Else
                    'Sea(SeaZone).AreaNumber = AreaNumber
                    Area(AreaNumber).Province = ProvinceNumber 'make backward connection so can link from Area to Province for neighbors
                    NumSeas += 1
                End If

                'Build combo boxes for neighbors
                frmProvinceInfo.cbxNeighbor1.Items.Add(Area(AreaNumber).Name)
                frmProvinceInfo.cbxNeighbor2.Items.Add(Area(AreaNumber).Name)
                frmProvinceInfo.cbxNeighbor3.Items.Add(Area(AreaNumber).Name)
                frmProvinceInfo.cbxNeighbor4.Items.Add(Area(AreaNumber).Name)
                frmProvinceInfo.cbxNeighbor5.Items.Add(Area(AreaNumber).Name)
                frmProvinceInfo.cbxNeighbor6.Items.Add(Area(AreaNumber).Name)



                AreaNumber += 1

            End If
        Next

        TotalAreas = AreaNumber

        For AreaNumber = AreaNumber - 1 To 0 Step -1

            If Area(AreaNumber).Type = LAND Then 'If land, then fill out province info
                ReDim Preserve Province(ProvinceNumber)
                ReDim Province(ProvinceNumber).Neighbors(MAX_NEIGHBORS_LAND - 1) '-1 because top array index = 1 less than actual max
                ReDim Province(ProvinceNumber).Connectors(MAX_NEIGHBORS_LAND - 1)
                ReDim Province(ProvinceNumber).ConnectorNames(MAX_NEIGHBORS_LAND - 1)

                Province(ProvinceNumber).Name = Area(AreaNumber).Name 'frmProvinceInfo.txtProvinceName.Text
                Province(ProvinceNumber).ID = ProvinceNumber 'CInt(frmProvinceInfo.txtProvinceID.Text)
                Province(ProvinceNumber).AreaNumber = AreaNumber
                Area(AreaNumber).Province = ProvinceNumber 'make backward connection so can link from Area to Province for neighbors
                Province(ProvinceNumber).MapElement = Area(AreaNumber).MapElement 'frmProvinceInfo.txtAssociatedTextbox.Text
                Province(ProvinceNumber).Topography = Area(AreaNumber).Topography 'CInt(frmProvinceInfo.txtTopgraphy.Text)


                'Province(ProvinceNumber).PoliticalAffiliation = LOCAL_CONTROL
                Province(ProvinceNumber).Farmland = 500 \ (Province(ProvinceNumber).Topography + 2)
                Province(ProvinceNumber).Peasants = 200 \ (Province(ProvinceNumber).Topography + 1)
                Province(ProvinceNumber).AgricultureLevel = TWO_FIELD
                Province(ProvinceNumber).SurplusPopulation = 0 'Province(ProvinceNumber).Peasants + (Province(ProvinceNumber).AgricultureLevel * Province(ProvinceNumber).Peasants \ 20)
                Province(ProvinceNumber).HarvestActual = 0
                Province(ProvinceNumber).Nobles = Province(ProvinceNumber).Peasants \ 100
                Province(ProvinceNumber).Clergy = Province(ProvinceNumber).Peasants \ 100
                Province(ProvinceNumber).Townspeople = Province(ProvinceNumber).Peasants \ 100
                Province(ProvinceNumber).SocialState = ORDERLY

                AddInDynamicProvinceInfo(ProvinceNumber)

                'ClearProvinceDisplay()

                ProvinceNumber += 1 ' get ready for next province, or if it's the last one, will record actual # of provinces

            Else 'if not Land, = Sea

                ReDim Preserve Sea(SeaZone)
                ReDim Sea(SeaZone).Neighbors(MAX_NEIGHBORS_SEA - 1) '-1 because top array index = 1 less than actual max
                ReDim Sea(SeaZone).Connectors(MAX_NEIGHBORS_SEA - 1)
                ReDim Sea(SeaZone).ConnectorNames(MAX_NEIGHBORS_SEA - 1)
                'frmProvinceInfo.txtProvinceID.Text = SeaZone

                Sea(SeaZone).Name = Area(AreaNumber).Name 'frmProvinceInfo.txtProvinceName.Text
                Sea(SeaZone).ID = SeaZone 'CInt(frmProvinceInfo.txtProvinceID.Text)
                Area(AreaNumber).Province = SeaZone 'Will require 2 step idenification: type and number
                Sea(SeaZone).AreaNumber = AreaNumber
                Sea(SeaZone).MapElement = Area(AreaNumber).MapElement 'frmProvinceInfo.txtAssociatedTextbox.Text
                Sea(SeaZone).Topography = Area(AreaNumber).Topography 'CInt(frmProvinceInfo.txtTopgraphy.Text)

                Sea(SeaZone).Controller = NONE

                ClearProvinceDisplay()

                SeaZone += 1

            End If

        Next

        TotalProvinces = ProvinceNumber
        TotalSeas = SeaZone

        InitializeNeighborsNconnections()
        SetUpConnections()
        FindNeighbors()

        SaveConnectors()
        SaveAreas()
        SaveProvinces(PLAYER_SAVE)
        SaveSeas()

        MsgBox("Database Build Complete")

    End Sub

    Private Sub PreserveDynamicProvinceInfo()
        Dim ProvinceNum As Integer
        ReDim Climates(TotalProvinces)        'Note: Climates is declared at top of module as array of int
        ReDim Affiliations(TotalProvinces)  'ditto
        ReDim Loyalties(TotalProvinces)
        ReDim Religions(TotalProvinces)

        For ProvinceNum = 0 To TotalProvinces - 1
            Climates(ProvinceNum) = Province(ProvinceNum).Climate
            Affiliations(ProvinceNum) = Province(ProvinceNum).PoliticalAffiliation
            Loyalties(ProvinceNum) = Province(ProvinceNum).Loyalty
            Religions(ProvinceNum) = Province(ProvinceNum).Religion

        Next
    End Sub

    Private Sub AddInDynamicProvinceInfo(ProvinceNum)
        ' no loop needed because it's called from loop in Build routine

        Province(ProvinceNum).Climate = Climates(ProvinceNum)
        Province(ProvinceNum).PoliticalAffiliation = Affiliations(ProvinceNum)
        Province(ProvinceNum).Loyalty = Loyalties(ProvinceNum)
        Province(ProvinceNum).Religion = Religions(ProvinceNum)

    End Sub

    Private Sub ClearProvinceDisplay()
        frmProvinceInfo.txtProvinceName.Text = ""
        frmProvinceInfo.txtAssociatedTextbox.Text = ""
        frmProvinceInfo.txtAreaID.Text = ""
        frmProvinceInfo.txtAreaType.Text = ""
        frmProvinceInfo.txtTopgraphy.Text = ""
        frmProvinceInfo.txtPoliticalAffiliation.Text = ""
        frmProvinceInfo.txtFarmland.Text = ""
        frmProvinceInfo.txtPeasants.Text = ""
        frmProvinceInfo.txtAgriculturalLevel.Text = ""
        frmProvinceInfo.txtSurplusPop.Text = ""
        frmProvinceInfo.txtHarvestActual.Text = ""
        frmProvinceInfo.txtNeighbor1.Text = ""
        frmProvinceInfo.txtNeighbor2.Text = ""
        frmProvinceInfo.txtNeighbor3.Text = ""
        frmProvinceInfo.txtNeighbor4.Text = ""
        frmProvinceInfo.txtNeighbor5.Text = ""
        frmProvinceInfo.txtNeighbor6.Text = ""
        frmProvinceInfo.txtNeighbor7.Text = ""
        frmProvinceInfo.txtNeighbor8.Text = ""
        frmProvinceInfo.txtNeighbor9.Text = ""
        frmProvinceInfo.txtProvinceID.Text = ""
        frmProvinceInfo.cbxConnector1.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector2.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector3.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector4.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector5.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector6.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector7.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxConnector8.SelectedIndex = NO_SELECTION
        'frmProvinceInfo.cbxConnector9.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor1.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor2.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor3.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor4.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor5.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor6.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor7.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor8.SelectedIndex = NO_SELECTION
        frmProvinceInfo.cbxNeighbor9.SelectedIndex = NO_SELECTION

        'frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBrittany_Click(sender As System.Object, e As System.EventArgs) Handles txtBrittany.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBurgundy_Click(sender As System.Object, e As System.EventArgs) Handles txtBurgundy.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLorraine_Click(sender As System.Object, e As System.EventArgs) Handles txtLorraine.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSwabia_Click(sender As System.Object, e As System.EventArgs) Handles txtSwabia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBavaria_Click(sender As System.Object, e As System.EventArgs) Handles txtBavaria.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtRheinland_Click(sender As System.Object, e As System.EventArgs) Handles txtRheinland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtChampagne_Click(sender As System.Object, e As System.EventArgs) Handles txtChampagne.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIleDeFrance_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIleDeFrance.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtOrleans_TextClick(sender As System.Object, e As System.EventArgs) Handles txtOrleans.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBerry_Click(sender As System.Object, e As System.EventArgs) Handles txtBerry.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtToulouse_Click(sender As System.Object, e As System.EventArgs) Handles txtToulouse.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtGuyenne_Click(sender As System.Object, e As System.EventArgs) Handles txtGuyenne.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtAquitaine_Click(sender As Object, e As System.EventArgs) Handles txtAquitaine.Click


        HandleClickOnTextbox(sender, e)


    End Sub

    Private Sub txtAquitaine_DoubleClick(sender As Object, e As System.EventArgs) Handles txtAquitaine.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtAquitaine_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAquitaine.TextChanged

    End Sub

    Private Sub txtPoitou_Click(sender As System.Object, e As System.EventArgs) Handles txtPoitou.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtAnjou_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAnjou.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNormandy_Click(sender As System.Object, e As System.EventArgs) Handles txtNormandy.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtPicardy_Click(sender As System.Object, e As System.EventArgs) Handles txtPicardy.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtArtois_Click(sender As System.Object, e As System.EventArgs) Handles txtArtois.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtFlanders_Click(sender As System.Object, e As System.EventArgs) Handles txtFlanders.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtFranconia_Click(sender As System.Object, e As System.EventArgs) Handles txtFranconia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSaxony_Click(sender As System.Object, e As System.EventArgs) Handles txtSaxony.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtHolland_Click(sender As System.Object, e As System.EventArgs) Handles txtHolland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEngland_Click(sender As System.Object, e As System.EventArgs) Handles txtEngland.Click

        HandleClickOnTextbox(sender, e)

    End Sub


    'Private Sub btnExploreLines_Click(sender As System.Object, e As System.EventArgs)
    '    Dim ControlIndicator As String
    '    Dim AreaNum As Integer = 0

    '    'If ShowingNames = True Then

    '    For Each Me.ctrl In Controls
    '        ControlIndicator = Me.ctrl.Name.Substring(0, 3)
    '        If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
    '            If ShowingNames = True Then
    '                If Area(AreaNum).Type = LAND Then
    '                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).Climate)
    '                Else
    '                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Sea(Area(AreaNum).Province).Climate)
    '                End If
    '            Else
    '                Me.ctrl.Text = Area(AreaNum).Name
    '                'End If
    '            End If
    '            AreaNum += 1
    '        End If
    '    Next

    '    If ShowingNames = True Then
    '        ShowingNames = False
    '    Else
    '        ShowingNames = True
    '    End If
    '    'End I

    '    'Me.Refresh()


    '    'MsgBox("Mission Accomplished!")

    'End Sub

    Sub InitializeNeighborsNconnections()
        Dim AreaNum As Integer = 0
        Dim ProvinceNum As Integer = 0
        Dim SeaZone As Integer = 0
        Dim i As Integer = 0

        For AreaNum = 0 To TotalAreas - 1
            If Area(AreaNum).Type = LAND Then
                ProvinceNum = Area(AreaNum).Province
                For i = 0 To MAX_NEIGHBORS_LAND - 1
                    Province(ProvinceNum).Neighbors(i) = -1
                    Province(ProvinceNum).Connectors(i) = -1
                    Province(ProvinceNum).ConnectorNames(i) = "-"
                Next
            Else
                SeaZone = Area(AreaNum).Province
                For i = 0 To MAX_NEIGHBORS_SEA - 1
                    Sea(SeaZone).Neighbors(i) = -1
                    Sea(SeaZone).Connectors(i) = -1
                    Sea(SeaZone).ConnectorNames(i) = "-"
                Next
            End If
        Next


    End Sub


    Sub FindNeighbors()
        Dim ConnectorNum As Integer = 0
        Dim AreaA As Integer = 0
        Dim AreaB As Integer = 0
        Dim NeighborNum As Integer = 0
        Dim SeaZone As Integer = 0

        For ConnectorNum = 0 To TotalConnectors - 1
            AreaA = Connector(ConnectorNum).OneEnd
            AreaB = Connector(ConnectorNum).OtherEnd

            If Area(AreaA).Type = LAND Then
                For NeighborNum = 0 To MAX_NEIGHBORS_LAND - 1
                    If Province(Area(AreaA).Province).Neighbors(NeighborNum) = -1 Then
                        Province(Area(AreaA).Province).Neighbors(NeighborNum) = AreaB
                        Exit For
                    End If
                Next
            Else
                For NeighborNum = 0 To MAX_NEIGHBORS_SEA - 1
                    If Sea(Area(AreaA).Province).Neighbors(NeighborNum) = -1 Then
                        Sea(Area(AreaA).Province).Neighbors(NeighborNum) = AreaB
                        Exit For
                    End If
                Next
            End If

            NeighborNum = 0

            If Area(AreaB).Type = LAND Then
                For NeighborNum = 0 To MAX_NEIGHBORS_LAND - 1
                    If Province(Area(AreaB).Province).Neighbors(NeighborNum) = -1 Then
                        Province(Area(AreaB).Province).Neighbors(NeighborNum) = AreaA
                        Exit For
                    End If
                Next
            Else
                For NeighborNum = 0 To MAX_NEIGHBORS_SEA - 1
                    If Sea(Area(AreaB).Province).Neighbors(NeighborNum) = -1 Then
                        Sea(Area(AreaB).Province).Neighbors(NeighborNum) = AreaA
                        Exit For
                    End If
                Next
            End If

        Next


    End Sub


    Sub SetUpConnections()
        'Dim TotalShapes As Integer

        'TotalShapes = ShapeContainer1.Shapes.Count
        TotalConnectors = ShapeContainer1.Shapes.Count

        ReDim Connector(TotalConnectors - 1)

        For LineNumber = 0 To TotalConnectors - 1

            Connector(LineNumber).ID = LineNumber
            Connector(LineNumber).Name = ShapeContainer1.Shapes.Item(LineNumber).Name
            'Connector(LineNumber).Color = ShapeContainer1.Shapes.Item(LineNumber).BorderColor

            Select Case ShapeContainer1.Shapes.Item(LineNumber).BorderColor
                Case OCEAN_CONNECTOR_COLOR
                    Connector(LineNumber).Type = SEALANE
                Case COASTAL_CONNECTOR_COLOR
                    Connector(LineNumber).Type = SEALANE
                Case RIVER_CONNECTOR_COLOR
                    Connector(LineNumber).Type = RIVER
                Case ROAD_CONNECTOR_COLOR
                    Connector(LineNumber).Type = ROADS
                Case Else
                    MsgBox(CStr(Connector(LineNumber).Name) & "'s Connector Color is Invalid")
            End Select

            Connector(LineNumber).X1 = ShapeContainer1.Shapes.Item(LineNumber).X1
            Connector(LineNumber).Y1 = ShapeContainer1.Shapes.Item(LineNumber).Y1
            Connector(LineNumber).X2 = ShapeContainer1.Shapes.Item(LineNumber).X2
            Connector(LineNumber).Y2 = ShapeContainer1.Shapes.Item(LineNumber).Y2
            Connector(LineNumber).OneEnd = -1
            Connector(LineNumber).OtherEnd = -1


        Next

        FindConnections()

    End Sub

    Sub FindConnections()
        Dim LineNameControl As String = ""
        Dim TotalShapes As Integer = 0
        Dim LineNumber As Integer = 0
        Dim ControlIndicator As String
        Dim AreaNumber As Integer = 0
        Dim X1, Y1, X2, Y2 As Integer
        Dim Iam As String
        Dim AreasConnectors(MAX_NEIGHBORS_SEA) As String
        Dim ConnectorType(MAX_NEIGHBORS_SEA) As Integer

        For Each Me.ctrl In Controls

            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" And Me.ctrl.Name <> "txtYear" Then

                X1 = Me.ctrl.Left
                Y1 = Me.ctrl.Top
                X2 = X1 + Me.ctrl.Width
                Y2 = Y1 + Me.ctrl.Height

                Iam = Me.ctrl.Text
                FindConnectorsConnections(X1, X2, Y1, Y2, AreaNumber) 'AreasConnectors, ConnectorType)

                AreaNumber += 1
            End If

        Next

    End Sub


    Sub FindConnectorsConnections(X1 As Integer, X2 As Integer, Y1 As Integer, Y2 As Integer, AreaID As Integer)

        Dim TotalShapes As Integer
        'Dim LineName As String
        Dim EndOneIsIn As Boolean
        Dim EndTwoIsIn As Boolean
        Dim X1isIn, X2isIn, Y1isIn, Y2isIn As Boolean
        Dim ThisAreaConnectorNum As Integer = 0
        Dim MaxConnections As Integer = 0
        Dim TestString(MAX_NEIGHBORS_SEA) As String
        Dim TestNum(MAX_NEIGHBORS_SEA) As Integer
        Dim AreaProvince As Integer = 0

        TotalShapes = ShapeContainer1.Shapes.Count


        AreaProvince = Area(AreaID).Province

        If Area(AreaID).Type = LAND Then
            ''MaxConnections = MAX_NEIGHBORS_LAND
            'ReDim Province(AreaProvince).ConnectorNames(MAX_NEIGHBORS_LAND)
            'ReDim Province(AreaProvince).Connectors(MAX_NEIGHBORS_LAND)
            MaxConnections = MAX_NEIGHBORS_LAND
        Else
            'ReDim Sea(AreaProvince).ConnectorNames(MAX_NEIGHBORS_SEA)
            'ReDim Sea(AreaProvince).Connectors(MAX_NEIGHBORS_SEA)
            MaxConnections = MAX_NEIGHBORS_SEA
        End If

        For ThisAreaConnectorNum = 0 To MaxConnections - 1
            TestString(ThisAreaConnectorNum) = ""
            TestNum(ThisAreaConnectorNum) = -1
        Next

        ThisAreaConnectorNum = 0 'reinitialize

        For LineNumber = 0 To TotalShapes - 1

            X1isIn = False
            X2isIn = False
            Y1isIn = False
            Y2isIn = False
            EndOneIsIn = False
            EndTwoIsIn = False
            'X1isIn = False

            'first check to see if X1Y1 end is in box

            If Connector(LineNumber).X1 > X1 And Connector(LineNumber).X1 < X2 Then
                X1isIn = True
            End If

            If Connector(LineNumber).X2 > X1 And Connector(LineNumber).X2 < X2 Then
                X2isIn = True
            End If

            If Connector(LineNumber).Y1 > Y1 And Connector(LineNumber).Y1 < Y2 Then
                Y1isIn = True
            End If

            If Connector(LineNumber).Y2 > Y1 And Connector(LineNumber).Y2 < Y2 Then
                Y2isIn = True
            End If

            If X1isIn Then
                If Y1isIn Then
                    EndOneIsIn = True
                    Connector(LineNumber).OneEnd = AreaID
                End If
            End If

            If X2isIn Then
                If Y2isIn Then
                    EndTwoIsIn = True
                    Connector(LineNumber).OtherEnd = AreaID
                End If
            End If


            If EndOneIsIn Or EndTwoIsIn Then
                TestString(ThisAreaConnectorNum) = Connector(LineNumber).Name
                TestNum(ThisAreaConnectorNum) = Connector(LineNumber).Type


                ThisAreaConnectorNum += 1

            End If

        Next

        ThisAreaConnectorNum = 0

        For ThisAreaConnectorNum = 0 To MaxConnections - 1
            If Area(AreaID).Type = LAND Then
                Province(AreaProvince).ConnectorNames(ThisAreaConnectorNum) = TestString(ThisAreaConnectorNum)
                Province(AreaProvince).Connectors(ThisAreaConnectorNum) = TestNum(ThisAreaConnectorNum)
            Else
                Sea(AreaProvince).ConnectorNames(ThisAreaConnectorNum) = TestString(ThisAreaConnectorNum)
                Sea(AreaProvince).Connectors(ThisAreaConnectorNum) = TestNum(ThisAreaConnectorNum)
            End If
        Next

    End Sub


    Private Sub btnShowSeaInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnShowSeaInfo.Click

        SelectedArea = 0

        'PopulateSeaDisplay(SelectedArea)

        frmSeaInformation.ShowDialog()


    End Sub

    Private Sub txtIvoryCoast_Click(sender As System.Object, e As System.EventArgs) Handles txtIvoryCoast.Click

    End Sub

    Private Sub lineGaliciaMidAtlantic_Click(sender As System.Object, e As System.EventArgs) Handles lineGaliciaMidAtlantic.Click

    End Sub

    Private Sub linePortugalCentralAtlantic_Click(sender As System.Object, e As System.EventArgs) Handles linePortugalCentralAtlantic.Click

    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click

        If PlayerAction <> NO_SELECTION Then
            MsgBox("Note that partially completed Actions are not saved.  When you resume this Game it will start at the Beginning of this Action.")
        End If

        Try
            SaveProvinces(PLAYER_SAVE)
            SaveSeas()
            SaveConnectors()
            SaveGovernments(PLAYER_SAVE)
            SaveGlobals(PLAYER_SAVE)
            MsgBox("Game Saved")
        Catch
            MsgBox("Problem Saving Game")
        End Try

    End Sub

    Private Sub btnTest_Click(sender As System.Object, e As System.EventArgs) Handles btnTest.Click

        'frmHelpDisplay.Show()
        'DetermineWeather()
        'If lineParisOrleans.Visible = True Then
        '    lineParisOrleans.Visible = False
        'Else
        '    lineParisOrleans.Visible = True
        'End If



    End Sub


    Private Sub gbxTextToDisplay_Enter(sender As System.Object, e As System.EventArgs) Handles gbxTextToDisplay.Enter

    End Sub

    Private Sub rbnReligionText_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnReligionText.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    '    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).Climate)
                    'Else
                    '    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Sea(Area(AreaNum).Province).Climate)
                    Me.ctrl.Text = NameReligion(Province(Area(AreaNum).Province).Religion)
                Else
                    Me.ctrl.Text = "-"
                End If
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub rbnPeasants_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnPeasants.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = CStr(Province(Area(AreaNum).Province).Peasants) & "/" & CStr(Province(Area(AreaNum).Province).Farmland)
                    'Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).Peasants)
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub rbnHarvest_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnHarvest.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).HarvestActual)
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub rbnName_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnName.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then
                Me.ctrl.Text = Area(AreaNum).Name
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub rbnTerrain_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnTerrain.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't 
            If Me.rbnTerrain.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                Me.ctrl.BackColor = GetTerrainColor(Area(AreaNum).Topography)
                'Select Case Area(AreaNum).Topography
                '    Case OCEAN
                '        Me.ctrl.BackColor = OCEAN_COLOR
                '    Case COASTAL
                '        Me.ctrl.BackColor = COASTAL_COLOR
                '    Case FLATLAND
                '        Me.ctrl.BackColor = FLATLAND_COLOR
                '    Case RUGGED
                '        Me.ctrl.BackColor = RUGGED_COLOR
                '    Case MOUNTAINS
                '        Me.ctrl.BackColor = MOUNTAIN_COLOR
                'End Select
                AreaNum += 1
            End If
        Next

        If CanSeeMap Then
            If Me.rbnTerrain.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If

    End Sub

    Private Sub rbnWeather_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnWeather.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnWeather.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If


        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Select Case WeatherByArea(Province(Area(AreaNum).Province).Climate)
                        Case TERRIBLE_WEATHER
                            Me.ctrl.BackColor = TERRIBLE_WEATHER_COLOR
                        Case BAD_WEATHER
                            Me.ctrl.BackColor = BAD_WEATHER_COLOR
                        Case NORMAL_WEATHER
                            Me.ctrl.BackColor = NORMAL_WEATHER_COLOR
                        Case GOOD_WEATHER
                            Me.ctrl.BackColor = GOOD_WEATHER_COLOR
                        Case GREAT_WEATHER
                            Me.ctrl.BackColor = GREAT_WEATHER_COLOR
                    End Select
                Else ' if is sea
                    Select Case WeatherByArea(Sea(Area(AreaNum).Province).Climate)
                        Case TERRIBLE_WEATHER
                            Me.ctrl.BackColor = TERRIBLE_WEATHER_COLOR
                        Case BAD_WEATHER
                            Me.ctrl.BackColor = BAD_WEATHER_COLOR
                        Case NORMAL_WEATHER
                            Me.ctrl.BackColor = NORMAL_WEATHER_COLOR
                        Case GOOD_WEATHER
                            Me.ctrl.BackColor = GOOD_WEATHER_COLOR
                        Case GREAT_WEATHER
                            Me.ctrl.BackColor = GREAT_WEATHER_COLOR
                    End Select

                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnWeather.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If

    End Sub

    Private Sub rbnNCT_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnNCT.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).Nobles) _
                        & COMMA & CStr(Province(Area(AreaNum).Province).Clergy) & COMMA & CStr(Province(Area(AreaNum).Province).Townspeople)
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next


    End Sub

    Private Sub rbnSocialState_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnSocialStateColor.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnSocialStateColor.Checked Then
                Me.BackgroundImage = Nothing
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.BackColor = GetSocialStateColor(Province(Area(AreaNum).Province).SocialState)
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnSocialStateColor.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If

    End Sub

    Private Sub rbnPoliticalAffiliation_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnAffiliation.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = Government(Province(Area(AreaNum).Province).PoliticalAffiliation).Name
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next

    End Sub


    Private Sub txtAlgeria_DoubleClick(sender As Object, e As System.EventArgs) Handles txtAlgeria.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtAlgeria_Click(sender As System.Object, e As System.EventArgs) Handles txtAlgeria.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNavarre_Click(sender As System.Object, e As System.EventArgs) Handles txtNavarre.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub rbnAutonomy_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnAutonomy.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0
        Dim ProvinceNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnAutonomy.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    If Province(Area(AreaNum).Province).PoliticalAffiliation < MaxAffiliationColors Then
                        Me.ctrl.BackColor = AffiliationColors(Province(Area(AreaNum).Province).PoliticalAffiliation)
                    Else
                        Me.ctrl.BackColor = DISTANT_KINGDOM_COLOR
                    End If
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If
                AreaNum += 1
            End If
        Next

        If CanSeeMap Then
            If Me.rbnAutonomy.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If


    End Sub

    Private Sub btnAffiliation_Click(sender As System.Object, e As System.EventArgs) Handles btnAffiliation.Click
        Me.rbnAutonomy.Checked = True
        Me.rbnAffiliation.Checked = True
    End Sub

    Private Sub rbnSurplusPopulation_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnSurplusPopulation.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).SurplusPopulation)
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next


    End Sub

    Private Sub btnRecord_Click(sender As System.Object, e As System.EventArgs) Handles btnRecord.Click
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0
        Dim StrLength As Integer = 0

        If rbnName.Checked Then
            MsgBox("Names not set here")
            Exit Sub
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then

                If rbnReligionText.Checked Then
                    If Area(AreaNum).Type = LAND Then
                        Province(Area(AreaNum).Province).Religion = CInt(Me.ctrl.Text)
                        'Else
                        '    Sea(Area(AreaNum).Province).Climate = CInt(Me.ctrl.Text)
                    End If
                Else ' if not religion
                    If rbnPeasants.Checked Then
                        If Area(AreaNum).Type = LAND Then
                            StrLength = Me.ctrl.Text.Length
                            Province(Area(AreaNum).Province).Peasants = CInt(Me.ctrl.Text.Substring(5, StrLength - 5))
                        End If
                    Else 'if not climate or peasants
                        If rbnHarvest.Checked Then
                            If Area(AreaNum).Type = LAND Then
                                Province(Area(AreaNum).Province).HarvestActual = CInt(Me.ctrl.Text)
                            End If
                        Else ' if not climate, peasants, or harvest
                            If rbnAffiliation.Checked Then ' not ready for prime time yet 'Still not ready for prime time
                                If Area(AreaNum).Type = LAND Then
                                    Province(Area(AreaNum).Province).PoliticalAffiliation = CInt(Me.ctrl.Text.Substring(0, 2))
                                End If 'is land
                            End If 'Affiliation checked

                        End If 'Harvest checked

                    End If 'peasants checked


                End If 'if is climate
                'Else
                'MsgBox("Names not set here")
                'End If
                AreaNum += 1
            End If
        Next

        MsgBox("Changes Recorded")

    End Sub

    Private Sub btnGovernments_Click(sender As System.Object, e As System.EventArgs) Handles btnGovernments.Click

        SelectedGovernment = 1 'selected government

        frmGovernmentInfo.Show()

    End Sub

    Private Sub gbxActions_Enter(sender As System.Object, e As System.EventArgs)

    End Sub

    Private Sub lblNumActions_Click(sender As System.Object, e As System.EventArgs)

    End Sub

    Private Sub btnDoNothing_Click(sender As System.Object, e As System.EventArgs)
        AutoTurn()
    End Sub

    Private Sub gbxActions_Enter_1(sender As System.Object, e As System.EventArgs) Handles gbxActions.Enter

    End Sub

    Private Sub rbnMilitary_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnMilitary.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0
        Dim Militia As Integer = 0
        Dim MilitiaString As String = ""
        Dim ProvinceID As Integer = -1
        Dim LocalKnights As Integer = 0
        Dim KnightString As String = ""

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then
                If Area(AreaNum).Type = LAND Then
                    ProvinceID = Area(AreaNum).Province
                    'Militia = CInt(CDec(Province(ProvinceID).Peasants) / CDec(WARRIOR_RATIO))
                    'LocalKnights = CInt(CDec(Province(ProvinceID).Nobles) / CDec(WARRIOR_RATIO))
                    'Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(LocalKnights) & " / " & CStr(Militia)
                    Militia = GetProvincialMilitia(ProvinceID)
                    LocalKnights = GetLocalKnights(ProvinceID) ' this will be 10X other values
                    If LocalKnights > 0 Then
                        KnightString = CStr(LocalKnights) & "00"
                    Else
                        KnightString = "0"
                    End If
                    If Militia > 0 Then
                        MilitiaString = CStr(Militia) & "K/ "
                    Else
                        MilitiaString = "0/ "
                    End If
                    Me.ctrl.Text = MilitiaString & KnightString
                Else
                    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": -"
                End If
                AreaNum += 1
            End If
        Next
    End Sub

    Private Sub btnAttack_Click(sender As System.Object, e As System.EventArgs) Handles btnAttack.Click
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult

        PlayerAction = ATTACKING
        lblPlayerAction.Text = ATTACK_STRING
        lblPlayerAction.Refresh()
        ActionPhase = DESIGNATE_ACTION_TARGET
        lblCurrentPhaselbl.Text = ATTACK_PHASE_LBL
        lblCurrentPhaselbl.Refresh()
        lblCurrentPhase.Text = SELECT_TARGET_STRING
        lblCurrentPhase.Refresh()

        Me.rbnAutonomy.Checked = True
        rbnAutonomy_CheckedChanged(sender, e)

        Me.rbnMilitary.Checked = True
        rbnMilitary_CheckedChanged(sender, e)

        If TurnDate = ScenarioStartDate And CurrentAction < (TotalActions / 2) Then
            MsgBox("Click on the Province you want to Attack!")
        Else
            If PromptSelectTarget = True Then
                MsgStr = "Click on the Province you want to Attack!" & DOUBLE_SPACE
                MsgStr &= "(Click OK to Go On Now and Continue Showing This Prompt in the Future," & vbCrLf & "or CANCEL to Go On but Stop Showing This Prompt in the Future.)"
                Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Prompt Select Target")
                If Decision = MsgBoxResult.Cancel Then
                    Decision = MsgBox("Warning: Once you stop Showing the Prompt, you can't get it back.  You should only Stop it When you're Certain you'll know what you need to do at this point in Future Attack Actions.  You can always Stop it Later.  Are you Sure you want to Stop It Now?  ", MsgBoxStyle.YesNo, "Confirm Stop Prompt")
                    If Decision = MsgBoxResult.Yes Then
                        PromptSelectTarget = False
                    End If
                End If
            End If
        End If

    End Sub

    Private Sub btnRule_Click(sender As System.Object, e As System.EventArgs) Handles btnRule.Click
        Dim RuleControlsVisible As Boolean = False

        If PlayerAction <> RULING Then
            ToggleRuleControls(RuleControlsVisible)
            PlayerAction = RULING
            lblPlayerAction.Text = RULE_STRING
            lblPlayerAction.Refresh()
            lblCurrentPhaselbl.Text = HOW_RULE_LBL
            lblCurrentPhaselbl.Refresh()
            lblCurrentPhase.Text = HOW_RULE_NOT_PICKED_STR
        Else
            MsgBox("Pick a specific form of Ruling from the Buttons to the Right.")
        End If

    End Sub

    Private Sub btnAdminister_Click(sender As System.Object, e As System.EventArgs) Handles btnAdminister.Click
        Dim ProvinceNum As Integer
        Dim ProvincesControlled As Integer = 0
        Dim TotalSupport As Integer = 0
        Dim RuleControlsVisible = True
        Dim Decision As MsgBoxResult = vbNo

        Decision = MsgBox("Riding the Circuit means travelling from Province to Province to review the administration of your officials, " & _
                          "and dispense justice.  Done right, it can help improve the Social State of your realm.  Sometimes, though " & _
                          "even the best-intentioned intervention can stir up more trouble." & vbCrLf & vbCrLf & _
                          "DO YOU WANT TO PROCEED ON THE CIRCUIT?", vbYesNo, "Ride the Circuit?")
        If Decision = vbYes Then
            Randomize()

            ActionPhase = ADMINISTER
            lblCurrentPhase.Text = ADMINISTER_STRING
            lblPlayerAction.Refresh()


            Me.rbnName.Checked = True
            rbnName_CheckedChanged(sender, e)

            Me.rbnSocialStateColor.Checked = True
            rbnSocialState_CheckedChanged(sender, e)

            ProvincesControlled = CalculatePoliticalSupport(ActiveGovernment)

            For ProvinceNum = 0 To TotalProvinces - 1
                If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment Then
                    AdministerProvince(ProvinceNum, ActiveGovernment, ProvincesControlled)
                    CalculatePoliticalSupport(ActiveGovernment)
                End If
            Next



            Me.rbnAffiliation.PerformClick()
            Me.rbnAutonomy.PerformClick()
            Me.Refresh()
            'RuleControlsVisible = False
            'ToggleRuleControls(RuleControlsVisible)
            ConcludeAction()
            ' AutoTurn()
        Else
            CancelAction()
        End If

        'rbnLoyaltyText_CheckedChanged(sender, e) ' won't be necessary if update as go along
        'rbnSocialState_CheckedChanged(sender, e)
        'MsgBox("Click on the Province you want to Administer!") ' for now at least, admininsters all

    End Sub

    Private Sub btnConstruct_Click(sender As System.Object, e As System.EventArgs) Handles btnConstruct.Click
        PlayerAction = BUILDING
        lblPlayerAction.Text = BUILD_STRING
        lblPlayerAction.Refresh()

        MsgBox("Constructing:" & CStr(TurnDate) & ", action " & CStr(CurrentAction) & " of " & CStr(TotalActions))

        AutoTurn()

    End Sub

    Private Sub btnPatronize_Click(sender As System.Object, e As System.EventArgs) Handles btnPatronize.Click
        PlayerAction = PATRONIZING
        lblPlayerAction.Text = PATRONIZE_STRING
        lblPlayerAction.Refresh()

        MsgBox("Patronizing " & CStr(TurnDate) & ", action " & CStr(CurrentAction) & " of " & CStr(TotalActions))

        AutoTurn()

    End Sub

    Private Sub btnNegotiate_Click(sender As System.Object, e As System.EventArgs) Handles btnNegotiate.Click
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim Contiguous As Boolean = False
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim NegotiationsThisRound(TotalGovernments - 1) As Integer
        Dim Finished As Boolean = False

        For i = 0 To TotalGovernments - 1
            If i = 0 Or i = 1 Then
                NegotiationsThisRound(i) = 1 ' so when check if all negotiations over, first two (local and Franks) will be seen as done
            Else
                NegotiationsThisRound(i) = 0
            End If
        Next

        i = 2

        Do
            Contiguous = DetermineIfGovernmentsContiguous(ActiveGovernment, i)

            If Contiguous = True Then
                '    MsgBox(GetGovernmentName(i) & " ARE Contiguous")
                'Else
                '    MsgBox(GetGovernmentName(i) & " are NOT Contiguous")
                'End If
                If NegotiationsThisRound(i) = 0 Then ' if you haven't negotiated with them yet
                    MsgStr = "Your current relationship with the " & Government(i).Name & " is " & DescribeDiploRelations(ActiveGovernment, i) & "." & vbCrLf & vbCrLf
                    If Government(ActiveGovernment).DiplomaticRelations(i) = MAX_RELATES Then
                        MsgStr &= "This is as good as it gets, so there's no point negotiating with them now."
                        MsgBox(MsgStr)
                        NegotiationsThisRound(i) = 1
                        Decision = MsgBoxResult.No ' keep going
                    Else
                        MsgStr &= "Do you want to negotiate with them?" & vbCrLf & vbCrLf
                        MsgStr &= "Click YES to do so, NO postpone negotiations with them for now, and CANCEL to stop Negotiating with everyone." & vbCrLf & vbCrLf
                        ' MsgStr &= "(Note that you get one chance to Negotiate with each Kingdom; clicking NO is a way to put off the current one for the moment.)"
                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate?")
                    End If
                    If Decision = MsgBoxResult.Yes Then
                        NegotiationsThisRound(i) = 1
                        Negotiate(ActiveGovernment, i)
                    Else
                        If Decision = MsgBoxResult.Cancel Then
                            'Decision = MsgBox("Are you sure you want to stop negotiations with everyone and go on to another Action?", MsgBoxStyle.YesNo, "End Negotiations?")
                            'If Decision = MsgBoxResult.Yes Then
                            Exit Do  ' end round if player wants to 
                            'End If
                        End If
                    End If
                    'Else
                    'MsgBox("You have already negotiated with the " & GetGovernmentName(i))
                End If
            Else 'isn't contiguous
                NegotiationsThisRound(i) = 1 'since can't negotiate, consider this one done
            End If

            If i < TotalGovernments - 1 Then
                i += 1
            Else
                i = 2
            End If

            ' see if should end round because all possible negotiations have taken place
            Finished = True
            For j = 0 To TotalGovernments - 1
                If NegotiationsThisRound(j) = 0 Then Finished = False
            Next

        Loop While Finished = False
        'Next

        MsgBox("Negotiations are over.")
        ConcludeAction()
        'AutoTurn() ' shouldn't need this since Conclude Action contains it, and seems to be cause of the "skipped" player turns

    End Sub

    Private Sub txtAvergne_Click(sender As Object, e As System.EventArgs) Handles txtAvergne.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtAvergne_DoubleClick(sender As System.Object, e As System.EventArgs) Handles txtAvergne.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Sub DetermineClickedArea(sender As Control, e As System.EventArgs)
        Dim i, j As Integer
        Dim senderName As String
        Dim AreaName As String
        Dim OriginalRbn As Integer

        OriginalRbn = CurrentlyCheckedTxtTextRbn()

        If OriginalRbn <> 8 Then '8 is the number in returned above if it is already checked
            Me.rbnName.Checked = True ' in case rbns not set to "Name", which is needed to find area
            rbnName_CheckedChanged(sender, e)
        End If

        senderName = CStr(sender.ToString)

        For i = 0 To TotalProvinces - 1
            AreaName = "System.Windows.Forms.TextBox, Text: " & Province(i).Name
            If AreaName = senderName Then
                SelectedType = LAND
                SelectedArea = Province(i).ID
                'MsgBox(Province(SelectedArea).Name & " was selected.")
                If OriginalRbn <> 8 Then '8 is the number in returned above if Name rbn was already checked
                    RestoreOriginallyCheckedTxtTextRbn(OriginalRbn, sender, e)
                End If
                Exit Sub
            End If
        Next

        'should only get here if doesn't find a province
        For j = 0 To TotalSeas - 1
            AreaName = "System.Windows.Forms.TextBox, Text: " & Sea(j).Name
            If AreaName = senderName Then
                SelectedType = WATER
                SelectedArea = Sea(j).ID
                'MsgBox(Sea(SelectedArea).Name & " was selected.")
                Exit For
            End If

        Next

        If OriginalRbn <> 8 Then '8 is the number in returned above if Name rbn was already checked
            RestoreOriginallyCheckedTxtTextRbn(OriginalRbn, sender, e)
        End If

    End Sub

    Function CurrentlyCheckedTxtTextRbn() As Integer
        Dim RbnNumber = -1
        If rbnAffiliation.Checked Then
            RbnNumber = 1
        ElseIf rbnPeasants.Checked Then
            RbnNumber = 2
        ElseIf rbnHarvest.Checked Then
            RbnNumber = 3
        ElseIf rbnReligionText.Checked Then
            RbnNumber = 4
        ElseIf rbnMilitary.Checked Then
            RbnNumber = 5
        ElseIf rbnSurplusPopulation.Checked Then
            RbnNumber = 6
        ElseIf rbnNCT.Checked Then
            RbnNumber = 7
        ElseIf rbnName.Checked Then
            RbnNumber = 8
        ElseIf rbnLoyaltyText.Checked Then
            RbnNumber = 9
        End If

        Return RbnNumber
    End Function

    Sub RestoreOriginallyCheckedTxtTextRbn(OriginalRbn As Integer, sender As Control, e As System.EventArgs)
        Select Case OriginalRbn
            Case 1
                rbnAffiliation.Checked = True
                rbnPoliticalAffiliation_CheckedChanged(sender, e)
            Case 2
                rbnPeasants.Checked = True
                rbnPeasants_CheckedChanged(sender, e)
            Case 3
                rbnHarvest.Checked = True
                rbnHarvest_CheckedChanged(sender, e)
            Case 4
                rbnReligionText.Checked = True
                rbnReligionText_CheckedChanged(sender, e)
            Case 5
                rbnMilitary.Checked = True
                rbnMilitary_CheckedChanged(sender, e)
            Case 6
                rbnSurplusPopulation.Checked = True
                rbnSurplusPopulation_CheckedChanged(sender, e)
            Case 7
                rbnNCT.Checked = True
                rbnNCT_CheckedChanged(sender, e)
            Case 8
                'Don't need to do anything because it was autochecked
            Case 9
                rbnLoyaltyText.Checked = True
                rbnLoyaltyText_CheckedChanged(sender, e)
        End Select
    End Sub
    Private Sub txtBalticSea_Click(sender As Object, e As System.EventArgs) Handles txtBalticSea.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBalticSea_DoubleClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles txtBalticSea.MouseClick

        frmSeaInformation.ShowDialog()

    End Sub

    Private Sub txtArdennes_Click(sender As Object, e As System.EventArgs) Handles txtArdennes.Click

        HandleClickOnTextbox(sender, e)

    End Sub


    Private Sub txtArdennes_DoubleClick(sender As Object, e As System.EventArgs) Handles txtArdennes.DoubleClick
        frmProvinceInfo.ShowDialog()
    End Sub

    Private Sub HandleClickOnTextbox(sender As Object, e As System.EventArgs)

        DetermineClickedArea(sender, e)

        If PlayerAction <> NO_ACTION Then
            SetActionTarget(sender)
        End If

    End Sub

    Private Sub txtIleDeFrance_Click(sender As System.Object, e As System.EventArgs) Handles txtIleDeFrance.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtChampagne_DockChanged(sender As Object, e As System.EventArgs) Handles txtChampagne.DockChanged

    End Sub

    Private Sub txtChampagne_DoubleClick(sender As System.Object, e As System.EventArgs) Handles txtChampagne.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtAustria_Click(sender As Object, e As System.EventArgs) Handles txtAustria.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBalkans_Click(sender As Object, e As System.EventArgs) Handles txtBalkans.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBayOfBiscay_Click(sender As Object, e As System.EventArgs) Handles txtBayOfBiscay.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBearn_Click(sender As Object, e As System.EventArgs) Handles txtBearn.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtBlackSea_Click(sender As Object, e As System.EventArgs) Handles txtBlackSea.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtCaribbean_Click(sender As Object, e As System.EventArgs) Handles txtCaribbean.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtCastile_Click(sender As Object, e As System.EventArgs) Handles txtCastile.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtCatalonia_Click(sender As Object, e As System.EventArgs) Handles txtCatalonia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtCorsica_Click(sender As Object, e As System.EventArgs) Handles txtCorsica.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtDauphine_Click(sender As Object, e As System.EventArgs) Handles txtDauphine.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtDenmark_Click(sender As Object, e As System.EventArgs) Handles txtDenmark.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEasternMed_Click(sender As Object, e As System.EventArgs) Handles txtEasternMed.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEasternSeaboard_Click(sender As Object, e As System.EventArgs) Handles txtEasternSeaboard.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEastGermany_Click(sender As Object, e As System.EventArgs) Handles txtEastGermany.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEgypt_Click(sender As Object, e As System.EventArgs) Handles txtEgypt.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEnglishChannel_Click(sender As Object, e As System.EventArgs) Handles txtEnglishChannel.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtEquitorialAfrica_Click(sender As Object, e As System.EventArgs) Handles txtEquitorialAfrica.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtFrancheComte_Click(sender As Object, e As System.EventArgs) Handles txtFrancheComte.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtGalicia_Click(sender As Object, e As System.EventArgs) Handles txtGalicia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtGibraltar_Click(sender As Object, e As System.EventArgs) Handles txtGibraltar.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtGreece_Click(sender As Object, e As System.EventArgs) Handles txtGreece.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtGrenada_Click(sender As Object, e As System.EventArgs) Handles txtGrenada.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIllyria_Click(sender As Object, e As System.EventArgs) Handles txtIllyria.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIndia_Click(sender As Object, e As System.EventArgs) Handles txtIndia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIndianOcean_Click(sender As Object, e As System.EventArgs) Handles txtIndianOcean.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIndochina_Click(sender As Object, e As System.EventArgs) Handles txtIndochina.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIreland_Click(sender As Object, e As System.EventArgs) Handles txtIreland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtIrishSea_Click(sender As Object, e As System.EventArgs) Handles txtIrishSea.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLangueoc_Click(sender As Object, e As System.EventArgs) Handles txtLangueoc.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLevant_Click(sender As Object, e As System.EventArgs) Handles txtLevant.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLibya_Click(sender As Object, e As System.EventArgs) Handles txtLibya.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLomardy_Click(sender As Object, e As System.EventArgs) Handles txtLomardy.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLousiana_Click(sender As Object, e As System.EventArgs) Handles txtLousiana.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtLyonnais_Click(sender As Object, e As System.EventArgs) Handles txtLyonnais.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtMadagascar_Click(sender As Object, e As System.EventArgs) Handles txtMadagascar.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtMidAtlanticOcean_Click(sender As Object, e As System.EventArgs) Handles txtMidAtlanticOcean.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtMorocco_Click(sender As Object, e As System.EventArgs) Handles txtMorocco.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNaples_Click(sender As Object, e As System.EventArgs) Handles txtNaples.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNorthAtlantic_Click(sender As Object, e As System.EventArgs) Handles txtNorthAtlantic.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNorthSea_Click(sender As Object, e As System.EventArgs) Handles txtNorthSea.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtNorway_Click(sender As Object, e As System.EventArgs) Handles txtNorway.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtPiedmont_Click(sender As Object, e As System.EventArgs) Handles txtPiedmont.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtPoland_Click(sender As Object, e As System.EventArgs) Handles txtPoland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtPortugal_Click(sender As Object, e As System.EventArgs) Handles txtPortugal.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtProvence_Click(sender As Object, e As System.EventArgs) Handles txtProvence.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtQuebec_Click(sender As Object, e As System.EventArgs) Handles txtQuebec.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtRome_Click(sender As Object, e As System.EventArgs) Handles txtRome.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtRousillon_Click(sender As Object, e As System.EventArgs) Handles txtRousillon.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtRussia_Click(sender As Object, e As System.EventArgs) Handles txtRussia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSaragossa_Click(sender As Object, e As System.EventArgs) Handles txtSaragossa.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSardinia_Click(sender As Object, e As System.EventArgs) Handles txtSardinia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSavoy_Click(sender As Object, e As System.EventArgs) Handles txtSavoy.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtScotland_Click(sender As Object, e As System.EventArgs) Handles txtScotland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSenegal_Click(sender As Object, e As System.EventArgs) Handles txtSenegal.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSicily_Click(sender As Object, e As System.EventArgs) Handles txtSicily.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSouthAtlantic_Click(sender As Object, e As System.EventArgs) Handles txtSouthAtlantic.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSweden_Click(sender As Object, e As System.EventArgs) Handles txtSweden.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtSwitzerland_Click(sender As Object, e As System.EventArgs) Handles txtSwitzerland.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtTunesia_Click(sender As Object, e As System.EventArgs) Handles txtTunesia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtTurkey_Click(sender As Object, e As System.EventArgs) Handles txtTurkey.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtTuscany_Click(sender As Object, e As System.EventArgs) Handles txtTuscany.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtTyrolia_Click(sender As Object, e As System.EventArgs) Handles txtTyrolia.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtWales_Click(sender As Object, e As System.EventArgs) Handles txtWales.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtWestAfrica_Click(sender As Object, e As System.EventArgs) Handles txtWestAfrica.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtWesternMediterranean_Click(sender As Object, e As System.EventArgs) Handles txtWesternMediterranean.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub txtWestIndies_Click(sender As Object, e As System.EventArgs) Handles txtWestIndies.Click

        HandleClickOnTextbox(sender, e)

    End Sub

    Private Sub rbnReligionColor_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnReligionColor.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnReligionColor.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.BackColor = GetReligionColor(Province(Area(AreaNum).Province).Religion)
                    '    Select Case Province(Area(AreaNum).Province).Religion
                    '        Case PAGAN
                    '            Me.ctrl.BackColor = PAGAN_COLOR
                    '        Case CATHOLIC
                    '            Me.ctrl.BackColor = CATHOLIC_COLOR
                    '        Case ARIAN
                    '            Me.ctrl.BackColor = ARIAN_COLOR
                    '        Case ORTHADOX
                    '            Me.ctrl.BackColor = ORTHADOX_COLOR
                    '        Case MUSLIM
                    '            Me.ctrl.BackColor = MUSLIM_COLOR
                    '        Case WALDENSIAN
                    '            Me.ctrl.BackColor = WALDENSIAN_COLOR
                    '        Case ALBEGENSIAN
                    '            Me.ctrl.BackColor = ALBEGENSIAN_COLOR
                    '        Case PROTESTANT
                    '            Me.ctrl.BackColor = PROTESTANT_COLOR
                    '    End Select
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnReligionColor.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If


    End Sub

    Private Sub rbnLoyaltyColor_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnLoyaltyColor.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnLoyaltyColor.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.BackColor = GetLoyaltyColor(Province(Area(AreaNum).Province).Loyalty)
                    'Select Case Province(Area(AreaNum).Province).Loyalty
                    '    Case ENTHUSIASTIC
                    '        Me.ctrl.BackColor = ENTHUSIASTIC_COLOR
                    '    Case SUPPORTIVE
                    '        Me.ctrl.BackColor = SUPPORTIVE_COLOR
                    '    Case INDIFFERENT
                    '        Me.ctrl.BackColor = INDIFFERENT_COLOR
                    '    Case DISENCHANTED
                    '        Me.ctrl.BackColor = DISENCHANTED_COLOR
                    '    Case ENTHUSIASTIC
                    '        Me.ctrl.BackColor = ENTHUSIASTIC_COLOR
                    'End Select
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnLoyaltyColor.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
            End If
        End If

    End Sub

    Private Sub rbnLoyaltyText_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnLoyaltyText.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = NameLoyaltyLevel(Province(Area(AreaNum).Province).Loyalty)
                Else
                    Me.ctrl.Text = "-"
                End If
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub txtAnjou_DoubleClick(sender As Object, e As System.EventArgs) Handles txtAnjou.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtArtois_DoubleClick(sender As Object, e As System.EventArgs) Handles txtArtois.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtAustria_DoubleClick(sender As Object, e As System.EventArgs) Handles txtAustria.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBalkans_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBalkans.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBavaria_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBavaria.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBearn_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBearn.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBerry_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBerry.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBrittany_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBrittany.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtBurgundy_DoubleClick(sender As Object, e As System.EventArgs) Handles txtBurgundy.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtCastile_DoubleClick(sender As Object, e As System.EventArgs) Handles txtCastile.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtCatalonia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtCatalonia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtCorsica_DoubleClick(sender As Object, e As System.EventArgs) Handles txtCorsica.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub



    Private Sub txtDauphine_DoubleClick(sender As Object, e As System.EventArgs) Handles txtDauphine.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtDenmark_DoubleClick(sender As Object, e As System.EventArgs) Handles txtDenmark.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtEasternSeaboard_DoubleClick(sender As Object, e As System.EventArgs) Handles txtEasternSeaboard.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtEastGermany_DoubleClick(sender As Object, e As System.EventArgs) Handles txtEastGermany.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtEgypt_DoubleClick(sender As Object, e As System.EventArgs) Handles txtEgypt.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtEngland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtEngland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtEquitorialAfrica_DoubleClick(sender As Object, e As System.EventArgs) Handles txtEquitorialAfrica.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtFlanders_DoubleClick(sender As Object, e As System.EventArgs) Handles txtFlanders.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtFrancheComte_DoubleClick(sender As Object, e As System.EventArgs) Handles txtFrancheComte.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtFranconia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtFranconia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtGalicia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtGalicia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtGreece_DoubleClick(sender As Object, e As System.EventArgs) Handles txtGreece.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtGrenada_DoubleClick(sender As Object, e As System.EventArgs) Handles txtGrenada.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtGuyenne_DoubleClick(sender As Object, e As System.EventArgs) Handles txtGuyenne.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtHolland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtHolland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtIllyria_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIllyria.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtIndia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIndia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtIndochina_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIndochina.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtIreland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIreland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtIvoryCoast_DoubleClick(sender As Object, e As System.EventArgs) Handles txtIvoryCoast.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLangueoc_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLangueoc.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLevant_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLevant.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLibya_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLibya.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLomardy_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLomardy.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLorraine_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLorraine.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLousiana_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLousiana.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLyonnais_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLyonnais.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtLyonnais_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles txtLyonnais.DragDrop

    End Sub

    Private Sub txtMadagascar_DoubleClick(sender As Object, e As System.EventArgs) Handles txtMadagascar.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtMorocco_DoubleClick(sender As Object, e As System.EventArgs) Handles txtMorocco.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtNaples_DoubleClick(sender As Object, e As System.EventArgs) Handles txtNaples.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtNavarre_DoubleClick(sender As Object, e As System.EventArgs) Handles txtNavarre.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtNormandy_DoubleClick(sender As Object, e As System.EventArgs) Handles txtNormandy.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtNorway_DoubleClick(sender As Object, e As System.EventArgs) Handles txtNorway.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtOrleans_DoubleClick(sender As Object, e As System.EventArgs) Handles txtOrleans.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtPicardy_DoubleClick(sender As Object, e As System.EventArgs) Handles txtPicardy.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtPiedmont_DoubleClick(sender As Object, e As System.EventArgs) Handles txtPiedmont.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtPoitou_DoubleClick(sender As Object, e As System.EventArgs) Handles txtPoitou.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtPoland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtPoland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtPortugal_DoubleClick(sender As Object, e As System.EventArgs) Handles txtPortugal.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtProvence_DoubleClick(sender As Object, e As System.EventArgs) Handles txtProvence.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtQuebec_DoubleClick(sender As Object, e As System.EventArgs) Handles txtQuebec.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtRheinland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtRheinland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtRome_DoubleClick(sender As Object, e As System.EventArgs) Handles txtRome.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtRousillon_DoubleClick(sender As Object, e As System.EventArgs) Handles txtRousillon.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtRussia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtRussia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSaragossa_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSaragossa.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSardinia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSardinia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSavoy_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSavoy.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSaxony_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSaxony.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtScotland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtScotland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSenegal_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSenegal.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSicily_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSicily.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSwabia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSwabia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSweden_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSweden.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtSwitzerland_DoubleClick(sender As Object, e As System.EventArgs) Handles txtSwitzerland.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtToulouse_DoubleClick(sender As Object, e As System.EventArgs) Handles txtToulouse.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtTunesia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtTunesia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtTurkey_DoubleClick(sender As Object, e As System.EventArgs) Handles txtTurkey.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtTuscany_DoubleClick(sender As Object, e As System.EventArgs) Handles txtTuscany.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtTyrolia_DoubleClick(sender As Object, e As System.EventArgs) Handles txtTyrolia.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtWales_DoubleClick(sender As Object, e As System.EventArgs) Handles txtWales.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtWestAfrica_DoubleClick(sender As Object, e As System.EventArgs) Handles txtWestAfrica.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub txtWestIndies_DoubleClick(sender As Object, e As System.EventArgs) Handles txtWestIndies.DoubleClick

        frmProvinceInfo.ShowDialog()

    End Sub

    Private Sub rbnSocialStateText_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnSocialStateText.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = DescribeSocialState(Province(Area(AreaNum).Province).SocialState)
                Else
                    Me.ctrl.Text = "-"
                End If
                AreaNum += 1
            End If
        Next


    End Sub

    Private Sub rbnLanguageText_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnLanguageText.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    '    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Province(Area(AreaNum).Province).Climate)
                    'Else
                    '    Me.ctrl.Text = Area(AreaNum).Name.Substring(0, 3) & ": " & CStr(Sea(Area(AreaNum).Province).Climate)
                    Me.ctrl.Text = NameLanguage(Province(Area(AreaNum).Province).Language)
                Else
                    Me.ctrl.Text = "-"
                End If
                AreaNum += 1
            End If
        Next

    End Sub

    Private Sub rbnLanguageColor_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnLanguageColor.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnLanguageColor.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.BackColor = GetLanguageColor(Province(Area(AreaNum).Province).Language)
                    'Select Case Province(Area(AreaNum).Province).Language
                    '    Case LOCAL_LANGUAGE
                    '        Me.ctrl.BackColor = LOCAL_LANGUAGE_COLOR
                    '    Case ROMANCE
                    '        Me.ctrl.BackColor = ROMANCE_LANGUAGE_COLOR
                    '    Case LOCAL_ROMANCE
                    '        Me.ctrl.BackColor = ROMANCE_LANGUAGE_COLOR
                    '    Case FRENCH
                    '        Me.ctrl.BackColor = ROMANCE_LANGUAGE_COLOR
                    '    Case SPANISH
                    '        Me.ctrl.BackColor = ROMANCE_LANGUAGE_COLOR
                    '    Case GERMANIC
                    '        Me.ctrl.BackColor = GERMANIC_LANGUAGE_COLOR
                    '    Case LOCAL_GERMANIC
                    '        Me.ctrl.BackColor = GERMANIC_LANGUAGE_COLOR
                    '    Case GERMAN
                    '        Me.ctrl.BackColor = GERMANIC_LANGUAGE_COLOR
                    '    Case GREEK
                    '        Me.ctrl.BackColor = GREEK_LANGUAGE_COLOR
                    '    Case CELTIC
                    '        Me.ctrl.BackColor = CELTIC_LANGUAGE_COLOR
                    '    Case SLAVIC
                    '        Me.ctrl.BackColor = SLAVIC_LANGUAGE_COLOR
                    '    Case ARABIC
                    '        Me.ctrl.BackColor = ARABIC_LANGUAGE_COLOR
                    'End Select
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnLanguageColor.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
                'Me.Refresh()
            End If
        End If


    End Sub

    Private Sub btnLoyalty_Click(sender As System.Object, e As System.EventArgs) Handles btnLoyalty.Click
        Me.rbnLoyaltyText.Checked = True
        Me.rbnLoyaltyColor.Checked = True

    End Sub

    Private Sub btnReligion_Click(sender As System.Object, e As System.EventArgs) Handles btnReligion.Click
        Me.rbnReligionText.Checked = True
        Me.rbnReligionColor.Checked = True

    End Sub

    Private Sub btnLanguage_Click(sender As System.Object, e As System.EventArgs) Handles btnLanguage.Click
        Me.rbnLanguageText.Checked = True
        Me.rbnLanguageColor.Checked = True

    End Sub

    Private Sub SocialState_Click(sender As System.Object, e As System.EventArgs) Handles btnSocialState.Click
        Me.rbnSocialStateText.Checked = True
        Me.rbnSocialStateColor.Checked = True

    End Sub

    Public Sub ToggleRuleControls(ByVal CurrentState As Boolean)
        Dim StateToBecome As Boolean

        If CurrentState = True Then
            StateToBecome = False
        Else
            StateToBecome = True
        End If

        Me.lblHowRule.Visible = StateToBecome
        Me.lblHowRule.Refresh()
        Me.btnAdminister.Visible = StateToBecome
        Me.btnAdminister.Refresh()
        Me.btnConvert.Visible = StateToBecome
        Me.btnConvert.Refresh()
        Me.btnLawCode.Visible = StateToBecome
        Me.btnLawCode.Refresh()

    End Sub

    Private Sub btnConvert_Click(sender As System.Object, e As System.EventArgs) Handles btnConvert.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim ChristianSupport As Integer = 0
        Dim PaganSupport As Integer = 0
        Dim NumChristian As Integer = 0
        Dim NumPagan As Integer = 0
        Dim TotalProvincesControlled As Integer = 0
        ' Dim NetGainOfProvinces As Integer = 0
        Dim StrengthOfResistance As Integer = 0
        Dim ChristianSupportStr As String = ""
        Dim PaganSupportStr As String = ""
        Dim i As Integer
        Dim MsgStr As String = ""

        If Government(PlayerSide).Religion = PAGAN Then
            ActionPhase = CONVERT
            lblCurrentPhase.Text = CONVERT_STRING
            lblPlayerAction.Refresh()

            Me.rbnAffiliation.PerformClick()

            Me.rbnReligionColor.Checked = True
            rbnReligionColor_CheckedChanged(sender, e)

            ' Get Average support for each 
            For i = 0 To TotalProvinces - 1
                If Province(i).PoliticalAffiliation = PlayerSide Then
                    TotalProvincesControlled += 1
                    If Province(i).Religion = PAGAN Then
                        NumPagan += 1
                        PaganSupport += Province(i).Loyalty
                    Else
                        If Province(i).Religion > CHRISTIAN_LOWER_BOUND And Province(i).Religion < CHRISTIAN_UPPER_BOUND Then
                            NumChristian += 1
                            ChristianSupport += Province(i).Loyalty
                        End If
                    End If
                End If
            Next

            ChristianSupport = CInt(CDec(ChristianSupport) / CDec(NumChristian))
            PaganSupport = CInt(CDec(PaganSupport) / CDec(NumPagan))
            ' ConquestVPs = TotalProvincesControlled - ProvincesAtStart ' should be tracked as happens now
            'StrengthOfResistance = ConquestVPs \ 4
            'If StrengthOfResistance > 4 Then
            '    StrengthOfResistance = 4
            'End If

            ChristianSupportStr = NameLoyaltyLevel(ChristianSupport)
            PaganSupportStr = NameLoyaltyLevel(PaganSupport)

            MsgStr = "The wife of your king is Catholic and wants him to convert to Catholicism.  This is also the faith of the leaders "
            MsgStr &= "of the provinces of the old Roman Empire as well as the Pope in Rome.  "
            MsgStr &= "Converting to Catholicism will improve your relations with them." & vbCrLf & vbCrLf
            MsgStr &= "However, converting to Christianity  will trouble your own people, the Franks, most of whom continue to worship their traditional gods. "
            MsgStr &= "They live in the original Frankish provinces in the East as well as serve in your army and government occupying provinces "
            MsgStr &= "that used to belong to the Empire." & vbCrLf & vbCrLf
            MsgStr &= "Currently, you control " & CStr(NumChristian) & "Christian provinces and support for you in them is " & ChristianSupportStr & "." & vbCrLf & vbCrLf
            MsgStr &= "You control " & CStr(NumPagan) & " Pagan provinces, and support for you in them is " & PaganSupportStr
            MsgStr &= " and your Army's state is " & DescribeArmyState(Government(PlayerSide).ArmyState) & "." & vbCrLf & vbCrLf
            MsgStr &= "The readiness of the Franks to accept your conversion mainly depends on their belief in the power of your new God, "
            MsgStr &= "in particular His ability to bring victory in battle." & vbCrLf & vbCrLf
            MsgStr &= "So far you have conquored " & CStr(ConquestVPs) & " provinces. "
            MsgStr &= "Right now, resistance to your conversion among the Franks will be "
            If ConquestVPs <= 0 Then
                StrengthOfResistance = 4
                MsgStr &= "overwhelming."
            Else
                If ConquestVPs > 12 Then
                    StrengthOfResistance = 0
                    MsgStr &= "inconsequential."
                Else
                    If ConquestVPs > 8 Then
                        StrengthOfResistance = 1
                        MsgStr &= "weak."
                    Else
                        If ConquestVPs > 4 Then
                            StrengthOfResistance = 2
                            MsgStr &= "moderate."
                        Else
                            StrengthOfResistance = 3
                            MsgStr &= "strong."
                        End If '>4
                    End If '>8
                End If '>12
            End If
            MsgStr &= vbCrLf & vbCrLf

            MsgStr &= "ARE YOU SURE YOU WANT TO CONVERT NOW?"

            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Convert?")

            If Decision = MsgBoxResult.Yes Then
                'Decision = MsgBox("The wife of your king is Catholic and wants him to convert to Catholicism.  This is also the faith of the leaders " _
                '                  & "of the provinces of the old Roman Empire as well as the Pope in Rome.  However, most of your fellow " _
                '                  & "German rulers have embraced Arianism." & vbCrLf & vbCrLf _
                '                  & "Converting to Catholicism will make ruling Catholic provinces easier, while becoming Arian " _
                '                  & "will make the leaders of the other Germanic kingdoms more inclined to cooperate with the Franks. " & vbCrLf & vbCrLf _
                '                  & "Click YES to do as the king's wife wishes and convert to Catholicism or NO to convert to Arianism.", vbYesNo, "Catholic or Arian?")
                'If Decision = MsgBoxResult.Yes Then
                Government(ActiveGovernment).Religion = CATHOLIC ' Need decision before this!!
                'Else
                '    Government(ActiveGovernment).Religion = ARIAN
                'End If

                IncrementCulturalVPs(MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE)
                'CulturalVPs += MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE
                'RefreshCulturalVP_Display()

                ConversionReaction(StrengthOfResistance)

                Me.rbnAffiliation.PerformClick()
                Me.rbnAutonomy.PerformClick()
                Me.Refresh()

                ConcludeAction()

                'AutoTurn() ' done in Conclude Action
            Else
                CancelAction()
            End If
            'MsgBox("Loop through provinces to see reactions, and then governments.")
        Else
            MsgBox("You already converted.  Pick another Action.")
            CancelAction()
        End If ' are still pagan

    End Sub

    Private Sub rbnDiploRelatesText_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnDiploRelatesText.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Me.ctrl.Text = DescribeDiploRelations(PlayerSide, Province(Area(AreaNum).Province).PoliticalAffiliation)
                Else
                    Me.ctrl.Text = Area(AreaNum).Name
                End If
                AreaNum += 1
            End If
        Next


    End Sub

    Private Sub rbnDiploRelatesColor_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbnDiploRelatesColor.CheckedChanged
        Dim ControlIndicator As String
        Dim AreaNum As Integer = 0

        If CanSeeMap Then ' would be nice to blank background so redraw of textboxes is faster, but doesn't work
            If Me.rbnDiploRelatesColor.Checked Then
                Me.BackgroundImage = Nothing
                'Me.Refresh()
            End If
        End If

        For Each Me.ctrl In Controls
            ControlIndicator = Me.ctrl.Name.Substring(0, 3)
            If ControlIndicator = "txt" Then 'And Me.ctrl.Name <> "txtYear" Then ' shldn't be needed now that Date is a label
                If Area(AreaNum).Type = LAND Then
                    Select Case Government(PlayerSide).DiplomaticRelations(Province(Area(AreaNum).Province).PoliticalAffiliation)
                        'Case ALLIED
                        '    Me.ctrl.BackColor = ALLIED_COLOR
                        Case FRIENDLY
                            Me.ctrl.BackColor = FRIENDLY_COLOR
                        Case NEUTRAL
                            Me.ctrl.BackColor = NEUTRAL_COLOR
                        Case HOSTILE
                            Me.ctrl.BackColor = HOSTILE_COLOR
                            'Case ENEMY
                            '    Me.ctrl.BackColor = ENEMY_COLOR
                        Case NO_POWER
                            Me.ctrl.BackColor = LOCAL_CONTROL_COLOR
                        Case SELF
                            Me.ctrl.BackColor = SELF_COLOR
                    End Select
                Else ' if is water
                    If Sea(Area(AreaNum).Province).Topography = COASTAL Then
                        Me.ctrl.BackColor = COASTAL_COLOR
                    Else ' is deep water
                        Me.ctrl.BackColor = OCEAN_COLOR
                    End If
                End If

                AreaNum += 1

            End If
        Next

        If CanSeeMap Then
            If Me.rbnDiploRelatesColor.Checked Then
                Me.Refresh()
                Me.BackgroundImage = EternalFrance1.My.Resources.Resources.MapScreenForBackgroundCropped
            End If
        End If


    End Sub

    Private Sub btnDiploRelates_Click(sender As System.Object, e As System.EventArgs) Handles btnDiploRelates.Click
        Me.rbnDiploRelatesText.Checked = True
        Me.rbnDiploRelatesColor.Checked = True

    End Sub

    Private Sub lblDatelbl_Click(sender As System.Object, e As System.EventArgs) Handles lblDate.Click

    End Sub

    Private Sub gbxColors_Enter(sender As System.Object, e As System.EventArgs) Handles gbxColors.Enter

    End Sub

    Private Sub lblSocialVPs_Click(sender As System.Object, e As System.EventArgs) Handles lblSocialVPs.Click

    End Sub

    Private Sub btnLawCode_Click(sender As Object, e As System.EventArgs) Handles btnLawCode.Click
        Dim GoAhead As MsgBoxResult = MsgBoxResult.No
        Dim MsgStr As String = ""

        If Government(PlayerSide).LawCode = 0 Then 'FOR NOW; LATER WILL NEED TO FILTER BY APPROPRIATE SITUATION
            MsgStr = "Codifying your Laws will improve your ability to Administer the Provinces you Rule.  "
            MsgStr &= "However, to do so, you will have to employ a staff of Legal Scholars familiar with Roman as well as Frankish Law. " & vbCrLf & vbCrLf
            MsgStr &= "This will cost " & LAW_CODE_COST & ",000 " & CurrencyStr & ", and you currently have " & Government(PlayerSide).Treasury & ",000." & vbCrLf & vbCrLf

            If Government(PlayerSide).Treasury < LAW_CODE_COST Then
                MsgStr &= "Therefore, you cannot currently afford this."
                MsgBox(MsgStr)
                CancelAction()
            Else
                MsgStr &= "Do you want to Continue?"
                GoAhead = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Codify Laws?")
                If GoAhead = MsgBoxResult.Yes Then
                    Government(PlayerSide).LawCode += 1
                    'CulturalVPs += MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE 'Decided against give Cultural points
                    'RefreshCulturalVP_Display()
                    MsgBox("Congratulations! Your Legal Scholars have Codified your Laws.")
                    ConcludeAction()
                Else
                    'MsgBox("Pick another Action.")
                    CancelAction()
                End If
            End If
        Else
            MsgBox("You have already Codified your Laws. There's no point trying to do it again.")
            CancelAction()
        End If

    End Sub

    Private Sub lblConquestVPs_Click(sender As System.Object, e As System.EventArgs) Handles lblConquestVPs.Click

    End Sub

    Private Sub gbxVPs_Enter(sender As System.Object, e As System.EventArgs) Handles gbxVPs.Enter

    End Sub

    Private Sub btnStartGame_Click(sender As System.Object, e As System.EventArgs) Handles btnStartGame.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        If CurrentAction = INTRODUCTION Then
            CurrentAction = EXPLORING
            lblPlayerAction.Text = EXPLORE_STRING
            lblCurrentPhase.Text = EXPLORE_PHASE_STRING
            txtExploreMessage.Visible = True
            lblClickExplore.Visible = False
            btnStartGame.Text = "Begin!"
            frmHelpDisplay.Show()
        Else
            Decision = MsgBox("Are you sure you don't want to Explore any more?", MsgBoxStyle.YesNo, "Stop Exploring?")
            If Decision = MsgBoxResult.Yes Then
                CurrentAction = NO_ACTION
                lblPlayerAction.Text = NO_SELECTION_STRING
                lblCurrentPhase.Text = NO_PHASE_STRING
                txtExploreMessage.Visible = False
                txtAttackOnly.Visible = True

                DoSocioeconomicChange()
                CalcGovernmentResources()
                CurrentAction = 0
                TotalActions = CreateActionQueue()
                btnStartGame.Visible = False
                btnAttack.Visible = True
                'btnNegotiate.Visible = True ' these get turned on later, after WHEN_SHOW_CONTROLS actions have taken place
                'btnRule.Visible = True

                AutoTurn()
            End If 'really wants to stop exploring

        End If ' current action is No action (just starting) else Explore (


    End Sub

    Private Sub btnHelp_Click(sender As Object, e As System.EventArgs) Handles btnHelp.Click

        frmHelpDisplay.Show()

    End Sub

    Private Sub txtExploreMessage_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtExploreMessage.TextChanged

    End Sub

    Private Sub lineGibraltarMidAtlantic_Click(sender As System.Object, e As System.EventArgs) Handles lineGibraltarMidAtlantic.Click

    End Sub

    Private Sub lineBiscayAtlantic_Click(sender As System.Object, e As System.EventArgs) Handles lineBiscayAtlantic.Click

    End Sub

    Private Sub lineChannelAtlantic_Click(sender As System.Object, e As System.EventArgs) Handles lineChannelAtlantic.Click

    End Sub
End Class
