﻿Public Class frmSeaInformation
    Dim TextboxChanged As Boolean = False
    Dim RecordChanged As Boolean = False

    Private Sub frmSeaInformation_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        PopulateSeaDisplay(SelectedArea)
        TextboxChanged = False
        RecordChanged = False

        If Playing = vbYes Then
            Me.btnRecord.Hide()
            Me.btnRestoreData.Hide()
            Me.btnSave.Hide()
        End If

    End Sub

    Private Sub btnPreviousSea_Click(sender As System.Object, e As System.EventArgs) Handles btnPreviousSea.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then ' whenver Record Changes, Textbox change set to false, so this test shouldn't be needed.
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedArea > 0 Then
            SelectedArea -= 1
        Else
            SelectedArea = TotalSeas - 1
        End If

        PopulateSeaDisplay(SelectedArea)
        TextboxChanged = False

        Me.Refresh()

    End Sub

    Private Sub btnNextSea_Click(sender As System.Object, e As System.EventArgs) Handles btnNextSea.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then ' whenver Record Changes, Textbox change set to false, so this test shouldn't be needed.
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedArea < TotalSeas - 1 Then
            SelectedArea += 1
        Else
            SelectedArea = 0
        End If

        PopulateSeaDisplay(SelectedArea)
        TextboxChanged = False

        Me.Refresh()

    End Sub

    Private Sub btnCloseSeaInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnCloseSeaInfo.Click

        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        If RecordChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        Close()

    End Sub

    Private Sub lblConnectors_Click(sender As System.Object, e As System.EventArgs) Handles lblConnectors.Click

    End Sub

    Private Sub txtAreaType_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAreaType.TextChanged

    End Sub

    Private Sub txtAssociatedTextbox_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAssociatedTextbox.TextChanged

    End Sub

    Private Sub txtAreaID_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAreaID.TextChanged

    End Sub

    Private Sub txtSeaID_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtSeaID.TextChanged

    End Sub

    Private Sub txtSeaName_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtSeaName.TextChanged

    End Sub

    Private Sub txtControl_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtControl.TextChanged

    End Sub

    Private Sub txtClimate_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtClimate.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If RecordChanged = False Then
            MsgBox("No Information Updated; No reason to Save")
            Exit Sub
        End If

        If TextboxChanged = True Then
            MsgBox("Recent Change(s) Unrecorded. Save Without Them?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        MsgBoxResult = MsgBox("Update Permanent Record?", MsgBoxStyle.YesNo, "Failsafe")
        If MsgBoxResult = vbYes Then
            SaveSeas()
            RecordChanged = False
        End If



    End Sub

    Private Sub btnRecord_Click(sender As System.Object, e As System.EventArgs) Handles btnRecord.Click

        'So can Backup existing values in case of problem
        Dim Cl As Integer
        Cl = Sea(SelectedArea).Climate

        If TextboxChanged = False Then
            MsgBox("No Information Updated; No reason to Record")
            Exit Sub
        End If

        Try
            Sea(SelectedArea).Climate = CInt(Me.txtClimate.Text)
            RecordChanged = True
            TextboxChanged = False

        Catch
            MsgBox("Invalid Value in a Textbox (A Blank?)")
            Sea(SelectedArea).Climate = Cl
        End Try

    End Sub

    Private Sub btnRestoreData_Click(sender As System.Object, e As System.EventArgs) Handles btnRestoreData.Click
        Dim MsgboxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = False Then
            MsgBox("No Information Updated; No reason to Restore")
            Exit Sub
        End If

        MsgboxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")

        If MsgboxResult = vbYes Then

            PopulateSeaDisplay(SelectedArea)
            TextboxChanged = False

            Me.Refresh()

        End If


    End Sub
End Class