﻿
Imports System.IO

Module Module1
    Dim RecordList() As String

    Function ReadInFile(FileToRead As String)
        Dim RecordsReadIn As Integer
        Dim ImportedTextStream As StreamReader
        Dim LineOfInput As String = ""
        Dim Headers As String = ""
        Dim FilePath As String = ""

        ' Get Path to File
        FilePath = Directory.GetCurrentDirectory & FileToRead
        'MsgBox(FilePath)

        'Read text file into a single huge string
        ImportedTextStream = New StreamReader(FilePath)

        Do Until ImportedTextStream.EndOfStream
            ReDim Preserve RecordList(RecordsReadIn)
            LineOfInput = ImportedTextStream.ReadLine()

            RecordList(RecordsReadIn) = LineOfInput
            RecordsReadIn += 1
        Loop

        ImportedTextStream.Close()

        Return RecordsReadIn

    End Function

    Sub ImportAreas() ' (ByVal GameType As Integer) ' only import At Start values since don't change during game like Provinces, etc.
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim Fields(NUM_FIELDS_IN_AREAS - 1) As String


        RecordsInFile = ReadInFile(AREAS_AT_START_FILENAME)
        TotalAreas = RecordsInFile

        ReDim Area(RecordsInFile - 1)

        For RecordNumber = 0 To RecordsInFile - 1

            Record = RecordList(RecordNumber)

            Fields = Record.Split(",")

            Area(RecordNumber).ID = CStr(Fields(0)) 'shouldn't these be CInt?
            Area(RecordNumber).Name = Fields(1)
            Area(RecordNumber).Type = CStr(Fields(2))
            Area(RecordNumber).MapElement = Fields(3)
            Area(RecordNumber).Topography = CStr(Fields(4))
            Area(RecordNumber).Province = CStr(Fields(5))

        Next


    End Sub

    Sub ImportProvinces(ByVal GameType As Integer)
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim NumFields As Integer = 0
        Dim Fields() As String
        Dim Neighbor As Integer = 0
        Dim Connectors As Integer = 0
        Dim FieldNum As Integer = 0
        Dim FileNameStr As String = ""

        If GameType = NEW_GAME Then
            FileNameStr = PROVINCES_AT_START_FILENAME
        Else
            FileNameStr = SAVED_PROVINCES_FILENAME
        End If

        RecordsInFile = ReadInFile(FileNameStr)
        TotalProvinces = RecordsInFile

        ReDim Province(RecordsInFile - 1)

        ReDim Fields(NUM_FIELDS_IN_PROVINCES)

        For RecordNumber = 0 To RecordsInFile - 1

            ReDim Province(RecordNumber).Neighbors(MAX_NEIGHBORS_LAND - 1)
            ReDim Province(RecordNumber).Connectors(MAX_NEIGHBORS_LAND - 1)
            ReDim Province(RecordNumber).ConnectorNames(MAX_NEIGHBORS_LAND - 1)

            Record = RecordList(RecordNumber)

            Fields = Record.Split(",")

            Province(RecordNumber).ID = CStr(Fields(0)) 'Shouldn't these be CInt?
            Province(RecordNumber).Name = Fields(1)
            Province(RecordNumber).MapElement = Fields(2)
            Province(RecordNumber).Topography = CStr(Fields(3))
            Province(RecordNumber).Climate = CStr(Fields(4))
            Province(RecordNumber).AreaNumber = CStr(Fields(5))
            Province(RecordNumber).PoliticalAffiliation = CStr(Fields(6))
            Province(RecordNumber).Farmland = CStr(Fields(7))
            Province(RecordNumber).Peasants = CStr(Fields(8))
            Province(RecordNumber).AgricultureLevel = CStr(Fields(9))
            Province(RecordNumber).SurplusPopulation = CStr(Fields(10))
            Province(RecordNumber).HarvestActual = CStr(Fields(11))
            Province(RecordNumber).Nobles = CStr(Fields(12))
            Province(RecordNumber).Clergy = CStr(Fields(13))
            Province(RecordNumber).Townspeople = CStr(Fields(14))
            Province(RecordNumber).SocialState = CStr(Fields(15))
            FieldNum = 16
            For Neighbor = 0 To MAX_NEIGHBORS_LAND - 1
                Province(RecordNumber).Neighbors(Neighbor) = CStr(Fields(FieldNum))
                FieldNum += 1
                Province(RecordNumber).ConnectorNames(Neighbor) = Fields(FieldNum)
                FieldNum += 1
                Province(RecordNumber).Connectors(Neighbor) = CStr(Fields(FieldNum))
                FieldNum += 1
            Next
            Province(RecordNumber).Loyalty = CInt(Fields(FieldNum))
            FieldNum += 1
            Province(RecordNumber).Religion = CInt(Fields(FieldNum))
            FieldNum += 1
            Province(RecordNumber).Language = CInt(Fields(FieldNum))
        Next


    End Sub

    Sub ImportSeas(ByVal GameType As Integer)
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim NumFields As Integer = 0
        Dim Fields() As String
        Dim Neighbor As Integer = 0
        Dim Connectors As Integer = 0
        Dim FieldNum As Integer = 0
        Dim FileNameStr As String = ""

        If GameType = NEW_GAME Then
            FileNameStr = SEAS_AT_START_FILENAME
        Else
            FileNameStr = SAVED_SEAS_FILENAME
        End If

        RecordsInFile = ReadInFile(FileNameStr)
        'RecordsInFile = ReadInFile(SEAS_AT_START_FILENAME)
        TotalSeas = RecordsInFile

        ReDim Sea(RecordsInFile - 1)

        ReDim Fields(NUM_FIELDS_IN_SEAS)

        For RecordNumber = 0 To RecordsInFile - 1

            ReDim Sea(RecordNumber).Neighbors(MAX_NEIGHBORS_SEA - 1)
            ReDim Sea(RecordNumber).Connectors(MAX_NEIGHBORS_SEA - 1)
            ReDim Sea(RecordNumber).ConnectorNames(MAX_NEIGHBORS_SEA - 1)

            Record = RecordList(RecordNumber)

            Fields = Record.Split(",")

            Sea(RecordNumber).ID = CStr(Fields(0))
            Sea(RecordNumber).Name = Fields(1)
            Sea(RecordNumber).MapElement = Fields(2)
            Sea(RecordNumber).Topography = CStr(Fields(3))
            Sea(RecordNumber).AreaNumber = CStr(Fields(4))
            Sea(RecordNumber).Climate = CStr(Fields(5))
            Sea(RecordNumber).Controller = CStr(Fields(6))
            FieldNum = 7
            For Neighbor = 0 To MAX_NEIGHBORS_SEA - 1
                Sea(RecordNumber).Neighbors(Neighbor) = CStr(Fields(FieldNum))
                FieldNum += 1
                Sea(RecordNumber).ConnectorNames(Neighbor) = Fields(FieldNum)
                FieldNum += 1
                Sea(RecordNumber).Connectors(Neighbor) = CStr(Fields(FieldNum))
                FieldNum += 1
            Next
        Next

        RecordNumber = Neighbor 'dumb statement to hang a breakpoint on

    End Sub

    Sub ImportConnectors(ByVal GameType As Integer)
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim Fields(NUM_FIELDS_IN_AREAS - 1) As String
        Dim FileNameStr As String = ""

        If GameType = NEW_GAME Then
            FileNameStr = CONNECTORS_AT_START_FILENAME
        Else
            FileNameStr = SAVED_CONNECTORS_FILENAME
        End If

        RecordsInFile = ReadInFile(FileNameStr)
        'RecordsInFile = ReadInFile(CONNECTORS_AT_START_FILENAME)
        TotalConnectors = RecordsInFile

        ReDim Connector(RecordsInFile - 1)

        For RecordNumber = 0 To RecordsInFile - 1

            Record = RecordList(RecordNumber)

            Fields = Record.Split(",")

            Connector(RecordNumber).ID = CStr(Fields(0)) 'shouldn't these be CInt?
            Connector(RecordNumber).Name = Fields(1)
            Connector(RecordNumber).Type = CStr(Fields(2))
            Connector(RecordNumber).X1 = Fields(3)
            Connector(RecordNumber).Y1 = CStr(Fields(4))
            Connector(RecordNumber).OneEnd = CStr(Fields(5))
            Connector(RecordNumber).X2 = Fields(6)
            Connector(RecordNumber).Y2 = CStr(Fields(7))
            Connector(RecordNumber).OtherEnd = CStr(Fields(8))

        Next

    End Sub

    Sub ImportGovernments(ByVal GameType As Integer)
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim Fields(NUM_FIELDS_IN_GOVERNMENTS - 1) As String
        Dim FieldNum As Integer = 0
        Dim Kingdom As Integer = 0
        Dim FileNameStr As String = ""

        If GameType = NEW_GAME Then
            FileNameStr = GOVERNMENTS_AT_START_FILENAME
        Else
            FileNameStr = SAVED_GOVERNMENTS_FILENAME
        End If

        RecordsInFile = ReadInFile(FileNameStr)
        'RecordsInFile = ReadInFile(GOVERNMENTS_AT_START_FILENAME)
        TotalGovernments = RecordsInFile

        ReDim Fields((NUM_FIELDS_IN_GOVERNMENTS + TotalGovernments) - 1)

        ReDim Government(RecordsInFile - 1)

        For RecordNumber = 0 To RecordsInFile - 1

            ReDim Government(RecordNumber).DiplomaticRelations(TotalGovernments - 1)

            Record = RecordList(RecordNumber)

            Fields = Record.Split(",")

            Government(RecordNumber).ID = CInt(Fields(0)) 'CStr(Fields(0)) 'shouldn't these be CInt? 'Let's give it a try with this new file
            Government(RecordNumber).Name = Fields(1)
            Government(RecordNumber).LeadershipState = CInt(Fields(2))
            Government(RecordNumber).Generalship = Fields(3)
            Government(RecordNumber).Treasury = CInt(Fields(4))
            Government(RecordNumber).TotalBenefices = CInt(Fields(5))
            Government(RecordNumber).RoyalEstates = CInt(Fields(6))
            Government(RecordNumber).Cavalary = CInt(Fields(7))
            Government(RecordNumber).Infantry = CInt(Fields(8))
            Government(RecordNumber).ArmyState = CInt(Fields(9))
            Government(RecordNumber).Support = CInt(Fields(10))
            Government(RecordNumber).Religion = CInt(Fields(11))
            Government(RecordNumber).PoliticalSavvy = CInt(Fields(12))
            Government(RecordNumber).Language = CInt(Fields(13))
            FieldNum = 14
            For Kingdom = 0 To TotalGovernments - 1
                Government(RecordNumber).DiplomaticRelations(Kingdom) = CInt(Fields(FieldNum))
                FieldNum += 1
            Next
            Government(RecordNumber).LawCode = CInt(Fields(FieldNum))
            FieldNum += 1
            Government(RecordNumber).NavalCapability = CInt(Fields(FieldNum))
            FieldNum += 1
            Government(RecordNumber).Reputation = CInt(Fields(FieldNum))

        Next
    End Sub

    Sub ImportGlobals() ' (ByVal GameType As Integer) ' only import Saved values since At Start are hardwired in.
        Dim RecordsInFile As Integer = 0
        Dim RecordNumber As Integer = 0
        Dim Record As String
        Dim Fields(5) As String 'start with number known; Redim Preserve below to  ' actually redim preserve is for actionqueue, but seems to work anyway


        RecordsInFile = ReadInFile(SAVED_GLOBALS_FILENAME)

        Record = RecordList(RecordNumber)

        Fields = Record.Split(",")

        TurnDate = CInt(Fields(0))
        PlayerSide = CInt(Fields(1))
        ActiveGovernment = CInt(Fields(2))
        CurrentAction = Fields(3)
        TotalActions = CStr(Fields(4))

        ReDim Preserve ActionQueue(TotalActions - 1)

        For i = 0 To TotalActions - 1
            ActionQueue(i) = CInt(Fields(5 + i))
        Next

        CurrencyStr = Fields(5 + TotalActions)

        For i = 0 To CLIMATE_ZONES - 1
            WeatherByArea(i) = Fields(6 + TotalActions + i)
        Next

        ConquestVPs = Fields(6 + TotalActions + CLIMATE_ZONES)
        SocialVPs = Fields(6 + TotalActions + CLIMATE_ZONES + 1)
        CulturalVPs = Fields(6 + TotalActions + CLIMATE_ZONES + 2)

    End Sub

    Sub Autosave()
        Dim DateStr As String = ""
        Dim TimeStr As String = ""
        Dim DateTimeIntStr As String = ""

        DateStr = DateString
        TimeStr = TimeString

        DateTimeIntStr = GetDateTimeIntStr(DateStr, TimeStr)

        SaveProvinces(DateTimeIntStr)
        SaveGovernments(DateTimeIntStr)
        SaveGlobals(DateTimeIntStr)

        'MsgBox(DateStr & ", " & TimeStr & ", " & DateTimeIntStr)

    End Sub

    Function GetDateTimeIntStr(ByVal DateStr As String, ByVal TimeStr As String) As String
        Dim DateTimeIntStr As String = ""
        Dim DateIntStr As String = ""
        Dim TimeIntStr As String = ""
        Dim DateLength As Integer = 0
        Dim TimeLength As Integer = 0
        Dim DateChar As Char()
        Dim TimeChar As Char()
        Dim i As Integer = 0

        'Time = DateValue()
        'Datestr = DateString
        DateLength = Datestr.Length
        ReDim DateChar(DateLength - 1)
        DateChar = Datestr.ToCharArray
        For i = 0 To DateLength - 1
            If DateChar(i) <> "-" Then
                DateIntStr &= DateChar(i)
            End If
        Next

        'TimeStr = TimeString
        TimeLength = TimeStr.Length
        ReDim TimeChar(TimeLength - 1)
        TimeChar = TimeStr.ToCharArray
        For i = 0 To TimeLength - 1
            If TimeChar(i) <> ":" Then
                TimeIntStr &= TimeChar(i)
            End If
        Next

        DateTimeIntStr = DateIntStr & TimeIntStr


        Return DateTimeIntStr
    End Function

    Sub SaveGovernments(ByVal DateTimeStr As String) '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveGovernmentsPath As String = ""
        Dim GovernmentNumber As Integer
        Dim LineToSave As String
        Dim FilenameStr As String = ""

        SavePlace = (Directory.GetCurrentDirectory)

        If Playing = MsgBoxResult.No Then
            FilenameStr = GOVERNMENTS_AT_START_FILENAME
        Else
            If DateTimeStr = PLAYER_SAVE Then
                FilenameStr = SAVED_GOVERNMENTS_FILENAME
            Else
                SavePlace &= AUTO_SAVE_PLACE
                FilenameStr = StartDateTimeStr & AUTO_SAVED_GOVERNMENTS_FILENAME & DateTimeStr & ".txt"
            End If
        End If

        SaveGovernmentsPath = SavePlace & FilenameStr 'GOVERNMENTS_AT_START_FILENAME

        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveGovernmentsPath, False) 'False means will replace current contents

        For GovernmentNumber = 0 To TotalGovernments - 1
            LineToSave = CStr(Government(GovernmentNumber).ID) & "," _
                & Government(GovernmentNumber).Name & "," & CStr(Government(GovernmentNumber).LeadershipState) _
                & "," & Government(GovernmentNumber).Generalship & "," _
                & CStr(Government(GovernmentNumber).Treasury) & "," _
                & CStr(Government(GovernmentNumber).TotalBenefices) & COMMA _
                & CStr(Government(GovernmentNumber).RoyalEstates) & COMMA _
                & CStr(Government(GovernmentNumber).Cavalary) & COMMA _
                & CStr(Government(GovernmentNumber).Infantry) & COMMA _
                & CStr(Government(GovernmentNumber).ArmyState) & COMMA _
                & CStr(Government(GovernmentNumber).Support) & COMMA _
                & CStr(Government(GovernmentNumber).Religion) & COMMA _
                & CStr(Government(GovernmentNumber).PoliticalSavvy) & COMMA _
                & CStr(Government(GovernmentNumber).Language)
            For Kingdom = 0 To TotalGovernments - 1
                LineToSave = LineToSave & COMMA & CStr(Government(GovernmentNumber).DiplomaticRelations(Kingdom))
            Next
            LineToSave &= COMMA & CStr(Government(GovernmentNumber).LawCode)
            LineToSave &= COMMA & CStr(Government(GovernmentNumber).NavalCapability)
            LineToSave &= COMMA & CStr(Government(GovernmentNumber).Reputation)

            StreamToWrite.WriteLine(LineToSave)

            StreamToWrite.Close()
            LineToSave = ""

            StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveGovernmentsPath, True) 'Now start appending

        Next

        StreamToWrite.Close()

    End Sub

    Sub SaveAreas() '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveAreasPath As String = ""
        Dim AreaNumber As Integer
        Dim LineToSave As String
        Dim FilenameStr As String = ""

        SavePlace = (Directory.GetCurrentDirectory)

        'If Playing = MsgBoxResult.No Then ' SaveAreas should ONLY be called if saving underlying structure; never changed during play!
        FilenameStr = AREAS_AT_START_FILENAME
        'Else
        'FilenameStr = SAVED_AREAS_FILENAME
        'End If

        SaveAreasPath = SavePlace & FilenameStr
        'SaveAreasPath = SavePlace & AREAS_AT_START_FILENAME
        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveAreasPath, False) 'False means will replace current contents

        For AreaNumber = 0 To TotalAreas - 1
            LineToSave = CStr(Area(AreaNumber).ID) & "," _
                & Area(AreaNumber).Name & "," & CStr(Area(AreaNumber).Type) _
                & "," & Area(AreaNumber).MapElement & "," _
                & CStr(Area(AreaNumber).Topography) & "," _
                & CStr(Area(AreaNumber).Province)

            StreamToWrite.WriteLine(LineToSave)

            StreamToWrite.Close()
            LineToSave = ""

            StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveAreasPath, True) 'Now start appending

        Next

        StreamToWrite.Close()

    End Sub

    Sub SaveProvinces(ByVal DateTimeStr As String) '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveProvincesPath As String = ""
        Dim ProvinceNumber As Integer
        Dim LineToSave As String
        Dim FilenameStr As String = ""

        SavePlace = (Directory.GetCurrentDirectory)


        If Playing = MsgBoxResult.No Then
            FilenameStr = PROVINCES_AT_START_FILENAME
        Else
            If DateTimeStr = PLAYER_SAVE Then
                FilenameStr = SAVED_PROVINCES_FILENAME
            Else
                SavePlace &= AUTO_SAVE_PLACE
                FilenameStr = StartDateTimeStr & AUTO_SAVED_PROVINCES_FILENAME & DateTimeStr & ".txt"
            End If
        End If

        SaveProvincesPath = SavePlace & FilenameStr
        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveProvincesPath, False) 'False means will replace current contents

        For ProvinceNumber = 0 To TotalProvinces - 1
            LineToSave = CStr(Province(ProvinceNumber).ID) _
                    & COMMA & Province(ProvinceNumber).Name _
                    & COMMA & Province(ProvinceNumber).MapElement _
                    & COMMA & CStr(Province(ProvinceNumber).Topography) _
                    & COMMA & CStr(Province(ProvinceNumber).Climate) _
                    & COMMA & CStr(Province(ProvinceNumber).AreaNumber) _
                    & COMMA & CStr(Province(ProvinceNumber).PoliticalAffiliation) _
                    & COMMA & CStr(Province(ProvinceNumber).Farmland) _
                    & COMMA & CStr(Province(ProvinceNumber).Peasants) _
                    & COMMA & CStr(Province(ProvinceNumber).AgricultureLevel) _
                    & COMMA & CStr(Province(ProvinceNumber).SurplusPopulation) _
                    & COMMA & CStr(Province(ProvinceNumber).HarvestActual) _
                    & COMMA & CStr(Province(ProvinceNumber).Nobles) _
                    & COMMA & CStr(Province(ProvinceNumber).Clergy) _
                    & COMMA & CStr(Province(ProvinceNumber).Townspeople) _
                    & COMMA & CStr(Province(ProvinceNumber).SocialState)

            For Neighbor = 0 To MAX_NEIGHBORS_LAND - 1
                LineToSave = LineToSave & COMMA & CStr(Province(ProvinceNumber).Neighbors(Neighbor)) _
                    & COMMA & Province(ProvinceNumber).ConnectorNames(Neighbor) _
                    & COMMA & CStr(Province(ProvinceNumber).Connectors(Neighbor))
            Next
            LineToSave = LineToSave & COMMA & CStr(Province(ProvinceNumber).Loyalty) _
            & COMMA & CStr(Province(ProvinceNumber).Religion) _
            & COMMA & CStr(Province(ProvinceNumber).Language)

            StreamToWrite.WriteLine(LineToSave)
            StreamToWrite.Close()

            LineToSave = ""

            StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveProvincesPath, True) 'Now start appending

        Next
        StreamToWrite.Close()
    End Sub

    Sub SaveSeas() '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveSeasPath As String = ""
        Dim SeaZone As Integer
        Dim LineToSave As String
        Dim FilenameStr As String = ""

        SavePlace = (Directory.GetCurrentDirectory)

        If Playing = MsgBoxResult.No Then
            FilenameStr = SEAS_AT_START_FILENAME
        Else
            FilenameStr = SAVED_SEAS_FILENAME
        End If

        SaveSeasPath = SavePlace & FilenameStr
        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveSeasPath, False) 'False means will replace current contents

        For SeaZone = 0 To TotalSeas - 1
            LineToSave = CStr(Sea(SeaZone).ID) _
            & COMMA & Sea(SeaZone).Name _
            & COMMA & Sea(SeaZone).MapElement _
            & COMMA & CStr(Sea(SeaZone).Topography) _
            & COMMA & CStr(Sea(SeaZone).AreaNumber) _
            & COMMA & CStr(Sea(SeaZone).Climate) _
            & COMMA & CStr(Sea(SeaZone).Controller)

            For Neighbor = 0 To MAX_NEIGHBORS_SEA - 1
                LineToSave = LineToSave & COMMA & CStr(Sea(SeaZone).Neighbors(Neighbor)) _
                    & COMMA & Sea(SeaZone).ConnectorNames(Neighbor) _
                    & COMMA & CStr(Sea(SeaZone).Connectors(Neighbor))
            Next

            StreamToWrite.WriteLine(LineToSave)

            StreamToWrite.Close()
            LineToSave = ""

            StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveSeasPath, True) 'Now start appending
        Next

        StreamToWrite.Close()

    End Sub

    Sub SaveConnectors()

        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveConnectorsPath As String = ""
        Dim ConnectorNum As Integer
        Dim LineToSave As String
        Dim FilenameStr As String = ""

        SavePlace = (Directory.GetCurrentDirectory)

        If Playing = MsgBoxResult.No Then
            FilenameStr = CONNECTORS_AT_START_FILENAME
        Else
            FilenameStr = SAVED_CONNECTORS_FILENAME
        End If

        SaveConnectorsPath = SavePlace & FilenameStr

        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveConnectorsPath, False) 'False means will replace current contents

        For ConnectorNum = 0 To TotalConnectors - 1
            LineToSave = CStr(Connector(ConnectorNum).ID) _
            & COMMA & Connector(ConnectorNum).Name _
            & COMMA & CStr(Connector(ConnectorNum).Type) _
            & COMMA & CStr(Connector(ConnectorNum).X1) _
            & COMMA & CStr(Connector(ConnectorNum).Y1) _
            & COMMA & CStr(Connector(ConnectorNum).OneEnd) _
            & COMMA & CStr(Connector(ConnectorNum).X2) _
            & COMMA & CStr(Connector(ConnectorNum).Y2) _
            & COMMA & CStr(Connector(ConnectorNum).OtherEnd)


            StreamToWrite.WriteLine(LineToSave)

            StreamToWrite.Close()
            LineToSave = ""

            StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveConnectorsPath, True) 'Now start appending
        Next

        StreamToWrite.Close()

    End Sub

    Sub SaveGlobals(ByVal DateTimeStr As String) '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveGlobalsPath As String = ""
        Dim LineToSave As String
        Dim FilenameStr As String = ""
        Dim i As Integer = 0

        SavePlace = (Directory.GetCurrentDirectory)

        'If Playing = MsgBoxResult.No Then
        '    FilenameStr = GLOBALS_AT_START_FILENAME
        'Else
        If DateTimeStr = PLAYER_SAVE Then
            FilenameStr = SAVED_GLOBALS_FILENAME ' Globals at start are hardwired in for now; so only need save them for Saved Game
        Else
            SavePlace &= AUTO_SAVE_PLACE
            FilenameStr = StartDateTimeStr & AUTO_SAVED_GLOBALS_FILENAME & DateTimeStr & ".txt"
        End If
        'End If

        SaveGlobalsPath = SavePlace & FilenameStr
        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveGlobalsPath, False) 'False means will replace current contents

        LineToSave = CStr(TurnDate) & ","

        LineToSave &= CStr(PlayerSide) & ","
        LineToSave &= CStr(ActiveGovernment) & ","

        LineToSave &= CStr(CurrentAction - 1) & "," ' need to decrement this because first thing Action Loop does is increment it, before player can save
        LineToSave &= CStr(TotalActions) & ","

        For i = 0 To TotalActions - 1
            LineToSave &= CStr(ActionQueue(i)) & ","
        Next

        LineToSave &= CurrencyStr & "," ' don't put & "," so can lead with it in loop and end without it at final element

        For i = 0 To CLIMATE_ZONES - 1
            LineToSave &= CStr(WeatherByArea(i)) & ","
        Next

        LineToSave &= CStr(ConquestVPs) & ","
        LineToSave &= CStr(SocialVPs) & ","
        LineToSave &= CStr(CulturalVPs)

        StreamToWrite.WriteLine(LineToSave)

        StreamToWrite.Close()
        LineToSave = ""

        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveGlobalsPath, True) 'Now start appending

        StreamToWrite.Close()

    End Sub

    Sub SaveEnd(ByVal DateTimeStr As String) '(FileToWrite As String)
        Dim StreamToWrite As StreamWriter
        Dim SavePlace As String = ""
        Dim SaveEndPath As String = ""
        Dim LineToSave As String
        Dim FilenameStr As String = ""
        Dim i As Integer = 0
        Dim VictoryStr As String = ""

        VictoryStr = DescribeVictoryLevel()

        SavePlace = (Directory.GetCurrentDirectory)

        'If DateTimeStr = PLAYER_SAVE Then
        '    FilenameStr = SAVED_GLOBALS_FILENAME ' Globals at start are hardwired in for now; so only need save them for Saved Game
        'Else

        'Single Save Path
        SavePlace &= AUTO_SAVE_PLACE
        FilenameStr = StartDateTimeStr & AUTO_SAVED_END_FILENAME & DateTimeStr & ".txt"
        'End If
        'End If

        SaveEndPath = SavePlace & FilenameStr
        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveEndPath, False) 'False means will replace current contents

        LineToSave = CStr(TurnDate) & ","

        LineToSave &= CStr(ConquestVPs) & ","
        LineToSave &= CStr(SocialVPs) & ","
        LineToSave &= CStr(CulturalVPs) & ","
        LineToSave &= CStr(TotalVPs) & ","
        LineToSave &= VictoryStr

        StreamToWrite.WriteLine(LineToSave)

        StreamToWrite.Close()
        LineToSave = ""

        StreamToWrite = My.Computer.FileSystem.OpenTextFileWriter(SaveEndPath, True) 'Now start appending

        StreamToWrite.Close()

    End Sub



    Sub PopulateProvinceDisplay(ProvinceID As Integer)

        If Playing = MsgBoxResult.Yes Then
            'frmProvinceInfo.txtTopgraphy.Text = CStr(Province(ProvinceID).Topography)
            frmProvinceInfo.txtPoliticalAffiliation.Text = Government(Province(ProvinceID).PoliticalAffiliation).Name
            frmProvinceInfo.txtSocialState.Text = DescribeSocialState(Province(ProvinceID).SocialState)
            frmProvinceInfo.txtLoyalty.Text = NameLoyaltyLevel(Province(ProvinceID).Loyalty)
            frmProvinceInfo.txtReligion.Text = NameReligion(Province(ProvinceID).Religion)
            frmProvinceInfo.txtLanguage.Text = NameLanguage(Province(ProvinceID).Language)
        Else
            'frmProvinceInfo.txtTopgraphy.Text = CStr(Province(ProvinceID).Topography)
            frmProvinceInfo.txtPoliticalAffiliation.Text = CStr(Province(ProvinceID).PoliticalAffiliation)
            frmProvinceInfo.txtSocialState.Text = CStr(Province(ProvinceID).SocialState)
            frmProvinceInfo.txtLoyalty.Text = CStr(Province(ProvinceID).Loyalty)
            frmProvinceInfo.txtReligion.Text = CStr(Province(ProvinceID).Religion)
            frmProvinceInfo.txtLanguage.Text = CStr(Province(ProvinceID).Language)
        End If

        frmProvinceInfo.txtProvinceName.Text = Province(ProvinceID).Name
        frmProvinceInfo.txtAssociatedTextbox.Text = Province(ProvinceID).MapElement
        frmProvinceInfo.txtProvinceID.Text = CStr(Province(ProvinceID).ID)
        frmProvinceInfo.txtAreaID.Text = CStr(Province(ProvinceID).AreaNumber)
        frmProvinceInfo.txtAreaType.Text = "Land"
        frmProvinceInfo.txtTopgraphy.Text = GetTerrainName(Province(ProvinceID).Topography)
        frmProvinceInfo.txtClimate.Text = NameClimateZone(Province(ProvinceID).Climate)
        'frmProvinceInfo.txtPoliticalAffiliation.Text = CStr(Province(ProvinceID).PoliticalAffiliation)
        frmProvinceInfo.txtFarmland.Text = CStr(Province(ProvinceID).Farmland)
        frmProvinceInfo.txtPeasants.Text = CStr(Province(ProvinceID).Peasants)
        frmProvinceInfo.txtAgriculturalLevel.Text = CStr(Province(ProvinceID).AgricultureLevel)
        frmProvinceInfo.txtSurplusPop.Text = CStr(Province(ProvinceID).SurplusPopulation)
        frmProvinceInfo.txtHarvestActual.Text = CStr(Province(ProvinceID).HarvestActual)
        frmProvinceInfo.txtNobles.Text = CStr(Province(ProvinceID).Nobles)
        frmProvinceInfo.txtClergy.Text = CStr(Province(ProvinceID).Clergy)
        frmProvinceInfo.txtTownspeople.Text = CStr(Province(ProvinceID).Townspeople)
        'frmProvinceInfo.txtSocialState.Text = CStr(Province(ProvinceID).SocialState)
        'frmProvinceInfo.txtLoyalty.Text = CStr(Province(ProvinceID).Loyalty)
        'frmProvinceInfo.txtReligion.Text = CStr(Province(ProvinceID).Religion)
        'frmProvinceInfo.txtLanguage.Text = CStr(Province(ProvinceID).Language)
        'following is temporary
        frmProvinceInfo.txtNeighbor1.Text = CStr(Province(ProvinceID).Neighbors(0))
        frmProvinceInfo.txtNeighbor2.Text = CStr(Province(ProvinceID).Neighbors(1))
        frmProvinceInfo.txtNeighbor3.Text = CStr(Province(ProvinceID).Neighbors(2))
        frmProvinceInfo.txtNeighbor4.Text = CStr(Province(ProvinceID).Neighbors(3))
        frmProvinceInfo.txtNeighbor5.Text = CStr(Province(ProvinceID).Neighbors(4))
        frmProvinceInfo.txtNeighbor6.Text = CStr(Province(ProvinceID).Neighbors(5))
        frmProvinceInfo.txtNeighborName1.Text = Area(Province(ProvinceID).Neighbors(0)).Name
        If Province(ProvinceID).Neighbors(1) >= 0 Then
            frmProvinceInfo.txtNeighborName2.Text = Area(Province(ProvinceID).Neighbors(1)).Name
        Else
            frmProvinceInfo.txtNeighborName2.Text = ""
        End If
        If Province(ProvinceID).Neighbors(2) >= 0 Then
            frmProvinceInfo.txtNeighborName3.Text = Area(Province(ProvinceID).Neighbors(2)).Name
        Else
            frmProvinceInfo.txtNeighborName3.Text = ""
        End If
        If Province(ProvinceID).Neighbors(3) >= 0 Then
            frmProvinceInfo.txtNeighborName4.Text = Area(Province(ProvinceID).Neighbors(3)).Name
        Else
            frmProvinceInfo.txtNeighborName4.Text = ""
        End If
        If Province(ProvinceID).Neighbors(4) >= 0 Then
            frmProvinceInfo.txtNeighborName5.Text = Area(Province(ProvinceID).Neighbors(4)).Name
        Else
            frmProvinceInfo.txtNeighborName5.Text = ""
        End If
        If Province(ProvinceID).Neighbors(5) >= 0 Then
            frmProvinceInfo.txtNeighborName6.Text = Area(Province(ProvinceID).Neighbors(5)).Name
        Else
            frmProvinceInfo.txtNeighborName6.Text = ""
        End If
        frmProvinceInfo.txtConnectorName1.Text = CStr(Province(ProvinceID).ConnectorNames(0))
        frmProvinceInfo.txtConnectorName2.Text = CStr(Province(ProvinceID).ConnectorNames(1))
        frmProvinceInfo.txtConnectorName3.Text = CStr(Province(ProvinceID).ConnectorNames(2))
        frmProvinceInfo.txtConnectorName4.Text = CStr(Province(ProvinceID).ConnectorNames(3))
        frmProvinceInfo.txtConnectorName5.Text = CStr(Province(ProvinceID).ConnectorNames(4))
        frmProvinceInfo.txtConnectorName6.Text = CStr(Province(ProvinceID).ConnectorNames(5))
        frmProvinceInfo.cbxConnector1.SelectedIndex = Province(ProvinceID).Connectors(0)
        frmProvinceInfo.cbxConnector2.SelectedIndex = Province(ProvinceID).Connectors(1)
        frmProvinceInfo.cbxConnector3.SelectedIndex = Province(ProvinceID).Connectors(2)
        frmProvinceInfo.cbxConnector4.SelectedIndex = Province(ProvinceID).Connectors(3)
        frmProvinceInfo.cbxConnector5.SelectedIndex = Province(ProvinceID).Connectors(4)
        frmProvinceInfo.cbxConnector6.SelectedIndex = Province(ProvinceID).Connectors(5)
        frmProvinceInfo.txtConnector1.Text = CStr(Province(ProvinceID).Connectors(0))
        frmProvinceInfo.txtConnector2.Text = CStr(Province(ProvinceID).Connectors(1))
        frmProvinceInfo.txtConnector3.Text = CStr(Province(ProvinceID).Connectors(2))
        frmProvinceInfo.txtConnector4.Text = CStr(Province(ProvinceID).Connectors(3))
        frmProvinceInfo.txtConnector5.Text = CStr(Province(ProvinceID).Connectors(4))
        frmProvinceInfo.txtConnector6.Text = CStr(Province(ProvinceID).Connectors(5))
    End Sub
    'frmProvinceInfo.cbxConnector7.SelectedIndex = NO_SELECTION
    'frmProvinceInfo.cbxConnector8.SelectedIndex = NO_SELECTION
    'frmProvinceInfo.txtConnector7.Text = NO_SELECTION
    'frmProvinceInfo.txtConnector8.Text = NO_SELECTION
    'frmProvinceInfo.cbxConnector9.SelectedIndex = NO_SELECTION
    'frmProvinceInfo.txtNeighbor7.Text = ""
    'frmProvinceInfo.txtNeighbor8.Text = ""
    'frmProvinceInfo.txtNeighbor9.Text = ""
    'frmProvinceInfo.cbxConnector1.SelectedIndex = Province(ProvinceID).Connectors(0)
    'frmProvinceInfo.cbxConnector2.SelectedIndex = Province(ProvinceID).Connectors(1)
    'frmProvinceInfo.cbxConnector3.SelectedIndex = Province(ProvinceID).Connectors(2)
    'frmProvinceInfo.cbxConnector4.SelectedIndex = Province(ProvinceID).Connectors(3)
    'frmProvinceInfo.cbxConnector5.SelectedIndex = Province(ProvinceID).Connectors(4)
    'frmProvinceInfo.cbxConnector6.SelectedIndex = Province(ProvinceID).Connectors(5)
    'frmProvinceInfo.cbxConnector2.SelectedIndex = Province(ProvinceID).Connectors(1)
    'frmProvinceInfo.cbxConnector3.SelectedIndex = Province(ProvinceID).Connectors(2)
    'frmProvinceInfo.cbxConnector4.SelectedIndex = Province(ProvinceID).Connectors(3)
    'frmProvinceInfo.cbxConnector5.SelectedIndex = Province(ProvinceID).Connectors(4)
    'frmProvinceInfo.cbxConnector6.SelectedIndex = Province(ProvinceID).Connectors(5)
    'ReDim Province(ProvinceID).ConnectorNames(5) 'TEMPORARY!
    'frmProvinceInfo.txtConnector1.Text = Province(ProvinceID).ConnectorNames(0)
    'frmProvinceInfo.txtConnector2.Text = Province(ProvinceID).ConnectorNames(1)
    'frmProvinceInfo.txtConnector3.Text = Province(ProvinceID).ConnectorNames(2)
    'frmProvinceInfo.txtConnector4.Text = Province(ProvinceID).ConnectorNames(3)
    'frmProvinceInfo.txtConnector5.Text = Province(ProvinceID).ConnectorNames(4)
    'frmProvinceInfo.txtConnector6.Text = Province(ProvinceID).ConnectorNames(5)
    'frmProvinceInfo.txtConnector9.Text = NO_SELECTION
    'frmProvinceInfo.cbxNeighbor1.SelectedIndex = Province(ProvinceID).Neighbors(0)
    'frmProvinceInfo.cbxNeighbor2.SelectedIndex = Province(ProvinceID).Neighbors(1)
    'frmProvinceInfo.cbxNeighbor3.SelectedIndex = Province(ProvinceID).Neighbors(2)
    'frmProvinceInfo.cbxNeighbor4.SelectedIndex = Province(ProvinceID).Neighbors(3)
    'frmProvinceInfo.cbxNeighbor5.SelectedIndex = Province(ProvinceID).Neighbors(4)
    'frmProvinceInfo.cbxNeighbor6.SelectedIndex = Province(ProvinceID).Neighbors(5)
    'frmProvinceInfo.cbxNeighbor7.SelectedIndex = NO_SELECTION
    'frmProvinceInfo.cbxNeighbor8.SelectedIndex = NO_SELECTION
    'frmProvinceInfo.cbxNeighbor9.SelectedIndex = NO_SELECTION

    'frmProvinceInfo.ShowDialog()

    'End Sub

    Sub PopulateSeaDisplay(SeaZone As Integer)

        frmSeaInformation.txtSeaName.Text = Sea(SeaZone).Name
        frmSeaInformation.txtAssociatedTextbox.Text = Sea(SeaZone).MapElement
        frmSeaInformation.txtSeaID.Text = CStr(Sea(SeaZone).ID)
        frmSeaInformation.txtAreaID.Text = CStr(Sea(SeaZone).AreaNumber)
        frmSeaInformation.txtAreaType.Text = "Sea"
        frmSeaInformation.txtTopgraphy.Text = CStr(Sea(SeaZone).Topography)
        frmSeaInformation.txtClimate.Text = CStr(Sea(SeaZone).Climate)
        frmSeaInformation.txtControl.Text = CStr(Sea(SeaZone).Controller)

        ' this use of Neighbor boxes should be temporary
        frmSeaInformation.txtNeighbor1.Text = CStr(Sea(SeaZone).Neighbors(0))
        frmSeaInformation.txtNeighbor2.Text = CStr(Sea(SeaZone).Neighbors(1))
        frmSeaInformation.txtNeighbor3.Text = CStr(Sea(SeaZone).Neighbors(2))
        frmSeaInformation.txtNeighbor4.Text = CStr(Sea(SeaZone).Neighbors(3))
        frmSeaInformation.txtNeighbor5.Text = CStr(Sea(SeaZone).Neighbors(4))
        frmSeaInformation.txtNeighbor6.Text = CStr(Sea(SeaZone).Neighbors(5))
        frmSeaInformation.txtNeighbor7.Text = CStr(Sea(SeaZone).Neighbors(6))
        frmSeaInformation.txtNeighbor8.Text = CStr(Sea(SeaZone).Neighbors(7))
        frmSeaInformation.txtNeighbor9.Text = CStr(Sea(SeaZone).Neighbors(8))
        frmSeaInformation.txtNeighbor10.Text = CStr(Sea(SeaZone).Neighbors(9))
        frmSeaInformation.txtNeighbor11.Text = CStr(Sea(SeaZone).Neighbors(10))
        frmSeaInformation.txtNeighbor12.Text = CStr(Sea(SeaZone).Neighbors(11))
        frmSeaInformation.txtNeighbor13.Text = CStr(Sea(SeaZone).Neighbors(12))
        frmSeaInformation.txtNeighbor14.Text = CStr(Sea(SeaZone).Neighbors(13))
        frmSeaInformation.txtNeighbor15.Text = CStr(Sea(SeaZone).Neighbors(14))
        frmSeaInformation.txtNeighbor16.Text = CStr(Sea(SeaZone).Neighbors(15))
        frmSeaInformation.txtNeighbor17.Text = CStr(Sea(SeaZone).Neighbors(16))
        'frmSeaInformation.txtNeighbor18.Text = CStr(Sea(SeaZone).Neighbors(17))
        'frmProvinceInfo.txtNeighborName1.Text = Area(Province(ProvinceID).Neighbors(0)).Name
        frmSeaInformation.txtNeighborName1.Text = Area(Sea(SeaZone).Neighbors(0)).Name
        If Sea(SeaZone).Neighbors(1) >= 0 Then
            frmSeaInformation.txtNeighborName2.Text = Area(Sea(SeaZone).Neighbors(1)).Name
        Else
            frmSeaInformation.txtNeighborName2.Text = ""
        End If
        If Sea(SeaZone).Neighbors(2) >= 0 Then
            frmSeaInformation.txtNeighborName3.Text = Area(Sea(SeaZone).Neighbors(2)).Name
        Else
            frmSeaInformation.txtNeighborName3.Text = ""
        End If
        If Sea(SeaZone).Neighbors(3) >= 0 Then
            frmSeaInformation.txtNeighborName4.Text = Area(Sea(SeaZone).Neighbors(3)).Name
        Else
            frmSeaInformation.txtNeighborName4.Text = ""
        End If
        If Sea(SeaZone).Neighbors(4) >= 0 Then
            frmSeaInformation.txtNeighborName5.Text = Area(Sea(SeaZone).Neighbors(4)).Name
        Else
            frmSeaInformation.txtNeighborName5.Text = ""
        End If
        If Sea(SeaZone).Neighbors(5) >= 0 Then
            frmSeaInformation.txtNeighborName6.Text = Area(Sea(SeaZone).Neighbors(5)).Name
        Else
            frmSeaInformation.txtNeighborName6.Text = ""
        End If
        If Sea(SeaZone).Neighbors(6) >= 0 Then
            frmSeaInformation.txtNeighborName7.Text = Area(Sea(SeaZone).Neighbors(6)).Name
        Else
            frmSeaInformation.txtNeighborName7.Text = ""
        End If
        If Sea(SeaZone).Neighbors(7) >= 0 Then
            frmSeaInformation.txtNeighborName8.Text = Area(Sea(SeaZone).Neighbors(7)).Name
        Else
            frmSeaInformation.txtNeighborName8.Text = ""
        End If
        If Sea(SeaZone).Neighbors(8) >= 0 Then
            frmSeaInformation.txtNeighborName9.Text = Area(Sea(SeaZone).Neighbors(8)).Name
        Else
            frmSeaInformation.txtNeighborName9.Text = ""
        End If
        If Sea(SeaZone).Neighbors(9) >= 0 Then
            frmSeaInformation.txtNeighborName10.Text = Area(Sea(SeaZone).Neighbors(9)).Name
        Else
            frmSeaInformation.txtNeighborName10.Text = ""
        End If
        If Sea(SeaZone).Neighbors(10) >= 0 Then
            frmSeaInformation.txtNeighborName11.Text = Area(Sea(SeaZone).Neighbors(10)).Name
        Else
            frmSeaInformation.txtNeighborName11.Text = ""
        End If
        If Sea(SeaZone).Neighbors(11) >= 0 Then
            frmSeaInformation.txtNeighborName12.Text = Area(Sea(SeaZone).Neighbors(11)).Name
        Else
            frmSeaInformation.txtNeighborName12.Text = ""
        End If
        If Sea(SeaZone).Neighbors(12) >= 0 Then
            frmSeaInformation.txtNeighborName13.Text = Area(Sea(SeaZone).Neighbors(12)).Name
        Else
            frmSeaInformation.txtNeighborName13.Text = ""
        End If
        If Sea(SeaZone).Neighbors(13) >= 0 Then
            frmSeaInformation.txtNeighborName14.Text = Area(Sea(SeaZone).Neighbors(13)).Name
        Else
            frmSeaInformation.txtNeighborName14.Text = ""
        End If
        If Sea(SeaZone).Neighbors(14) >= 0 Then
            frmSeaInformation.txtNeighborName15.Text = Area(Sea(SeaZone).Neighbors(14)).Name
        Else
            frmSeaInformation.txtNeighborName15.Text = ""
        End If
        If Sea(SeaZone).Neighbors(15) >= 0 Then
            frmSeaInformation.txtNeighborName16.Text = Area(Sea(SeaZone).Neighbors(15)).Name
        Else
            frmSeaInformation.txtNeighborName16.Text = ""
        End If
        If Sea(SeaZone).Neighbors(16) >= 0 Then
            frmSeaInformation.txtNeighborName17.Text = Area(Sea(SeaZone).Neighbors(16)).Name
        Else
            frmSeaInformation.txtNeighborName17.Text = ""
        End If
        frmSeaInformation.txtConnectorName1.Text = CStr(Sea(SeaZone).ConnectorNames(0))
        frmSeaInformation.txtConnectorName2.Text = CStr(Sea(SeaZone).ConnectorNames(1))
        frmSeaInformation.txtConnectorName3.Text = CStr(Sea(SeaZone).ConnectorNames(2))
        frmSeaInformation.txtConnectorName4.Text = CStr(Sea(SeaZone).ConnectorNames(3))
        frmSeaInformation.txtConnectorName5.Text = CStr(Sea(SeaZone).ConnectorNames(4))
        frmSeaInformation.txtConnectorName6.Text = CStr(Sea(SeaZone).ConnectorNames(5))
        frmSeaInformation.txtConnectorName7.Text = CStr(Sea(SeaZone).ConnectorNames(6))
        frmSeaInformation.txtConnectorName8.Text = CStr(Sea(SeaZone).ConnectorNames(7))
        frmSeaInformation.txtConnectorName9.Text = CStr(Sea(SeaZone).ConnectorNames(8))
        frmSeaInformation.txtConnectorName10.Text = CStr(Sea(SeaZone).ConnectorNames(9))
        frmSeaInformation.txtConnectorName11.Text = CStr(Sea(SeaZone).ConnectorNames(10))
        frmSeaInformation.txtConnectorName12.Text = CStr(Sea(SeaZone).ConnectorNames(11))
        frmSeaInformation.txtConnectorName13.Text = CStr(Sea(SeaZone).ConnectorNames(12))
        frmSeaInformation.txtConnectorName14.Text = CStr(Sea(SeaZone).ConnectorNames(13))
        frmSeaInformation.txtConnectorName15.Text = CStr(Sea(SeaZone).ConnectorNames(14))
        frmSeaInformation.txtConnectorName16.Text = CStr(Sea(SeaZone).ConnectorNames(15))
        frmSeaInformation.txtConnectorName17.Text = CStr(Sea(SeaZone).ConnectorNames(16))
        'frmSeaInformation.txtConnectorName18.Text = CStr(Sea(SeaZone).ConnectorNames(17))
        ''frmSeaInformation.txtNeighbor7.Text = ""
        ''frmSeaInformation.txtNeighbor8.Text = ""
        ''frmSeaInformation.txtNeighbor9.Text = ""
        frmSeaInformation.cbxConnector1.SelectedIndex = Sea(SeaZone).Connectors(0)
        frmSeaInformation.cbxConnector2.SelectedIndex = Sea(SeaZone).Connectors(1)
        frmSeaInformation.cbxConnector3.SelectedIndex = Sea(SeaZone).Connectors(2)
        frmSeaInformation.cbxConnector4.SelectedIndex = Sea(SeaZone).Connectors(3)
        frmSeaInformation.cbxConnector5.SelectedIndex = Sea(SeaZone).Connectors(4)
        frmSeaInformation.cbxConnector6.SelectedIndex = Sea(SeaZone).Connectors(5)
        frmSeaInformation.cbxConnector7.SelectedIndex = Sea(SeaZone).Connectors(6)
        frmSeaInformation.cbxConnector8.SelectedIndex = Sea(SeaZone).Connectors(7)
        frmSeaInformation.cbxConnector9.SelectedIndex = Sea(SeaZone).Connectors(8)

        frmSeaInformation.txtConnector1.Text = CStr(Sea(SeaZone).Connectors(0))
        frmSeaInformation.txtConnector2.Text = CStr(Sea(SeaZone).Connectors(1))
        frmSeaInformation.txtConnector3.Text = CStr(Sea(SeaZone).Connectors(2))
        frmSeaInformation.txtConnector4.Text = CStr(Sea(SeaZone).Connectors(3))
        frmSeaInformation.txtConnector5.Text = CStr(Sea(SeaZone).Connectors(4))
        frmSeaInformation.txtConnector6.Text = CStr(Sea(SeaZone).Connectors(5))
        frmSeaInformation.txtConnector7.Text = CStr(Sea(SeaZone).Connectors(6))
        frmSeaInformation.txtConnector8.Text = CStr(Sea(SeaZone).Connectors(7))
        frmSeaInformation.txtConnector9.Text = CStr(Sea(SeaZone).Connectors(8))
        frmSeaInformation.txtConnector10.Text = CStr(Sea(SeaZone).Connectors(9))
        frmSeaInformation.txtConnector11.Text = CStr(Sea(SeaZone).Connectors(10))
        frmSeaInformation.txtConnector12.Text = CStr(Sea(SeaZone).Connectors(11))
        frmSeaInformation.txtConnector13.Text = CStr(Sea(SeaZone).Connectors(12))
        frmSeaInformation.txtConnector14.Text = CStr(Sea(SeaZone).Connectors(13))
        frmSeaInformation.txtConnector15.Text = CStr(Sea(SeaZone).Connectors(14))
        frmSeaInformation.txtConnector16.Text = CStr(Sea(SeaZone).Connectors(15))
        frmSeaInformation.txtConnector17.Text = CStr(Sea(SeaZone).Connectors(16))
    End Sub

    'frmSeaInformation.txtFarmland.Text = CStr(Province(ProvinceID).Farmland)
    'frmSeaInformation.txtPeasants.Text = CStr(Province(ProvinceID).Peasants)
    'frmSeaInformation.txtAgriculturalLevel.Text = CStr(Province(ProvinceID).AgricultureLevel)
    'frmSeaInformation.txtSurplusPopulation.Text = CStr(Province(ProvinceID).SurplusPopulation)
    'frmSeaInformation.txtHarvestActual.Text = CStr(Province(ProvinceID).HarvestActual)
    'frmSeaInformation.txtConnector18.Text = CStr(Sea(SeaZone).Connectors(17))
    'frmSeaInformation.cbxNeighbor1.SelectedIndex = Sea(SeaZone).Neighbors(0)
    'frmSeaInformation.cbxNeighbor2.SelectedIndex = Sea(SeaZone).Neighbors(1)
    'frmSeaInformation.cbxNeighbor3.SelectedIndex = Sea(SeaZone).Neighbors(2)
    'frmSeaInformation.cbxNeighbor4.SelectedIndex = Sea(SeaZone).Neighbors(3)
    'frmSeaInformation.cbxNeighbor5.SelectedIndex = Sea(SeaZone).Neighbors(4)
    'frmSeaInformation.cbxNeighbor6.SelectedIndex = Sea(SeaZone).Neighbors(5)
    'frmSeaInformation.cbxNeighbor10.SelectedIndex = Sea(SeaZone).Connectors(9)
    'frmSeaInformation.cbxNeighbor11.SelectedIndex = Sea(SeaZone).Connectors(10)
    'frmSeaInformation.cbxNeighbor12.SelectedIndex = Sea(SeaZone).Connectors(11)


    'frmSeaInformation.ShowDialog()

    Sub PopulateGovernmentDisplay(GovernmentID As Integer)

        If Playing = MsgBoxResult.Yes Then
 
            frmGovernmentInfo.txtName.Text = Government(GovernmentID).Name
            frmGovernmentInfo.txtID.Text = CStr(Government(GovernmentID).ID)
            frmGovernmentInfo.txtLeadershipState.Text = DescribeGovernmentState(Government(GovernmentID).LeadershipState)
            frmGovernmentInfo.txtGeneralship.Text = GetAbilityNames(Government(GovernmentID).Generalship)
            frmGovernmentInfo.txtTreasury.Text = CStr(Government(GovernmentID).Treasury)
            frmGovernmentInfo.txtTotalBenefices.Text = CStr(Government(GovernmentID).TotalBenefices)
            frmGovernmentInfo.txtRoyalEstates.Text = CStr(Government(GovernmentID).RoyalEstates)
            frmGovernmentInfo.txtCavalry.Text = CStr(Government(GovernmentID).Cavalary)
            frmGovernmentInfo.txtInfantry.Text = CStr(Government(GovernmentID).Infantry)
            frmGovernmentInfo.txtArmyState.Text = DescribeArmyState(Government(GovernmentID).ArmyState)
            frmGovernmentInfo.txtSupport.Text = NameLoyaltyLevel(Government(GovernmentID).Support)
            frmGovernmentInfo.txtReligion.Text = NameReligion(Government(GovernmentID).Religion)
            frmGovernmentInfo.txtPoliticalSavvy.Text = GetAbilityNames(Government(GovernmentID).PoliticalSavvy)
            frmGovernmentInfo.txtLanguage.Text = NameLanguage(Government(GovernmentID).Language)
            frmGovernmentInfo.txtLawCode.Text = NameLawCode(Government(GovernmentID).LawCode)
            frmGovernmentInfo.txtNavalCapability.Text = NameNavalCapability(Government(GovernmentID).NavalCapability)
            frmGovernmentInfo.txtReputation.Text = NameReputation(Government(GovernmentID).Reputation)
            frmGovernmentInfo.txtKingdom1.Text = DescribeDiploRelations(GovernmentID, 1)
            frmGovernmentInfo.txtKingdom2.Text = DescribeDiploRelations(GovernmentID, 2)
            frmGovernmentInfo.txtKingdom3.Text = DescribeDiploRelations(GovernmentID, 3)
            frmGovernmentInfo.txtKingdom4.Text = DescribeDiploRelations(GovernmentID, 4)
            frmGovernmentInfo.txtKingdom5.Text = DescribeDiploRelations(GovernmentID, 5)
            frmGovernmentInfo.txtKingdom6.Text = DescribeDiploRelations(GovernmentID, 6)
            frmGovernmentInfo.txtKingdom7.Text = DescribeDiploRelations(GovernmentID, 7)
            frmGovernmentInfo.txtKingdom8.Text = DescribeDiploRelations(GovernmentID, 8)
            frmGovernmentInfo.txtKingdom9.Text = DescribeDiploRelations(GovernmentID, 9)
            frmGovernmentInfo.txtKingdom10.Text = DescribeDiploRelations(GovernmentID, 10)
        Else

            frmGovernmentInfo.txtName.Text = Government(GovernmentID).Name
            frmGovernmentInfo.txtID.Text = CStr(Government(GovernmentID).ID)
            frmGovernmentInfo.txtLeadershipState.Text = CStr(Government(GovernmentID).LeadershipState)
            frmGovernmentInfo.txtGeneralship.Text = CStr(Government(GovernmentID).Generalship)
            frmGovernmentInfo.txtTreasury.Text = CStr(Government(GovernmentID).Treasury)
            frmGovernmentInfo.txtTotalBenefices.Text = CStr(Government(GovernmentID).TotalBenefices)
            frmGovernmentInfo.txtRoyalEstates.Text = CStr(Government(GovernmentID).RoyalEstates)
            frmGovernmentInfo.txtCavalry.Text = CStr(Government(GovernmentID).Cavalary)
            frmGovernmentInfo.txtInfantry.Text = CStr(Government(GovernmentID).Infantry)
            frmGovernmentInfo.txtArmyState.Text = CStr(Government(GovernmentID).ArmyState)
            frmGovernmentInfo.txtSupport.Text = CStr(Government(GovernmentID).Support)
            frmGovernmentInfo.txtReligion.Text = CStr(Government(GovernmentID).Religion)
            frmGovernmentInfo.txtPoliticalSavvy.Text = CStr(Government(GovernmentID).PoliticalSavvy)
            frmGovernmentInfo.txtLanguage.Text = CStr(Government(GovernmentID).Language)
            frmGovernmentInfo.txtKingdom1.Text = CStr(Government(GovernmentID).DiplomaticRelations(1))
            frmGovernmentInfo.txtKingdom2.Text = CStr(Government(GovernmentID).DiplomaticRelations(2))
            frmGovernmentInfo.txtKingdom3.Text = CStr(Government(GovernmentID).DiplomaticRelations(3))
            frmGovernmentInfo.txtKingdom4.Text = CStr(Government(GovernmentID).DiplomaticRelations(4))
            frmGovernmentInfo.txtKingdom5.Text = CStr(Government(GovernmentID).DiplomaticRelations(5))
            frmGovernmentInfo.txtKingdom6.Text = CStr(Government(GovernmentID).DiplomaticRelations(6))
            frmGovernmentInfo.txtKingdom7.Text = CStr(Government(GovernmentID).DiplomaticRelations(7))
            frmGovernmentInfo.txtKingdom8.Text = CStr(Government(GovernmentID).DiplomaticRelations(8))
            frmGovernmentInfo.txtKingdom9.Text = CStr(Government(GovernmentID).DiplomaticRelations(9))
            frmGovernmentInfo.txtKingdom10.Text = CStr(Government(GovernmentID).DiplomaticRelations(10))
        End If
    End Sub

    Function DescribeGovernmentState(ByVal GovernmentState As Integer) As String
        Dim GovernmentStateStr As String = ""

        Select Case GovernmentState

            Case VIGOROUS

                GovernmentStateStr = VIGOROUS_STR

            Case LACKLUSTER

                GovernmentStateStr = LACKLUSTER_STR

            Case DISARRAY

                GovernmentStateStr = DISARRAY_STR

            Case UNDEFINED

                GovernmentStateStr = UNDEFINED_STR

            Case Else

                GovernmentStateStr = "Problem"

        End Select

        Return GovernmentStateStr

    End Function

    Function DescribeArmyState(ByVal ArmyState As Integer) As String
        Dim ArmyStateStr As String = ""

        Select Case ArmyState

            Case FANATICAL

                ArmyStateStr = FANATICAL_STR

            Case PROFICIENT

                ArmyStateStr = PROFICIENT_STR

            Case STOLID

                ArmyStateStr = STOLID_STR

            Case UNRELIABLE

                ArmyStateStr = UNRELIABLE_STR

            Case INEFFECTUAL

                ArmyStateStr = INEFFECTUAL_STR

            Case UNDEFINED

                ArmyStateStr = UNDEFINED_STR

            Case Else

                If ArmyState > FANATICAL Then ' because can go beyond limits within an action
                    ArmyStateStr = FANATICAL_STR
                Else
                    ArmyStateStr = INEFFECTUAL_STR
                End If
                'ArmyStateStr = "Problem"

        End Select

        Return ArmyStateStr

    End Function

    Function DescribeSocialState(ByVal SocialState As Integer) As String
        Dim SocialStateStr As String = ""

        Select Case SocialState

            Case CHAOS

                SocialStateStr = CHAOS_STR

            Case DISORDER

                SocialStateStr = DISORDER_STR

            Case ORDERLY

                SocialStateStr = ORDERLY_STR

            Case PROSPEROUS

                SocialStateStr = PROSPEROUS_STR

            Case BOOMING

                SocialStateStr = BOOMING_STR

            Case Else

                If SocialState < CHAOS Then   ' may go beyond limits within an action
                    SocialStateStr = CHAOS_STR
                Else
                    SocialStateStr = BOOMING_STR
                End If

                'SocialStateStr = "Problem"

        End Select

        Return SocialStateStr

    End Function

    Function DescribeDiploRelations(ByVal Country1 As Integer, ByVal Country2 As Integer) As String
        Dim RelateStr As String = ""
        Dim Relates As Integer = -100

        Relates = Government(Country1).DiplomaticRelations(Country2)

        Select Case Relates

            'Case ALLIED

            '    RelateStr = ALLIED_STR

            Case FRIENDLY

                RelateStr = FRIENDLY_STR

            Case NEUTRAL

                RelateStr = NEUTRAL_STR

            Case HOSTILE

                RelateStr = HOSTILE_STR

                'Case ENEMY

                '    RelateStr = ENEMY_STR

            Case NO_POWER

                RelateStr = NO_POWER_STR

            Case SELF

                RelateStr = SELF_STR

            Case UNDEFINED

                RelateStr = UNDEFINED_STR


            Case Else

                MsgBox("Difficulty Describing Relations between " & CStr(Country1) & " and " & CStr(Country2) & ", which are " & CStr(Relates))

        End Select


        Return RelateStr

    End Function

    Function GetSocialStateColor(ByVal SocialState As Integer) As System.Drawing.Color
        Dim SocialStateColor As System.Drawing.Color

        Select Case SocialState
            Case CHAOS
                SocialStateColor = CHAOS_COLOR
            Case DISORDER
                SocialStateColor = DISORDER_COLOR
            Case ORDERLY
                SocialStateColor = ORDERLY_COLOR
            Case PROSPEROUS
                SocialStateColor = PROSPEROUS_COLOR
            Case BOOMING
                SocialStateColor = BOOMING_COLOR
            Case Else

                If SocialState < CHAOS Then   ' may go beyond limits within an action
                    SocialStateColor = CHAOS_COLOR
                Else
                    SocialStateColor = BOOMING_COLOR
                End If
                'SocialStateStr = "Problem"
        End Select

        Return SocialStateColor

    End Function

    Function NameClimateZone(ByVal ZoneNumber As Integer) As String
        Dim ZoneStr As String = "Problem with Climate"

        Select Case ZoneNumber
            Case 0
                ZoneStr = CLIMATE_ZONE_0_STR
            Case 1
                ZoneStr = CLIMATE_ZONE_1_STR
            Case 2
                ZoneStr = CLIMATE_ZONE_2_STR
            Case 3
                ZoneStr = CLIMATE_ZONE_3_STR
            Case 4
                ZoneStr = CLIMATE_ZONE_4_STR
            Case 5
                ZoneStr = CLIMATE_ZONE_5_STR
            Case 6
                ZoneStr = CLIMATE_ZONE_6_STR
            Case 7
                ZoneStr = CLIMATE_ZONE_7_STR
            Case 8
                ZoneStr = CLIMATE_ZONE_8_STR
            Case 9
                ZoneStr = CLIMATE_ZONE_9_STR
            Case 10
                ZoneStr = CLIMATE_ZONE_10_STR
        End Select

        Return ZoneStr

    End Function

    Function NameWeather(ByVal Type As Integer) As String
        Dim TypeStr As String = "Problem with Weather"

        Select Case Type
            Case TERRIBLE_WEATHER
                TypeStr = TERRIBLE_WEATHER_STR
            Case BAD_WEATHER
                TypeStr = BAD_WEATHER_STR
            Case NORMAL_WEATHER
                TypeStr = NORMAL_WEATHER_STR
            Case GOOD_WEATHER
                TypeStr = GOOD_WEATHER_STR
            Case GREAT_WEATHER
                TypeStr = GREAT_WEATHER_STR
        End Select

        Return TypeStr

    End Function

    Function NameReligion(ByVal Sect As Integer) As String
        Dim SectStr As String = "Problem with Religion"

        Select Case Sect
            Case PAGAN
                SectStr = PAGAN_STR
            Case CATHOLIC
                SectStr = CATHOLIC_STR
            Case ARIAN
                SectStr = ARIAN_STR
            Case ORTHADOX
                SectStr = ORTHADOX_STR
            Case MUSLIM
                SectStr = MUSLIM_STR
            Case WALDENSIAN
                SectStr = WALDENSIAN_STR
            Case ALBEGENSIAN
                SectStr = ALBEGENSIAN_STR
            Case MUSLIM
                SectStr = MUSLIM_STR
            Case UNDEFINED
                SectStr = UNDEFINED_STR

        End Select

        Return SectStr

    End Function

    Function NameLanguage(ByVal Language As Integer) As String
        Dim LanguageStr As String = "Problem with Language"

        Select Case Language
            Case LOCAL_LANGUAGE
                LanguageStr = LOCAL_LANGUAGE_STR
                'Case ROMANCE
                '    LanguageStr = ROMANCE_STR
            Case FRENCH
                LanguageStr = FRENCH_STR
            Case LANGUEDOC
                LanguageStr = LANGUEDOC_STR
            Case LANGUEDOIL
                LanguageStr = LANGUEDOIL_STR
            Case LOCAL_IBERIAN
                LanguageStr = LOCAL_IBERIAN_STR
            Case LOCAL_ITALIAN
                LanguageStr = LOCAL_ITALIAN_STR
                'Case GERMANIC
                '    LanguageStr = GERMANIC_STR
            Case LOCAL_GERMANIC
                LanguageStr = LOCAL_GERMANIC_STR
            Case ENGLISH
                LanguageStr = ENGLISH_STR
            Case GREEK
                LanguageStr = GREEK_STR
            Case LOCAL_CELTIC
                LanguageStr = LOCAL_CELTIC_STR
            Case BRETON
                LanguageStr = BRETON_STR
            Case LOCAL_SLAVIC
                LanguageStr = LOCAL_SLAVIC_STR
            Case LOCAL_ARABIC
                LanguageStr = LOCAL_ARABIC_STR
            Case TURKIC
                LanguageStr = TURKIC_STR
            Case UNDEFINED
                LanguageStr = UNDEFINED_STR
        End Select

        Return LanguageStr

    End Function

    Function NameLoyaltyLevel(ByVal Loyalty As Integer) As String
        Dim LoyaltyStr As String = "Problem with Loyalty"

        Select Case Loyalty
            Case ENTHUSIASTIC
                LoyaltyStr = ENTHUSIASTIC_STR
            Case SUPPORTIVE
                LoyaltyStr = SUPPORTIVE_STR
            Case INDIFFERENT
                LoyaltyStr = INDIFFERENT_STR
            Case DISENCHANTED
                LoyaltyStr = DISENCHANTED_STR
            Case REBELLIOUS
                LoyaltyStr = REBELLIOUS_STR
            Case UNDEFINED
                LoyaltyStr = UNDEFINED_STR
        End Select

        Return LoyaltyStr

    End Function

    Sub SetTargetTextbox(Target)
        For Each frmMapScreen.ctrl In frmMapScreen.Controls
            If frmMapScreen.ctrl.Name = Area(Province(Target).AreaNumber).MapElement Then
                TargetBox = frmMapScreen.ctrl
                Exit For
            End If
        Next

    End Sub

    Sub RefreshConquestVP_Display()
        Dim Blanks As String = ""

        If ConquestVPs < 100 Then
            Blanks &= " " ' add 1 blank
            If ConquestVPs < 10 Then
                Blanks &= " " ' add 1 more
            End If
        End If
        frmMapScreen.lblConquestVPs.Text = CONQUEST_VP_LBL_BASE & vbTab & Blanks & CStr(ConquestVPs)
        frmMapScreen.lblConquestVPs.Refresh()
    End Sub

    Sub RefreshSocialStateVP_Display()
        Dim Blanks As String = ""

        If SocialVPs < 100 Then
            Blanks &= " " ' add 1 blank
            If SocialVPs < 10 Then
                Blanks &= " " ' add 1 more
            End If
        End If
        frmMapScreen.lblSocialVPs.Text = SOCIAL_STATE_VP_LBL_BASE & vbTab & Blanks & CStr(SocialVPs)
        frmMapScreen.lblSocialVPs.Refresh()
    End Sub

    Sub RefreshCulturalVP_Display()
        Dim Blanks As String = ""

        If CulturalVPs < 100 Then
            Blanks &= " " ' add 1 blank
            If CulturalVPs < 10 Then
                Blanks &= " " ' add 1 more
            End If
        End If
        frmMapScreen.lblCulturalVPs.Text = CULTURE_VP_LBL_BASE & vbTab & Blanks & CStr(CulturalVPs)
        frmMapScreen.lblCulturalVPs.Refresh()
    End Sub

    Sub RefreshTotalVP_Display()
        Dim Blanks As String = ""

        If TotalVPs < 100 Then
            Blanks &= " " ' add 1 blank
            If TotalVPs < 10 Then
                Blanks &= " " ' add 1 more
            End If
        End If
        frmMapScreen.lblTotalVPs.Text = TOTAL_VP_LBL_BASE & vbTab & Blanks & CStr(TotalVPs)
        frmMapScreen.lblTotalVPs.Refresh()
    End Sub

    Function NameLawCode(ByVal CodeType As Integer) As String
        Dim CodeNameStr As String = ""

        Select Case CodeType
            Case NO_LAW_CODE
                CodeNameStr = NO_CODE_STR
            Case TRIBAL_CODE
                CodeNameStr = TRIBAL_CODE_STR
            Case FEUDAL_CODE
                CodeNameStr = FEUDAL_CODE_STR
            Case IMPERIAL_CODE
                CodeNameStr = IMPERIAL_CODE_STR
            Case INDUSTRIAL_CODE
                CodeNameStr = INDUSTRIAL_CODE_STR
        End Select

        Return CodeNameStr

    End Function

    Function NameNavalCapability(ByVal NavCap As Integer) As String
        Dim CapabilityStr As String = ""

        Select Case NavCap
            Case NO_NAVY
                CapabilityStr = NO_NAVY_STR
            Case COASTAL_SAIL
                CapabilityStr = COASTAL_SAIL_STR
            Case OCEANGOING_SAIL
                CapabilityStr = OCEANGOING_SAIL_STR
            Case COASTAL_STEAM
                CapabilityStr = COASTAL_STEAM_STR
            Case OCEANGOING_STEAM
                CapabilityStr = OCEANGOING_STEAM_STR
        End Select
        Return CapabilityStr
    End Function

    Function NameReputation(ByVal Repute As Integer) As String
        Dim ReputeStr As String = ""

        Select Case Repute
            Case HONEST
                ReputeStr = HONEST_STR
            Case UNCERTAIN
                ReputeStr = UNCERTAIN_STR
            Case DISHONEST
                ReputeStr = DISHONEST_STR
            Case Else
                ReputeStr = "Reputation out of range: " & CStr(Repute)
        End Select

        Return ReputeStr

    End Function

    Sub EndGame()
        Dim MsgStr As String = ""
        Dim VictoryLevelStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim DateStr As String = ""
        Dim TimeStr As String = ""
        Dim DateTimeStr As String = ""

        MsgStr = "THE GAME IS OVER." & DOUBLE_SPACE
        If TotalVPs >= VictoryPointGoal Then
            MsgStr &= "Congratulations! " & DOUBLE_SPACE
        End If

        MsgStr &= "Provinces Conquered: " & vbTab & CStr(ConquestVPs) & vbTab & " (1 point each)" & vbCrLf
        MsgStr &= "Social States Improved: " & vbTab & CStr(SocialVPs) & vbTab & " (1 point each)" & vbCrLf
        MsgStr &= "Cultural Achievements: " & vbTab & CStr(CulturalVPs) & vbTab & " (10 points for Conversion)" & DOUBLE_SPACE

        MsgStr &= "Total Victory Points: " & vbTab & vbTab & CStr(TotalVPs) & vbTab & " (Goal = " & CStr(VictoryPointGoal) & ")" & DOUBLE_SPACE

        If TotalVPs >= 25 Then

            MsgStr &= "Victory Level: " & vbTab & DescribeVictoryLevel() & DOUBLE_SPACE
            MsgStr &= CStr(VictoryPointGoal) & " = " & MARGINAL_VICTORY_STR & vbCrLf
            MsgStr &= CStr(SUBSTANTIAL_VICTORY) & " = " & SUBSTANTIAL_VICTORY_STR & vbCrLf
            MsgStr &= CStr(DECISIVE_VICTORY) & " = " & DECISIVE_VICTORY_STR & DOUBLE_SPACE

        End If

        MsgBox(MsgStr)

        DateStr = DateString
        TimeStr = TimeString
        DateTimeStr = GetDateTimeIntStr(DateStr, TimeStr)
        SaveEnd(DateTimeStr)

        End

        'MsgStr &= "Do you Want to Play Again?"

        'Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Game Over")

        'If Decision = MsgBoxResult.Yes Then
        '    frmMapScreen.Close()
        '    frmMapScreen.Show()
        'Else
        '    End
        'End If

    End Sub

    Function DescribeVictoryLevel() As String
        Dim VictoryLevel As String = "None"

        If TotalVPs >= 45 Then
            VictoryLevel = DECISIVE_VICTORY_STR
        Else
            If TotalVPs >= 35 Then
                VictoryLevel = SUBSTANTIAL_VICTORY_STR
            Else
                If TotalVPs >= 30 Then
                    VictoryLevel = MARGINAL_VICTORY_STR
                Else
                    If TotalVPs >= 25 Then
                        VictoryLevel = NEAR_VICTORY_STR
                    End If
                End If
            End If
        End If

        Return VictoryLevel

    End Function

    Function GetReligionColor(ByVal Religion As Integer) As System.Drawing.Color
        Dim Color As System.Drawing.Color

        Select Case Religion
            Case PAGAN
                Color = PAGAN_COLOR
            Case CATHOLIC
                Color = CATHOLIC_COLOR
            Case ARIAN
                Color = ARIAN_COLOR
            Case ORTHADOX
                Color = ORTHADOX_COLOR
            Case MUSLIM
                Color = MUSLIM_COLOR
            Case WALDENSIAN
                Color = WALDENSIAN_COLOR
            Case ALBEGENSIAN
                Color = ALBEGENSIAN_COLOR
            Case PROTESTANT
                Color = PROTESTANT_COLOR
        End Select

        Return Color

    End Function

    Function GetLanguageColor(ByVal Language As Integer) As System.Drawing.Color
        Dim Color As System.Drawing.Color

        Select Case Language
            Case LOCAL_LANGUAGE
                Color = LOCAL_LANGUAGE_COLOR
                'Case ROMANCE
                '    Color = ROMANCE_LANGUAGE_COLOR
                'Case LOCAL_ROMANCE
                '    Color = ROMANCE_LANGUAGE_COLOR
            Case FRENCH
                Color = FRENCH_LANGUAGE_COLOR
            Case LANGUEDOC
                Color = LANGUEDOC_LANGUAGE_COLOR
            Case LANGUEDOIL
                Color = LANGUEDOIL_LANGUAGE_COLOR
            Case LOCAL_IBERIAN
                Color = LOCAL_IBERIAN_COLOR
            Case LOCAL_ITALIAN
                Color = LOCAL_ITALIAN_COLOR
            Case LOCAL_GERMANIC
                Color = LOCAL_GERMANIC_COLOR
                'Case GERMAN
                '    Color = GERMANIC_LANGUAGE_COLOR
            Case ENGLISH
                Color = ENGLISH_LANGUAGE_COLOR
            Case GREEK
                Color = GREEK_LANGUAGE_COLOR
            Case LOCAL_CELTIC
                Color = LOCAL_CELTIC_COLOR
            Case BRETON
                Color = BRETON_COLOR
            Case LOCAL_SLAVIC
                Color = LOCAL_SLAVIC_COLOR
            Case LOCAL_ARABIC
                Color = LOCAL_ARABIC_COLOR
            Case TURKIC
                Color = TURKIC_LANGUAGE_COLOR
        End Select

        Return Color

    End Function

    Function GetLoyaltyColor(ByVal Loyalty As Integer) As System.Drawing.Color
        Dim Color As System.Drawing.Color

        Select Case Loyalty
            Case ENTHUSIASTIC
                Color = ENTHUSIASTIC_COLOR
            Case SUPPORTIVE
                Color = SUPPORTIVE_COLOR
            Case INDIFFERENT
                Color = INDIFFERENT_COLOR
            Case DISENCHANTED
                Color = DISENCHANTED_COLOR
            Case REBELLIOUS
                Color = REBELLIOUS_COLOR

        End Select

        Return Color

    End Function

    Function GetTerrainColor(ByVal Terrain As Integer) As System.Drawing.Color
        Dim Color As System.Drawing.Color

        Select Case Terrain
            Case OCEAN
                Color = OCEAN_COLOR
            Case COASTAL
                Color = COASTAL_COLOR
            Case FLATLAND
                Color = FLATLAND_COLOR
            Case RUGGED
                Color = RUGGED_COLOR
            Case MOUNTAINS
                Color = MOUNTAIN_COLOR
        End Select

        Return Color

    End Function

    Function GetTerrainName(ByVal Terrain As Integer) As String
        Dim TerrainStr As String = ""

        Select Case Terrain
            Case OCEAN
                TerrainStr = OCEAN_STR
            Case COASTAL
                TerrainStr = COASTAL_STR
            Case FLATLAND
                TerrainStr = FLATLAND_STR
            Case RUGGED
                TerrainStr = RUGGED_STR
            Case MOUNTAINS
                TerrainStr = MOUNTAINS_STR
        End Select

        Return TerrainStr

    End Function

    Function GetGovernmentColor(GovernmentID As Integer) As System.Drawing.Color
        Dim GovernmentColor As System.Drawing.Color

        Select Case GovernmentID

            Case 0
                GovernmentColor = LOCAL_CONTROL_COLOR

            Case POWER_1
                GovernmentColor = POWER_1_COLOR

            Case POWER_2
                GovernmentColor = POWER_2_COLOR

            Case POWER_3
                GovernmentColor = POWER_3_COLOR

            Case POWER_4
                GovernmentColor = POWER_4_COLOR

            Case POWER_5
                GovernmentColor = POWER_5_COLOR

            Case POWER_6
                GovernmentColor = POWER_6_COLOR

            Case POWER_7
                GovernmentColor = POWER_7_COLOR

            Case POWER_8
                GovernmentColor = POWER_8_COLOR

            Case POWER_9
                GovernmentColor = POWER_9_COLOR

            Case POWER_10
                GovernmentColor = POWER_10_COLOR

            Case POWER_11
                GovernmentColor = POWER_11_COLOR

            Case POWER_12
                GovernmentColor = POWER_12_COLOR

            Case POWER_13
                GovernmentColor = POWER_13_COLOR

            Case POWER_14
                GovernmentColor = POWER_14_COLOR

            Case Else
                GovernmentColor = LOCAL_CONTROL_COLOR
        End Select

        Return GovernmentColor

    End Function

    Function GetAbilityNames(AbilityLevel As Integer) As String
        Dim AbilityName As String = ""

        Select Case AbilityLevel

            Case GENIUS
                Return GENIUS_STR

            Case TALENTED
                Return TALENTED_STR

            Case MEDIOCRE
                Return MEDIOCRE_STR

            Case INEPT
                Return INEPT_STR

            Case DISASTROUS
                Return DISASTROUS_STR

            Case UNDEFINED
                Return UNDEFINED_STR

            Case Else
                Return "Problem finding word"
        End Select

    End Function

    Function DescribeChanceOfSuccess(ByVal Probability As Integer) As String
        Dim ProbabilityStr As String = ""

        Select Case Probability
            Case 10
                ProbabilityStr = " an Overwhelming Chance "

            Case 7, 8, 9
                ProbabilityStr = " a Good Chance "

            Case 4, 5, 6
                ProbabilityStr = " a Moderate Chance "

            Case 1, 2, 3
                ProbabilityStr = " a Marginal Chance "

            Case 0
                ProbabilityStr = " No Chance "

            Case Else
                ProbabilityStr = " Bad Probability Estimate Lookup "

        End Select

        Return ProbabilityStr

    End Function



End Module
