﻿Imports System.IO
Public Class frmAtStartWorksheet

    Private Sub frmAtStartWorksheet_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Dim x, y As Integer
        Dim FilePath As String = ""
        Dim LeftBorderAnchor = 27
        Dim TopBorderAnchor = 163
        Dim VerticleBorderSpacing = 30
        Dim VerticleOrderNumber = 1

        WorksheetOpen = True


        FilePath = Directory.GetCurrentDirectory & DIDACTIC_DIRECTORY & "\BordersQuestion.rtf"

        rtbBordersQuestion.LoadFile(FilePath, RichTextBoxStreamType.RichText)

        cbxNorthwestBorder.Left = LeftBorderAnchor
        cbxNorthwestBorder.Top = TopBorderAnchor

        cbxWesternBorder.Left = LeftBorderAnchor
        cbxWesternBorder.Top = TopBorderAnchor + VerticleBorderSpacing * VerticleOrderNumber
        VerticleOrderNumber += 1

        cbxSouthwestBorder.Left = LeftBorderAnchor
        cbxSouthwestBorder.Top = TopBorderAnchor + VerticleBorderSpacing * VerticleOrderNumber
        VerticleOrderNumber += 1

        cbxSouthBorder.Left = LeftBorderAnchor
        cbxSouthBorder.Top = TopBorderAnchor + VerticleBorderSpacing * VerticleOrderNumber
        VerticleOrderNumber += 1

        cbxSoutheastBorder.Left = LeftBorderAnchor
        cbxSoutheastBorder.Top = TopBorderAnchor + VerticleBorderSpacing * VerticleOrderNumber
        VerticleOrderNumber += 1

        cbxNortheastBorder.Left = LeftBorderAnchor
        cbxNortheastBorder.Top = TopBorderAnchor + VerticleBorderSpacing * VerticleOrderNumber

    End Sub

    Private Sub btnSubmit_Click(sender As System.Object, e As System.EventArgs) Handles btnSubmit.Click
        Dim Msgstr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Decision = MsgBox("Are you sure you're done with this Question?", MsgBoxStyle.YesNo, "Submit Answers?")

        If Decision = MsgBoxResult.Yes Then

            If ActionPhase = BORDER_QUESTION Then

                ProcessBorderQuestion()
                HideBorderQuestionStuff()

                ActionPhase = TERRAIN_QUESTION
                frmMapScreen.lblCurrentPhase.Text = TERRAIN_QUESTION_STRING

                LoadTerrainComboBoxes()
                GetTerrainQuestion()
                ShowTerrainQuestionStuff()

            Else
                ProcessTerrainQuestion()
                WorksheetOpen = False
                Me.Close()
            End If

        End If


    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Decision = MsgBox("Are you sure you want to stop doing the Worksheet?", MsgBoxStyle.YesNo, "Stop Worksheet?")

        If Decision = MsgBoxResult.Yes Then
            WorksheetOpen = False
            Me.Close()
        End If


    End Sub

    Private Sub ProcessBorderQuestion()
        Dim Msgstr As String = ""

        With WorksheetScore
            With .BorderQuestion

                .BorderTotal = 0 'need to get rid of the -1
                If cbxNorthwestBorder.Checked = True Then
                    .NorthwestBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .NorthwestBorder
                    Msgstr = "First answer correct: "
                Else
                    .NorthwestBorder = WRONG_ANSWER_VALUE
                    Msgstr = "First answer incorrect: "
                End If

                Msgstr &= "France's Northwestern Border was on a pronounced natural feature, the English Channel." & DOUBLE_SPACE

                If cbxWesternBorder.Checked = True Then
                    .WestBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .WestBorder
                    Msgstr &= "Second answer correct: "
                Else
                    .WestBorder = WRONG_ANSWER_VALUE
                    Msgstr &= "Second answer incorrect: "
                End If
                Msgstr &= "France's Western Border was on a pronounced natural feature, the Bay of Biscay." & DOUBLE_SPACE

                'With WorksheetScore
                If cbxSouthwestBorder.Checked = True Then
                    .SouthwestBorder = WRONG_ANSWER_VALUE
                    Msgstr &= "Third answer incorrect: "
                Else
                    .SouthwestBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .SouthwestBorder
                    Msgstr &= "Third answer correct: "
                End If
                ''End With

                Msgstr &= "While the part of France's Southwestern border around Bearn was on High Mountains (the Pyranees), "
                Msgstr &= "in the south Catalonia was on the far side of the Mountains from the rest of the Kingdom, "
                Msgstr &= "and eventually it became part of Spain." & DOUBLE_SPACE

                If cbxSouthBorder.Checked = True Then
                    .SouthBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .SouthBorder
                    Msgstr &= "Fourth answer correct: "
                Else
                    .SouthBorder = WRONG_ANSWER_VALUE
                    Msgstr &= "Fourth answer incorrect: "
                End If
                Msgstr &= "France's Southern Border was on a pronounced natural feature, the Mediterranean Sea." & DOUBLE_SPACE

                If cbxSoutheastBorder.Checked = True Then
                    .SoutheastBorder = WRONG_ANSWER_VALUE
                    Msgstr &= "Fifth answer incorrect: "
                Else
                    .SoutheastBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .SoutheastBorder
                    Msgstr &= "Fifth answer correct: "
                End If
                Msgstr &= "While the central part of the Kingdom's Southeastern border lay in the rugged terrain around Avergne, "
                Msgstr &= "in the north and south more open terrain connected the Rhone valley occupied by the Kingdom of Burgundy with the rest of France.  "
                Msgstr &= "Eventually France absorbed it.  The more pronounced natural feature in this region is the Mountains to the east, "
                Msgstr &= "the Alps, which divide France from Italy today." & DOUBLE_SPACE

                If cbxNortheastBorder.Checked = True Then
                    .NortheastBorder = WRONG_ANSWER_VALUE
                    Msgstr &= "Sixth answer incorrect: "
                Else
                    .NortheastBorder = CORRECT_ANSWER_VALUE
                    .BorderTotal += .NortheastBorder
                    Msgstr &= "Sixth answer correct: "
                End If
                Msgstr &= "While the land does rise in the east out of the Paris basin and the Ardennes contains some rugged terrain, "
                Msgstr &= "France's northeastern border has always been its most open frontier.  Even today only part of it lies on the "
                Msgstr &= "mighty Rhine River (roughly from Switzerland to between Swabia and the Rhineland), and in the Middle Ages this "
                Msgstr &= "barrier lay far to the east." & DOUBLE_SPACE

                Msgstr &= "Your score on this question was: " & CStr(.BorderTotal) & " of " & POINTS_IN_BORDER_QUESTION & "."

            End With '.BorderQuestion

            MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Results")

            .WorksheetTotalScore = .BorderQuestion.BorderTotal ' assumes Border question is first!

        End With ' worksheet

        SaveWorksheet(BORDER_QUESTION)

    End Sub

    Sub LoadTerrainComboBoxes()

        cmbFieldForestFarmland.Items.Add(200)
        cmbFieldForestFarmland.Items.Add(100)
        cmbFieldForestFarmland.Items.Add(300)
        cmbFieldForestFarmland.Items.Add(500)
        cmbFieldForestFarmland.Items.Add(400)

        cmbFieldForestHarvest.Items.Add("300-400")
        cmbFieldForestHarvest.Items.Add("100-200")
        cmbFieldForestHarvest.Items.Add("500-600")
        cmbFieldForestHarvest.Items.Add("400-500")
        cmbFieldForestHarvest.Items.Add("200-300")

        cmbFieldForestPeasants.Items.Add("200-300")
        cmbFieldForestPeasants.Items.Add("300-400")
        cmbFieldForestPeasants.Items.Add("500-600")
        cmbFieldForestPeasants.Items.Add("100-200")
        cmbFieldForestPeasants.Items.Add("400-500")

        cmbDifficultFarmland.Items.Add(200)
        cmbDifficultFarmland.Items.Add(100)
        cmbDifficultFarmland.Items.Add(300)
        cmbDifficultFarmland.Items.Add(500)
        cmbDifficultFarmland.Items.Add(400)

        cmbDifficultHarvest.Items.Add("300-400")
        cmbDifficultHarvest.Items.Add("100-200")
        cmbDifficultHarvest.Items.Add("500-600")
        cmbDifficultHarvest.Items.Add("400-500")
        cmbDifficultHarvest.Items.Add("200-300")

        cmbDifficultPeasants.Items.Add("200-300")
        cmbDifficultPeasants.Items.Add("300-400")
        cmbDifficultPeasants.Items.Add("500-600")
        cmbDifficultPeasants.Items.Add("100-200")
        cmbDifficultPeasants.Items.Add("400-500")

        cmbMountainousFarmland.Items.Add(200)
        cmbMountainousFarmland.Items.Add(100)
        cmbMountainousFarmland.Items.Add(300)
        cmbMountainousFarmland.Items.Add(500)
        cmbMountainousFarmland.Items.Add(400)

        cmbMountainousHarvest.Items.Add("300-400")
        cmbMountainousHarvest.Items.Add("100-200")
        cmbMountainousHarvest.Items.Add("500-600")
        cmbMountainousHarvest.Items.Add("400-500")
        cmbMountainousHarvest.Items.Add("200-300")

        cmbMountainousPeasants.Items.Add("200-300")
        cmbMountainousPeasants.Items.Add("300-400")
        cmbMountainousPeasants.Items.Add("500-600")
        cmbMountainousPeasants.Items.Add("100-200")
        cmbMountainousPeasants.Items.Add("400-500")

    End Sub

    Sub GetTerrainQuestion()
        Dim FilePath As String = ""

        Try
            FilePath = Directory.GetCurrentDirectory & DIDACTIC_DIRECTORY & "\TerrainQuestion.rtf"
            rtbBordersQuestion.LoadFile(FilePath, RichTextBoxStreamType.RichText)
        Catch
            MsgBox("Problem Getting Terrain Question")
        End Try

    End Sub

    Sub ShowTerrainQuestionStuff()

        lblCaveat.Visible = True
        lblDifficultTerrain.Visible = True
        lblFieldAndForest.Visible = True
        lblMountainous.Visible = True
        lblFarmland.Visible = True
        lblHarvest.Visible = True
        lblPeasants.Visible = True
        cmbDifficultFarmland.Visible = True
        cmbDifficultHarvest.Visible = True
        cmbDifficultPeasants.Visible = True
        cmbFieldForestFarmland.Visible = True
        cmbFieldForestHarvest.Visible = True
        cmbFieldForestPeasants.Visible = True
        cmbMountainousFarmland.Visible = True
        cmbMountainousHarvest.Visible = True
        cmbMountainousPeasants.Visible = True

    End Sub

    Sub HideBorderQuestionStuff()

        rtbBordersQuestion.Text = ""
        cbxNorthwestBorder.Visible = False
        cbxWesternBorder.Visible = False
        cbxSouthwestBorder.Visible = False
        cbxSouthBorder.Visible = False
        cbxSoutheastBorder.Visible = False
        cbxNortheastBorder.Visible = False

    End Sub

    Private Sub ProcessTerrainQuestion()
        Dim Msgstr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Yes

        With WorksheetScore
            With .TerrainQuestion

                ' Field and Forest

                If cmbFieldForestFarmland.SelectedItem = FIELD_AND_FOREST_FARMLAND Then
                    .FieldAndForestFarmland = CORRECT_ANSWER_VALUE
                     Msgstr = "First answer correct: "
                Else
                    .FieldAndForestFarmland = WRONG_ANSWER_VALUE
                    Msgstr = "First answer incorrect: "
                End If
                .TerrainTotal = .FieldAndForestFarmland ' = not += so -1 of initialization eliminated

                Msgstr &= "The Amount of Potential Farmland in Field and Forest Provinces is " & CStr(FIELD_AND_FOREST_FARMLAND) & "." & DOUBLE_SPACE

                If cmbFieldForestHarvest.SelectedItem = FIELD_AND_FOREST_HARVEST Then
                    .FieldAndForestHarvest = CORRECT_ANSWER_VALUE
                    Msgstr &= "Second answer correct: "
                Else
                    .FieldAndForestHarvest = WRONG_ANSWER_VALUE
                    Msgstr &= "Second answer incorrect: "
                End If
                .TerrainTotal += .FieldAndForestHarvest

                Msgstr &= "Field and Forest Provinces' Harvests range from " & FIELD_AND_FOREST_HARVEST & "." & DOUBLE_SPACE

                If cmbFieldForestPeasants.SelectedItem = FIELD_AND_FOREST_PEASANTS Then
                    .FieldAndForestPeasants = CORRECT_ANSWER_VALUE
                    Msgstr &= "Third answer correct: "
                Else
                    .FieldAndForestPeasants = WRONG_ANSWER_VALUE
                    Msgstr &= "Third answer incorrect: "
                End If
                .TerrainTotal += .FieldAndForestPeasants

                Msgstr &= "Field and Forest Provinces' Peasant Populations range from " & FIELD_AND_FOREST_PEASANTS & "." & DOUBLE_SPACE

                If cmbDifficultFarmland.SelectedItem = DIFFICULT_FARMLAND Then
                    .DifficultFarmland = CORRECT_ANSWER_VALUE
                    Msgstr &= "Fourth answer correct: "
                Else
                    .DifficultFarmland = WRONG_ANSWER_VALUE
                    Msgstr = "Fourth answer incorrect: "
                End If
                .TerrainTotal += .DifficultFarmland

                Msgstr &= "The Amount of Potential Farmland in Provinces with Difficult Terrain is " & CStr(DIFFICULT_FARMLAND) & "." & DOUBLE_SPACE

                If cmbDifficultHarvest.SelectedItem = DIFFICULT_HARVEST Then
                    .DifficultHarvest = CORRECT_ANSWER_VALUE
                    Msgstr &= "Fifth answer correct: "
                Else
                    .DifficultHarvest = WRONG_ANSWER_VALUE
                    Msgstr &= "Fifth answer incorrect: "
                End If
                .TerrainTotal += .DifficultHarvest

                Msgstr &= "Difficult Provinces' Harvests range from " & DIFFICULT_HARVEST & "." & DOUBLE_SPACE

                If cmbDifficultPeasants.SelectedItem = DIFFICULT_PEASANTS Then
                    .DifficultPeasants = CORRECT_ANSWER_VALUE
                    Msgstr &= "Sixth answer correct: "
                Else
                    .DifficultPeasants = WRONG_ANSWER_VALUE
                    Msgstr &= "Sixth answer incorrect: "
                End If
                .TerrainTotal += .DifficultPeasants

                Msgstr &= "Difficult Provinces' Peasant Populations range from " & DIFFICULT_PEASANTS & "." & DOUBLE_SPACE

                If cmbMountainousFarmland.SelectedItem = MOUNTAINOUS_FARMLAND Then
                    .MountainousFarmland = CORRECT_ANSWER_VALUE
                    Msgstr &= "Seventh answer correct: "
                Else
                    .MountainousFarmland = WRONG_ANSWER_VALUE
                    Msgstr = "Seventh answer incorrect: "
                End If
                .TerrainTotal += .MountainousFarmland

                Msgstr &= "The Amount of Potential Farmland in Mountainous Provinces is " & CStr(MOUNTAINOUS_FARMLAND) & "." & DOUBLE_SPACE

                If cmbMountainousHarvest.SelectedItem = MOUNTAINOUS_HARVEST Then
                    .MountainousHarvest = CORRECT_ANSWER_VALUE
                    Msgstr &= "Eighth answer correct: "
                Else
                    .MountainousHarvest = WRONG_ANSWER_VALUE
                    Msgstr &= "Eighth answer incorrect: "
                End If
                .TerrainTotal += .MountainousHarvest

                Msgstr &= "Mountainous Provinces' Harvests range from " & MOUNTAINOUS_HARVEST & "." & DOUBLE_SPACE

                If cmbMountainousPeasants.SelectedItem = MOUNTAINOUS_PEASANTS Then
                    .MountainousPeasants = CORRECT_ANSWER_VALUE
                    Msgstr &= "Ninth answer correct: "
                Else
                    .MountainousPeasants = WRONG_ANSWER_VALUE
                    Msgstr &= "Ninth answer incorrect: "
                End If
                .TerrainTotal += .MountainousPeasants

                Msgstr &= "Mountainous Provinces' Peasant Populations range from " & FIELD_AND_FOREST_PEASANTS & "." & DOUBLE_SPACE

                Msgstr &= "Your score on this question was: " & CStr(.TerrainTotal) & " of " & CStr(POINTS_IN_TERRAIN_QUESTION - 1) & "." & DOUBLE_SPACE
                ' -1 in above line is because the Final Question below is not in there yet

                Msgstr &= "FINAL QUESTION: " & vbCr
                Msgstr &= "A Direct Relationship is one in which if one thing Increases, the other does too." & vbCr
                Msgstr &= "An Inverse Relationship is one in which if one thing Increases, the other Decreases." & DOUBLE_SPACE
                Msgstr &= "Was the relationship between a Province's Farmland and its typical Harvest and Peasant Population Inverse?"

                Decision = MsgBox(Msgstr, MsgBoxStyle.YesNo, "Terrain Question Results")

                If Decision = MsgBoxResult.Yes Then
                    Msgstr = "Incorrect: "
                    .DirectOrInverse = WRONG_ANSWER_VALUE
                Else
                    Msgstr = "Correct: "
                    .DirectOrInverse = CORRECT_ANSWER_VALUE
                End If

                .TerrainTotal += .DirectOrInverse
                Msgstr &= "The more Farmland there was, the larger the typical Harvest could be, and the bigger the Population that could be supported." & DOUBLE_SPACE

            End With '.TerrainQuestion

            .WorksheetTotalScore += .TerrainQuestion.TerrainTotal

            Msgstr &= "TOTAL SCORE on this part of the Worksheet: " & CStr(.WorksheetTotalScore) & " of " & CStr(POINTS_IN_BORDER_QUESTION + POINTS_IN_TERRAIN_QUESTION)

            MsgBox(Msgstr)


        End With ' worksheet

        SaveWorksheet(TERRAIN_QUESTION)

    End Sub
 
End Class