﻿
Imports System.IO
Imports System.Math

Public Class frmCenturyWorksheet

    Private Sub frmCenturyWorksheet_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        Dim Msgstr As String = ""

        WorksheetOpen = True

        If SocioecoCombosDone = False Then
            SetupComboBoxes()
            SocioecoCombosDone = True ' This is set to false in SocioeconomicDevelopment in prep for first time form opens, but after that shouldn't re-populate list
        End If

        lblLastCentury.Text = "Past Century (since " & CStr((TurnDate + TURN_INTERVAL) - 100) & ")"

        Msgstr = "Use the Socioeconomic Trends Graph to indicate the changes in the Weather, Agricultural Level, Harvest, and the number "
        Msgstr &= "of Peasants, Nobles, Clergy, and Townspeople over the past Century and since the beginning of the Game."
        rtbCenturyQuestions.Text = Msgstr


    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Decision = MsgBox("If you Cancel the Worksheet, you will have to all start over again.  " _
                          & "Are you sure you want to stop doing the Worksheet?", MsgBoxStyle.YesNo, "Stop Doing Worksheet?")

        If Decision = MsgBoxResult.Yes Then
            WorksheetTask = END_WORKSHEET
            Me.Close()
            WorksheetOpen = False
        End If

    End Sub

    Private Sub btnViewWorksheet_Click(sender As System.Object, e As System.EventArgs) Handles btnViewWorksheet.Click

        Me.Close()
        WorksheetTask = SHOW_GRAPH

    End Sub

    Private Sub btnSubmit_Click(sender As System.Object, e As System.EventArgs) Handles btnSubmit.Click
        Dim Msgstr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim CenturysWeatherTrend As Double = CDbl(NORMAL_WEATHER)
        Dim OverallWeatherTrend As Double = CDbl(NORMAL_WEATHER)
        Dim CenturysAgriLevelChange As Double = 0.0
        Dim OverallAgriLevelChange As Double = 0.0
        Dim WeatherTrendName As String = ""
        Dim CenturysHarvestChange As Integer = 0
        Dim OverallHarvestChange As Integer = 0
        'Dim Direction As Integer
        Dim EndDate As Integer = 0
        Dim CenturyAgo As Integer = 0
        Dim EndDateStr As String = ""
        Dim CenturyAgoStr As String = ""
        Dim CenturysPeasantChange As Integer = 0
        Dim OverallPeasantChange As Integer = 0
        Dim CenturysNobleChange As Integer = 0
        Dim OverallNobleChange As Integer = 0
        Dim CenturysClergyChange As Integer = 0
        Dim OverallClergyChange As Integer = 0
        Dim CenturysTownspeopleChange As Integer = 0
        Dim OverallTownspeopleChange As Integer = 0
        Dim WSIndex As Integer = 0

        WSIndex = (TurnNum \ (100 \ TURN_INTERVAL)) - 1

        EndDate = TurnDate + TURN_INTERVAL
        CenturyAgo = EndDate - ((100 \ TURN_INTERVAL) * TURN_INTERVAL)
        EndDateStr = CStr(EndDate)
        CenturyAgoStr = CStr(CenturyAgo)

        Decision = MsgBox("Are you sure you're done with this Question?", MsgBoxStyle.YesNo, "Submit Answers?")

        If Decision = MsgBoxResult.Yes Then

            With WorksheetScore
                With .SocioeconomicQuestion(WSIndex)

                    .SocioeconomicTotal = 0 'Initialize SubTotal for Socioeconomic

                    ' ----------------------- 
                    ' WEATHER(STUFF)

                    CenturysWeatherTrend = AnalyzeWeatherTrend(TurnNum - 4, TurnNum)
                    OverallWeatherTrend = AnalyzeWeatherTrend(0, TurnNum)

                    ProcessWeatherAnswers(CenturysWeatherTrend, OverallWeatherTrend, WSIndex)

                    If .WeatherThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr = "First Answer Correct: "
                    Else
                        Msgstr = "First Answer Incorrect: "
                    End If

                    WeatherTrendName = WeatherTrendToWeatherType(CenturysWeatherTrend)
                    Msgstr &= "the Average Weather during the century was " & NameWeather(WeatherTrendName) & "." & DOUBLE_SPACE


                    If .WeatherOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Second Answer Correct: "
                    Else
                        Msgstr &= "Second Answer Incorrect: "
                    End If

                    WeatherTrendName = WeatherTrendToWeatherType(OverallWeatherTrend)
                    Msgstr &= "the Average Weather since " & CStr(ScenarioStartDate) & " has been " & NameWeather(WeatherTrendName) & "." & DOUBLE_SPACE

                    ' ----------------------- 
                    ' AGRI LEVEL STUFF

                    CenturysAgriLevelChange = TurnRecord(TurnNum).AgriLevel - TurnRecord(TurnNum - 4).AgriLevel

                    .AgriChangeThisCentury = CheckAgriChangeAnswer(CenturysAgriLevelChange, cmbAgriLvlThisCent)
                    .SocioeconomicTotal += .AgriChangeThisCentury

                    If .AgriChangeThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Third Answer Correct: "
                    Else
                        Msgstr &= "Third Answer Incorrect: "
                    End If

                    Msgstr &= "Improved Agricultural Technology and Techniques rose " & CStr(CenturysAgriLevelChange) & " in the past Century." & DOUBLE_SPACE

                    .AgriOverall = CheckAgriLevelAnswer(TurnRecord(TurnNum).AgriLevel, cmbAgriLvlOverall)
                    .SocioeconomicTotal += .AgriOverall

                    If .AgriOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Fourth Answer Correct: "
                    Else
                        Msgstr &= "Fourth Answer Incorrect: "
                    End If

                    Msgstr &= "The Overall Level of Agricultural Technology and Techniques in the Kingdom is " & CStr(TurnRecord(TurnNum).AgriLevel) & " of 2.0." & DOUBLE_SPACE

                    ' ----------------------- 
                    ' HARVEST STUFF

                    CenturysHarvestChange = AnalyzeTwoDateTrend(TurnNum - 4, TurnNum, HARVEST_TREND_ID)

                    .HarvestThisCentury = CheckMagnitudeAnswer(CenturysHarvestChange, cmbHarvestsThisCentury)
                    .SocioeconomicTotal += .HarvestThisCentury

                    If .HarvestThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Fifth Answer Correct: "
                    Else
                        Msgstr &= "Fifth Answer Incorrect: "
                    End If

                    'Msgstr &= "The " & CStr(TurnDate + TURN_INTERVAL) & " Harvest was " & CStr(CenturysHarvestChange) & "%  of that in "
                    'Msgstr &= CStr((TurnDate + TURN_INTERVAL) - ((100 \ TURN_INTERVAL) * TURN_INTERVAL)) & "." & DOUBLE_SPACE

                    If CenturysHarvestChange = 0 Then
                        Msgstr &= "The Harvest neither rose nor declined from " & CenturyAgoStr & " and " & EndDateStr & "."
                    Else
                        Msgstr &= "The Harvest in  " & EndDateStr & " was " & CStr(Abs(CenturysHarvestChange)) & "% "
                        If CenturysHarvestChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CenturyAgoStr & "." & DOUBLE_SPACE
                    End If

                    OverallHarvestChange = AnalyzeTwoDateTrend(0, TurnNum, HARVEST_TREND_ID)

                    .HarvestOverall = CheckMagnitudeAnswer(OverallHarvestChange, cmbHarvestsOverall)
                    .SocioeconomicTotal += .HarvestOverall

                    If .HarvestOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Sixth Answer Correct: "
                    Else
                        Msgstr &= "Sixth Answer Incorrect: "
                    End If

                    'Msgstr &= "The " & CStr(TurnDate + TURN_INTERVAL) & " Harvest was " & CStr(CenturysHarvestChange) & "%  of that in "
                    'Msgstr &= CStr(ScenarioStartDate) & "." & DOUBLE_SPACE

                    If OverallHarvestChange = 0 Then
                        Msgstr &= "The Harvest neither rose nor declined from " & CStr(ScenarioStartDate) & " and " & EndDateStr & "."
                    Else
                        Msgstr &= "The Harvest in  " & EndDateStr & " was " & CStr(Abs(OverallHarvestChange)) & "% "
                        If OverallHarvestChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CStr(ScenarioStartDate) & "." & DOUBLE_SPACE
                    End If



                    ' ----------------------- 
                    ' POPULATION STUFF

                    ' PEASANT STUFF

                    CenturysPeasantChange = AnalyzeTwoDateTrend(TurnNum - 4, TurnNum, PEASANT_TREND_ID)

                    .PeasantsThisCentury = CheckMagnitudeAnswer(CenturysPeasantChange, cmbPeasantsThisCentury)
                    .SocioeconomicTotal += .PeasantsThisCentury

                    If .PeasantsThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Seventh Answer Correct: "
                    Else
                        Msgstr &= "Seventh Answer Incorrect: "
                    End If

                    'Msgstr &= "The " & CStr(TurnDate + TURN_INTERVAL) & " Harvest was " & CStr(CenturysHarvestChange) & "%  of that in "
                    'Msgstr &= CStr((TurnDate + TURN_INTERVAL) - ((100 \ TURN_INTERVAL) * TURN_INTERVAL)) & "." & DOUBLE_SPACE

                    If CenturysPeasantChange = 0 Then
                        Msgstr &= "The Peasant population neither rose nor declined from " & CenturyAgoStr & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Peasant population in " & EndDateStr & " was " & CStr(Abs(CenturysPeasantChange)) & "% "
                        If CenturysPeasantChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CenturyAgoStr & "." & DOUBLE_SPACE
                    End If

                    OverallPeasantChange = AnalyzeTwoDateTrend(0, TurnNum, PEASANT_TREND_ID)

                    .PeasantsOverall = CheckMagnitudeAnswer(OverallPeasantChange, cmbPeasantsOverall)
                    .SocioeconomicTotal += .PeasantsOverall

                    If .PeasantsOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Eighth Answer Correct: "
                    Else
                        Msgstr &= "Eighth Answer Incorrect: "
                    End If

                    'Msgstr &= "The " & CStr(TurnDate + TURN_INTERVAL) & " Harvest was " & CStr(CenturysHarvestChange) & "%  of that in "
                    'Msgstr &= CStr(ScenarioStartDate) & "." & DOUBLE_SPACE

                    If OverallPeasantChange = 0 Then
                        Msgstr &= "The Peasant population neither rose nor declined from " & CStr(ScenarioStartDate) & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Peasant population in  " & EndDateStr & " was " & CStr(Abs(OverallPeasantChange)) & "% "
                        If OverallPeasantChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CStr(ScenarioStartDate) & "." & DOUBLE_SPACE
                    End If

                    ' -----------------------------------
                    ' NOBLE STUFF

                    CenturysNobleChange = AnalyzeTwoDateTrend(TurnNum - 4, TurnNum, NOBLE_TREND_ID)

                    .NoblesThisCentury = CheckMagnitudeAnswer(CenturysNobleChange, cmbNoblesThisCentury)
                    .SocioeconomicTotal += .NoblesThisCentury

                    If .NoblesThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Ninth Answer Correct: "
                    Else
                        Msgstr &= "Ninth Answer Incorrect: "
                    End If

                    If CenturysNobleChange = 0 Then
                        Msgstr &= "The Noble population neither rose nor declined from " & CenturyAgoStr & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Noble population in " & EndDateStr & " was " & CStr(Abs(CenturysNobleChange)) & "% "
                        If CenturysNobleChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CenturyAgoStr & "." & DOUBLE_SPACE
                    End If

                    OverallNobleChange = AnalyzeTwoDateTrend(0, TurnNum, NOBLE_TREND_ID)

                    .NoblesOverall = CheckMagnitudeAnswer(OverallNobleChange, cmbNoblesOverall)
                    .SocioeconomicTotal += .NoblesOverall

                    If .NoblesOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Tenth Answer Correct: "
                    Else
                        Msgstr &= "Tenth Answer Incorrect: "
                    End If

                    If OverallNobleChange = 0 Then
                        Msgstr &= "The Noble population neither rose nor declined from " & CStr(ScenarioStartDate) & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Noble population in  " & EndDateStr & " was " & CStr(Abs(OverallNobleChange)) & "% "
                        If OverallNobleChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CStr(ScenarioStartDate) & "." & DOUBLE_SPACE
                    End If

                    ' -----------------------------------
                    ' CLERGY STUFF

                    CenturysClergyChange = AnalyzeTwoDateTrend(TurnNum - 4, TurnNum, CLERGY_TREND_ID)

                    .ClergyThisCentury = CheckMagnitudeAnswer(CenturysClergyChange, cmbClergyThisCentury)
                    .SocioeconomicTotal += .ClergyThisCentury

                    If .ClergyThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Eleventh Answer Correct: "
                    Else
                        Msgstr &= "Eleventh Answer Incorrect: "
                    End If

                    If CenturysClergyChange = 0 Then
                        Msgstr &= "The Clergy population neither rose nor declined from " & CenturyAgoStr & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Clergy population in " & EndDateStr & " was " & CStr(Abs(CenturysClergyChange)) & "% "
                        If CenturysClergyChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CenturyAgoStr & "." & DOUBLE_SPACE
                    End If

                    OverallClergyChange = AnalyzeTwoDateTrend(0, TurnNum, CLERGY_TREND_ID)

                    .ClergyOverall = CheckMagnitudeAnswer(OverallClergyChange, cmbClergyOverall)
                    .SocioeconomicTotal += .ClergyOverall

                    If .ClergyOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Twelfth Answer Correct: "
                    Else
                        Msgstr &= "Twelfth Answer Incorrect: "
                    End If

                    If OverallClergyChange = 0 Then
                        Msgstr &= "The Clergy population neither rose nor declined from " & CStr(ScenarioStartDate) & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Clergy population in  " & EndDateStr & " was " & CStr(Abs(OverallClergyChange)) & "% "
                        If OverallClergyChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CStr(ScenarioStartDate) & "." & DOUBLE_SPACE
                    End If

                    ' -----------------------------------
                    ' TOWNSPEOPLE STUFF

                    CenturysTownspeopleChange = AnalyzeTwoDateTrend(TurnNum - 4, TurnNum, TOWNSPEOPLE_TREND_ID)

                    .TownspeopleThisCentury = CheckMagnitudeAnswer(CenturysTownspeopleChange, cmbTowniesThisCentury)
                    .SocioeconomicTotal += .TownspeopleThisCentury

                    If .TownspeopleThisCentury = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Eleventh Answer Correct: "
                    Else
                        Msgstr &= "Eleventh Answer Incorrect: "
                    End If

                    If CenturysTownspeopleChange = 0 Then
                        Msgstr &= "The Urban population neither rose nor declined from " & CenturyAgoStr & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Urban population in " & EndDateStr & " was " & CStr(Abs(CenturysTownspeopleChange)) & "% "
                        If CenturysTownspeopleChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CenturyAgoStr & "." & DOUBLE_SPACE
                    End If

                    OverallTownspeopleChange = AnalyzeTwoDateTrend(0, TurnNum, TOWNSPEOPLE_TREND_ID)

                    .TownspeopleOverall = CheckMagnitudeAnswer(OverallTownspeopleChange, cmbTowniesOverall)
                    .SocioeconomicTotal += .TownspeopleOverall

                    If .TownspeopleOverall = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "Twelfth Answer Correct: "
                    Else
                        Msgstr &= "Twelfth Answer Incorrect: "
                    End If

                    If OverallTownspeopleChange = 0 Then
                        Msgstr &= "The Urban population neither rose nor declined from " & CStr(ScenarioStartDate) & " to " & EndDateStr & "."
                    Else
                        Msgstr &= "The Urban population in  " & EndDateStr & " was " & CStr(Abs(OverallTownspeopleChange)) & "% "
                        If OverallTownspeopleChange > 0 Then
                            Msgstr &= " higher "
                        Else
                            Msgstr &= " lower "
                        End If
                        Msgstr &= " than in " & CStr(ScenarioStartDate) & "." & DOUBLE_SPACE
                    End If

                    Msgstr &= "Your score on this Question Set was: " & CStr(.SocioeconomicTotal) & " of " & POINTS_IN_SOCIOECONOMIC_QUESTION & "." & vbCrLf

                 End With

                .WorksheetTotalScore += .SocioeconomicQuestion(WSIndex).SocioeconomicTotal

                Msgstr &= "Your score on the Worksheet overall is " & CStr(.WorksheetTotalScore) & " of "
                Msgstr &= CStr(POINTS_IN_BORDER_QUESTION + POINTS_IN_TERRAIN_QUESTION + (POINTS_IN_SOCIOECONOMIC_QUESTION * (WSIndex + 1)))
                Msgstr &= " Overall."

                MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Socioeconomic Trends Questions Feedback")


            End With

            SaveWorksheet(SOCIOECONOMIC_TRENDS_QUESTION)

            ClearComboBoxes()
            WorksheetTask = END_WORKSHEET
            WorksheetOpen = False
            Me.Close()

        End If

    End Sub

    Function CheckMagnitudeAnswer(ByVal Change As Integer, ComboBox As System.Windows.Forms.ComboBox) As Integer
        Dim AnswerValue As Integer = 0

        'Public Const EPOCHAL_INCREASE_STR As String = "Epochal Increase (> 10 Times)"
        'Public Const HUGE_INCREASE_STR As String = "Huge Increase (> Doubled)"
        'Public Const SUBSTANTIAL_INCREASE_STR As String = "Subtantial Increase (> 50%)"
        'Public Const SIGNIFICANT_INCREASE_STR As String = "Signficant Inccrease (> 10%)"
        'Public Const MARGINAL_INCREASE_STR As String = "Marginal Increase (<= 10%)"
        'Public Const UNCHANGED_STR As String = "Unchanged"
        'Public Const SMALL_DECREASE As String = "Small Decrease (<= 10%)"
        'Public Const SIGNIFICANT_DECREASE_STR As String = "Significant Decrease (> 10%)"
        'Public Const SUBSTANTIAL_DECREASE_STR As String = "Substantial Decrease (> 25%)"
        'Public Const CATASTROPHIC_DECREASE_STR As String = "Catastrophic Decrease (> 50%)"

        If Change > EPOCAL_INCREASE Then
            If ComboBox.SelectedItem = EPOCHAL_INCREASE_STR Then
                AnswerValue = CORRECT_ANSWER_VALUE
            Else
                AnswerValue = WRONG_ANSWER_VALUE
            End If
        Else
            If Change > HUGE_INCREASE Then
                If ComboBox.SelectedItem = HUGE_INCREASE_STR Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Else
                If Change > SUBSTANTIAL_INCREASE Then
                    If ComboBox.SelectedItem = SUBSTANTIAL_INCREASE_STR Then
                        AnswerValue = CORRECT_ANSWER_VALUE
                    Else
                        AnswerValue = WRONG_ANSWER_VALUE
                    End If
                Else
                    If Change > SIGNIFICANT_INCREASE Then
                        If ComboBox.SelectedItem = SIGNIFICANT_INCREASE_STR Then
                            AnswerValue = CORRECT_ANSWER_VALUE
                        Else
                            AnswerValue = WRONG_ANSWER_VALUE
                        End If
                    Else
                        If Change > UNCHANGED Then
                            If ComboBox.SelectedItem = SUBSTANTIAL_INCREASE_STR Then
                                AnswerValue = CORRECT_ANSWER_VALUE
                            Else
                                AnswerValue = WRONG_ANSWER_VALUE
                            End If
                        Else
                            If Change = UNCHANGED Then
                                If ComboBox.SelectedItem = UNCHANGED_STR Then
                                    AnswerValue = CORRECT_ANSWER_VALUE
                                Else
                                    AnswerValue = WRONG_ANSWER_VALUE
                                End If
                            Else
                                If Change > SIGNIFICANT_DECREASE Then
                                    If ComboBox.SelectedItem = SMALL_DECREASE_STR Then
                                        AnswerValue = CORRECT_ANSWER_VALUE
                                    Else
                                        AnswerValue = WRONG_ANSWER_VALUE
                                    End If
                                Else
                                    If Change > SUBSTANTIAL_DECREASE Then
                                        If ComboBox.SelectedItem = SIGNIFICANT_DECREASE_STR Then
                                            AnswerValue = CORRECT_ANSWER_VALUE
                                        Else
                                            AnswerValue = WRONG_ANSWER_VALUE
                                        End If
                                    Else
                                        If Change > CATASTROPHIC_DECREASE Then
                                            If ComboBox.SelectedItem = SUBSTANTIAL_DECREASE_STR Then
                                                AnswerValue = CORRECT_ANSWER_VALUE
                                            Else
                                                AnswerValue = WRONG_ANSWER_VALUE
                                            End If
                                        Else
                                            If ComboBox.SelectedItem = CATASTROPHIC_DECREASE_STR Then
                                                AnswerValue = CORRECT_ANSWER_VALUE
                                            Else
                                                AnswerValue = WRONG_ANSWER_VALUE
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If

        Return AnswerValue

    End Function

    Function AnalyzeTwoDateTrend(ByVal StartTurn As Integer, ByVal EndTurn As Integer, ByVal DataSource As Integer) As Integer
        Dim Trend As Integer = 0
        Dim i As Integer = 0
        Dim StartValue As Integer = 0
        Dim EndValue As Integer = 0

        Select Case DataSource
            Case HARVEST_TREND_ID
                StartValue = TurnRecord(StartTurn).TotalHarvest
                EndValue = TurnRecord(EndTurn).TotalHarvest
            Case PEASANT_TREND_ID
                StartValue = TurnRecord(StartTurn).NumPeasants
                EndValue = TurnRecord(EndTurn).NumPeasants
            Case NOBLE_TREND_ID
                StartValue = TurnRecord(StartTurn).NumNobles
                EndValue = TurnRecord(EndTurn).NumNobles
            Case CLERGY_TREND_ID
                StartValue = TurnRecord(StartTurn).NumClergy
                EndValue = TurnRecord(EndTurn).NumClergy
            Case TOWNSPEOPLE_TREND_ID
                StartValue = TurnRecord(StartTurn).NumTownspeople
                EndValue = TurnRecord(EndTurn).NumTownspeople
        End Select

        Trend = CInt((CDbl(EndValue - StartValue)) / CDbl(StartValue) * 100)
 
        Return Trend

    End Function


    Function CheckAgriChangeAnswer(ByVal AgLevChange As Double, ComboBox As System.Windows.Forms.ComboBox) As Integer
        Dim AnswerValue As Integer = WRONG_ANSWER_VALUE

        Select Case ComboBox.SelectedItem
            Case ABRUPT_DIFFUSION_STR
                If AgLevChange > CDbl(ABRUPT_DIFFUSION) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case RAPID_DIFFUSION_STR
                If AgLevChange > CDbl(RAPID_DIFFUSION) And AgLevChange <= CDbl(ABRUPT_DIFFUSION) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case MODERATE_DIFFUSION_STR
                If AgLevChange > CDbl(MODERATE_DIFFUSION) And AgLevChange <= CDbl(RAPID_DIFFUSION) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case SLOW_DIFFUSION_STR
                If AgLevChange > CDbl(NO_DIFFUSION) And AgLevChange <= CDbl(MODERATE_DIFFUSION) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case NO_DIFFUSION_STR
                If AgLevChange = CDbl(NO_DIFFUSION) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case Else
                MsgBox("Problem Finding Answer Value of Agricultural Level Change")
        End Select

        Return AnswerValue

    End Function

    Function CheckAgriLevelAnswer(ByVal AgLev As Double, ComboBox As System.Windows.Forms.ComboBox) As Integer
        Dim AnswerValue As Integer = WRONG_ANSWER_VALUE

        Select Case ComboBox.SelectedItem
            Case ALL_NEW_STR
                If AgLev = CDbl(ALL_NEW) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case MOSTLY_NEW_STR
                If AgLev > CDbl(MOSTLY_NEW) And AgLev < CDbl(ALL_NEW) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case MIXED_STR
                If AgLev >= CDbl(MIXED) And AgLev <= CDbl(MOSTLY_NEW) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case A_FEW_NEW_STR
                If AgLev > CDbl(NO_NEW) And AgLev < CDbl(MIXED) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case NO_NEW_STR
                If AgLev = CDbl(NO_NEW) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case Else
                MsgBox("Problem Finding Answer Value of Overall Agricultural Level.")
        End Select

        Return AnswerValue

    End Function

    Function WeatherTrendToWeatherType(ByVal Trend As Double) As Integer
        Dim Type As Integer

        If Trend > 1.0 Then
            Type = GREAT_WEATHER
        Else
            If Trend > 0.0 Then
                Type = GOOD_WEATHER
            Else
                If Trend = 0.0 Then
                    Type = NORMAL_WEATHER
                Else
                    If Trend < -1.0 Then
                        Type = TERRIBLE_WEATHER
                    Else
                        Type = BAD_WEATHER
                    End If
                End If
            End If
        End If

        Return Type
    End Function

    Sub ProcessWeatherAnswers(ByVal CenturyTrend As Double, ByVal OverallTrend As Double, ByVal WorksheetIndex As Integer)

        With WorksheetScore
            With .SocioeconomicQuestion(WorksheetIndex)

                .WeatherThisCentury = CheckWeatherAnswer(CenturyTrend, cmbWeatherThisCentury)
                .SocioeconomicTotal += .WeatherThisCentury

                .WeatherOverall = CheckWeatherAnswer(OverallTrend, cmbWeatherOverall)
                .SocioeconomicTotal += .WeatherOverall

            End With '.SocieconomicQuestion
        End With 'WorksheetScore

    End Sub

    Function AnalyzeWeatherTrend(ByVal StartTurn As Integer, ByVal EndTurn As Integer) As Double
        Dim WeatherTrend As Double = CDbl(NORMAL_WEATHER)
        Dim i As Integer = 0

        For i = StartTurn To EndTurn
            WeatherTrend += TurnRecord(i).AverageWeather
        Next

        WeatherTrend = WeatherTrend / CDbl(EndTurn - StartTurn)

        Return WeatherTrend
    End Function

    Function CheckWeatherAnswer(ByVal WeatherTrend As Double, ByRef ComboBox As System.Windows.Forms.ComboBox) As Integer
        Dim AnswerValue As Integer = WRONG_ANSWER_VALUE

        Select Case ComboBox.SelectedItem
            Case GREAT_WEATHER_LIST_ITEM
                If WeatherTrend > CDbl(GOOD_WEATHER) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case GOOD_WEATHER_LIST_ITEM
                If WeatherTrend > CDbl(NORMAL_WEATHER) And WeatherTrend <= CDbl(GOOD_WEATHER) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case NORMAL_WEATHER_LIST_ITEM
                If WeatherTrend = CDbl(NORMAL_WEATHER) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case BAD_WEATHER_LIST_ITEM
                If WeatherTrend < CDbl(NORMAL_WEATHER) And WeatherTrend >= CDbl(BAD_WEATHER) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case TERRIBLE_WEATHER_LIST_ITEM
                If WeatherTrend < CDbl(BAD_WEATHER) Then
                    AnswerValue = CORRECT_ANSWER_VALUE
                Else
                    AnswerValue = WRONG_ANSWER_VALUE
                End If
            Case Else
                MsgBox("Problem Finding Answer Value of Weather Trend")
        End Select

        Return AnswerValue
    End Function

    'Function CheckOverallWeatherAnswer(ByVal WeatherTrend As Double) As Integer
    '    Dim AnswerValue As Integer = WRONG_ANSWER_VALUE

    '    Select Case cmbWeatherOverall.SelectedItem
    '        Case GREAT_WEATHER_LIST_ITEM
    '            If WeatherTrend > CDbl(GOOD_WEATHER) Then
    '                AnswerValue = CORRECT_ANSWER_VALUE
    '            Else
    '                AnswerValue = WRONG_ANSWER_VALUE
    '            End If
    '        Case GOOD_WEATHER_LIST_ITEM
    '            If WeatherTrend > CDbl(NORMAL_WEATHER) And WeatherTrend <= CDbl(GOOD_WEATHER) Then
    '                AnswerValue = CORRECT_ANSWER_VALUE
    '            Else
    '                AnswerValue = WRONG_ANSWER_VALUE
    '            End If
    '        Case NORMAL_WEATHER_LIST_ITEM
    '            If WeatherTrend = CDbl(NORMAL_WEATHER) Then
    '                AnswerValue = CORRECT_ANSWER_VALUE
    '            Else
    '                AnswerValue = WRONG_ANSWER_VALUE
    '            End If
    '        Case BAD_WEATHER_LIST_ITEM
    '            If WeatherTrend < CDbl(NORMAL_WEATHER) And WeatherTrend >= CDbl(BAD_WEATHER) Then
    '                AnswerValue = CORRECT_ANSWER_VALUE
    '            Else
    '                AnswerValue = WRONG_ANSWER_VALUE
    '            End If
    '        Case TERRIBLE_WEATHER_LIST_ITEM
    '            If WeatherTrend < CDbl(BAD_WEATHER) Then
    '                AnswerValue = CORRECT_ANSWER_VALUE
    '            Else
    '                AnswerValue = WRONG_ANSWER_VALUE
    '            End If
    '        Case Else
    '            MsgBox("Problem Finding Answer Value of Weather Trend")
    '    End Select

    '    Return AnswerValue
    'End Function

    Sub SetupComboBoxes()

        cmbWeatherThisCentury.Items.Add(GREAT_WEATHER_LIST_ITEM)
        cmbWeatherThisCentury.Items.Add(GOOD_WEATHER_LIST_ITEM)
        cmbWeatherThisCentury.Items.Add(NORMAL_WEATHER_LIST_ITEM)
        cmbWeatherThisCentury.Items.Add(BAD_WEATHER_LIST_ITEM)
        cmbWeatherThisCentury.Items.Add(TERRIBLE_WEATHER_LIST_ITEM)

        cmbAgriLvlThisCent.Items.Add(ABRUPT_DIFFUSION_STR)
        cmbAgriLvlThisCent.Items.Add(RAPID_DIFFUSION_STR)
        cmbAgriLvlThisCent.Items.Add(MODERATE_DIFFUSION_STR)
        cmbAgriLvlThisCent.Items.Add(SLOW_DIFFUSION_STR)
        cmbAgriLvlThisCent.Items.Add(NO_DIFFUSION_STR)

        cmbHarvestsThisCentury.Items.Add(EPOCHAL_INCREASE_STR)
        cmbHarvestsThisCentury.Items.Add(HUGE_INCREASE_STR)
        cmbHarvestsThisCentury.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbHarvestsThisCentury.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbHarvestsThisCentury.Items.Add(MARGINAL_INCREASE_STR)
        cmbHarvestsThisCentury.Items.Add(UNCHANGED_STR)
        cmbHarvestsThisCentury.Items.Add(SMALL_DECREASE_STR)
        cmbHarvestsThisCentury.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbHarvestsThisCentury.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbHarvestsThisCentury.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbPeasantsThisCentury.Items.Add(EPOCHAL_INCREASE_STR)
        cmbPeasantsThisCentury.Items.Add(HUGE_INCREASE_STR)
        cmbPeasantsThisCentury.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbPeasantsThisCentury.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbPeasantsThisCentury.Items.Add(MARGINAL_INCREASE_STR)
        cmbPeasantsThisCentury.Items.Add(UNCHANGED_STR)
        cmbPeasantsThisCentury.Items.Add(SMALL_DECREASE_STR)
        cmbPeasantsThisCentury.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbPeasantsThisCentury.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbPeasantsThisCentury.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbNoblesThisCentury.Items.Add(EPOCHAL_INCREASE_STR)
        cmbNoblesThisCentury.Items.Add(HUGE_INCREASE_STR)
        cmbNoblesThisCentury.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbNoblesThisCentury.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbNoblesThisCentury.Items.Add(MARGINAL_INCREASE_STR)
        cmbNoblesThisCentury.Items.Add(UNCHANGED_STR)
        cmbNoblesThisCentury.Items.Add(SMALL_DECREASE_STR)
        cmbNoblesThisCentury.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbNoblesThisCentury.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbNoblesThisCentury.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbClergyThisCentury.Items.Add(EPOCHAL_INCREASE_STR)
        cmbClergyThisCentury.Items.Add(HUGE_INCREASE_STR)
        cmbClergyThisCentury.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbClergyThisCentury.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbClergyThisCentury.Items.Add(MARGINAL_INCREASE_STR)
        cmbClergyThisCentury.Items.Add(UNCHANGED_STR)
        cmbClergyThisCentury.Items.Add(SMALL_DECREASE_STR)
        cmbClergyThisCentury.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbClergyThisCentury.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbClergyThisCentury.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbTowniesThisCentury.Items.Add(EPOCHAL_INCREASE_STR)
        cmbTowniesThisCentury.Items.Add(HUGE_INCREASE_STR)
        cmbTowniesThisCentury.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbTowniesThisCentury.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbTowniesThisCentury.Items.Add(MARGINAL_INCREASE_STR)
        cmbTowniesThisCentury.Items.Add(UNCHANGED_STR)
        cmbTowniesThisCentury.Items.Add(SMALL_DECREASE_STR)
        cmbTowniesThisCentury.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbTowniesThisCentury.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbTowniesThisCentury.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbWeatherOverall.Items.Add(GREAT_WEATHER_LIST_ITEM)
        cmbWeatherOverall.Items.Add(GOOD_WEATHER_LIST_ITEM)
        cmbWeatherOverall.Items.Add(NORMAL_WEATHER_LIST_ITEM)
        cmbWeatherOverall.Items.Add(BAD_WEATHER_LIST_ITEM)
        cmbWeatherOverall.Items.Add(TERRIBLE_WEATHER_LIST_ITEM)

        cmbAgriLvlOverall.Items.Add(ALL_NEW_STR)
        cmbAgriLvlOverall.Items.Add(MOSTLY_NEW_STR)
        cmbAgriLvlOverall.Items.Add(MIXED_STR)
        cmbAgriLvlOverall.Items.Add(A_FEW_NEW_STR)
        cmbAgriLvlOverall.Items.Add(NO_NEW_STR)

        cmbHarvestsOverall.Items.Add(EPOCHAL_INCREASE_STR)
        cmbHarvestsOverall.Items.Add(HUGE_INCREASE_STR)
        cmbHarvestsOverall.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbHarvestsOverall.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbHarvestsOverall.Items.Add(MARGINAL_INCREASE_STR)
        cmbHarvestsOverall.Items.Add(UNCHANGED_STR)
        cmbHarvestsOverall.Items.Add(SMALL_DECREASE_STR)
        cmbHarvestsOverall.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbHarvestsOverall.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbHarvestsOverall.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbPeasantsOverall.Items.Add(EPOCHAL_INCREASE_STR)
        cmbPeasantsOverall.Items.Add(HUGE_INCREASE_STR)
        cmbPeasantsOverall.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbPeasantsOverall.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbPeasantsOverall.Items.Add(MARGINAL_INCREASE_STR)
        cmbPeasantsOverall.Items.Add(UNCHANGED_STR)
        cmbPeasantsOverall.Items.Add(SMALL_DECREASE_STR)
        cmbPeasantsOverall.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbPeasantsOverall.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbPeasantsOverall.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbNoblesOverall.Items.Add(EPOCHAL_INCREASE_STR)
        cmbNoblesOverall.Items.Add(HUGE_INCREASE_STR)
        cmbNoblesOverall.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbNoblesOverall.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbNoblesOverall.Items.Add(MARGINAL_INCREASE_STR)
        cmbNoblesOverall.Items.Add(UNCHANGED_STR)
        cmbNoblesOverall.Items.Add(SMALL_DECREASE_STR)
        cmbNoblesOverall.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbNoblesOverall.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbNoblesOverall.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbClergyOverall.Items.Add(EPOCHAL_INCREASE_STR)
        cmbClergyOverall.Items.Add(HUGE_INCREASE_STR)
        cmbClergyOverall.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbClergyOverall.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbClergyOverall.Items.Add(MARGINAL_INCREASE_STR)
        cmbClergyOverall.Items.Add(UNCHANGED_STR)
        cmbClergyOverall.Items.Add(SMALL_DECREASE_STR)
        cmbClergyOverall.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbClergyOverall.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbClergyOverall.Items.Add(CATASTROPHIC_DECREASE_STR)

        cmbTowniesOverall.Items.Add(EPOCHAL_INCREASE_STR)
        cmbTowniesOverall.Items.Add(HUGE_INCREASE_STR)
        cmbTowniesOverall.Items.Add(SUBSTANTIAL_INCREASE_STR)
        cmbTowniesOverall.Items.Add(SIGNIFICANT_INCREASE_STR)
        cmbTowniesOverall.Items.Add(MARGINAL_INCREASE_STR)
        cmbTowniesOverall.Items.Add(UNCHANGED_STR)
        cmbTowniesOverall.Items.Add(SMALL_DECREASE_STR)
        cmbTowniesOverall.Items.Add(SIGNIFICANT_DECREASE_STR)
        cmbTowniesOverall.Items.Add(SUBSTANTIAL_DECREASE_STR)
        cmbTowniesOverall.Items.Add(CATASTROPHIC_DECREASE_STR)

    End Sub

    Sub ClearComboBoxes()

        cmbWeatherThisCentury.Items.Clear()
        cmbWeatherThisCentury.SelectedItem = NO_ITEM
        cmbWeatherThisCentury.Text = NO_ITEM

        cmbAgriLvlThisCent.Items.Clear()
        cmbAgriLvlThisCent.SelectedItem = NO_ITEM
        cmbAgriLvlThisCent.Text = NO_ITEM

        cmbHarvestsThisCentury.Items.Clear()
        cmbHarvestsThisCentury.SelectedItem = NO_ITEM
        cmbHarvestsThisCentury.Text = NO_ITEM

        cmbPeasantsThisCentury.Items.Clear()
        cmbPeasantsThisCentury.SelectedItem = NO_ITEM
        cmbPeasantsThisCentury.Text = NO_ITEM

        cmbNoblesThisCentury.Items.Clear()
        cmbNoblesThisCentury.SelectedItem = NO_ITEM
        cmbNoblesThisCentury.Text = NO_ITEM

        cmbClergyThisCentury.Items.Clear()
        cmbClergyThisCentury.SelectedItem = NO_ITEM
        cmbClergyThisCentury.Text = NO_ITEM

        cmbTowniesThisCentury.Items.Clear()
        cmbTowniesThisCentury.SelectedItem = NO_ITEM
        cmbTowniesThisCentury.Text = NO_ITEM

        cmbWeatherOverall.Items.Clear()
        cmbWeatherOverall.SelectedItem = NO_ITEM
        cmbWeatherOverall.Text = NO_ITEM

        cmbAgriLvlOverall.Items.Clear()
        cmbAgriLvlOverall.SelectedItem = NO_ITEM
        cmbAgriLvlOverall.Text = NO_ITEM

        cmbHarvestsOverall.Items.Clear()
        cmbHarvestsOverall.SelectedItem = NO_ITEM
        cmbHarvestsOverall.Text = NO_ITEM

        cmbPeasantsOverall.Items.Clear()
        cmbPeasantsOverall.SelectedItem = NO_ITEM
        cmbPeasantsOverall.Text = NO_ITEM

        cmbNoblesOverall.Items.Clear()
        cmbNoblesOverall.SelectedItem = NO_ITEM
        cmbNoblesOverall.Text = NO_ITEM

        cmbClergyOverall.Items.Clear()
        cmbClergyOverall.SelectedItem = NO_ITEM
        cmbClergyOverall.Text = NO_ITEM

        cmbTowniesOverall.Items.Clear()
        cmbTowniesOverall.SelectedItem = NO_ITEM
        cmbTowniesOverall.Text = NO_ITEM

    End Sub


End Class

' Raw Weather Trend Answer Lookup; all moved into 
'Select Case cmbWeatherThisCentury.SelectedItem
'    Case GREAT_WEATHER_LIST_ITEM
'        If CenturysWeatherTrend > CDbl(GOOD_WEATHER) Then
'            .WeatherThisCentury = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherThisCentury = WRONG_ANSWER_VALUE
'        End If
'    Case GOOD_WEATHER_LIST_ITEM
'        If CenturysWeatherTrend > CDbl(NORMAL_WEATHER) And CenturysWeatherTrend <= CDbl(GOOD_WEATHER) Then
'            .WeatherThisCentury = CORRECT_ANSWER_VALUE
'            .SocioeconomicTotal += .WeatherThisCentury
'        Else
'            .WeatherThisCentury = WRONG_ANSWER_VALUE
'        End If
'    Case NORMAL_WEATHER_LIST_ITEM
'        If CenturysWeatherTrend = CDbl(NORMAL_WEATHER) Then
'            .WeatherThisCentury = CORRECT_ANSWER_VALUE
'            .SocioeconomicTotal += .WeatherThisCentury
'        Else
'            .WeatherThisCentury = WRONG_ANSWER_VALUE
'        End If
'    Case BAD_WEATHER_LIST_ITEM
'        If CenturysWeatherTrend < CDbl(NORMAL_WEATHER) And CenturysWeatherTrend <= CDbl(BAD_WEATHER) Then
'            .WeatherThisCentury = CORRECT_ANSWER_VALUE
'            .SocioeconomicTotal += .WeatherThisCentury
'        Else
'            .WeatherThisCentury = WRONG_ANSWER_VALUE
'        End If
'    Case TERRIBLE_WEATHER_LIST_ITEM
'        If CenturysWeatherTrend < CDbl(BAD_WEATHER) Then
'            .WeatherThisCentury = CORRECT_ANSWER_VALUE
'            .SocioeconomicTotal += .WeatherThisCentury
'        Else
'            .WeatherThisCentury = WRONG_ANSWER_VALUE
'        End If
'End Select

'Select Case cmbWeatherOverall.SelectedItem
'    Case GREAT_WEATHER_LIST_ITEM
'        If OverallWeatherTrend > CDbl(GOOD_WEATHER) Then
'            .WeatherOverall = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherOverall = WRONG_ANSWER_VALUE
'        End If
'    Case GOOD_WEATHER_LIST_ITEM
'        If OverallWeatherTrend > CDbl(NORMAL_WEATHER) And OverallWeatherTrend <= CDbl(GOOD_WEATHER) Then
'            .WeatherOverall = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherOverall = WRONG_ANSWER_VALUE
'        End If
'    Case NORMAL_WEATHER_LIST_ITEM
'        If OverallWeatherTrend = CDbl(NORMAL_WEATHER) Then
'            .WeatherOverall = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherOverall = WRONG_ANSWER_VALUE
'        End If
'    Case BAD_WEATHER_LIST_ITEM
'        If OverallWeatherTrend < CDbl(NORMAL_WEATHER) And OverallWeatherTrend <= CDbl(BAD_WEATHER) Then
'            .WeatherOverall = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherOverall = WRONG_ANSWER_VALUE
'        End If
'    Case TERRIBLE_WEATHER_LIST_ITEM
'        If OverallWeatherTrend < CDbl(BAD_WEATHER) Then
'            .WeatherOverall = CORRECT_ANSWER_VALUE
'        Else
'            .WeatherOverall = WRONG_ANSWER_VALUE
'        End If
'End Select
