﻿Public Class frmFinalWorksheet

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Decision = MsgBox("If you Cancel the Worksheet, you will have to all start over again.  " _
                          & "Are you sure you want to stop doing the Worksheet?", MsgBoxStyle.YesNo, "Stop Doing Worksheet?")

        If Decision = MsgBoxResult.Yes Then
            WorksheetTask = END_WORKSHEET
            Me.Close()
            WorksheetOpen = False
        End If

    End Sub

    Private Sub btnViewGraph_Click(sender As System.Object, e As System.EventArgs) Handles btnViewGraph.Click

        Me.Close()
        WorksheetTask = SHOW_GRAPH

    End Sub

    Private Sub btnSubmit_Click(sender As System.Object, e As System.EventArgs) Handles btnSubmit.Click
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim Msgstr As String = ""
        Dim NumGenerations As Integer


        Decision = MsgBox("Are you sure you're done with these Questions?", MsgBoxStyle.YesNo, "Submit Answers?")

        If Decision = MsgBoxResult.Yes Then

            With WorksheetScore
                With .FinalQuestion

                    .FinalQuestionsTotal = 0 'initialize subtotal

                    ' ------------------------------
                    ' Weather Influence

                    If cmbWeatherInfluence.SelectedItem = WEATHER_MODEST_STR Then
                        .WeatherInfluenceQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .WeatherInfluenceQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .WeatherInfluenceQuestion

                    If .WeatherInfluenceQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr = "1) Correct: "
                    Else
                        Msgstr = "1) Incorrect: "
                    End If
                    Msgstr &= WEATHER_MODEST_STR & DOUBLE_SPACE

                    ' --------------------------------
                    ' Agri Level and Generations

                    NumGenerations = DetermineNumAgriRevGenerations()

                    If cmbAgriLvlGenerations.SelectedIndex = NumGenerations - 1 Then
                        .AgriLvlAndGenerationsQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .AgriLvlAndGenerationsQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .AgriLvlAndGenerationsQuestion

                    If .AgriLvlAndGenerationsQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "2) Correct: "
                    Else
                        Msgstr &= "2) Incorrect: "
                    End If
                    Msgstr &= "It took only " & CStr(NumGenerations) & " Generations for the new Agricultural Techniques and Technologies to be adopted in most of France." & DOUBLE_SPACE

                    ' -----------------------------------
                    ' Agri Level and Harvests

                    If cmbAgriLvlAndHarvests.SelectedItem = DIRECT_THEN_CONTINUE_STR Then
                        .AgriLvlAndHarvestQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .AgriLvlAndHarvestQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .AgriLvlAndHarvestQuestion

                    If .AgriLvlAndHarvestQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "3) Correct: "
                    Else
                        Msgstr &= "3) Incorrect: "
                    End If
                    Msgstr &= DIRECT_THEN_CONTINUE_STR & DOUBLE_SPACE

                    ' -----------------------------------
                    ' Peasants and Harvests

                    If cmbPeasantsAndHarvest.SelectedItem = PEASANTS_SLOWER_STR Then
                        .PeasantsAndHarvestQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .PeasantsAndHarvestQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .PeasantsAndHarvestQuestion

                    If .PeasantsAndHarvestQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "4) Correct: "
                    Else
                        Msgstr &= "4) Incorrect: "
                    End If
                    Msgstr &= PEASANTS_SLOWER_STR & DOUBLE_SPACE

                    ' -----------------------------------
                    ' Nobles and Clergy Question

                    If cmbNoblesAndClergyQuestion.SelectedItem = NC_SAME_STR Then
                        .NoblesAndClergyQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .NoblesAndClergyQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .NoblesAndClergyQuestion

                    If .NoblesAndClergyQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "5) Correct: "
                    Else
                        Msgstr &= "5) Incorrect: "
                    End If
                    Msgstr &= NC_SAME_STR & DOUBLE_SPACE

                    ' -----------------------------------
                    ' Townspeople Question

                    If cmbTownspeopleQuestion.SelectedItem = TOWNIES_FASTER_STR Then
                        .TownspeopleQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .TownspeopleQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .TownspeopleQuestion

                    If .TownspeopleQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "6) Correct: "
                    Else
                        Msgstr &= "6) Incorrect: "
                    End If
                    Msgstr &= TOWNIES_FASTER_STR & DOUBLE_SPACE

                    ' -----------------------------------
                    ' Overall Question

                    If cmbOverallQuestion.SelectedItem = THE_TOWNSPEOPLE_STR Then
                        .OverallQuestion = CORRECT_ANSWER_VALUE
                    Else
                        .OverallQuestion = WRONG_ANSWER_VALUE
                    End If
                    .FinalQuestionsTotal += .OverallQuestion

                    If .OverallQuestion = CORRECT_ANSWER_VALUE Then
                        Msgstr &= "7) Correct: "
                    Else
                        Msgstr &= "7) Incorrect: "
                    End If
                    Msgstr &= "The " & THE_TOWNSPEOPLE_STR & " grew most in Numbers and Importance between " & CStr(ScenarioStartDate)
                    Msgstr &= " and " & CStr(ScenarioEndDate) & "." & DOUBLE_SPACE

                End With ' .Final Questions
                .WorksheetTotalScore += .FinalQuestion.FinalQuestionsTotal

                Msgstr &= "Your score on the Worksheet overall is " & CStr(.WorksheetTotalScore) & " of "
                Msgstr &= CStr(TOTAL_POINTS_IN_WORKSHEET)
                Msgstr &= " Overall."

                MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Final Questions Feedback")

            End With ' WorksheetScore

            SaveWorksheet(FINAL_QUESTIONS)
            SaveGlobals("End")

            ClearFinalComboBoxes()
            WorksheetTask = END_WORKSHEET
            WorksheetOpen = False
            Me.Close()
        End If

    End Sub

    Private Sub frmFinalWorksheet_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Msgstr As String = ""

        WorksheetOpen = True

        If FinalCombosDone = False Then
            SetUpFinalControls()
            FinalCombosDone = True ' This is set to false in SocioeconomicDevelopment in prep for first time form opens, but after that shouldn't re-populate list
        End If

        'FilePath = Directory.GetCurrentDirectory & DIDACTIC_DIRECTORY & "\BordersQuestion.rtf"
        'rtbCenturyQuestions.LoadFile(FilePath, RichTextBoxStreamType.RichText)

        'lblLastCentury.Text = "Past Century (since " & CStr((TurnDate + TURN_INTERVAL) - 100) & ")"

        Msgstr = "Use the Socioeconomic Trends Graph to answer the following Questions about the Relationship of Weather Patterns, "
        Msgstr &= "changing Agricultural Techniques and Technologies, the Growth of the Food Supply, and the relative Growth "
        Msgstr &= "and changing Importance of various Classes in French society."
        rtbCenturyQuestions.Text = Msgstr

    End Sub

    Sub SetUpFinalControls()
        Dim Msgstr As String = ""

        '------ Weather Question

        Msgstr = "1) Which of the following statements best sums up the influence of the prevailing weather between "
        Msgstr &= CStr(ScenarioStartDate) & " and " & CStr(ScenarioEndDate) & "?"
        lblWeatherQuestion.Text = Msgstr

        Msgstr = WILD_FLUCTUATIONS_STR
        cmbWeatherInfluence.Items.Add(Msgstr)

        Msgstr = WEATHER_SOLE_REASON_STR
        cmbWeatherInfluence.Items.Add(Msgstr)

        Msgstr = WEATHER_MODEST_STR
        cmbWeatherInfluence.Items.Add(Msgstr)

        Msgstr = GROW_AND_CONTRACT_STR
        cmbWeatherInfluence.Items.Add(Msgstr)

        '--------- Agri Tech Diffusion

        Msgstr = "2) If a new generation takes about 25 years to grow to maturity, how many generations did it take to go from a small minority " & vbCrLf
        Msgstr &= " of the French (index <1.2) to the great majority (>1.8) using the new Agricultural technologies and techniques?"
        lblAgriLvl1.Text = Msgstr

        'cmbAgriLvlGenerations.Items.Add("One")
        'cmbAgriLvlGenerations.Items.Add("Two")
        'cmbAgriLvlGenerations.Items.Add("Three")
        'cmbAgriLvlGenerations.Items.Add("Four")
        'cmbAgriLvlGenerations.Items.Add("Five")
        'cmbAgriLvlGenerations.Items.Add("Six")
        'cmbAgriLvlGenerations.Items.Add("Seven")
        'cmbAgriLvlGenerations.Items.Add("Eight")
        'cmbAgriLvlGenerations.Items.Add("More")

        '--------- Agri Level and Harvests
        Msgstr = "3) Which of the following best describes the relationship between the changes in the Agricultural Level and the changes" & vbCrLf
        Msgstr &= "in the size of the Harvest in the Kingdom of France between " & CStr(ScenarioStartDate) & " and " & CStr(ScenarioEndDate) & "?"
        lblHarvests.Text = Msgstr

        cmbAgriLvlAndHarvests.Items.Add(DIRECT_THEN_CONTINUE_STR)
        cmbAgriLvlAndHarvests.Items.Add(INDIRECT_STR)
        cmbAgriLvlAndHarvests.Items.Add(STEADY_DIRECT_STR)
        cmbAgriLvlAndHarvests.Items.Add(INDIRECT_THEN_CONINUE_STR)

        '--------- Harvests and Peasants
        Msgstr = "4) Which of the following best describes the relationship between the changes in the size of the Harvest and changes in the " & vbCrLf
        Msgstr &= "number of Peasants in the Kingdom of France between " & CStr(ScenarioStartDate) & " and " & CStr(ScenarioEndDate) & "?"
        lblPeasantQuestion.Text = Msgstr

        cmbPeasantsAndHarvest.Items.Add(PEASANTS_FASTER_STR)
        cmbPeasantsAndHarvest.Items.Add(PEASANTS_SAME_STR)
        cmbPeasantsAndHarvest.Items.Add(PEASANTS_SLOWER_STR)
        'cmbPeasantsAndHarvest.Items.Add(PEASANTS_INDEPENDENT_STR)

        '--------- Peasants, Nobles, and Clergy
        Msgstr = "5) Which of the following best describes the relationship between the changes in the number of Peasants and changes in the " & vbCrLf
        Msgstr &= "number of Nobles and Clergy in the Kingdom of France between " & CStr(ScenarioStartDate) & " and " & CStr(ScenarioEndDate) & "?"
        lblNoblesAndClergyQuestion.Text = Msgstr

        cmbNoblesAndClergyQuestion.Items.Add(NC_FASTER_STR)
        cmbNoblesAndClergyQuestion.Items.Add(NC_SAME_STR)
        cmbNoblesAndClergyQuestion.Items.Add(NC_SLOWER_STR)
        'cmbNoblesAndClergyQuestion.Items.Add(NC_INDEPENDENT_STR)

        '--------- Townspeople
        Msgstr = "6) Which of the following best describes the relationship between the change in the number of Townspeople and change in the " & vbCrLf
        Msgstr &= "size of the other Classes in the Kingdom of France between " & CStr(ScenarioStartDate) & " and " & CStr(ScenarioEndDate) & "?"
        lblTownspeopleQuestion.Text = Msgstr

        cmbTownspeopleQuestion.Items.Add(TOWNIES_FASTER_STR)
        cmbTownspeopleQuestion.Items.Add(TOWNIES_SAME_STR)
        cmbTownspeopleQuestion.Items.Add(TOWNIES_SLOWER_STR)
        'cmbTownspeopleQuestion.Items.Add(TOWNIES_FELL_STR)

        '--------- Overall 
        Msgstr = "7) If a Class' importance in Society is related to its size relative to the total Population, which Class " & vbCrLf
        Msgstr &= "grew most in importance  in the Kingdom of France from " & CStr(ScenarioStartDate) & " to " & CStr(ScenarioEndDate) & "?"
        lblOverallQuestion.Text = Msgstr

        cmbOverallQuestion.Items.Add(THE_PEASANTS_STR)
        cmbOverallQuestion.Items.Add(THE_NOBLES_STR)
        cmbOverallQuestion.Items.Add(THE_CLERGY_STR)
        cmbOverallQuestion.Items.Add(THE_TOWNSPEOPLE_STR)

        'lblPeasantQuestion.Text = Msgstr

    End Sub

    Sub ClearFinalComboBoxes()

        cmbWeatherInfluence.Items.Clear()
        cmbWeatherInfluence.SelectedItem = NO_ITEM
        cmbWeatherInfluence.Text = NO_ITEM

        cmbAgriLvlGenerations.Items.Clear()
        cmbAgriLvlGenerations.SelectedItem = NO_ITEM
        cmbAgriLvlGenerations.Text = NO_ITEM

        cmbAgriLvlAndHarvests.Items.Clear()
        cmbAgriLvlAndHarvests.SelectedItem = NO_ITEM
        cmbAgriLvlAndHarvests.Text = NO_ITEM

        cmbPeasantsAndHarvest.Items.Clear()
        cmbPeasantsAndHarvest.SelectedItem = NO_ITEM
        cmbPeasantsAndHarvest.Text = NO_ITEM

        cmbNoblesAndClergyQuestion.Items.Clear()
        cmbNoblesAndClergyQuestion.SelectedItem = NO_ITEM
        cmbNoblesAndClergyQuestion.Text = NO_ITEM

        cmbTownspeopleQuestion.Items.Clear()
        cmbTownspeopleQuestion.SelectedItem = NO_ITEM
        cmbTownspeopleQuestion.Text = NO_ITEM

        cmbOverallQuestion.Items.Clear()
        cmbOverallQuestion.SelectedItem = NO_ITEM
        cmbOverallQuestion.Text = NO_ITEM

    End Sub

    Function DetermineNumAgriRevGenerations()
        Dim NumGens As Integer = 0
        Dim i As Integer

        For i = 0 To TurnsInScenario - 1
            If TurnRecord(i).AgriLevel < 1.8 Then
                NumGens += 1
            Else
                Exit For
            End If
        Next

        Return NumGens
    End Function

End Class