﻿Imports System.Math

Module Module3

    Sub AutoTurn()
        Dim ActionLoop As Integer = 0

        If CurrentAction = 0 Then
            DoSpecialEvents()
        End If

        For ActionLoop = CurrentAction To TotalActions - 1
            CurrentAction += 1
            ActiveGovernment = ActionQueue(ActionLoop)
            If ActiveGovernment = PlayerSide Then
                frmPlayerControls.ShowDialog()
                Exit For
            Else
                'MsgBox("The " & GetGovernmentName(ActiveGovernment) & " now active: " & CStr(TurnDate) & ", action " & CStr(CurrentAction) & " of " & CStr(TotalActions))
                AttackAI(ActiveGovernment)
                If PlayerTarget > -1 Then
                    Attack(PlayerBase, PlayerTarget)
                    'MsgBox("The " & GetGovernmentName(ActiveGovernment) & " have decided to attack " & Province(PlayerTarget).Name & " from " & Province(PlayerBase).Name)
                Else
                    NegotiateAI(ActiveGovernment)
                End If
            End If

        Next

        If CurrentAction = TotalActions Then
            Try
                WrapUpTurn()
                If TurnDate < ScenarioEndDate - TURN_INTERVAL Then
                    BeginTurn()
                Else
                    'If WorksheetGame - True Then ' don't need this because last worksheet comes at beginning of turn
                    '    frmBeginTurn.Show()
                    'End If
                    EndGame()

                    If WorksheetGame = True Then
                        PlayerAction = DOING_WORKSHEET

                        ActionPhase = FINAL_QUESTIONS

                        FinalCombosDone = False ' so they'll be set up on first opening of form
                        PopulateTurnDisplay(TurnNum)


                        Do
                            WorksheetTask = SHOW_WORKSHEET
                            frmFinalWorksheet.ShowDialog()
                            'FinalCombosDone = True ' This is set in form itself once they're set up

                            If WorksheetTask = SHOW_GRAPH Then
                                frmBeginTurn.ShowDialog()
                            End If

                        Loop Until (WorksheetTask = END_WORKSHEET)
                        FinalCombosDone = False ' reset this just in case worksheet called from elsewherew

                    End If

                    End 'Program end

                    End If
            Catch
                MsgBox("Problem Advancing Turn")
            End Try

        End If

    End Sub


    Sub WrapUpTurn()
        Dim ProvinceNum As Integer
        Dim NameString As String
        Dim StrLength As Integer
        Dim IsLastProvince As Boolean = False
        Dim Rand As New Random
        Dim DieRoll As Integer = -1
        'Dim Size As Integer
        Dim i As Integer = 0
        Dim AdminLoad(TotalGovernments - 1) As Integer

        For i = 1 To TotalGovernments - 1
            AdminLoad(i) = TotalProvincesControlled(i)
        Next

        Randomize()

        For ProvinceNum = 0 To TotalProvinces - 1

            Province(ProvinceNum).TimesTaxed = 0

            Province(ProvinceNum).HarvestActual = 0 '0 this out now so if peaceful migration in, the migrants' harvests will be counted
            If Province(ProvinceNum).SurplusPopulation > 0 Then

                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                    MsgBox("Famine in " & Province(ProvinceNum).Name & "!  " & Province(ProvinceNum).SurplusPopulation & ",000 people died.")
                End If 'player knows

                Province(ProvinceNum).SurplusPopulation = 0
                DecrementSocialState(ProvinceNum, CHAOS)
                If Province(ProvinceNum).PoliticalAffiliation > LOCAL_CONTROL Then
                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                        NameString = Government(Province(ProvinceNum).PoliticalAffiliation).Name
                        MsgBox("Support for the Government of " & NameString & " has declined in " _
                               & Province(ProvinceNum).Name & " because of its inability to secure new lands for its people.")
                        DecrementSocialState(ProvinceNum, CHAOS)
                        DecrementSocialVPs(SOCIAL_STATE_VP_VALUE)
                    End If 'is player's concern
                    DecrementProvincialLoyalty(ProvinceNum)
                End If
            End If

            If Province(ProvinceNum).Language \ 100 <> 1 And Province(ProvinceNum).Language \ 100 <> 3 Then 'if people aren't Latin speakers or Greek (ie, not used to civ)
                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    DieRoll = Rand.Next(0, 3)
                    If DieRoll > AdminLoad(Province(ProvinceNum).PoliticalAffiliation) Then
                        DecrementProvincialLoyalty(ProvinceNum)
                    End If
                End If

                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    If Government(Province(ProvinceNum).PoliticalAffiliation).Name <> AVARS_STR Then
                        DieRoll = Rand.Next(0, 6)
                        If DieRoll < (Province(ProvinceNum).Farmland \ BASE_PROVINCE_SIZE) \ 2 Then
                            DecrementProvincialLoyalty(ProvinceNum)
                        End If
                    End If
                End If

                If Province(ProvinceNum).Loyalty > REBELLIOUS Then
                    DieRoll = Rand.Next(0, 6)
                    If DieRoll >= Province(ProvinceNum).Loyalty + 2 Then
                        DecrementProvincialLoyalty(ProvinceNum)
                    End If
                End If
            End If

            If Province(ProvinceNum).Loyalty = REBELLIOUS Then ' *** Turned off for db Development ' remember will 
                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                    NameString = Government(Province(ProvinceNum).PoliticalAffiliation).Name
                    StrLength = NameString.Length
                    MsgBox(Province(ProvinceNum).Name & " has broken free from " & NameString) '.Substring(4, StrLength - 4))
                    DecrementConquestVPs(ProvinceNum)

                    'ConquestVPs -= PROVINCE_VP_VALUE
                    'RefreshConquestVP_Display()
                End If 'player cares

                If Province(ProvinceNum).PoliticalAffiliation > LOCAL_CONTROL Then
                    IsLastProvince = CheckIfGovernmentEliminated(Province(ProvinceNum).PoliticalAffiliation)
                    If IsLastProvince Then
                        ClearOutLoser(Province(ProvinceNum).PoliticalAffiliation)
                    End If
                    Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL
                End If

            End If ' is REBELLIOUS

        Next 'Province

        Autosave()

    End Sub

    Function CreateActionQueue() As Integer
        Dim GovernmentNum As Integer = 0
        Dim Rand As New Random
        'Dim DieRoll As Integer = 0
        Dim Actions(TotalGovernments - 1) As Integer
        Dim TotalActions As Integer = 0
        Dim ActionRound As Integer = 0
        Dim MostActions As Integer = 0
        Dim ActionNumber As Integer = 0
        Dim DieRoll1 As Integer = -1
        Dim DieRoll2 As Integer = -1

        Randomize()

        Actions(0) = 0 'make sure first value in array is 0 because it's the Local gvts

        For GovernmentNum = 1 To TotalGovernments - 1 ' don't do 0 because that's Locals
 
            DieRoll2 = Rand.Next(1, 4) ' was 5) but decreased to avoid > 11 and run off action queue building range (not use 10 and 11)

            If GovernmentNum = FRANCE Then ' to give French a boost because they do stuff others don't have to
                DieRoll2 += 2
            End If

            Actions(GovernmentNum) = DieRoll2 + Government(GovernmentNum).LeadershipState * 3 'reduced from 4 for same reason; alternative is revise lookup table to include 12

            TotalActions += Actions(GovernmentNum)
            Try
                If Actions(GovernmentNum) > MostActions Then
                    MostActions = Actions(GovernmentNum)
                End If
            Catch
                MsgBox("Problem Setting Up Action Sequence")
            End Try
        Next

        ReDim ActionQueue(TotalActions - 1)
        ActionNumber = 0

        If MostActions > 0 Then
            For ActionRound = 1 To MostActions
                For GovernmentNum = 1 To TotalGovernments - 1
                    If CheckIfActs(ActionRound, MostActions, Actions(GovernmentNum)) Then
                        ActionQueue(ActionNumber) = GovernmentNum
                        ActionNumber += 1
                    End If

                Next
            Next
        Else
            MsgBox("No state stable enough to undertake significant actions.")
        End If

        'MsgBox("Action Queue Created")


        Return TotalActions

    End Function

    Function CheckIfActs(ByVal Round As Integer, ByVal TotalRounds As Integer, ByVal TotalGvtActions As Integer) As Boolean
        Dim Acts As Boolean = False

        Select Case Round
            Case 1
                Select Case TotalRounds
                    Case 1
                        If TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 2
                        If TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions <= 7 And TotalGvtActions >= 4 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions <= 8 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions <= 10 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions <= 11 And TotalGvtActions >= 6 Then
                            Acts = True
                        End If
                End Select
            Case 2
                Select Case TotalRounds
                    Case 1
                    Case 2
                        If TotalGvtActions = 2 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 3
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                        If TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                End Select
            Case 4 ' Current Round of
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                        If TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                End Select
            Case 5 'current round of 
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                        If TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 6
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                        If TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 7
                        If TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Or TotalGvtActions = 1 Then
                            Acts = True
                        End If
                End Select
            Case 7
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                        If TotalGvtActions <= 7 And TotalGvtActions >= 4 Then
                            Acts = True
                        End If
                    Case 8
                        If TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 8
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                        If TotalGvtActions <= 8 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 6 Or TotalGvtActions = 5 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 2 Then
                            Acts = True
                        End If
                End Select
            Case 9
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                        If TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 10
                        If TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 7 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 7 Or TotalGvtActions = 6 Or TotalGvtActions = 3 Then
                            Acts = True
                        End If
                End Select
            Case 10
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                    Case 10
                        If TotalGvtActions <= 10 And TotalGvtActions >= 5 Then
                            Acts = True
                        End If
                    Case 11
                        If TotalGvtActions = 11 Or TotalGvtActions = 10 Or TotalGvtActions = 9 Or TotalGvtActions = 8 Or TotalGvtActions = 5 Or TotalGvtActions = 4 Then
                            Acts = True
                        End If
                End Select
            Case 11 ' current round, it's the highest, so only possibility
                Select Case TotalRounds
                    Case 1
                    Case 2
                    Case 3
                    Case 4
                    Case 5
                    Case 6
                    Case 7
                    Case 8
                    Case 9
                    Case 10
                    Case 11
                        If TotalGvtActions <= 11 And TotalGvtActions >= 6 Then
                            Acts = True
                        End If
                End Select
        End Select

        Return Acts

    End Function


    Function CalculateTotalBenefices(ByVal ProvinceNumber As Integer) As Integer
        Dim TotalBenefices As Integer = 0

        TotalBenefices = Province(ProvinceNumber).Peasants \ PEASANTS_PER_BENEFICE

        Return TotalBenefices

    End Function

    Function CalculateRoyalEstates(ByVal ProvinceNumber As Integer)
        Dim RoyalEstates As Integer = 0

        RoyalEstates = CalculateTotalBenefices(ProvinceNumber) = Province(ProvinceNumber).Nobles + Province(ProvinceNumber).Clergy

        Return RoyalEstates

    End Function

    Sub CalcGovernmentResources()
        Dim ProvinceNum As Integer = 0
        Dim Suzarien As Integer = 0
        Dim MsgStr As String = "Problem with Calculating Income from Desmene"
        Dim Demesne As Integer = 0
        Dim PlayerDemesne As Integer = 0

        For Suzarien = 0 To TotalGovernments - 1
            If Government(Suzarien).Name <> ELIMINATED_POWER_STRING Then
                Government(Suzarien).TotalBenefices = 0
                Government(Suzarien).RoyalEstates = 0
                Government(Suzarien).Cavalary = 1
            End If
        Next

        For ProvinceNum = 0 To TotalProvinces - 1
            Suzarien = Province(ProvinceNum).PoliticalAffiliation

            If Suzarien > 0 Then
                If ProvinceNum = Government(Suzarien).Capitol Then
                    Demesne = DetermineTaxBase(ProvinceNum)
                    If Suzarien = FRENCH Then
                        PlayerDemesne = Demesne
                    End If
                    Government(Suzarien).Treasury += Demesne
                    Province(ProvinceNum).TimesTaxed = 1
                    Government(Suzarien).TotalBenefices += CalculateTotalBenefices(ProvinceNum)
                    Government(Suzarien).RoyalEstates += CalculateRoyalEstates(ProvinceNum)
                    'Government(Suzarien).Infantry += Government(Suzarien).TotalBenefices - Province(ProvinceNum).Nobles + Province(ProvinceNum).Peasants Mod 25
                End If
                Government(Suzarien).Cavalary += GetLocalKnights(ProvinceNum)
            End If

        Next

        MsgStr = "Your Treasury gained " & CStr(PlayerDemesne) & ",000 " & CurrencyStr & " from your Familial Landholdings around Paris."

    End Sub

    Sub DetermineLeadershipStates()
        Dim GovernmentNum As Integer = 0
        Dim DieRoll1 As Integer = 0
        Dim DieRoll2 As Integer = 0
        Dim Rand As New Random
        Dim SpecialLeader As Integer = UNDEFINED
        Dim SpecialGeneral As Integer = UNDEFINED
        Dim SpecialPolitician As Integer = UNDEFINED
        Dim SpecialPatron As Integer = UNDEFINED
        Dim SpecialAdmin As Integer = UNDEFINED

        Randomize()

        For GovernmentNum = 1 To TotalGovernments - 1

            SpecialLeader = DetermineIfSpecialLeader(GovernmentNum)
            If SpecialLeader = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 11)
                Select Case DieRoll1
                    Case 1, 2, 3, 4, 5
                        Government(GovernmentNum).LeadershipState = DISARRAY
                    Case 6, 7, 8, 9, 10
                        Government(GovernmentNum).LeadershipState = LACKLUSTER
                        'Case 10 
                        '    Government(GovernmentNum).LeadershipState = VIGOROUS ' especially
                        'Case Else
                        '    Government(GovernmentNum).LeadershipState = 3 ' this is in case add bonus for develop bureaucracy

                        ' or can add even more, or make 1, 2, 3 = Dim BaseLeadershipState = 0, BaseLeadershipState + 1
                End Select
                'If GovernmentNum = FRANCE Then
                '    Government(GovernmentNum).LeadershipState += 1 'special bonus for French since they have to do stuff others don't
                'End If
            Else
                Government(GovernmentNum).LeadershipState = SpecialLeader
            End If

            SpecialGeneral = DetermineIfSpecialGeneral(GovernmentNum)
            If SpecialGeneral = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    'Case 1
                    '    Government(GovernmentNum).Generalship = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).Generalship = INEPT
                    Case 1, 5, 6, 7, 8, 9, 10, 14
                        Government(GovernmentNum).Generalship = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).Generalship = TALENTED
                        'Case 14
                        '    Government(GovernmentNum).Generalship = GENIUS
                End Select
            Else
                Government(GovernmentNum).Generalship = SpecialGeneral
            End If

            SpecialPolitician = DetermineIfSpecialPolitician(GovernmentNum)
            If SpecialPolitician = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    'Case 1
                    '    Government(GovernmentNum).PoliticalSavvy = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).PoliticalSavvy = INEPT
                    Case 1, 5, 6, 7, 8, 9, 10, 14
                        Government(GovernmentNum).PoliticalSavvy = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).PoliticalSavvy = TALENTED
                        'Case 14
                        '    Government(GovernmentNum).PoliticalSavvy = GENIUS
                End Select
            Else
                Government(GovernmentNum).PoliticalSavvy = SpecialPolitician
            End If


            SpecialPatron = DetermineIfSpecialPatron(GovernmentNum)
            If SpecialPatron = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    'Case 1
                    '    Government(GovernmentNum).LeadershipState = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).Refinement = INEPT
                    Case 1, 5, 6, 7, 8, 9, 10, 14
                        Government(GovernmentNum).Refinement = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).Refinement = TALENTED
                        'Case 14
                        '    Government(GovernmentNum).LeadershipState = GENIUS
                End Select
            Else
                Government(GovernmentNum).Refinement = SpecialPatron
            End If

            DetermineIfSpecialAdministrator(GovernmentNum)
            If SpecialAdmin = UNDEFINED Then
                DieRoll1 = Rand.Next(1, 15)
                Select Case DieRoll1
                    'Case 1
                    '    Government(GovernmentNum).AdminAbility = DISASTROUS
                    Case 2, 3, 4
                        Government(GovernmentNum).AdminAbility = INEPT
                    Case 1, 5, 6, 7, 8, 9, 10, 14
                        Government(GovernmentNum).AdminAbility = MEDIOCRE
                    Case 11, 12, 13
                        Government(GovernmentNum).AdminAbility = TALENTED
                        'Case 14
                        '    Government(GovernmentNum).Adminability = GENIUS
                End Select
            Else
                Government(GovernmentNum).AdminAbility = SpecialAdmin
            End If

        Next

    End Sub

    Function DetermineIfSpecialLeader(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate

            Case ScenarioStartDate '975
                IsSpecial = DISARRAY

            Case ScenarioStartDate + TURN_INTERVAL ' 1000
                IsSpecial = DISARRAY

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025
                IsSpecial = DISARRAY

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If
            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225
                If GovNum = FRANCE Then
                    IsSpecial = VIGOROUS
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250
                If GovNum = FRANCE Then
                    IsSpecial = LACKLUSTER
                End If

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275

        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialGeneral(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate

            Case ScenarioStartDate '975

            Case ScenarioStartDate + TURN_INTERVAL ' 1000

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125
                IsSpecial = INEPT

            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175
                ' Rise of heresy in south
            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200
                IsSpecial = GENIUS
                ' Albegenisain crusade begins, but without King

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225
                ' Albegensian Crusade

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275

        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialPolitician(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate

            Case ScenarioStartDate '975

            Case ScenarioStartDate + TURN_INTERVAL ' 1000

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175

            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275

        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialAdministrator(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate

            Case ScenarioStartDate '975

            Case ScenarioStartDate + TURN_INTERVAL ' 1000

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150
                IsSpecial = TALENTED

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175

            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275

        End Select

        Return IsSpecial

    End Function

    Function DetermineIfSpecialPatron(ByVal GovNum As Integer) As Integer
        Dim IsSpecial As Integer = UNDEFINED

        Select Case TurnDate

            Case ScenarioStartDate '975

            Case ScenarioStartDate + TURN_INTERVAL ' 1000

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100
                IsSpecial = GENIUS

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125
                IsSpecial = GENIUS

            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175

            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275

        End Select

        Return IsSpecial

    End Function

    Sub DoSpecialEvents()
        Dim WifeRepudiated As Boolean = True

        Select Case TurnDate

            Case ScenarioStartDate '975 - 1000
                ' first marraige problems Robert Capet, second king in line, repudiates wife; trouble with Pope, excommunicated

            Case ScenarioStartDate + TURN_INTERVAL ' 1000 - 1025
                WifeRepudiated = DoMarriageProblems()
                ' Peace of God Movement; Jones 84
                ' England and Norway become Danish

            Case ScenarioStartDate + TURN_INTERVAL * 2 ' 1025 - 1050
                ' Truce of God Movement; Jones, 85
                ' England and Norway stop being Danish
                ' Umayyads disintegrate in Spain
                ' Morocco, Algeria, and Tunisia become Independent; break from Shia
                ' Fatamids only = Egypt and Levant

            Case ScenarioStartDate + TURN_INTERVAL * 3 ' 1050 - 1075
                AlmovoradsReplaceUmayyads()
                ' Poitou, Aquitaine, and Guyenne merged
                ' Normans conquor England
                ' Normans take Naples
                ' Almovorads, fanatical, take Morocco

            Case ScenarioStartDate + TURN_INTERVAL * 4 ' 1075 - 1100
                DoManzikert()
                ' second king repudiates wife (for love, not kids), excommunicated
                ' Seljuk Turks appear, take Turkey and Levant
                ' Leon takes Castile
                ' Almovorads take Southern Spain (Grenada, Portugual, Castile)
                ' Normans take Sicily

            Case ScenarioStartDate + TURN_INTERVAL * 5 ' 1100 - 1125
                WifeRepudiated = DoMarriageProblems()
                ' Marriage annulled legally by Church Council
                    ' 1st Crusade Start; Goubert, 17? Jones, 85
                    ' Louis the Fat allies with towns; Goubert, 17
                    ' Almovorads take Saragossa
                    ' England take Wales effectively

            Case ScenarioStartDate + TURN_INTERVAL * 6 ' 1125 - 1150
                WifeRepudiated = DoMarriageProblems()
                If Province(NORMANDY).PoliticalAffiliation <> ENGLAND Then
                    TransferProvince(NORMANDY, ENGLAND)
                    'Province(NORMANDY).PoliticalAffiliation = ENGLAND
                    'Province(NORMANDY).ControlLevel = 0
                    'Province(NORMANDY).Loyalty = INDIFFERENT
                    MsgBox("The English have Captured Normandy!")
                End If
                ' Repudiate Wife (end)? - Louis VII and Eleanore  -- Louis cultivated learning and made stone fortresses; alliance with church strengthened administration
                ' English take Normandy if not already 
                ' Crusaders take Levant; Chaos
                ' Turkey = Chaos and Political disunion
                ' Barcelona and Provence united
                ' England a naval power by now

            Case ScenarioStartDate + TURN_INTERVAL * 7 ' 1150 - 1175
                WifeRepudiated = DoMarriageProblems()
                DoAngevinEmpire(WifeRepudiated)
                ' Repudiate Wife (beginning) ? - this is Eleanor
                ' England gets Aquitaine, Gascony, Anjou, Normandy, Avergne, Berry, Bearn
                ' Gothic architecture starts
                ' Almohad's take Morocco, Grenada, Castile?, Algeria, Tunesia
                ' Zangids take Egypt and Libya
                ' Germans and Danes Crusade North-East 
                ' Norman Sicily becomes K of Sicily

            Case ScenarioStartDate + TURN_INTERVAL * 8 ' 1175 - 1200
                ' Third Crusade
                ' Expulsion of Jews
                ' many Baliff's installed
                ' Notre Dame started
                ' Paris walls built
                ' crown revinues up 80%
                ' Portugual becomes Kingdom; Spain basically Portugual, Castile, Navarre, and Aragon

            Case ScenarioStartDate + TURN_INTERVAL * 9 ' 1200 -1225
                DoMarriageProblems()
                ' inherit Artois, part of Picardy
                ' repudiate wife? short time, => Papal Interdict
                ' Jews invited back
                ' start using mercenaries
                ' University of Paris starts
                ' crown revinues 80% higher than 1175
                ' start installing  baliffs
                ' Latin Empire takes Byzantine Greece
                ' Venice gets Illyria
                ' Ayyubid takes Egypt and Libya
                ' Balkans local control

            Case ScenarioStartDate + TURN_INTERVAL * 10 ' 1225 - 1250
                DoAlbegensianCrusade()
                ' special tax on clergy to support Albegensian crusade
                ' big resistance in Languedoc (ince. Toulouse, Avergne)
                ' use of misi dominici by Louis IX
                ' kings assert power to legislate
                ' Artois, Anjou, Maine, Poitou, and Auvergne made appenages; first two remain autonomous many centuries
                ' Arabs (Almohads) only have Grenada in Spain
                ' Greece local
                ' Mongols rule Levant and Turkey
                ' HRE vs. Popes in Italy

            Case ScenarioStartDate + TURN_INTERVAL * 11 ' 1250 - 1275
                ' partial expulsion of Jews (Wikipedia, Hist of Jews in France)
                ' Parlement established
                ' Livre Tournaise introduced 
                ' Mongols take Levant, Russia
                ' Mamelukes take Egypt & Libya
                ' Morocco, Algeria, Tunesia, and Grenada all independent
                ' Pope offers HRE to French king, his brother takes Sicily, Papal states become independent

            Case ScenarioStartDate + TURN_INTERVAL * 12 ' 1275 - 1300
                ' Crown gets upper Languedoc (Toulouse, Avergne) - which had been conquored but then = apernage after Albegensian Crusade; Gou, 24
                ' Poitou reverts to Crown
                ' local law codes codified
                ' atttempt to tax clergy leads to breach with Papacy
                ' Germans cease trying to control Italy
                ' England completes absorption of Wales
                ' France gets Navarre and Champagne by marriage
        End Select

        'Case 1300 - 1325
        ' 3 Estates first called together
        ' Famines
        ' first permanent taxes submitted to Estates, on merchandise and non-performance of military duty
        ' Knights Templars crushed and money confiscated

    End Sub

    Sub DoAlbegensianCrusade()
        Dim MsgStr As String = ""
        Dim i As Integer = 0


        MsgStr = "The Albegensian Heresy in Languedoc, Toulouse, and Rousillon has grown to Epidemic Proportions.  "
        MsgStr = "Reminding your King that he is Sworn to Uphold the Faith by his very Coronation Oath, the Pope is calling for a Crusade against them!  "

        For i = 14 To 16
            Province(i).Religion = ALBEGENSIAN 'Avergne
            Province(i).PoliticalAffiliation = LOCAL_CONTROL
            If Province(i).ControlLevel > INDEPENDENT Then
                Province(i).ControlLevel = AUTONOMOUS
                Province(i).Loyalty = DISENCHANTED
            Else
                Province(i).Loyalty = SUPPORTIVE
            End If
        Next

        ' 14, Languedoc, 15, Rousillon; 16, Toulouse;
    End Sub

    Sub DoAngevinEmpire(Repudiated)
        Dim Msgstr As String = ""

        Msgstr = "The King of England has Inherited Artois and Allied with Brittany." & DOUBLE_SPACE
        TransferProvince(65, ENGLAND) 'Artois
        TransferProvince(3, ENGLAND) ' Brittany

        If Repudiated = True Then
            Msgstr &= vbCrLf
            Msgstr &= "And by Marrying the Eleanor of Aquitaine, the recently repudiated Queen of France, he has acquired Control of: " & DOUBLE_SPACE
            If Province(4).PoliticalAffiliation <= FRANCE Then
                TransferProvince(4, ENGLAND) ' Poitou
                Msgstr &= Province(4).Name & vbCrLf
            End If
            If Province(11).PoliticalAffiliation <= FRANCE Then
                TransferProvince(11, ENGLAND) ' Avegnon
                Msgstr &= Province(11).Name & vbCrLf
            End If
            If Province(17).PoliticalAffiliation <= FRANCE Then
                TransferProvince(17, ENGLAND) 'Bearn
                Msgstr &= Province(17).Name & vbCrLf
            End If
            If Province(18).PoliticalAffiliation <= FRANCE Then
                TransferProvince(18, ENGLAND) ' Guyenne
                Msgstr &= Province(18).Name & vbCrLf
            End If
            If Province(19).PoliticalAffiliation <= FRANCE Then
                TransferProvince(19, ENGLAND) ' Aquataine
                Msgstr &= Province(19).Name & vbCrLf
            End If
        End If

        MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Angevin Empire")

    End Sub

    Sub TransferProvince(ByVal ID As Integer, ByVal ToWho As Integer)

        Province(ID).PoliticalAffiliation = ToWho
        Province(ID).ControlLevel = 0
        Province(ID).Loyalty = INDIFFERENT

    End Sub

    Sub DoManzikert()

        NewPeoples()
        MsgBox("The Seljuk Turks have Overrun Turkey and the Levant, dealing Christian Byzantium a devastating blow!")

    End Sub

    Sub AlmovoradsReplaceUmayyads()
        Dim i As Integer = 0

        MsgBox("The Umayyad Dynasty collapsed, and has been replaced by the Almorovids.")
        Government(8).Name = "Almorovads"
        Government(8).Generalship = TALENTED

    End Sub

    Function DoMarriageProblems() As Boolean
        Dim MsgStr As String = "Problem with Marriage Problems"
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim i As Integer = 0
        Dim Repudiated As Boolean = True

        MsgStr = "The Royal couple have proved unable to produce an Heir.  "
        MsgStr &= "Without one, the Dynasty's hold on the Throne will be thrown into Jeopardy!  "
        MsgStr &= "The traditional Solution is for the King to repudiate the current Queen and pick a New Wife, but "
        MsgStr &= "the Catholic Church adamently opposes this practice.  However, a Politically Savvy King "
        MsgStr &= "may be able to negotiate an Annulment." & DOUBLE_SPACE
        MsgStr &= "Should the King Repudiate the Queen and hope for an annulment while taking a new Wife?" & DOUBLE_SPACE

        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Repudiate Queen?")

        If Decision = MsgBoxResult.Yes Then
            Repudiated = True
            DieRoll = Rand.Next(0, 7)
            If Government(FRANCE).PoliticalSavvy + 2 > DieRoll Then
                MsgBox("After intense Negotiations, the Pope agreed to Annul the King's First Marriage, and the new Queen has produced an Heir.")
            Else
                MsgBox("The new Queen has produced an Heir, but the Cost is that the Church has become Hostile to the Dynasty.")
                Government(FRANCE).DiplomaticRelations(THE_PAPACY) = HOSTILE
            End If
        Else
            Repudiated = False
            DieRoll = Rand.Next(0, 4)
            If DieRoll = 0 Then
                MsgBox("Much to the relief of all concerned, the Queen produced an Heir and a Crisis was averted.")
            Else
                MsgStr = "The Queen proved Unable to produce an Heir, and a Succession Crisis occurred." & DOUBLE_SPACE
                MsgStr &= "Loyalty to the Crown decreased in all Provinces Controlled by it or Formally Affiliated with it."
                MsgBox(MsgStr)
                For i = 0 To TotalProvinces - 1
                    If Province(i).PoliticalAffiliation = FRANCE Or (Province(i).PoliticalAffiliation = LOCAL_CONTROL And Province(i).FormalAffiliation = FRANCE) Then
                        If Province(i).ControlLevel = INDEPENDENT Then
                            IncrementProvincialLoyalty(i)
                        Else
                            DecrementProvincialLoyalty(i)
                            If Province(i).Loyalty = REBELLIOUS Then
                                DecrementControlLevel(i)
                                MsgBox("The Relationship of " & Province(i).Name & " to the Kingdom declined to " & NameControlLevel(Province(i).ControlLevel) & ".")
                            End If
                        End If
                    End If
                Next
            End If
        End If

        Return Repudiated

    End Function

    '*******  NOTE: These are from above, but from Clovis scenario, and are on a 20 year cycle! ********
    'Case 500  NOTE: these are from Clovis s
    '    If GovNum = FranksID Then 'Clovis continued
    '        IsSpecial = VIGOROUS
    '    End If
    '    If GovNum = EasternEmpireID Then 'E Empire stirs
    '        IsSpecial = LACKLUSTER
    '    End If
    'Case 520
    '    If GovNum = FranksID Then 'Clovis' sons, who cooperated, beat Burgundians (keep from being disarray)
    '        IsSpecial = LACKLUSTER
    '    End If
    '    If GovNum = EasternEmpireID Then 'Justinian
    '        IsSpecial = VIGOROUS
    '    End If
    'Case 540
    '    If GovNum = EasternEmpireID Then 'Justinian
    '        IsSpecial = VIGOROUS
    '    End If
    'Case 560
    '    If GovNum = FranksID Then
    '        IsSpecial = DISARRAY
    '    End If
    'End Select
    'Select Case TurnDate
    '    Case 500 'Clovis
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '        If GovNum = EasternEmpireID Then
    '            IsSpecial = TALENTED
    '        End If
    '    Case 520 'Clovis's sons
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = TALENTED
    '        End If
    '        If GovNum = EasternEmpireID Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 540
    '        If GovNum = EasternEmpireID Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 720 'Charles Martel
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 720 'Charles Martel
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 760 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 780 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 800 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    'End Select

    'Select Case TurnDate
    '    Case 500
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = TALENTED
    '        End If
    '    Case 520
    '        If GovNum = EasternEmpireID Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 720 'Charles Martel
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 740 'Pepin the Younger
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 760 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 780 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 800 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    'End Select
    'Select Case TurnDate
    '    Case 760 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 780 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '    Case 800 'Charlemagne
    '        If Government(GovNum).Name = FrankishStr Then
    '            IsSpecial = GENIUS
    '        End If
    '        'Case 500
    '        'If GovNum = FRANKISH Then
    '        '    IsSpecial = True
    '        'End If
    'End Select



    'Function GetProvincialMilitia(ByVal ProvinceNum As Integer) As Integer
    '    Dim Strength As Integer = 0
    '    Dim FreePeasants As Integer = 0
    '    Dim Militia As Integer = 0
    '    Dim LocalNobles As Integer = 0

    '    FreePeasants = Province(ProvinceNum).Peasants - ((PEASANTS_PER_BENEFICE * Province(ProvinceNum).Nobles) + (PEASANTS_PER_BENEFICE * Province(ProvinceNum).Clergy))
    '    If FreePeasants < PEASANTS_PER_BENEFICE Then ' if residual unfree, don't count them as free
    '        FreePeasants = 0
    '    End If

    '    Militia = FreePeasants \ WARRIOR_RATIO

    '    ' need to insure that there's at least one defender, and if there are no local nobles, it's the local militia
    '    If Militia = 0 And Province(ProvinceNum).Nobles = 0 Then
    '        Militia = 1
    '    End If

    '    Return Militia

    'End Function

    'Function GetLocalKnights(ByVal ProvinceNum As Integer) As Integer ' NOTE that this returns 10x the number in standard game units (so 6 = .6)
    '    Dim LocalKnights As Integer

    '    LocalKnights = 10 * Province(ProvinceNum).Nobles / WARRIOR_RATIO 'SHOULDN'T THIS BE \, NOT *?? '* 30 \ WARRIOR_RATIO

    '    ' need to insure that there's at least one defender, and if there are any local nobles, it'll be them
    '    If LocalKnights = 0 And Province(ProvinceNum).Nobles > 0 Then
    '        LocalKnights = 1
    '    End If

    '    Return LocalKnights

    'End Function

    Sub SetActionTarget(sender As Object)
        Dim Decision As Microsoft.VisualBasic.MsgBoxResult
        Dim TargetTextbox As System.Windows.Forms.TextBox
        'Dim CurrentFont As System.Drawing.Font
        Dim Relations As Integer = UNDEFINED
        Dim MsgStr As String = ""
        Dim Rand As New Random
        Dim DieRoll As Integer = 0
        Dim OtherPower As Integer = 0
        Dim ProvincesControlled As Integer = 0

        Select Case PlayerAction

            Case ATTACKING
                Select Case ActionPhase

                    Case DESIGNATE_ACTION_TARGET
                        If SelectedType = LAND Then
                            If Province(SelectedArea).PoliticalAffiliation <> ActiveGovernment Then
                                If SeeIfNeighbor(SelectedArea, ActiveGovernment) Then
                                    If Province(SelectedArea).FormalAffiliation <> ActiveGovernment Or Province(SelectedArea).ControlLevel <> AUTONOMOUS Then
                                        OtherPower = Province(SelectedArea).PoliticalAffiliation
                                        Relations = Government(ActiveGovernment).DiplomaticRelations(OtherPower)
                                        If Relations > HOSTILE Then
                                            MsgStr = "Your relations with " & Government(OtherPower).Name
                                            MsgStr &= " are currently " & DescribeDiploRelations(ActiveGovernment, OtherPower) & vbCrLf & vbCrLf
                                            MsgStr &= "If you attack when Relations are better than Hostile, you will damage your Reputation, making it harder to come to agreements with other Powers in the future, "
                                            MsgStr &= "and possibly strengthen the resolve of the " & Government(OtherPower).Name & " army." & vbCrLf & vbCrLf
                                            MsgStr &= "To avoid this, you can create a Dispute that will reduce your Relations to Hostile, but it will delay your Attack." & vbCrLf & vbCrLf
                                            MsgStr &= "DO YOU WANT TO SWITCH FROM ATTACKING TO CREATING A DISPUTE?" & vbCrLf & vbCrLf
                                            MsgStr &= "Click YES to Create a Dispute instead of Attacking; click NO to continue with the Attack; click Cancel to do something else entirely."
                                            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Betray " & Government(Province(SelectedArea).PoliticalAffiliation).Name & "?")
                                            Select Case Decision
                                                Case MsgBoxResult.Yes
                                                    AdjustDiploRelates(ActiveGovernment, OtherPower, HOSTILE)
                                                    MsgBox("Your provocations have worked; relations between " & Government(ActiveGovernment).Name & " and " & Government(OtherPower).Name & _
                                                           " have become Hostile.")
                                                    ConcludeAction()
                                                    Exit Sub
                                                Case MsgBoxResult.No
                                                    Randomize()
                                                    DieRoll = Rand.Next(0, Relations + 2) 'NOTE that this assumes 3 levels of relations only; will have to be adjusted for 5
                                                    If DieRoll > 0 Then
                                                        IncrementArmyState(OtherPower)
                                                    End If
                                                    DecrementReputation(ActiveGovernment, Relations - HOSTILE)
                                                    AdjustDiploRelates(ActiveGovernment, OtherPower, HOSTILE)
                                                Case MsgBoxResult.Cancel
                                                    CancelAction()
                                                    Exit Sub
                                            End Select
                                        End If
                                    Else ' above, if it's not French or is but is Independent; below, if it's an autonomous province of France
                                        MsgStr = Province(SelectedArea).Name & " is an Autonomous Province of France.  "
                                        MsgStr &= "If you attack without Legal Justification, the Other Provinces of France will fear you as a Tyrant and their Loyalty to the Kingdom will decrease. " & DOUBLE_SPACE
                                        MsgStr &= "To avoid this, you need to bring and substantiate Charges of Perfidy against the Provincial Government, but it will delay your Attack." & DOUBLE_SPACE
                                        MsgStr &= "DO YOU WANT TO SWITCH FROM ATTACKING TO BRINGING CHARGES?" & DOUBLE_SPACE
                                        MsgStr &= "Click YES to Bring Charges instead of Attacking." & vbCrLf
                                        MsgStr &= "Click NO to continue with the Attack." & vbCrLf
                                        MsgStr &= "Click Cancel to do something else entirely."

                                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Bring Charges?")

                                        If Decision = MsgBoxResult.Cancel Then
                                            CancelAction()
                                            Exit Sub
                                        Else ' if wants to proceed with attack or inquest
                                            If Decision = MsgBoxResult.Yes Then
                                                DieRoll = Rand.Next(0, 13) - 6

                                                MsgStr = "Given your King's " & GetAbilityNames(Government(ActiveGovernment).AdminAbility) & " Administrative Ability and His "
                                                MsgStr &= GetAbilityNames(Government(ActiveGovernment).AdminAbility) & " Political Savvy plus " & Province(SelectedArea).Name & "'s "
                                                MsgStr &= NameLoyaltyLevel(Province(SelectedArea).Loyalty) & " Loyalty, "

                                                If DieRoll < Government(ActiveGovernment).AdminAbility + Government(ActiveGovernment).PoliticalSavvy - Province(SelectedArea).Loyalty Then
                                                    MsgStr &= "the Inquest succeeded in uncovering Irregularities in the Provincial Leaders' Conduct. " & DOUBLE_SPACE
                                                    MsgStr &= "The Province is now Outlawed (Independent) and you can Attack It with Impunity at the Next Opportunity."
                                                    MsgBox(MsgStr, MsgBoxStyle.OkOnly, "Results of Inquest")
                                                    DecrementControlLevel(SelectedArea)
                                                    ConcludeAction()
                                                    Exit Sub
                                                Else
                                                    MsgStr &= "the Inquest could not uncover any Irregularities in the Provincial Leaders' Conduct. " & DOUBLE_SPACE
                                                    MsgStr &= "Do you want to proceed with the Attack anyway?"
                                                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Results of Inquest")
                                                    If Decision = MsgBoxResult.No Then
                                                        ConcludeAction()
                                                        Exit Sub
                                                    End If
                                                End If

                                            End If
                                            DecrementSupportForGovernment(ActiveGovernment) ' if gets this far, is going ahead without justification
                                        End If

                                    End If ' if it's either 

                                    PlayerTarget = SelectedArea
                                    TargetBox = sender
                                    TargetTextbox = TargetBox
                                    'TargetTextbox.ForeColor = Color.Red
                                    TargetTextbox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Bold)
                                    ActionPhase = 2
                                    frmMapScreen.lblCurrentPhase.Text = SELECT_BASE_STRING
                                    frmMapScreen.lblCurrentPhase.Refresh()
                                    If TurnDate = ScenarioStartDate And CurrentAction < (TotalActions / 2) Then
                                        MsgBox("Now Click on the Province you want to attack FROM.")
                                    Else
                                        If PromptSelectBase = True Then
                                            MsgStr = "Now Click on the Province you want to attack FROM!" & DOUBLE_SPACE
                                            MsgStr &= "(Click OK to Go On Now and Continue Showing this Prompt in the Future, " & vbCrLf & "or CANCEL to Go On but Stop Showing This Prompt.)"
                                            Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Prompt Select Target")
                                            If Decision = MsgBoxResult.Cancel Then
                                                Decision = MsgBox("Warning: Once you stop Showing the Prompt, you can't get it back.  You should only Stop it When you're Certain you'll know what you need to do at this Point in Future Attack Actions.  You can always Stop it Later.  Are you Sure you want to Stop It Now?  ", MsgBoxStyle.YesNo, "Confirm Stop Prompt")
                                                If Decision = MsgBoxResult.Yes Then
                                                    PromptSelectBase = False
                                                End If
                                            End If ' If want stop showingSelectBasePrompt
                                        End If ' If ShowSelectBase is True
                                    End If
                                Else
                                    MsgBox("You can't attack that Province; you need to control an adjacent Province to Attack from")

                                End If 'is neighbor
                            Else
                                MsgBox("You can't Attack your own Province; try Ruling instead.")
                            End If ' is own province
                            'Else
                            '    MsgBox("You can't attack water")
                        End If
                    Case DESIGNATE_ATTACK_BASE
                        If SelectedType = LAND Then
                            If Province(SelectedArea).PoliticalAffiliation = ActiveGovernment Then
                                If SeeIfNeighbor(SelectedArea, PlayerTarget) Then
                                    PlayerBase = SelectedArea
                                    BaseBox = sender
                                    ActionPhase = 3
                                    'Decision = MsgBox("Are you sure you want to attack " & Province(PlayerTarget).Name & " from " & Province(PlayerBase).Name _
                                    '                      , MsgBoxStyle.YesNo, "Confirm Attack")
                                    'If Decision = Microsoft.VisualBasic.MsgBoxResult.Yes Then

                                    Attack(PlayerBase, PlayerTarget)

                                    'Else
                                    '    CancelAction()
                                    'End If

                                Else
                                    MsgBox("You can't Attack from that Province because it's not adjacent to the target.")
                                End If
                            Else
                                MsgBox("You can't Attack from a Province you don't Control.")
                            End If
                            'Else
                            '    MsgBox("You can't Attack water")
                        End If
                    Case Else
                        MsgBox("Action Phase too high")

                End Select
            Case PARLEYING
                If SelectedType = LAND Then
                    If Province(SelectedArea).PoliticalAffiliation > FRANCE Then
                        If Province(SelectedArea).FormalAffiliation = Province(SelectedArea).PoliticalAffiliation Then
                            Negotiate(ActiveGovernment, Province(SelectedArea).PoliticalAffiliation)
                        Else ' If Formal Affiliation = Effective Controller
                            If Province(SelectedArea).FormalAffiliation = LOCAL_CONTROL Or Province(SelectedArea).FormalAffiliation > FRANCE Then
                                If DetermineIfProvinceContiguous(ActiveGovernment, SelectedArea) = True Then
                                    MsgStr = Province(SelectedArea).Name & " is only loosely Affiliated with "
                                    MsgStr &= Government(Province(SelectedArea).PoliticalAffiliation).Name & ".  "
                                    MsgStr &= "Since it is adjacent to a Province you Control, you can Negotiate with the Leaders of the Province or "
                                    MsgStr &= Government(Province(SelectedArea).PoliticalAffiliation).Name & DOUBLE_SPACE
                                    MsgStr &= "Click 'Yes' to Negotiate with " & Government(Province(SelectedArea).PoliticalAffiliation).Name & vbCrLf
                                    MsgStr &= "Click 'No' to Negotiate with the Leaders of " & Province(SelectedArea).Name & "."
                                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Who to Negotiate With?")
                                    If Decision = MsgBoxResult.Yes Then
                                        Negotiate(ActiveGovernment, Province(SelectedArea).PoliticalAffiliation)
                                    Else
                                        ClientStateNegotiations(SelectedArea)
                                    End If
                                Else
                                    Negotiate(ActiveGovernment, Province(SelectedArea).PoliticalAffiliation)
                                End If ' if province is contiguous to French-controlled territory
                            Else
                                ClientStateNegotiations(SelectedArea)
                                'MsgBox("Routine for French Province Controlled by other Kingdom Under Construction.")
                            End If
                        End If 'effecive controller is formal affiliation
                    Else ' if effective control = another Kingdom
                        If Province(SelectedArea).PoliticalAffiliation = LOCAL_CONTROL Then
                            If Province(SelectedArea).FormalAffiliation = LOCAL_CONTROL Then
                                If DetermineIfProvinceContiguous(ActiveGovernment, SelectedArea) = True Then
                                    SovereignProvinceNegotiations(SelectedArea)
                                Else
                                    MsgBox(Province(SelectedArea).Name & " is a Sovereign Province.  You must have Territory Adjacent to it " & _
                                           "to Make Any Kind of Deal with It, which you Don't." & DOUBLE_SPACE & _
                                           "Pick Another Province or Kingdom to Negotiate with.")
                                End If
                            Else 'if Formal Affiliation <> Local, consider if it's France or somebody else
                                If Province(SelectedArea).FormalAffiliation = FRANCE Then
                                    If Province(SelectedArea).ControlLevel = INDEPENDENT Then
                                        ErrantFrenchProvinceNegotiations(SelectedArea)
                                    Else ' if it's Formally French but NOT Independent, then it should be Ruled
                                        MsgStr = Province(SelectedArea).Name & " is an Autonomous Province within your Kingdom.  "
                                        MsgStr &= "Rather than negotiate with it, you should try and Rule it."
                                        MsgBox(MsgStr)
                                    End If
                                Else
                                    OthersVasselNegotiations(SelectedArea)
                                End If
                            End If
                        Else 'if effective control isn't Local or another Kingdom (already determined), then it must be France!
                            MsgStr = "You have effective Control of " & Province(SelectedArea).Name
                            MsgStr &= ".  You don't need to Negotiate with it." & vbCrLf & "Just go ahead and Rule it!"
                            MsgBox(MsgStr)
                        End If
                    End If
                Else
                    MsgBox("The Sea is Oblivious to the Words of Man.")
                End If
            Case RULING
                If SelectedType = LAND Then
                    Select Case ActionPhase
                        Case CHARTER_TOWNS
                            If Province(SelectedArea).PoliticalAffiliation = ActiveGovernment Then
                                If Province(SelectedArea).Townspeople - ((Province(SelectedArea).TownCharters * CHARTERED_TOWN_SIZE)) > CHARTERED_TOWN_SIZE Then
                                    TargetBox = sender
                                    CharterTown(SelectedArea)
                                    ConcludeAction()
                                Else
                                    MsgStr = "There is no Town in " & Province(SelectedArea).Name & " large enough to warrant a Charter "
                                    If Province(SelectedArea).TownCharters > 0 Then
                                        MsgStr &= "that does not have one already"
                                    End If
                                    MsgStr &= "." & DOUBLE_SPACE
                                    MsgStr = "There must be at least " & CHARTERED_TOWN_SIZE & ",000 inhabitants in Unchartered Towns "
                                    MsgStr &= "for there to be a Town large enough to issue a new Charter to.  "
                                    MsgStr &= Province(SelectedArea).Name & " has "
                                    If Province(SelectedArea).TownCharters = 0 Then
                                        MsgStr &= "only "
                                    End If
                                    MsgStr &= Province(SelectedArea).Townspeople & ",000 Townspeople"
                                    If Province(SelectedArea).TownCharters > 0 Then
                                        MsgStr &= " and " & CStr(Province(SelectedArea).TownCharters) & " Chartered Towns already"
                                    End If
                                    MsgStr &= "."
                                    MsgBox(MsgStr)
                                End If
                            Else
                                MsgBox("You can't Charter a town in a Province you don't Control.")
                            End If

                        Case TAX
                            If ((Province(SelectedArea).FormalAffiliation = ActiveGovernment And Province(SelectedArea).PoliticalAffiliation <= ActiveGovernment And Province(SelectedArea).ControlLevel > INDEPENDENT) Or Province(SelectedArea).PoliticalAffiliation = ActiveGovernment) Then ' Or ((Province(SelectedArea).PoliticalAffiliation = NEUTRAL And Province(SelectedArea).ControlLevel > INDEPENDENT) Then
                                'If Province(SelectedArea).PoliticalAffiliation = NEUTRAL And Province(SelectedArea).ControlLevel > INDEPENDENT Then
                                TargetBox = sender
                                TaxProvince(SelectedArea)
                                ConcludeAction() ' here so 
                                'Else
                                '    If Province(SelectedArea).PoliticalAffiliation <> ActiveGovernment Then
                                '        MsgBox("You can't tax a Province another King controls.", "No Control")
                            Else
                                MsgBox(Province(SelectedArea).Name & " doesn't recognize your Authority and won't pay any Taxes to You.")
                                Exit Sub
                            End If
                            'End If
                            'MsgBox("You neither control nor have claim to " & Province(SelectedArea).Name & " so they refuse to pay you any Taxes.")
                            'End If
                        Case ADMINISTER
                            If ((Province(SelectedArea).FormalAffiliation = ActiveGovernment And Province(SelectedArea).PoliticalAffiliation <= ActiveGovernment And Province(SelectedArea).ControlLevel > INDEPENDENT) Or Province(SelectedArea).PoliticalAffiliation = ActiveGovernment) Then ' Or ((Province(SelectedArea).PoliticalAffiliation = NEUTRAL And Province(SelectedArea).ControlLevel > INDEPENDENT) Then

                                TargetBox = sender

                                'CalculatePoliticalSupport(ActiveGovernment) ' brought in from loop in old MapScreen routine

                                'ProvincesControlled = CalculatePoliticalSupport(ActiveGovernment)

                                AdministerProvince(SelectedArea, ActiveGovernment, ProvincesControlled, sender)

                                'CalculatePoliticalSupport(ActiveGovernment) ' ditto
                                'ConcludeAction() ' reactivate if not inside AdministerProvince
                            Else
                                MsgBox(Province(SelectedArea).Name & " doesn't recognize your Authority and won't allow you to Administer Justice there.")
                            End If

                        Case INSTALL_BALIFF
                            If Province(SelectedArea).PoliticalAffiliation = PlayerSide Then
                                If Province(SelectedArea).AdminLevel < BALIFF Then
                                    If Government(ActiveGovernment).Treasury >= BALIFF_COST Then
                                        TargetBox = sender
                                        InstallBaliff(SelectedArea)
                                        ConcludeAction()
                                    Else
                                        MsgBox("You don't have enough money to Install a Baliff.")
                                    End If
                                Else
                                    MsgBox(Province(SelectedArea).Name & " already has a Baliff.")
                                End If
                            Else
                                MsgBox("You can only Install a Baliff in a Province you Control.")
                            End If

                    End Select

                Else
                    Select Case ActionPhase
                        Case INSTALL_BALIFF
                            MsgBox("He'll drown!")
                        Case CHARTER_TOWNS
                            MsgBox("There are no Towns in the Sea!")
                        Case TAX
                            MsgBox("You can't Tax the Sea!")
                        Case ADMINISTER
                            MsgBox("You can't Administer Water!")
                    End Select
                End If

            Case PATRONIZING

                If SelectedType = LAND Then
                    TargetBox = sender ' links the Global variable Textbox to the specific control so can update display if need to
                    If Province(SelectedArea).PoliticalAffiliation = PlayerSide Then
                        Select Case ActionPhase
                            Case PATRONIZE_CHURCH
                                'MsgBox(Province(SelectedArea).Name & " was selected for Church Patronage.")
                                PatronizeByType(PATRONIZE_CHURCH, SelectedArea)
                            Case PATRONIZE_LEARNING
                                'MsgBox(Province(SelectedArea).Name & " was selected for Patronizing Learning.")
                                PatronizeByType(PATRONIZE_LEARNING, SelectedArea)
                                'Case PATRONIZE_ARTS
                                '    'MsgBox(Province(SelectedArea).Name & " was selected for Patronizing the Arts.")
                                '    PatronizeArts(SelectedArea)
                        End Select

                        ConcludeAction()

                    Else
                        MsgBox("You can only Patronize in Provinces you Control.")
                    End If
                Else
                    MsgBox("You can't Patronize water.")
                End If

            Case BUILDING

                If SelectedType = LAND Then
                    If Province(SelectedArea).PoliticalAffiliation = PlayerSide Then
                        TargetBox = sender ' links the Global variable Textbox to the specific control so can update display if need to
                        Select Case ActionPhase
                            Case BUILD_FORTIFICATIONS
                                'MsgBox(Province(SelectedArea).Name & " was selected for Fortifications.")
                                If Province(SelectedArea).Fortifications < CASTLES Then
                                    BuildForticiations(SelectedArea)
                                Else
                                    MsgBox(Province(SelectedArea).Name & "'s Fortifications have already been upgraded to Castles, and there " _
                                           & "is no more effective Technology available Now.  You should Fortify somewhere else.")
                                End If
                            Case BUILD_PALACE
                                'MsgBox(Province(SelectedArea).Name & " was selected for a New Palace.")
                                BuildPalace(SelectedArea)
                            Case BUILD_CANAL
                                MsgBox(Province(SelectedArea).Name & " was selected as one end of a new Canal.")
                                ' Need to build in an if then on a new subsubphase: select canal prov 1 and select prov 2, with prov2
                                ' needing to be flatland connected by road to 1

                                'For i = 0 To MAX_NEIGHBORS_LAND ' NOTE: This is start of check to see if base is suitable
                                '    If Province(SelectedArea).Connectors(i) = RIVER Or Province(SelectedArea).Connectors(i) = COASTAL Then
                                '        PotentialBase = Province(SelectedArea).Neighbors(i)
                                '    Else
                                '        MsgBox("There is no 
                                '    End If
                                '        If 
                                '    End If
                                'Next

                                'PlayerTarget = SelectedArea 'NOTE:  this imported from attack process above
                                'TargetBox = sender
                                'TargetTextbox = TargetBox
                                ''TargetTextbox.ForeColor = Color.Red
                                'TargetTextbox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Bold)
                                'ActionPhase = 2
                                'frmMapScreen.lblCurrentPhase.Text = SELECT_BASE_STRING
                                'frmMapScreen.lblCurrentPhase.Refresh()


                        End Select

                        ConcludeAction() ' Build action

                    Else
                        MsgBox("You can only Build in Provinces you Control.")
                    End If
                Else
                    MsgBox("You can't Build in the Water.")
                End If

            Case Else
                MsgBox("Action under construction")

        End Select

    End Sub

    Function SeeIfNeighbor(ProvinceOfInterest As Integer, TargetValue As Integer) As Boolean
        Dim PotentialTarget As Integer = -1
        Dim PotentialTargetArea As Integer = -1
        Dim i As Integer = 0
        Dim IsNeighbor As Boolean = False
        Dim PotentialTargetValue As Integer

        IsNeighbor = False

        For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move by land
            If Province(ProvinceOfInterest).Connectors(i) >= RIVER Then ' if neighbor is land connection
                PotentialTargetArea = Province(ProvinceOfInterest).Neighbors(i)
                PotentialTarget = Area(PotentialTargetArea).Province
                Select Case ActionPhase
                    Case DESIGNATE_ACTION_TARGET
                        PotentialTargetValue = Province(PotentialTarget).PoliticalAffiliation
                    Case DESIGNATE_ATTACK_BASE
                        PotentialTargetValue = Province(PotentialTarget).ID
                End Select

                If PotentialTargetValue = TargetValue Then
                    IsNeighbor = True
                    Exit For
                End If ' is one of your provinces
            Else ' check about sea

            End If ' is land connection
        Next

        'Need to put in check if by sea

        Return IsNeighbor ' if don't find a neighbor belonging to player

    End Function

    Sub CancelAction()

        'MsgBox("Action Cancelled.")
        Try
            If PlayerTarget >= 0 Then
                TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
            End If
        Catch
        End Try

        If PlayerAction = RULING Then
            ToggleRuleControls(True) 'these'll go off since this saying they're currently on
            'End If
        ElseIf PlayerAction = PATRONIZING Then
            TogglePatronizeControls(True) 'these'll go off since this saying they're currently on
        ElseIf PlayerAction = BUILDING Then
            ToggleBuildControls(True) ' ditto
        End If

        PlayerAction = NO_ACTION
        frmMapScreen.lblPlayerAction.Text = NO_SELECTION_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhase.Text = NO_SELECTION_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhaselbl.Text = ATTACK_PHASE_LBL
        frmMapScreen.lblCurrentPhaselbl.Refresh()
        ActionPhase = 0
        PlayerTarget = -1
        PlayerBase = -1

    End Sub

    'Sub Attack(ByVal Base As Integer, ByVal Target As Integer)
    '    Dim DieRoll1 As Integer = 0
    '    Dim DieRoll2 As Integer = 0
    '    'Dim DieRoll3 As Integer
    '    Dim DiceRoll As Integer = 0
    '    'Dim Modifiers As Integer
    '    Dim AttackFactor As Integer = 0
    '    Dim DefenseFactor As Integer = 0
    '    Dim PlayerDefending As Boolean = False
    '    Dim DefendingGeneralship As Integer = 0
    '    Dim DefendingGovernment As Integer = 0
    '    Dim DefendingArmyState As Integer = 0
    '    Dim Random10 As Integer = 0
    '    Dim DiceRoll2Decimal As Integer = 0
    '    Dim VictoryThreshhold As Integer
    '    Dim Rand As New Random
    '    Dim MsgStr As String
    '    Dim AI_Thinking As Boolean = False 'so when calc AF and DF knows to report it
    '    Dim DefenderEliminated As Boolean = False 'needed so autonomous provinces will be handled correctly below


    '    PlayerDefending = False 'so don't carry over 

    '    Randomize()

    '    AttackFactor = CalculateAttackFactor(Base, Target, AI_Thinking)

    '    DefendingGovernment = Province(Target).PoliticalAffiliation

    '    Government(DefendingGovernment).DiplomaticRelations(ActiveGovernment) = MIN_RELATES

    '    If DefendingGovernment > 0 Then
    '        'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '        PlayerDefending = True
    '    End If

    '    If PlayerDefending Then
    '        DefendingGeneralship = Government(DefendingGovernment).Generalship
    '        DefendingArmyState = Government(DefendingGovernment).ArmyState
    '    Else
    '        If (Province(Target).Language >= GERMANIC) And (Province(Target).Language < GREEK) Then ' becaause Germans so warlike 
    '            DefendingGeneralship = Rand.Next(1, 3)
    '            DefendingArmyState = Rand.Next(1, 3)
    '        Else
    '            DefendingGeneralship = Rand.Next(0, 5) - 2
    '            DefendingArmyState = Rand.Next(0, 5) - 2
    '        End If
    '    End If

    '    DefenseFactor = CalculateDefenseFactor(Target, PlayerDefending, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '    VictoryThreshhold = ApplyCombatModifiers(AttackFactor, DefenseFactor, Target, Base, DefendingGeneralship, DefendingArmyState)

    '    If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '        If VictoryThreshhold < 10 Then
    '            MsgStr = "The Attacker has a " & VictoryThreshhold & "0% chance of winning."
    '            MsgBox(MsgStr)
    '        Else
    '            MsgStr = ""
    '        End If
    '    Else
    '        MsgStr = ""
    '    End If

    '    Random10 = Rand.Next(1, 11)

    '    If Random10 <= VictoryThreshhold Then ' Defender Retreats
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            If VictoryThreshhold < 10 Then
    '                MsgStr = MsgStr & vbCrLf & vbCrLf & " The Attack Succeeded! " & vbCrLf & vbCrLf
    '                'Else
    '                '    MsgStr = "The Attacking forces are overwhelming! " & vbCrLf
    '            End If
    '        End If ' is player's concern
    '        MsgStr = MsgStr & "The " & Government(ActiveGovernment).Name & " take " & Province(Target).Name & vbCrLf
    '        MsgBox(MsgStr)

    '        ProvinceChangesHands(Target)

    '        ' Check if this was the last province the defender controlled
    '        If DefendingGovernment > LOCAL_CONTROL Then 'don't worry about this if autonomous province
    '            DefenderEliminated = CheckIfGovernmentEliminated(DefendingGovernment)
    '        End If ' Defender is a state

    '        If DefenderEliminated = False Then
    '            DecrementArmyState(DefendingGovernment)
    '            If PlayerDefending Then
    '                MsgStr = "The Defending Army's Morale declines to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "." & vbCrLf & vbCrLf
    '            Else
    '                MsgStr = ""
    '            End If
    '        Else 'Defender Was Eliminated
    '            MsgStr = "The " & Government(DefendingGovernment).Name & " have been eliminated." & vbCrLf & vbCrLf
    '            ClearOutLoser(DefendingGovernment)
    '        End If ' if defender NOT eliminated

    '        IncrementArmyState(ActiveGovernment)
    '        IncrementSocialState(Base, PROSPEROUS)

    '        MsgStr &= " The Attacking Army's Morale improved to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", " & vbCrLf _
    '                        & "and the Social State of " & Province(PlayerBase).Name & " rose to " & DescribeSocialState(Province(PlayerBase).SocialState) & "."
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgBox(MsgStr)
    '        End If

    '    Else 'Defender Holds
    '        'If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '        '    'If VictoryThreshhold > 0 Then
    '        '    '    MsgStr = MsgStr & "The result is " & Random10 & "! " & vbCrLf
    '        '    'End If
    '        'End If
    '        MsgStr = MsgStr & "The " & Government(ActiveGovernment).Name & " failed to take " & Province(Target).Name & "!" & vbCrLf & vbCrLf
    '        MsgBox(MsgStr)
    '        IncrementArmyState(Government(DefendingGovernment).ID)
    '        If PlayerDefending Then
    '            MsgStr = "The Defending Army's Morale improves to " & DescribeArmyState(Government(DefendingGovernment).ArmyState) & "!" & vbCrLf
    '        Else
    '            MsgStr = ""
    '        End If
    '        DecrementArmyState(Government(ActiveGovernment).ID)
    '        DecrementSocialState(Province(Base).ID, CHAOS)
    '        If ActiveGovernment = PlayerSide Then
    '            DecrementSocialVPs(Province(Base).SocialState)
    '            'SocialVPs -= SOCIAL_STATE_VP_VALUE
    '            'RefreshSocialStateVP_Display()
    '        End If
    '        MsgStr = MsgStr & "the Attacking Army's Morale declines to " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", " _
    '            & "and the Social State of " & Province(PlayerBase).Name & " drops to " & DescribeSocialState(Province(PlayerBase).SocialState) & "."
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgBox(MsgStr)
    '        End If
    '    End If

    '    ConcludeAction() '(DefendingGovernment)

    'End Sub

    'Function CalculateAttackFactor(ByVal Base As Integer, ByVal Target As Integer, ByVal AI_Thinking As Boolean) As Integer
    '    Dim TerrainModifier, AttackingInfantry, AttackingCavalry, AttackFactor As Integer
    '    Dim AttackingCavalryValue, AttackingInfantryValue As Integer
    '    Dim MsgStr As String

    '    TerrainModifier = Province(Target).Topography + 1

    '    AttackingInfantry = GetProvincialMilitia(Base) + Government(ActiveGovernment).Infantry
    '    AttackingInfantryValue = AttackingInfantry
    '    AttackingCavalry = (Government(ActiveGovernment).Cavalary) 'check on the effects of the multiplication
    '    AttackingCavalryValue = AttackingCavalry \ TerrainModifier 'check on the effects of the multiplication
    '    If AttackingCavalryValue < 1 Then AttackingCavalryValue = 1 'so at least 1 to avoid divide by 0 error
    '    AttackFactor = AttackingInfantryValue + AttackingCavalryValue

    '    If AI_Thinking = False Then
    '        If ActiveGovernment = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '            MsgStr = "Attacking force: " & AttackingInfantry & "000 Infantry and " & AttackingCavalry & "00 Cavalry led by a " _
    '                & GetAbilityNames(Government(ActiveGovernment).Generalship) & " General." & vbCrLf
    '            If Government(ActiveGovernment).ArmyState < 0 Then
    '                MsgStr = MsgStr & "The Attackers' morale is low." & vbCrLf
    '            ElseIf Government(ActiveGovernment).ArmyState > 0 Then
    '                MsgStr = MsgStr & "The Attackers' morale is high." & vbCrLf
    '            End If
    '            If TerrainModifier > 1 And AttackingCavalry > 0 Then
    '                MsgStr = MsgStr & "Difficult terrain hinders the attacking Cavalry." & vbCrLf
    '            End If
    '            If Province(Base).SocialState < 0 Then
    '                MsgStr = MsgStr & "The Attackers' Base is in disarray. "
    '            End If
    '            MsgBox(MsgStr)
    '        End If
    '    End If ' AI thinking?

    '    Return AttackFactor

    'End Function

    'Function CalculateDefenseFactor(ByVal Target As Integer, ByVal PlayerDef As Boolean, ByVal DefendingGen As Integer, _
    '                                ByVal DefendingArmyVal As Integer, AI_Thinking As Boolean) As Integer
    '    Dim DefendingGovernment, RoyalInfantry, TerrainModifier As Integer
    '    Dim DefendingCavalry, FortificationModifier, DefenseFactor, DefendingInfantry As Integer
    '    Dim DefendingCavalryValue, DefendingInfantryValue As Integer
    '    Dim MsgStr As String

    '    TerrainModifier = Province(Target).Topography + 1

    '    If PlayerDef Then
    '        DefendingGovernment = Province(Target).PoliticalAffiliation
    '        RoyalInfantry = Government(DefendingGovernment).Infantry
    '        DefendingCavalry = (Government(DefendingGovernment).Cavalary)
    '        DefendingCavalryValue = DefendingCavalry \ TerrainModifier
    '    Else
    '        DefendingCavalry = GetLocalKnights(Target)
    '        DefendingCavalryValue = DefendingCavalry \ TerrainModifier
    '        RoyalInfantry = 0
    '    End If
    '    If DefendingCavalryValue < 1 Then DefendingCavalryValue = 1 ' avoid divide by 0

    '    FortificationModifier = 0 'Province(PlayerTarget).Fortifications ' needs to be added in!!!

    '    DefendingInfantry = (GetProvincialMilitia(Target) + RoyalInfantry)
    '    DefendingInfantryValue = DefendingInfantry * (TerrainModifier + FortificationModifier)

    '    DefenseFactor = DefendingCavalryValue + DefendingInfantryValue

    '    If AI_Thinking = False Then
    '        If ActiveGovernment = PlayerSide Or DefendingGovernment = PlayerSide Then
    '            MsgStr = "Defending force: " & DefendingInfantry & "000 Infantry and " & DefendingCavalry & "00 Cavalry led by a " _
    '                & GetAbilityNames(DefendingGen) & " General." & vbCrLf
    '            If DefendingArmyVal < 0 Then
    '                MsgStr = MsgStr & "The Defenders' morale is low." & vbCrLf
    '            ElseIf DefendingArmyVal > 0 Then
    '                MsgStr = MsgStr & "The Defenders' morale is high." & vbCrLf
    '            End If
    '            If TerrainModifier > 1 And DefendingInfantry > 0 Then
    '                MsgStr = MsgStr & "The Terrain favors the defending Infantry." & vbCrLf
    '            End If
    '            If FortificationModifier > 0 And DefendingInfantry > 0 Then
    '                MsgStr = MsgStr & "The Province's Fortifications aid the defending Infantry." & vbCrLf
    '            End If
    '            If Province(Target).SocialState < 0 Then
    '                MsgStr = MsgStr & " The Province itself is in disarray. "
    '            End If
    '            MsgBox(MsgStr)
    '        End If
    '    End If 'is AI thinking

    '    Return DefenseFactor

    'End Function

    'Function ApplyCombatModifiers(ByVal AttackFactor As Integer, ByVal DefenseFactor As Integer, ByVal Target As Integer, _
    '                              ByVal Base As Integer, ByVal DefendingGen As Integer, ByVal DefendingArmyVal As Integer) As Integer
    '    Dim VictoryThreshhold, ForceRatio As Integer

    '    VictoryThreshhold = 5

    '    If AttackFactor >= DefenseFactor Then
    '        ForceRatio = AttackFactor \ DefenseFactor
    '        ForceRatio -= 1 'so 1:1 = no modifier up or down
    '    Else
    '        If AttackFactor < 1 Then
    '            AttackFactor = 1
    '        End If
    '        ForceRatio = -1 * (DefenseFactor \ AttackFactor)
    '        ForceRatio += 1 ' ditto
    '        End If

    '        VictoryThreshhold += ForceRatio

    '        VictoryThreshhold += Government(ActiveGovernment).Generalship - DefendingGen

    '        'DiceRoll += WeatherByArea(Province(Target).Climate) ' seems questionable as well as well as unnecessarily complicating

    '        VictoryThreshhold += Province(Base).SocialState - Province(Target).SocialState

    '        VictoryThreshhold += Government(ActiveGovernment).ArmyState - DefendingArmyVal

    '        If Province(Target).Farmland \ BASE_PROVINCE_SIZE > 1 Then ' if target area is huge
    '            VictoryThreshhold -= (Province(Target).Farmland \ BASE_PROVINCE_SIZE - 1)
    '        End If

    '        If VictoryThreshhold < 1 Then
    '            VictoryThreshhold = 1
    '        ElseIf VictoryThreshhold > 10 Then
    '            VictoryThreshhold = 10
    '        End If

    '        Return VictoryThreshhold

    'End Function

    'Sub ProvinceChangesHands(Target As Integer)
    '    Dim ProvinceNum As Integer = -1
    '    Dim PopulationTransferred As Integer = 0
    '    Dim Benefices As Integer = 0
    '    Dim OpenBenefices As Integer = 0
    '    Dim Treasure As Integer = 0
    '    Dim Decision As MsgBoxResult '= vbNo
    '    Dim rand As New Random
    '    Dim CoinFlip As Integer

    '    Randomize()

    '    ' Loser loses local knights from target province
    '    Government(Province(Target).PoliticalAffiliation).Cavalary -= GetLocalKnights(Target)

    '    If ActiveGovernment = PlayerSide Then
    '        IncrementConquestVPs(Target)
    '        'ConquestVPs += PROVINCE_VP_VALUE
    '        'RefreshConquestVP_Display()
    '    Else
    '        If Province(Target).PoliticalAffiliation = PlayerSide Then
    '            DecrementConquestVPs(Target)
    '            'ConquestVPs -= PROVINCE_VP_VALUE
    '            'RefreshConquestVP_Display()
    '        End If
    '    End If

    '    Province(Target).PoliticalAffiliation = ActiveGovernment

    '    'Loyalty will be the inverse of what it was before; the stronger it liked the old regime, the less it will like the new, and vice versa
    '    Province(Target).Loyalty = -1 * Province(Target).Loyalty

    '    If ActiveGovernment <> PlayerSide Then 'have to set target's textbox since player didn't click on it
    '        SetTargetTextbox(Target)
    '        'For Each frmMapScreen.ctrl In frmMapScreen.Controls
    '        '    If frmMapScreen.ctrl.Name = Area(Province(Target).AreaNumber).MapElement Then
    '        '        TargetBox = frmMapScreen.ctrl
    '        '        Exit For
    '        '    End If
    '        'Next
    '    End If

    '    ChangeTextboxAffiliation(ActiveGovernment)

    '    If ActiveGovernment = PlayerSide Then
    '        DecideHowHandleTreasure(Target)
    '    Else
    '        'MsgBox("Need to set up whether non-player side pillages.")
    '    End If

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        PopulationTransferred = 0
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment And ProvinceNum <> Target And Province(ProvinceNum).SurplusPopulation > 0 Then
    '            If Province(Target).Peasants < Province(Target).Farmland Then
    '                While Province(ProvinceNum).SurplusPopulation > 0 And Province(Target).Peasants < Province(Target).Farmland
    '                    Province(ProvinceNum).SurplusPopulation -= 1
    '                    Province(Target).Peasants += 1
    '                    PopulationTransferred += 1
    '                End While
    '                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '                    MsgBox(CStr(PopulationTransferred) & ",000 people have migrated from " & Province(ProvinceNum).Name _
    '                               & " to " & Province(Target).Name)
    '                End If
    '            End If ' Target Province has space for immigrants

    '            PopulationTransferred = 0

    '            If Province(ProvinceNum).SurplusPopulation > 0 Then ' this isn't done as "else" because also used for "spillover" from peaceful transfer, above
    '                PopulationTransferred = 0
    '                If ActiveGovernment = PlayerSide Then
    '                    Decision = MsgBox(CStr(Province(ProvinceNum).SurplusPopulation) & " people in " & Province(ProvinceNum).Name _
    '                        & " need land, but there is no room in " & Province(Target).Name & ", so letting them move in will displace some locals and anger the rest. " _
    '                        & "However, if your people can't move somewhere eventually, support for your government will decline. " & vbCrLf _
    '                        & "DO YOU WANT TO ALLOW THE MIGRATION?", MsgBoxStyle.YesNo, "Displace Locals?")
    '                Else
    '                    CoinFlip = rand.Next(0, 2)
    '                    If CoinFlip = 1 Then
    '                        Decision = vbYes
    '                    Else
    '                        Decision = vbNo
    '                    End If
    '                End If ' the player is active

    '                If Decision = vbYes Then
    '                    While Province(ProvinceNum).SurplusPopulation > 0
    '                        Province(ProvinceNum).SurplusPopulation -= 1
    '                        Province(Target).SurplusPopulation += 1
    '                        DecrementSocialState(Target, CHAOS)
    '                        PopulationTransferred += 1
    '                    End While

    '                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(Target).PoliticalAffiliation = PlayerSide Then
    '                        MsgBox(CStr(PopulationTransferred) & ",000 people have migrated from " & Province(ProvinceNum).Name _
    '                                    & " to " & Province(Target).Name & ", displacing an equal number of locals.")
    '                        If Province(Target).SocialState < 0 Then
    '                            MsgBox("Conditions in " & Province(Target).Name & " have become " & DescribeSocialState(Province(Target).SocialState))
    '                        End If
    '                    End If ' player cares
    '                End If ' player goes ahead and transfers population to the target
    '            End If ' if the province (still) has surplus population
    '        End If ' This province is the player's and has surplus population
    '    Next

    '    If ActiveGovernment = PlayerSide Then
    '        DecideHowHandleBenefices(Target)
    '    Else
    '        'MsgBox("Need to set up how non-player side handles land.")
    '    End If

    '    ' Winner gets local knights if has their support
    '    If Province(Target).Loyalty > 0 Then
    '        Government(ActiveGovernment).Cavalary += GetLocalKnights(Target)
    '        If Province(Target).PoliticalAffiliation = PlayerSide Then
    '            MsgBox("The local nobles have joined the " & Government(ActiveGovernment).Name & " army!")
    '        End If ' Player cares
    '    End If

    'End Sub

    'Function CheckIfGovernmentEliminated(ByVal WhichGvt As Integer) As Boolean
    '    Dim Eliminated As Boolean = True 'hypothesize it was eliminated; now test to see if any provinces affiliated
    '    Dim i As Integer

    '    For i = 0 To TotalProvinces - 1
    '        If Province(i).PoliticalAffiliation = WhichGvt Then
    '            Eliminated = False
    '            Exit For
    '        End If
    '    Next

    '    Return Eliminated
    'End Function

    'Sub DecrementArmyState(ByVal GovernmentNum As Integer)
    '    If Government(GovernmentNum).ArmyState > INEFFECTUAL Then
    '        Government(GovernmentNum).ArmyState -= 1
    '    End If
    'End Sub

    'Sub IncrementArmyState(ByVal GovernmentNum As Integer)
    '    If Government(GovernmentNum).ArmyState < FANATICAL Then
    '        Government(GovernmentNum).ArmyState += 1
    '    End If
    'End Sub

    Sub DecrementSupportForGovernment(ByVal GovNum As Integer)
        Dim i As Integer = 0
        Dim MsgStr As String = ""

        MsgBox("Loyalty to the Crown Declined in all Provinces You Control or are Formally Affiliated with the French Kingdom.")

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = GovNum Or (Province(i).PoliticalAffiliation = LOCAL_CONTROL And Province(i).FormalAffiliation = GovNum) Then
                DecrementProvincialLoyalty(i)
                If Province(i).Loyalty = REBELLIOUS Then
                    DecrementControlLevel(i)
                    MsgBox(Province(i).Name & "'s Relationship to the Crown has declined to " & NameControlLevel(Province(i).ControlLevel) & ".")
                End If
            End If
        Next

        'If Government(GovernmentNum).Support > REBELLIOUS Then ' this is old logic not actively called by any routine (9/13/13)
        '    Government(GovernmentNum).Support -= 1
        'End If
    End Sub

    Sub IncrementSupportForGovernment(ByVal GovernmentNum As Integer)
        If Government(GovernmentNum).Support < ENTHUSIASTIC Then
            Government(GovernmentNum).Support += 1
        End If
    End Sub

    Sub DecrementProvincialLoyalty(ByVal ProvinceNum As Integer)
        If Province(ProvinceNum).Loyalty > REBELLIOUS Then
            Province(ProvinceNum).Loyalty -= 1
        End If
        'MsgBox("Loyalty of " & Province(ProvinceNum).Name & " Decremented to " & CStr(Province(ProvinceNum).Loyalty))
    End Sub

    Sub IncrementProvincialLoyalty(ByVal ProvinceNum As Integer)
        If Province(ProvinceNum).Loyalty < ENTHUSIASTIC Then
            Province(ProvinceNum).Loyalty += 1
        End If
        'MsgBox("Loyalty of " & Province(ProvinceNum).Name & " Incremented to " & CStr(Province(ProvinceNum).Loyalty))
    End Sub

    Sub IncrementControlLevel(ByVal ProvinceNum As Integer)
        If Province(ProvinceNum).ControlLevel < MAX_CONTROL_LEVEL Then
            Dim Rand As New Random

            'If Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL Then ' other announces handle this already
            '    If Province(ProvinceNum).FormalAffiliation = PlayerSide Then
            '        MsgBox("You have gained control of " & Province(ProvinceNum).Name & ".")
            '    End If
            'End If

            Province(ProvinceNum).ControlLevel += 1

            Province(ProvinceNum).Loyalty = Rand.Next(0, 3) - 1

            If Province(ProvinceNum).ControlLevel = SUBORDINATE Then
                Province(ProvinceNum).PoliticalAffiliation = Province(ProvinceNum).FormalAffiliation
                ChangeTextboxControlLevel(Province(ProvinceNum).ControlLevel)
                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                    IncrementConquestVPs(ProvinceNum)
                    'ConquestVPs += 1
                    'RefreshConquestVP_Display()
                End If
                'Else
                '    If Province(ProvinceNum).ControlLevel = AUTONOMOUS Then
                '        Province(ProvinceNum).Loyalty *= -1
                '    End If
            End If

        End If

    End Sub

    Sub DecrementControlLevel(ByVal ProvinceNum As Integer)
        Dim Rand As New Random

        If Province(ProvinceNum).ControlLevel > INDEPENDENT Then

            Province(ProvinceNum).ControlLevel -= 1
            ChangeTextboxControlLevel(Province(ProvinceNum).ControlLevel)

            Province(ProvinceNum).Loyalty = Rand.Next(0, 3) - 1


            If Province(ProvinceNum).ControlLevel = AUTONOMOUS Then
                If Province(ProvinceNum).PoliticalAffiliation <> PlayerSide Then
                    If Province(ProvinceNum).FormalAffiliation = PlayerSide Then
                        MsgBox(Government(Province(ProvinceNum).PoliticalAffiliation).Name & " has lost control of " _
                               & Province(ProvinceNum).Name & ".  It is now " & NameControlLevel(Province(ProvinceNum).ControlLevel))
                    End If
                Else ' it is player side that's losing it
                    ConquestVPs -= 1
                    RefreshConquestVP_Display()
                End If
                Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL
                ChangeTextboxAffiliation(Province(ProvinceNum).PoliticalAffiliation)
                'Else
                'If Province(ProvinceNum).ControlLevel = INDEPENDENT Then 'seemed like a good idea, but turned out other announcements always handled this
                '    MsgBox(Province(ProvinceNum).Name & " is now fully " & INDEPENDENT_STR)
                'End If
            End If
        End If
    End Sub


    'Function CalculateLosses(ByVal ForceSize As Integer, ByVal LossPercent As Integer)
    '    Dim ActualLosses As Integer

    '    ActualLosses = ForceSize * LossPercent \ 100

    '    Return ActualLosses

    'End Function

    Sub ConcludeAction() '(ByVal Defender As Integer)
        'Dim Decision As MsgBoxResult '= vbNo
        'Dim ProvinceNum As Integer '= 0
        'Dim rand As New Random
        'Dim CoinFlip As Integer

        'If CurrentAction = ATTACKING Then
        '    TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
        'End If

        'Randomize()

        ' SURRENDER / COLLAPSE REMOVED BECAUSE HAPPENS TOO EASILY; IT'S A GOOD IDEA, BUT NEEDS TO BE REFINED
        'If Government(Defender).ArmyState = INEFFECTUAL And _
        '    Government(Defender).Cavalary < Government(ActiveGovernment).Cavalary Then

        '    'If Government(Defender).Support > INDIFFERENT Then
        '    If ActiveGovernment = PlayerSide Then
        '        Decision = MsgBox("The " & Government(Defender).Name & " have been broken! They are suing for Peace. " _
        '               & " If you accept their Surrender, their Provinces will become Yours, their Forces will fight for you, and you will gain their central Treasury, " _
        '               & "but you will have to forgo extorting the wealth and seizing the land in their Provinces. If you spurn their overtures, you will have to fight the " _
        '               & "remnants of their forces in each Province, but you can then give them to your Followers as you will. WILL YOU ACCEPT THEIR SURRENDER?", _
        '               MsgBoxStyle.YesNo, "Accept Surrender?")
        '    Else
        '        CoinFlip = rand.Next(0, 2)
        '        If CoinFlip = 1 Then
        '            Decision = vbYes
        '            MsgBox("The " & Government(Defender).Name & " have surendered to the " & GetGovernmentName(ActiveGovernment))
        '            'Else
        '            '    Decision = vbNo
        '            '    MsgBox("The " & Government(Defender).Name & " have collapsed.")
        '        End If
        '    End If
        '    'Else
        '    '    Decision = vbNo
        '    '    MsgBox("The " & Government(Defender).Name & " have collapsed.")
        '    'End If

        '    If Decision = vbYes Then
        '        For ProvinceNum = 0 To TotalProvinces - 1
        '            If Province(ProvinceNum).PoliticalAffiliation = Defender Then
        '                Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment
        '                Government(ActiveGovernment).Cavalary += GetLocalKnights(ProvinceNum)
        '                Government(ActiveGovernment).Infantry += Government(Defender).Infantry
        '                Government(ActiveGovernment).TotalBenefices += CalculateTotalBenefices(ProvinceNum)
        '                'Else
        '                '    Province(ProvinceNum).PoliticalAffiliation = LOCAL_CONTROL
        '                For Each frmMapScreen.ctrl In frmMapScreen.Controls
        '                    If frmMapScreen.ctrl.Name = Area(Province(ProvinceNum).AreaNumber).MapElement Then
        '                        TargetBox = frmMapScreen.ctrl
        '                        ChangeTextboxAffiliation(Province(ProvinceNum).PoliticalAffiliation)
        '                        Exit For
        '                    End If
        '                Next
        '            End If
        '        Next
        '    End If


        'frmMapScreen.Refresh()
        'Government(Defender).Cavalary = 0
        'Government(Defender).Infantry = 0
        'Government(Defender).Support = 0
        'Government(Defender).LeadershipState = -1
        'Government(ActiveGovernment).Treasury += Government(Defender).Treasury
        'Government(Defender).Treasury = 0
        'Government(Defender).TotalBenefices = 0
        'End If


        SelectedArea = NO_SELECTION
        Try
            If PlayerTarget >= 0 Then
                TargetBox.Font = New Font("Microsoft Sans Serif", 8.25, FontStyle.Regular)
            End If
        Catch

        End Try



        SelectedType = NO_SELECTION
        PlayerTarget = NO_SELECTION

        If PlayerAction = RULING Then
            ToggleRuleControls(True) 'these'll go off since this saying they're currently on
            'End If
        ElseIf PlayerAction = PATRONIZING Then
            TogglePatronizeControls(True) 'these'll go off since this saying they're currently on
        ElseIf PlayerAction = BUILDING Then
            ToggleBuildControls(True) ' ditto
        End If
        PlayerBase = NO_SELECTION

        PlayerAction = NO_SELECTION
        ActionPhase = NO_SELECTION
        frmMapScreen.lblPlayerAction.Text = NO_SELECTION_STRING
        frmMapScreen.lblCurrentPhase.Text = NO_PHASE_STRING
        frmMapScreen.lblPlayerAction.Refresh()
        frmMapScreen.lblCurrentPhase.Refresh()
        frmMapScreen.btnAffiliation.PerformClick()

        'If TurnDate = ScenarioStartDate And CurrentAction = WHEN_SHOW_CONTROLS Then ' Turned off because all being shown at beginning now
        '    frmMapScreen.txtAttackOnly.Visible = False
        '    frmMapScreen.btnNegotiate.Visible = True
        '    frmMapScreen.btnRule.Visible = True
        'End If

        If ActiveGovernment = PlayerSide Then

            AutoTurn()
        End If
    End Sub

    'Sub DecideHowHandleTreasure(ByVal ProvinceID As Integer)
    '    Dim Decision As MsgBoxResult = vbNo
    '    Dim TownspeopleKilled As Integer = 0
    '    Dim LootGained As Integer = 0

    '    Decision = MsgBox("The townspeople of " & Province(ProvinceID).Name & " have " & CStr(Province(ProvinceID).Townspeople) _
    '                      & ",000 " & CurrencyStr & " worth of treasure. " & vbCrLf & vbCrLf _
    '                      & "You can take some or all of it.  Taking it will damage the local economy, but enrich " _
    '                      & " your treasury and buy the continued support of your followers." & vbCrLf _
    '                      & "Sparing them will make you popular with your new subjects." & vbCrLf & vbCrLf _
    '                      & "DO YOU WANT TO SEIZE SOME?", vbYesNo, "Seize Wealth?")
    '    If Decision = vbYes Then
    '        Decision = MsgBox("You can let your men loot, which will make them happy and enrich you but inflict considerable harm on the locals.  " _
    '                          & "  Or you can extort protection money from the townspeople, which will net you about half the benefits, but inflict about half the pain." & vbCrLf _
    '                          & "DO YOU WANT TO LET YOUR MEN LOOT?", vbYesNo, "Loot?")
    '        If Decision = vbYes Then
    '            TownspeopleKilled = Province(ProvinceID).Townspeople \ 2
    '            If TownspeopleKilled = 0 Then
    '                TownspeopleKilled = 1
    '            End If
    '            Province(ProvinceID).Townspeople -= TownspeopleKilled
    '            MsgBox("You gained " & Province(ProvinceID).Townspeople & ",000 " & CurrencyStr & " in treasure and your Warriors are pleased.  " & vbCrLf _
    '                   & CStr(TownspeopleKilled) & ",000 Townspeople died, " & Province(ProvinceID).Name & " is in chaos and support for you in the Province declined.")
    '            Government(ActiveGovernment).Treasury += Province(ProvinceID).Townspeople
    '            'IncrementPoliticalSupport(PlayerSide)
    '            Province(ProvinceID).SocialState = CHAOS
    '            'Loyalty of Target Province goes down
    '        Else
    '            LootGained = Province(ProvinceID).Townspeople \ 2
    '            If LootGained < 1 Then
    '                LootGained = 1
    '            End If
    '            Government(ActiveGovernment).Treasury += LootGained
    '            MsgBox("You gained " & CStr(LootGained) & ",000 " & CurrencyStr & " in treasure.")
    '        End If
    '    Else
    '        'popularity with province goes up
    '        IncrementProvincialLoyalty(ProvinceID)
    '        'popularity with own supporters goes down
    '        DecrementArmyState(ActiveGovernment)
    '        MsgBox("Your army's commitment to your cause has Decreased to " & DescribeArmyState(ActiveGovernment))
    '    End If

    'End Sub

    'Sub DecideHowHandleBenefices(ByVal ProvinceID As Integer)
    '    Dim Benefices As Integer = 0
    '    'Dim OpenBenefices As Integer = 0
    '    Dim LocalNobles As Integer = 0
    '    Dim LocalClergy As Integer = 0
    '    Dim FreePeasants As Integer = 0
    '    Dim Decision As MsgBoxResult
    '    Dim GovernmentID As Integer = 0
    '    Dim OtherProvince As Integer = 0

    '    Benefices = (CalculateTotalBenefices(ProvinceID))
    '    FreePeasants = Benefices - (Province(ProvinceID).Nobles + Province(ProvinceID).Clergy)

    '    If Benefices > 0 Then
    '        LocalNobles = Province(ProvinceID).Nobles
    '        LocalClergy = Province(ProvinceID).Clergy

    '        Decision = MsgBox(Province(ProvinceID).Name & " contains enough land for " & CStr(Benefices) & " benefices.  " & vbCrLf _
    '         & CStr(LocalNobles) & " are occupied by Nobles, " & CStr(LocalClergy) & " are occupied by Clergy, and " _
    '         & CStr(FreePeasants) & " are owned by the Peasants themselves." & vbCrLf _
    '         & "If you redistribute land, you will please those you give it to, but you will alienate those you take it from." & vbCrLf _
    '         & "If you don't redistribute land, you will alienate your followers. " & vbCrLf _
    '         & "DO YOU WANT TO REDISTRIBUTE ANY LAND?", MsgBoxStyle.YesNo, "Seize Land?")
    '        If Decision = vbYes Then
    '            If FreePeasants > 0 Then
    '                Decision = MsgBox(" Some of the land is held by Free Peasants.  Taking it will alienate them but please your followers. " & vbCrLf _
    '                                  & "Do you want to reward your followers with control of the Free Peasants' land?", MsgBoxStyle.YesNo, "Take Peasants' Land?")
    '                If Decision = vbYes Then
    '                    Province(ProvinceID).Nobles += FreePeasants
    '                    DecrementProvincialLoyalty(ProvinceID)

    '                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                    Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " declined to " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "," & vbCrLf _
    '                           & "while your army's commitment to your cause Increased to " & DescribeArmyState(ActiveGovernment))
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if take it below max value for now
    '                    MsgBox("Loyalty in " & Province(ProvinceID).Name & " remained " & NameLoyaltyLevel(Province(ProvinceID).Loyalty) & "," & vbCrLf _
    '                           & "while your army's commitment to your cause Decreased to " & DescribeArmyState(ActiveGovernment) & ".")
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If
    '            End If 'if there are Free Peasants
    '            If LocalNobles > 0 Then
    '                Decision = MsgBox("Do you want to reward your followers with Local Nobles' land?", MsgBoxStyle.YesNo, "Take Nobles' Land?")
    '                If Decision = vbYes Then
    '                    Decision = MsgBox("The Local Nobles offer you tribute of " & CStr(Province(ProvinceID).Nobles) & _
    '                                      ",000 Dinari and their loyalty if you will leave them their lands." & vbCrLf _
    '                                      & "The tribute will satisfy your followers less than the land." & vbCrLf _
    '                                      & "DO YOU WANT TO ACCEPT THE NOBLES' OFFER?", vbYesNo, "Spare the Local Nobles?")
    '                    If Decision = vbYes Then
    '                        Province(ProvinceID).Loyalty = SUPPORTIVE
    '                        Government(ActiveGovernment).Treasury += Province(ProvinceID).Nobles
    '                        'Government(ActiveGovernment).Cavalary += GetLocalKnights(PlayerTarget)
    '                        'MsgBox("The local nobles have joined your army!")
    '                    Else
    '                        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                        DecrementProvincialLoyalty(ProvinceID)
    '                        MsgBox("Your army's commitment to your cause has Increased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    End If
    '                    'DecrememtProvincialLoyalty(PlayerTarget)
    '                    'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If
    '            End If ' if are local nobles
    '            If LocalClergy > 0 Then
    '                Decision = MsgBox("Do you want to reward your followers with Church land?", MsgBoxStyle.YesNo, "Take Church Land?")
    '                If Decision = vbYes Then
    '                    Decision = MsgBox("If you take Church lands, you will be able to support more warriors, but you will " & _
    '                                      "alienate the people of the province as well as offend other Christian peoples." & vbCrLf & vbCrLf _
    '                                      & "DO YOU WANT TO REWARD YOUR FOLLOWERS WITH CHURCH LAND?", vbYesNo, "REally take Church Land?")
    '                    If Decision = vbYes Then
    '                        Province(ProvinceID).Loyalty = REBELLIOUS
    '                        Province(ProvinceID).SocialState = CHAOS
    '                        Province(ProvinceID).Nobles += Province(PlayerTarget).Clergy
    '                        Province(ProvinceID).Clergy = 0
    '                        For OtherProvince = 0 To TotalProvinces - 1
    '                            If OtherProvince <> ProvinceID Then
    '                                If Province(OtherProvince).PoliticalAffiliation = ActiveGovernment Then
    '                                    If Province(OtherProvince).Religion = CATHOLIC Then
    '                                        DecrementProvincialLoyalty(OtherProvince)
    '                                        MsgBox("Support for your government has decreased in " & Province(OtherProvince).Name)
    '                                    End If ' province is Catholic 'WILL NEED TO GENERALIZE THIS FOR ALL RELIGIONS
    '                                End If ' province is controlled by this government
    '                            End If 'this isn't the province itself
    '                        Next
    '                        For GovernmentID = 1 To TotalGovernments - 1
    '                            If GovernmentID <> ActiveGovernment Then
    '                                If Government(GovernmentID).Religion = CATHOLIC Or Government(GovernmentID).Religion = ARIAN Then
    '                                    MsgBox("The " & Government(GovernmentID).Name & " vow to avenge this affront to the Church.")
    '                                End If 'Government is Catholic or Arian
    '                            End If 'Government isn't this one
    '                        Next
    '                        'Decrememt Church support or excommunicate
    '                        'IncrementSupportForGovernment(ActiveGovernment) ' or should this remain flat, since they expect it
    '                        Province(ProvinceID).Clergy = 0
    '                        Province(ProvinceID).Nobles += LocalClergy
    '                        Government(ActiveGovernment).ArmyState += 1 'increment even if takes it above max value for now
    '                        MsgBox("Your army's commitment to your cause has Increased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    Else
    '                        Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                        MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    End If
    '                Else
    '                    Government(ActiveGovernment).ArmyState -= 1 'decrement even if takes it above max value for now
    '                    MsgBox("Your army's commitment to your cause has Decreased.") ' to " & DescribeArmyState(ActiveGovernment))
    '                    'DecrementSupportForGovernment(ActiveGovernment)
    '                End If 'take church land
    '            End If 'there is church land
    '            If Government(ActiveGovernment).ArmyState > FANATICAL Then 'adjunst Army state back within limits
    '                Government(ActiveGovernment).ArmyState = FANATICAL         ' will have to do this with any support index affected
    '            ElseIf Government(ActiveGovernment).ArmyState < INEFFECTUAL Then
    '                Government(ActiveGovernment).ArmyState = INEFFECTUAL
    '            End If

    '            'frmPatronize.ShowDialog()
    '        End If ' take any land
    '    End If 'is land to take

    'End Sub

    'Sub ChangeTextboxAffiliation(ByVal ActiveGov As Integer)

    '    If frmMapScreen.rbnAutonomy.Checked Then
    '        TargetBox.BackColor = GetGovernmentColor(ActiveGov) ' should be active player's color !!!!! - set up to be 2/6
    '        TargetBox.Refresh()
    '    End If

    '    If frmMapScreen.rbnAffiliation.Checked Then
    '        TargetBox.Text = Government(ActiveGov).Name
    '        TargetBox.Refresh()
    '    End If

    'End Sub

    Sub ChangeTextboxSocialState(ByVal ProvID As Integer)

        ' NEED TO GET TEXTBOX TO SET COLOR !!
        If frmMapScreen.rbnSocialStateColor.Checked Then
            TargetBox.BackColor = GetSocialStateColor(Province(ProvID).SocialState) ' should be active player's color !!!!! - set up to be 2/6
            TargetBox.Refresh()
        End If

        If frmMapScreen.rbnSocialStateText.Checked Then
            TargetBox.Text = DescribeSocialState(Province(ProvID).SocialState)
            TargetBox.Refresh()
        End If

    End Sub

    'Sub AttackAI(ByVal ActiveGov As Integer)
    '    Dim ProvinceNum, PotentialTarget, CurrentTarget, CurrentTargetValue, CurrentVictoryPotential, PotentialTargetArea As Integer
    '    Dim TerrainModifier, AttackFactor, CurrentBase, PotentialBase As Integer
    '    Dim DefendingGovernment, DefendingGeneralship, DefendingArmyState, PlayerDefend, DefenseFactor As Integer
    '    Dim VictoryPotential, TreasureValue, LandValue, RentValue As Integer
    '    Dim PeopleToResettle As Integer
    '    Dim AI_Thinking = True
    '    Dim ProvinceOwner As Integer = -1
    '    Dim RelatesWithOwner As Integer = -100
    '    Dim i, j As Integer
    '    Dim PotentialConnectingSeaArea As Integer = -1
    '    Dim PotentialConnectingSea As Integer = -1
    '    Dim PotentialTargetName As String = "" 'only needed for debug box in Sea movement logic

    '    PotentialTarget = -1
    '    PotentialTargetArea = -1
    '    CurrentTarget = -1
    '    CurrentTargetValue = 0
    '    CurrentVictoryPotential = 0
    '    PeopleToResettle = 0
    '    CurrentBase = -1
    '    PotentialBase = -1

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
    '            PeopleToResettle += Province(ProvinceNum).SurplusPopulation
    '        End If
    '    Next

    '    For ProvinceNum = 0 To TotalProvinces - 1
    '        If Province(ProvinceNum).PoliticalAffiliation = ActiveGov Then
    '            PotentialBase = ProvinceNum
    '            For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move 
    '                If Province(PotentialBase).Connectors(i) >= RIVER Then ' if neighbor is land connection
    '                    PotentialTargetArea = Province(PotentialBase).Neighbors(i)
    '                    PotentialTarget = Area(PotentialTargetArea).Province
    '                    If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then

    '                        TerrainModifier = Province(PotentialTarget).Topography + 1

    '                        AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

    '                        DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

    '                        If DefendingGovernment > 0 Then
    '                            'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '                            PlayerDefend = True
    '                        Else
    '                            PlayerDefend = False
    '                        End If

    '                        If PlayerDefend Then
    '                            DefendingGeneralship = Government(DefendingGovernment).Generalship
    '                            DefendingArmyState = Government(DefendingGovernment).ArmyState
    '                        Else
    '                            DefendingGeneralship = 0
    '                            DefendingArmyState = 0
    '                        End If

    '                        DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '                        VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

    '                        If PeopleToResettle > 0 Then
    '                            LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
    '                            If LandValue > CurrentTargetValue Then
    '                                If VictoryPotential >= CurrentVictoryPotential Then
    '                                    ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                    If ProvinceOwner = 0 Then 'if is an independent province
    '                                        CurrentTarget = PotentialTarget
    '                                        CurrentTargetValue = LandValue
    '                                        CurrentVictoryPotential = VictoryPotential
    '                                        CurrentBase = PotentialBase
    '                                    Else 'Province belongs to a Kingdom
    '                                        RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                        If RelatesWithOwner = MIN_RELATES Then
    '                                            CurrentTarget = PotentialTarget
    '                                            CurrentTargetValue = LandValue
    '                                            CurrentVictoryPotential = VictoryPotential
    '                                            CurrentBase = PotentialBase
    '                                        Else ' if isn't actively belligerant
    '                                            RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                            AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                            If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                            End If ' Player is involved
    '                                        End If '  actively belligerant
    '                                    End If 'Belongs to a Kingdom
    '                                End If ' is currently most attractive target
    '                            Else
    '                                If LandValue = CurrentTargetValue Then
    '                                    If VictoryPotential > CurrentVictoryPotential Then
    '                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                            CurrentTarget = PotentialTarget
    '                                            CurrentTargetValue = LandValue
    '                                            CurrentVictoryPotential = VictoryPotential
    '                                            CurrentBase = PotentialBase
    '                                        Else 'Province belongs to a Kingdom
    '                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else ' if isn't actively belligerant
    '                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                    MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                End If ' Player is involved
    '                                            End If '  actively belligerant
    '                                        End If 'Belongs to a Kingdom
    '                                        'CurrentTarget = PotentialTarget
    '                                        'CurrentTargetValue = LandValue
    '                                        'CurrentVictoryPotential = VictoryPotential
    '                                        'CurrentBase = PotentialBase
    '                                    End If
    '                                End If
    '                            End If
    '                        Else ' no people to resettle
    '                            If VictoryPotential > 5 Then
    '                                TreasureValue = Province(PotentialTarget).Townspeople
    '                                RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
    '                                If TreasureValue >= RentValue Then
    '                                    If TreasureValue > CurrentTargetValue Then
    '                                        If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
    '                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                            If ProvinceOwner = 0 Then 'if is an independent province
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else 'Province belongs to a Kingdom
    '                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                If RelatesWithOwner = MIN_RELATES Then
    '                                                    CurrentTarget = PotentialTarget
    '                                                    CurrentTargetValue = LandValue
    '                                                    CurrentVictoryPotential = VictoryPotential
    '                                                    CurrentBase = PotentialBase
    '                                                Else ' if isn't actively belligerant
    '                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                        MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                    End If ' Player is involved
    '                                                End If '  actively belligerant
    '                                            End If 'Belongs to a Kingdom
    '                                            'CurrentTarget = PotentialTarget
    '                                            'CurrentTargetValue = TreasureValue
    '                                            'CurrentVictoryPotential = VictoryPotential
    '                                            'CurrentBase = PotentialBase
    '                                        End If
    '                                    End If
    '                                Else ' if rents more valuable than treasure
    '                                    If RentValue > CurrentTargetValue Then
    '                                        If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
    '                                            ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                            If ProvinceOwner = 0 Then 'if is an independent province
    '                                                CurrentTarget = PotentialTarget
    '                                                CurrentTargetValue = LandValue
    '                                                CurrentVictoryPotential = VictoryPotential
    '                                                CurrentBase = PotentialBase
    '                                            Else 'Province belongs to a Kingdom
    '                                                RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                If RelatesWithOwner = MIN_RELATES Then
    '                                                    CurrentTarget = PotentialTarget
    '                                                    CurrentTargetValue = LandValue
    '                                                    CurrentVictoryPotential = VictoryPotential
    '                                                    CurrentBase = PotentialBase
    '                                                Else ' if isn't actively belligerant
    '                                                    RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                    AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                    If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                        MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                           & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                    End If ' Player is involved
    '                                                End If '  actively belligerant
    '                                            End If 'Belongs to a Kingdom
    '                                            'CurrentTarget = PotentialTarget
    '                                            'CurrentTargetValue = RentValue
    '                                            'CurrentVictoryPotential = VictoryPotential
    '                                            'CurrentBase = PotentialBase
    '                                        End If
    '                                    End If 'Rents here > current target
    '                                End If 'treasure > rents
    '                            End If ' half a chance of victory
    '                        End If ' have people to resettle

    '                    End If ' isn't one of own provinces
    '                Else 'if is a Sea connection
    '                    If Province(PotentialBase).Connectors(i) = SEALANE Then
    '                        If Government(ActiveGov).NavalCapability > 0 Then
    '                            PotentialConnectingSeaArea = Province(PotentialBase).Neighbors(i)
    '                            PotentialConnectingSea = Area(PotentialConnectingSeaArea).Province
    '                            If Sea(PotentialConnectingSea).Topography >= -(Government(ActiveGov).NavalCapability) Then
    '                                For j = 0 To MAX_NEIGHBORS_SEA - 1
    '                                    If Sea(PotentialConnectingSea).Neighbors(j) >= 0 Then
    '                                        PotentialTargetArea = Sea(PotentialConnectingSea).Neighbors(j)
    '                                        If Area(PotentialTargetArea).Type >= LAND Then
    '                                            PotentialTarget = Area(PotentialTargetArea).Province
    '                                            If Province(PotentialTarget).ID <> Province(PotentialBase).ID Then 'if not trying to invade itself
    '                                                If Province(PotentialTarget).PoliticalAffiliation <> ActiveGov Then
    '                                                    TerrainModifier = Province(PotentialTarget).Topography + 1

    '                                                    AttackFactor = CalculateAttackFactor(PotentialBase, PotentialTarget, AI_Thinking)

    '                                                    DefendingGovernment = Province(PotentialTarget).PoliticalAffiliation

    '                                                    If DefendingGovernment > 0 Then
    '                                                        'PlayerDefending = Rand.Next(0, 2) ' can be variable later
    '                                                        PlayerDefend = True
    '                                                    Else
    '                                                        PlayerDefend = False
    '                                                    End If

    '                                                    If PlayerDefend Then
    '                                                        DefendingGeneralship = Government(DefendingGovernment).Generalship
    '                                                        DefendingArmyState = Government(DefendingGovernment).ArmyState
    '                                                    Else
    '                                                        DefendingGeneralship = 0
    '                                                        DefendingArmyState = 0
    '                                                    End If

    '                                                    DefenseFactor = CalculateDefenseFactor(PotentialTarget, PlayerDefend, DefendingGeneralship, DefendingArmyState, AI_Thinking)

    '                                                    VictoryPotential = ApplyCombatModifiers(AttackFactor, DefenseFactor, PotentialTarget, PotentialBase, DefendingGeneralship, DefendingArmyState)

    '                                                    If PeopleToResettle > 0 Then
    '                                                        LandValue = Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants
    '                                                        If LandValue > CurrentTargetValue Then
    '                                                            If VictoryPotential >= CurrentVictoryPotential Then
    '                                                                ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                    CurrentTarget = PotentialTarget
    '                                                                    CurrentTargetValue = LandValue
    '                                                                    CurrentVictoryPotential = VictoryPotential
    '                                                                    CurrentBase = PotentialBase
    '                                                                Else 'Province belongs to a Kingdom
    '                                                                    RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                    If RelatesWithOwner = MIN_RELATES Then
    '                                                                        CurrentTarget = PotentialTarget
    '                                                                        CurrentTargetValue = LandValue
    '                                                                        CurrentVictoryPotential = VictoryPotential
    '                                                                        CurrentBase = PotentialBase
    '                                                                    Else ' if isn't actively belligerant
    '                                                                        RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                        AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                        If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                            MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                        End If ' Player is involved
    '                                                                    End If '  actively belligerant
    '                                                                End If 'Belongs to a Kingdom
    '                                                            End If ' is currently most attractive target
    '                                                        Else
    '                                                            If LandValue = CurrentTargetValue Then
    '                                                                If VictoryPotential > CurrentVictoryPotential Then
    '                                                                    ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                    If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                        CurrentTarget = PotentialTarget
    '                                                                        CurrentTargetValue = LandValue
    '                                                                        CurrentVictoryPotential = VictoryPotential
    '                                                                        CurrentBase = PotentialBase
    '                                                                    Else 'Province belongs to a Kingdom
    '                                                                        RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                        If RelatesWithOwner = MIN_RELATES Then
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else ' if isn't actively belligerant
    '                                                                            RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                            AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                            If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                            End If ' Player is involved
    '                                                                        End If '  actively belligerant
    '                                                                    End If 'Belongs to a Kingdom
    '                                                                    'CurrentTarget = PotentialTarget
    '                                                                    'CurrentTargetValue = LandValue
    '                                                                    'CurrentVictoryPotential = VictoryPotential
    '                                                                    'CurrentBase = PotentialBase
    '                                                                End If
    '                                                            End If
    '                                                        End If
    '                                                    Else ' no people to resettle
    '                                                        If VictoryPotential > 5 Then
    '                                                            TreasureValue = Province(PotentialTarget).Townspeople
    '                                                            RentValue = Province(PotentialTarget).Peasants \ PEASANTS_PER_BENEFICE
    '                                                            If TreasureValue >= RentValue Then
    '                                                                If TreasureValue > CurrentTargetValue Then
    '                                                                    If VictoryPotential >= CurrentVictoryPotential - ((TreasureValue / CurrentTargetValue) - 1) Then
    '                                                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else 'Province belongs to a Kingdom
    '                                                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                                                CurrentTarget = PotentialTarget
    '                                                                                CurrentTargetValue = LandValue
    '                                                                                CurrentVictoryPotential = VictoryPotential
    '                                                                                CurrentBase = PotentialBase
    '                                                                            Else ' if isn't actively belligerant
    '                                                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                    MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                                End If ' Player is involved
    '                                                                            End If '  actively belligerant
    '                                                                        End If 'Belongs to a Kingdom
    '                                                                        'CurrentTarget = PotentialTarget
    '                                                                        'CurrentTargetValue = TreasureValue
    '                                                                        'CurrentVictoryPotential = VictoryPotential
    '                                                                        'CurrentBase = PotentialBase
    '                                                                    End If
    '                                                                End If
    '                                                            Else ' if rents more valuable than treasure
    '                                                                If RentValue > CurrentTargetValue Then
    '                                                                    If VictoryPotential >= CurrentVictoryPotential - ((RentValue / CurrentTargetValue) - 1) Then
    '                                                                        ProvinceOwner = Province(PotentialTarget).PoliticalAffiliation
    '                                                                        If ProvinceOwner = 0 Then 'if is an independent province
    '                                                                            CurrentTarget = PotentialTarget
    '                                                                            CurrentTargetValue = LandValue
    '                                                                            CurrentVictoryPotential = VictoryPotential
    '                                                                            CurrentBase = PotentialBase
    '                                                                        Else 'Province belongs to a Kingdom
    '                                                                            RelatesWithOwner = Government(ActiveGov).DiplomaticRelations(Province(PotentialTarget).PoliticalAffiliation)
    '                                                                            If RelatesWithOwner = MIN_RELATES Then
    '                                                                                CurrentTarget = PotentialTarget
    '                                                                                CurrentTargetValue = LandValue
    '                                                                                CurrentVictoryPotential = VictoryPotential
    '                                                                                CurrentBase = PotentialBase
    '                                                                            Else ' if isn't actively belligerant
    '                                                                                RelatesWithOwner = DecrementDiploRelates(RelatesWithOwner)
    '                                                                                AdjustDiploRelates(ActiveGov, ProvinceOwner, RelatesWithOwner)
    '                                                                                If ActiveGov = PlayerSide Or ProvinceOwner = PlayerSide Then
    '                                                                                    MsgBox("Spies report that the " & Government(ActiveGov).Name & "'s attitude toward you has declined to " _
    '                                                                                       & DescribeDiploRelations(ActiveGov, ProvinceOwner) & ".")
    '                                                                                End If ' Player is involved
    '                                                                            End If '  actively belligerant
    '                                                                        End If 'Belongs to a Kingdom
    '                                                                        'CurrentTarget = PotentialTarget
    '                                                                        'CurrentTargetValue = RentValue
    '                                                                        'CurrentVictoryPotential = VictoryPotential
    '                                                                        'CurrentBase = PotentialBase
    '                                                                    End If
    '                                                                End If 'Rents here > current target
    '                                                            End If 'treasure > rents
    '                                                        End If ' half a chance of victory
    '                                                    End If ' have people to resettle

    '                                                End If ' not owned by Active Government 
    '                                            End If 'not self
    '                                            'Else ' if neighbor = -1, ie, no more neighbors 'no, this would stop consideration if has sea connect to sea, even if possibly other land beyond
    '                                            'Exit For
    '                                        End If ' Land Neighbor to sea zone 
    '                                    End If ' this possibility is a Province or sea
    '                                Next 'next Neighbor of Potential Connecting Sea
    '                            End If ' if Naval Capable of operation in this type of sea
    '                        End If ' Government has Naval Capability
    '                    End If 'Connector is a Sealane (since already checked if Land Connection, only thing left would be -1, no connector
    '                End If ' if Neighbor is land connection
    '            Next ' i/Neighbor
    '        End If ' province is active government's (so can act as base)
    '    Next

    '    If CurrentTarget > -1 Then
    '        PlayerAction = ATTACKING
    '        PlayerTarget = CurrentTarget
    '        PlayerBase = CurrentBase
    '        If Province(PlayerTarget).PoliticalAffiliation = PlayerSide Then
    '            MsgBox("The " & Government(ActiveGov).Name & " are attacking " & Province(PlayerTarget).Name & " from " _
    '                   & Province(PlayerBase).Name)
    '        End If
    '        'Else
    '        'NegotiateAI(ActiveGov)
    '        'MsgBox("The " & GetGovernmentName(ActiveGov) & " will not attack this round. ") ' don't need to know this
    '    End If

    'End Sub

    Sub NegotiateAI(ByVal ActiveGmt As Integer)
        Dim OtherGmt As Integer = 0
        Dim IsContiguous As Boolean = False
        Dim Relationship As Integer = -100
        Dim NegotiatingPartner As Integer = -1
        Dim ThreatLevel As Integer = -100
        Dim ThreatPower As Integer = 0
        Dim PowerRatio As Integer = -100
        Dim Rand As New Random
        Dim RandomNum As Integer = -100
        Dim Decision As MsgBoxResult = MsgBoxResult.No

        Randomize()

        For OtherGmt = 1 To TotalGovernments - 1
            If OtherGmt <> ActiveGmt Then ' if not looking at self
                If OtherGmt <> PlayerSide Or ((OtherGmt = PlayerSide) And (Government(PlayerSide).Reputation > DISHONEST)) Then
                    IsContiguous = DetermineIfGovernmentsContiguous(ActiveGmt, OtherGmt)
                    If IsContiguous = True Then
                        Relationship = Government(ActiveGmt).DiplomaticRelations(OtherGmt)
                        If Relationship < MAX_RELATES Then ' at moment, won't do anything if it's at max; if change this, can make <> into = (or add else)
                            If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                                NegotiatingPartner = OtherGmt
                                ThreatLevel = Relationship 'MIN_RELATES 'shouldn't this be 0
                                ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                            Else ' if is a current potential negotiating partner
                                If Relationship < ThreatLevel Then ' if relations with this Kingdom are worse than with current prospect, this trumps it
                                    NegotiatingPartner = OtherGmt
                                    ThreatLevel = Relationship 'MIN_RELATES
                                    ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                                Else 'if relations are the same level
                                    If Relationship = ThreatLevel Then
                                        PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                                        If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                                            NegotiatingPartner = OtherGmt
                                            ThreatPower = PowerRatio
                                        Else
                                            If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                                                If Rand.Next(0, 2) = 1 Then
                                                    NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                                                End If
                                            End If 'if this threat is same
                                        End If 'if this threat is worse than current threat
                                    End If ' if this relationship is same as potential partner's
                                End If 'if this relationship is worse than potential partner's
                            End If 'if no current potential partner
                        End If 'is already at Max
                        'Select Case Relationship
                        '    Case MIN_RELATES 'at this point, hostile
                        '        If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                        '            NegotiatingPartner = OtherGmt
                        '            ThreatLevel = MIN_RELATES
                        '            ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                        '        Else ' if there is a current potential partner
                        '            If ThreatLevel = MIN_RELATES Then ' if current partner is also as hostile as can be
                        '                PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                        '                If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                        '                    NegotiatingPartner = OtherGmt
                        '                    ThreatPower = PowerRatio
                        '                Else
                        '                    If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                        '                        If Rand.Next(0, 2) = 1 Then
                        '                            NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                        '                        End If
                        '                    End If
                        '                End If
                        '            Else 'otherwise this trumps it
                        '                NegotiatingPartner = OtherGmt
                        '                ThreatLevel = MIN_RELATES
                        '                ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                        '            End If
                        '        End If
                        '    Case MAX_RELATES ' at this point, friendly
                        '        ' nothing to do for the moment
                        '    Case Else ' at this point, is Neutral
                        '        If NegotiatingPartner = -1 Then ' if no current potential negotiating partner
                        '            NegotiatingPartner = OtherGmt
                        '            ThreatLevel = MIN_RELATES
                        '            ThreatPower = CalculatePowerRatio(ActiveGmt, OtherGmt) 'REMEMBER, THE MORE NEGATIVE THE THREAT, THE WORSE IT IS !
                        '        Else ' if is a current potential negotiating partner
                        '            If Relationship < ThreatLevel Then ' if relations with this Kingdom are worse than with current prospect, this trumps it
                        '                NegotiatingPartner = OtherGmt
                        '                ThreatLevel = MIN_RELATES
                        '                ThreatPower = -(CalculatePowerRatio(ActiveGmt, OtherGmt)) ' negative because if other is more powerful, it's a bigger threat
                        '            Else 'if relations are the same level
                        '                If Relationship = ThreatLevel Then
                        '                    PowerRatio = CalculatePowerRatio(ActiveGmt, OtherGmt)
                        '                    If PowerRatio < ThreatPower Then ' see if this threat is worse than current
                        '                        NegotiatingPartner = OtherGmt
                        '                        ThreatPower = PowerRatio
                        '                    Else
                        '                        If PowerRatio = ThreatPower Then ' if equal threats, flip a coin
                        '                            If Rand.Next(0, 2) = 1 Then
                        '                                NegotiatingPartner = OtherGmt ' if one, then this becomes the new neg. partner (threat level and power stay same since was a tie)
                        '                            End If
                        '                        End If
                        '                    End If
                        '                End If
                        '            End If
                        '        End If
                        'End Select
                    End If ' is contiguous
                End If 'isn't player or is player but player's reputation > Dishonest
            End If ' isn't self
        Next

        If NegotiatingPartner > -1 Then
            PlayerAction = PARLEYING

            If NegotiatingPartner = PlayerSide Then
                If Government(ActiveGmt).DiplomaticRelations(PlayerSide) < MAX_RELATES Then ' to avoid initiating neg. only to find it's as good as it gets
                    If Government(PlayerSide).Reputation > DISHONEST Then
                        MsgBox(Government(ActiveGmt).Name & " wants to Negotiate with you.")
                        'Decision = MsgBox("The " & Government(ActiveGmt).Name & " want to Negotiate with You." & vbCrLf & vbCrLf _
                        '                  & "Will you receive their Ambassador?", MsgBoxStyle.YesNo, "Receive Ambassador from " & GetGovernmentName(ActiveGmt) & "?")
                        'If Decision = MsgBoxResult.Yes Then
                        Negotiate(NegotiatingPartner, ActiveGmt) 'reversed so PLayer become active gvt in actual negotiations
                    End If ' if AI will trust player
                End If 'not already at max
            Else
                Relationship = IncrementDiploRelates(ThreatLevel)
                AdjustDiploRelates(ActiveGmt, NegotiatingPartner, Relationship)
                RandomNum = Rand.Next(0, 2)
                If RandomNum = 1 Then
                    MsgBox("Spies report that the relationship between " & Government(ActiveGmt).Name & " and " _
                           & Government(NegotiatingPartner).Name & " has improved to " & DescribeDiploRelations(ActiveGmt, NegotiatingPartner) & ".")
                End If
            End If
            ConcludeAction()
        Else
            ConcludeAction()
            'Relationship = IncrementDiploRelates(ThreatLevel)
            'AdjustDiploRelates(ActiveGmt, NegotiatingPartner, Relationship)
            'MsgBox("Spies report that the relationship between the " & GetGovernmentName(ActiveGmt) & " and the " _
            '       & GetGovernmentName(NegotiatingPartner) & " have improved to " & DescribeDiploRelations(ActiveGmt, NegotiatingPartner) & ".")
        End If


    End Sub

    Sub AdministerProvince(ByVal ThisProvince As Integer, ByVal Ruler As Integer, ByVal ProvincesAdministering As Integer, sender As Object)
        Dim SuccessThreshhold As Integer = 4 ' 5 'seemed too easy to get improvements
        Dim Decision As MsgBoxResult
        Dim MsgStr As String = ""
        Dim MsgStr2 As String = ""
        Dim LanguageDifferential As Integer = 0
        Dim ReligiousDifferential As Integer = 0
        Dim Rand As New Random
        Dim DieRoll As Integer = 0
        Dim CostToHelp As Integer = 0
        Dim GoOn As Boolean = True
        Dim Payment As Integer = 0
        'Dim ArmyRatio As Integer = 0

        Randomize() ' should this be here?

        If Province(ThisProvince).ControlLevel = AUTONOMOUS Then
            MsgStr = "The Leaders of " & Province(ThisProvince).Name & " avow that It has Traditionally administered it's own Justice. "
            MsgStr &= "While They acknowledge your Royal Role as Chief Judge of the Realm and appreciate your Concern for their Welfare, "
            MsgStr &= "They protest that They can manage their own Affairs." & DOUBLE_SPACE
            MsgStr &= "You can assert your Prerogative to Administer Justice in " & Province(ThisProvince).Name & ", but given your King's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
            MsgStr &= " Political Skills and the Province's " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & " Loyalty,"
            MsgStr &= "there is a "
            If Government(ActiveGovernment).PoliticalSavvy + Province(ThisProvince).Loyalty > ENTHUSIASTIC Then
                MsgStr &= "slight "
            Else
                If Government(ActiveGovernment).PoliticalSavvy + Province(ThisProvince).Loyalty < REBELLIOUS Then
                    MsgStr &= "strong "
                End If
            End If

            MsgStr &= "chance that the Province will Resist rather than Accept this Imposition." & DOUBLE_SPACE

            Payment = Province(ThisProvince).Nobles - -Province(ThisProvince).TownCharters - Government(ActiveGovernment).PoliticalSavvy

            If Payment <= Government(ActiveGovernment).Treasury And Payment >= 1 Then
                MsgStr &= "You can improve your Chances by rewarding your Supporters with Gifts totalling "

                'MsgStr &= CStr(3 - Government(ActiveGovernment).PoliticalSavvy) & ",000 " & CurrencyStr & " from your Treasury's total of "
                MsgStr &= CStr(Payment) & ",000 " & CurrencyStr & " from your Treasury's total of "
                MsgStr &= CStr(Government(ActiveGovernment).Treasury) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE
            End If

            MsgStr2 = MsgStr

            If Payment <= Government(ActiveGovernment).Treasury Then
                'MsgStr &= "Click 'Yes' to Pay the " & CStr(3 - Government(ActiveGovernment).PoliticalSavvy) & ",000 " & CurrencyStr & " and Proceed." & vbCrLf
                MsgStr &= "Click 'Yes' to Pay the " & CStr(Payment) & ",000 " & CurrencyStr & " and Proceed." & vbCrLf
                MsgStr &= "Click 'No' to Proceed without paying anything." & vbCrLf
                MsgStr &= "Click 'Cancel' to Administer Justice in a More Deserving Province."
                Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Administer Justice in Autonomous " & Province(ThisProvince).Name & "?")
            Else
                MsgStr &= "Click 'OK to Proceed." & vbCrLf
                MsgStr &= "Click 'Cancel' to Administer Justice in a More Deserving Province."
                Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Administer Justice in Autonomous " & Province(ThisProvince).Name & "?")
            End If

            Select Case Decision
                Case MsgBoxResult.Cancel
                    Exit Sub
                Case MsgBoxResult.No
                    DieRoll = 0
                Case MsgBoxResult.Ok
                    DieRoll = 0
                Case MsgBoxResult.Yes
                    DieRoll = Rand.Next(0, (3 - Government(ActiveGovernment).PoliticalSavvy))
                    Government(ActiveGovernment).Treasury -= Payment
            End Select
            'MsgStr2 &= CStr(DieRoll) & vbCrLf
            MsgStr2 &= SPACER_STR & vbCrLf

            DieRoll += 4 - Rand.Next(0, 9)
            'MsgStr2 &= CStr(DieRoll) & DOUBLE_SPACE

            If Government(ActiveGovernment).PoliticalSavvy + Province(ThisProvince).Loyalty + DieRoll < 0 Then
                Do While Province(ThisProvince).Loyalty > REBELLIOUS
                    DecrementProvincialLoyalty(ThisProvince)
                Loop

                DecrementControlLevel(ThisProvince)

                MsgStr2 &= "Insisting that the King's Imposition represents an Illegitimate Infringement of its Traditional Liberties, "

                MsgStr2 &= Province(ThisProvince).Name & " will not agree to let the King Administer Justice in the Province at this Time"
                DecrementProvincialLoyalty(ThisProvince)
                If Province(ThisProvince).Loyalty > DISENCHANTED Then
                    MsgStr2 &= ", and Loyalty to the Crown Declined to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty)
                Else
                    DecrementControlLevel(ThisProvince)
                    MsgStr2 &= ", and the Province has Broken its Ties to the Crown and become " & NameControlLevel(Province(ThisProvince).ControlLevel)
                End If
                MsgStr2 &= "."
                'MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Administer Justice in Autonomous " & Province(ThisProvince).Name & "?")
                GoOn = False
            Else
                MsgStr2 &= "The Leaders of " & Province(ThisProvince).Name & "  agree to let the King Administer Justice in the Province at this Time."
                'MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Administer Justice in Autonomous " & Province(ThisProvince).Name & "?")
                GoOn = True
            End If
            MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Administer Justice in Autonomous " & Province(ThisProvince).Name & "?")
        End If

        If GoOn = True Then

            'SuccessThreshhold += Government(Ruler).PoliticalSavvy ' Success Threshhold initialized at 5

            'SuccessThreshhold += Province(ThisProvince).SocialState

            SuccessThreshhold += Government(Ruler).AdminAbility

            If Province(ThisProvince).ControlLevel >= SUBORDINATE Then
                SuccessThreshhold += Government(Ruler).ArmyState
                SuccessThreshhold += Province(ThisProvince).TownCharters
            End If

            SuccessThreshhold += Province(ThisProvince).Loyalty

            SuccessThreshhold += Government(Ruler).LawCode

            SuccessThreshhold += Government(Ruler).Parlements

            SuccessThreshhold += Province(ThisProvince).AdminLevel

            SuccessThreshhold += Province(ThisProvince).ControlLevel

            ReligiousDifferential = CalculateReligiousDifferential(Government(Ruler).Religion, Province(ThisProvince).Religion)
            SuccessThreshhold -= ReligiousDifferential

            LanguageDifferential = CalculateLanguageDifference(Government(Ruler).Language, Province(ThisProvince).Language)
            SuccessThreshhold -= LanguageDifferential

            If Province(ThisProvince).SurplusPopulation Then
                SuccessThreshhold -= 1 + Province(ThisProvince).SurplusPopulation \ 10 'also arbrary; see below
            End If

            'SuccessThreshhold -= ProvincesAdministering \ 10 ' 10 is arbitrary, but embodies that the more provinces to admin, the more difficult

            'If Province(ProvinceID).Religion = CATHOLIC Then
            '    SuccessThreshhold += Province(ProvinceID).Clergy \ (3 - Government(Ruler).PapalRelations 'activate once add in Papal Relations
            'End 

            If SuccessThreshhold < 0 Then
                SuccessThreshhold = 0
            Else
                If SuccessThreshhold > 10 Then
                    SuccessThreshhold = 10
                End If
            End If


            MsgStr = "The Social State of " & Province(ThisProvince).Name & " is currently " & DescribeSocialState(Province(ThisProvince).SocialState) & "." & vbCrLf

            MsgStr &= "Your efforts to administer it have " & DescribeChanceOfSuccess(SuccessThreshhold) & " of improving things." & DOUBLE_SPACE

            MsgStr &= SPACER_STR & vbCrLf

            MsgStr &= "Your King's Administrative Ability is  " & GetAbilityNames(Government(Ruler).AdminAbility) & "." & vbCrLf

            MsgStr &= "His Political Skills are " & GetAbilityNames(Government(Ruler).PoliticalSavvy) & "." & DOUBLE_SPACE

            MsgStr &= "The Province's Relationship with the Crown is " & NameControlLevel(Province(ThisProvince).ControlLevel) & "." & vbCrLf
            MsgStr &= "Its Loyalty is " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "." & DOUBLE_SPACE


            If Province(ThisProvince).ControlLevel >= SUBORDINATE Then
                MsgStr &= "Your Army is " & DescribeArmyState(Government(Ruler).ArmyState) & "." & DOUBLE_SPACE
                MsgStr &= "You have Chartered " & CStr(Province(ThisProvince).TownCharters) & " Towns in the Province." & DOUBLE_SPACE
            End If

            MsgStr &= "You have "
            If Government(Ruler).LawCode = 0 Then
                MsgStr &= "not yet "
            End If
            MsgStr &= "Codified your Laws." & vbCrLf

            MsgStr &= "You have "
            If Government(Ruler).Parlements = 0 Then
                MsgStr &= "not yet "
            End If
            MsgStr &= "established a Parlement." & vbCrLf

            MsgStr &= "You have "
            If Province(ThisProvince).AdminLevel = 0 Then
                MsgStr &= "not yet "
            End If
            MsgStr &= "installed a " & DescribeAdminLevel(Province(ThisProvince).AdminLevel + 1) & "." & DOUBLE_SPACE

            If ReligiousDifferential > 0 Then
                MsgStr &= "The fact that your Government is " & NameReligion(Government(Ruler).Religion) & " while the People of "

                MsgStr &= Province(ThisProvince).Name & " are " & NameReligion(Province(ThisProvince).Religion) & " makes the Situation "

                If ReligiousDifferential = 2 Then
                    MsgStr &= "much "
                End If

                MsgStr &= "more Difficult." & DOUBLE_SPACE
            End If

            MsgStr &= "The fact that your Government speaks "

            If LanguageDifferential = 0 Then
                MsgStr &= "the same "
            Else
                MsgStr &= "a different "
            End If

            If LanguageDifferential <= 1 Then
                MsgStr &= "Dialect "
                If LanguageDifferential = 0 Then
                    MsgStr &= "as "
                Else
                    MsgStr &= "from "
                End If
            Else
                MsgStr &= "Language than "
            End If

            MsgStr &= "the People of " & Province(ThisProvince).Name & " makes the Situation "

            If LanguageDifferential = 2 Then
                MsgStr &= "much "
            End If

            If LanguageDifferential = 0 Then
                MsgStr &= "Easier."
            Else
                MsgStr &= "more Difficult."
            End If
            MsgStr &= DOUBLE_SPACE

            If Province(ThisProvince).SurplusPopulation > 0 Then
                MsgStr &= "There is "
                If Province(ThisProvince).SurplusPopulation > 10 Then
                    MsgStr &= "Famine "
                Else
                    MsgStr &= "Hunger "
                End If
                MsgStr &= "in the Land, and desperate People roam the Countryside." & DOUBLE_SPACE
            End If

            MsgStr &= SPACER_STR & vbCrLf

            If SuccessThreshhold < 10 Then
                'CostToHelp = Province(ThisProvince).Peasants \ PEASANTS_PER_BENEFICE
                'CostToHelp = 1 + (Province(ThisProvince).Nobles \ (3 + Province(ThisProvince).Loyalty))

                CostToHelp = Province(ThisProvince).Nobles - Province(ThisProvince).Loyalty

                If Government(Ruler).Treasury >= CostToHelp Then
                    MsgStr &= "You have " & CStr(Government(Ruler).Treasury) & ",000 " & CurrencyStr & " in your Treasury." & vbCrLf
                    Decision = MsgBox(MsgStr & "You can improve your Chances of Success by spending " & CostToHelp & ",000 " & CurrencyStr & "." & DOUBLE_SPACE _
                                      & "DO YOU WANT TO SPEND THE MONEY?", MsgBoxStyle.YesNo, "Administer " & Province(ThisProvince).Name)
                    If Decision = vbYes Then
                        Government(Ruler).Treasury -= CostToHelp
                        SuccessThreshhold += 1
                    End If ' money committed
                Else
                    MsgBox(MsgStr & "You do not have enough Money in your Treasury to influnce the Outcome.")
                End If 'have enough money

                If ActiveGovernment = PlayerSide Then
                    If SuccessThreshhold < 10 Then
                        MsgStr = "You have a " & CStr(SuccessThreshhold) & "0% chance of Success ... "
                        MsgBox(MsgStr)
                        MsgStr &= DOUBLE_SPACE
                    Else
                        MsgStr = ""
                    End If
                Else
                    MsgStr = ""
                End If

            End If 'isn't overwhelming chance of success

            DieRoll = Rand.Next(1, 11)

            'If ActiveGovernment = PlayerSide Then
            '    If SuccessThreshhold < 10 Then
            '        MsgStr = MsgStr & "The result is " & CStr(DieRoll) & "! " & vbCrLf
            '    End If
            'End If ' is player's concern

            ' NEED TO MAKE THIS MUCH MORE CONSEQUENTIAL: LOYALTY RISE SHOULD = DIFFERENCE BETWEEN THRESHHOLD AND DIE ROLL, SO CAN HAVE BIG IMPACT
            ' AND LEAD TO IMPROVED CONTROL LEVEL -- OR ADD IN RANDOM INCREASE OF CONTROL LEVEL BASED ON POL SAVVY AND ADMIN ABILITY
            ' OR BOTH
            ' SAME WITH REVINUE: SHOULD HAVE CHANCE OF MAKE MONEY FROM ADMIN JUSTICE?

            If DieRoll <= SuccessThreshhold Then
                If Province(ThisProvince).SocialState < BOOMING Then
                    IncrementSocialState(ThisProvince, BOOMING)
                    MsgStr &= "Your Activities were a Success!" & DOUBLE_SPACE & "Social Conditions in " & Province(ThisProvince).Name
                    MsgStr &= " have improved to " & DescribeSocialState(Province(ThisProvince).SocialState)
                    SetTargetTextbox(ThisProvince)
                    ChangeTextboxSocialState(ThisProvince)
                    IncrementSocialVPs(Province(ThisProvince).SocialState)
                Else
                    MsgStr &= "Social conditions in " & Province(ThisProvince).Name & " remain " & BOOMING_STR
                End If
                If DieRoll <= (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
                    IncrementProvincialLoyalty(ThisProvince)
                    If Province(ThisProvince).Loyalty = ENTHUSIASTIC Then
                        If Province(ThisProvince).ControlLevel < MAX_CONTROL_LEVEL Then
                            MsgStr &= ", while its Relationship to the Crown has risen to " & NameControlLevel(Province(ThisProvince).ControlLevel + 1) & "!"
                        End If
                        IncrementControlLevel(ThisProvince)
                    Else
                        MsgStr &= ", while its Loyalty has increased to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                    End If
                Else
                    MsgStr &= ", although its Loyalty remains " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                End If
                'MsgBox(MsgStr)
                'SetActionTarget()
            Else 'if DieRoll <= to SuccesTHreshold
                If DieRoll > SuccessThreshhold * 2 Then
                    If Province(ThisProvince).SocialState > CHAOS Then
                        DecrementSocialState(ThisProvince, CHAOS)
                        SetTargetTextbox(ThisProvince)
                        ChangeTextboxSocialState(ThisProvince)
                        MsgStr &= "Your activities in " & Province(ThisProvince).Name & " provoked Resistance." & DOUBLE_SPACE & "Social Conditions there have deteriorated to " & DescribeSocialState(Province(ThisProvince).SocialState)
                        'DecrementProvincialLoyalty(ThisProvince)
                        DecrementSocialVPs(Province(ThisProvince).SocialState)
                        'RefreshSocialStateVP_Display()
                    Else
                        MsgStr &= "Conditions remain Chaotic in " & Province(ThisProvince).Name
                        'MsgBox(MsgStr)
                    End If
                    If DieRoll > 2 * (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
                        DecrementProvincialLoyalty(ThisProvince)
                        If Province(ThisProvince).Loyalty = REBELLIOUS Then
                            If Province(ThisProvince).ControlLevel > INDEPENDENT Then
                                MsgStr &= ", and its Relationship to the Crown has deteriorated to " & NameControlLevel(Province(ThisProvince).ControlLevel - 1) & "!"
                            End If
                            DecrementControlLevel(ThisProvince)
                        Else
                            MsgStr &= ", while its Loyalty has decreased to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                        End If
                    Else
                        MsgStr &= ", although its Loyalty remains " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                    End If
                Else
                    MsgStr &= "Reactions to your Rule in " & Province(ThisProvince).Name & " were Mixed." & DOUBLE_SPACE & "Social Conditions there remain Unchanged" ' & DescribeSocialState(ThisProvince) & "."
                    If DieRoll <= (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
                        IncrementProvincialLoyalty(ThisProvince)
                        If Province(ThisProvince).Loyalty = ENTHUSIASTIC Then
                            If Province(ThisProvince).ControlLevel < MAX_CONTROL_LEVEL Then
                                MsgStr &= ", while its Relationship to the Crown has risen to " & NameControlLevel(Province(ThisProvince).ControlLevel + 1)
                            End If
                            IncrementControlLevel(ThisProvince)
                        Else
                            MsgStr &= ", while its Loyalty has increased to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty)
                        End If
                    Else
                        If DieRoll > 2 * (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
                            DecrementProvincialLoyalty(ThisProvince)
                            If Province(ThisProvince).Loyalty = REBELLIOUS Then
                                If Province(ThisProvince).ControlLevel > INDEPENDENT Then
                                    MsgStr &= ", while its Relationship to the Crown has deteriorated to "
                                    MsgStr &= NameControlLevel(Province(ThisProvince).ControlLevel - 1) & "!"
                                End If
                                DecrementControlLevel(ThisProvince)
                            Else
                                MsgStr &= ", while its Loyalty has decreased to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                            End If
                        Else
                            MsgStr &= ", and its Loyalty remains " & NameLoyaltyLevel(Province(ThisProvince).Loyalty) & "."
                        End If
                    End If
                End If
            End If
            'Else ' don't need this: if threshhold > 10, then Die roll will automatically be less, so will be handled by successful low roll
            '    If Province(ThisProvince).SocialState < BOOMING Then
            '        IncrementSocialState(ThisProvince, BOOMING)
            '        MsgStr &= "Your Activities were a success! Social Conditions in " & Province(ThisProvince).Name & " have improved to " & DescribeSocialState(Province(ThisProvince).SocialState)
            '        SetTargetTextbox(ThisProvince)
            '        ChangeTextboxSocialState(ThisProvince)
            '        IncrementSocialVPs(Province(ThisProvince).SocialState)
            '    Else
            '        MsgStr = "Social conditions in " & Province(ThisProvince).Name & " remain " & BOOMING_STR
            '    End If
            '    If DieRoll <= (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
            '        IncrementProvincialLoyalty(ThisProvince)
            '        If Province(ThisProvince).Loyalty = ENTHUSIASTIC Then
            '            If Province(ThisProvince).ControlLevel < MAX_CONTROL_LEVEL Then
            '                MsgStr &= ", while its Relationship to the Crown has risen to " & NameControlLevel(Province(ThisProvince).ControlLevel + 1)
            '            End If
            '            IncrementControlLevel(ThisProvince)
            '        Else
            '            MsgStr &= ", while its Loyalty has increased to " & NameLoyaltyLevel(Province(ThisProvince).Loyalty)
            '        End If
            '    Else
            '        MsgStr &= ", although its Loyalty remains " & NameLoyaltyLevel(Province(ThisProvince).Loyalty)
            '    End If

            '    MsgStr &= "."

            'IncrementSocialState(ThisProvince, BOOMING)
            ''MsgStr = MsgStr & vbCrLf
            'MsgStr = MsgStr & "Your Activities were a success! Social Conditions in " & Province(ThisProvince).Name & " improved to" & CStr(Province(ThisProvince).SocialState) & "."
            'SetTargetTextbox(ThisProvince)
            'ChangeTextboxSocialState(ThisProvince)
            'IncrementSocialVPs(Province(ThisProvince).SocialState)
            'If DieRoll <= (SuccessThreshhold - Government(Ruler).AdminAbility + Government(Ruler).PoliticalSavvy) Then
            '    IncrementProvincialLoyalty(ThisProvince)
            '    If Province(ThisProvince).Loyalty = ENTHUSIASTIC Then
            '        If Province(ThisProvince).ControlLevel < MAX_CONTROL_LEVEL Then
            '            MsgStr &= "while its Relationship to the Crown rose to " & NameControlLevel(Province(ThisProvince).ControlLevel + 1)
            '        End If
            '        IncrementControlLevel(ThisProvince)
            '    Else
            '        IncrementProvincialLoyalty(ThisProvince)
            '        MsgStr &= ", while its Loyalty increased to " & Province(ThisProvince).Loyalty
            '    End If
            'End If
            '    MsgStr &=  & "!"

            MsgBox(MsgStr, MsgBoxStyle.OkOnly, "Results of Administering " & Province(ThisProvince).Name)

        End If ' GoOn 'success not assured

        'End If ' GoOn after Autonomous province leaders challenge right to admin.

        ConcludeAction()

    End Sub

    Function CalculatePoliticalSupport(ByVal GovernmentID As Integer) As Integer
        Dim ProvinceNum As Integer
        Dim ProvincesControlled As Integer = 0
        Dim TotalSupport As Integer = 0

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = ActiveGovernment Then
                ProvincesControlled += 1
                TotalSupport += Province(ProvinceNum).Loyalty
            End If
        Next
        If ProvincesControlled > 0 Then
            Government(GovernmentID).Support = CInt(CDec(TotalSupport) / CDec(ProvincesControlled))
        Else
            Government(GovernmentID).Support = UNDEFINED
        End If

        Return ProvincesControlled

    End Function

    Function TotalProvincesControlled(ByVal GovernmentID As Integer) As Integer
        Dim ProvinceNum As Integer
        Dim ProvincesControlled As Integer = 0

        For ProvinceNum = 0 To TotalProvinces - 1
            If Province(ProvinceNum).PoliticalAffiliation = GovernmentID Then
                ProvincesControlled += 1
            End If
        Next

        Return ProvincesControlled

    End Function

    Function CalculateReligiousDifferential(ByVal Religion1 As Integer, ByVal Religion2 As Integer) As Integer
        Dim ReligiousDifferential As Integer = 0

        If Religion1 <> Religion2 Then
            If Abs(Religion1 - Religion2) > MAX_CHRISTIAN_SECTS Then
                ReligiousDifferential = 2
            Else
                ReligiousDifferential = 1
            End If
        End If 'no else needed because ReligiousDifferential initialized to 0, no difference

        Return ReligiousDifferential

    End Function

    Function CalculateLanguageDifference(ByVal Language1 As Integer, ByVal Language2 As Integer) As Integer
        Dim LanguageDifference As Integer = 0
        Dim Str1 As String = ""
        Dim Str2 As String = ""
        Dim FirstDigit1 As Char = "0"
        Dim FirstDigit2 As Char = "0"

        If Abs(Language1 - Language2) > MINOR_LINGUISTIC_THRESHHOLD Then
            Str1 = CStr(Language1)
            Str2 = CStr(Language2)
            FirstDigit1 = Str1.Chars(0)
            FirstDigit2 = Str2.Chars(0)
            If FirstDigit1 = FirstDigit2 Then ' if difference within family
                LanguageDifference = 1
            Else ' difference between families
                LanguageDifference = 2
            End If ' no need to change LanguageDifference if Languages the same because initialized to 0
        End If

        Return LanguageDifference
    End Function

    'Function DescribeChanceOfSuccess(ByVal Probability As Integer) As String
    '    Dim ProbabilityStr As String = ""

    '    Select Case Probability
    '        Case 10
    '            ProbabilityStr = " an Overwhelming Chance "

    '        Case 7, 8, 9
    '            ProbabilityStr = " a Good Chance "

    '        Case 4, 5, 6
    '            ProbabilityStr = " a Moderate Chance "

    '        Case 1, 2, 3
    '            ProbabilityStr = " a Marginal Chance "

    '        Case 0
    '            ProbabilityStr = " No Chance "

    '        Case Else
    '            ProbabilityStr = " Bad Probability Estimate Lookup "

    '    End Select

    '    Return ProbabilityStr

    'End Function

    Public Sub ToggleBuildControls(ByVal CurrentState As Boolean)
        Dim StateToBecome As Boolean

        If CurrentState = True Then
            StateToBecome = False
        Else
            StateToBecome = True
        End If

        frmMapScreen.lblBuildWhat.Visible = StateToBecome
        frmMapScreen.lblBuildWhat.Refresh()
        frmMapScreen.btnBuildFort.Visible = StateToBecome
        frmMapScreen.btnBuildFort.Refresh()
        frmMapScreen.btnBuildPalace.Visible = StateToBecome
        frmMapScreen.btnBuildPalace.Refresh()
        'frmMapScreen.btnBuildCanal.Visible = StateToBecome ' get rid of this for now
        'frmMapScreen.btnBuildCanal.Refresh()

    End Sub

    Public Sub TogglePatronizeControls(ByVal CurrentState As Boolean)
        Dim StateToBecome As Boolean

        If CurrentState = True Then
            StateToBecome = False
        Else
            StateToBecome = True
        End If

        frmMapScreen.lblPatronizeWho.Visible = StateToBecome
        frmMapScreen.lblPatronizeWho.Refresh()
        frmMapScreen.btnPatronizeChurch.Visible = StateToBecome
        frmMapScreen.btnPatronizeChurch.Refresh()
        frmMapScreen.btnPatronizeLearning.Visible = StateToBecome
        frmMapScreen.btnPatronizeLearning.Refresh()
        frmMapScreen.btnPatronizeArts.Visible = StateToBecome
        frmMapScreen.btnPatronizeArts.Refresh()

    End Sub

    Public Sub ToggleRuleControls(ByVal CurrentState As Boolean)
        Dim StateToBecome As Boolean

        If CurrentState = True Then
            StateToBecome = False
        Else
            StateToBecome = True
        End If

        frmMapScreen.lblHowRule.Visible = StateToBecome
        frmMapScreen.lblHowRule.Refresh()
        frmMapScreen.btnAdminister.Visible = StateToBecome
        frmMapScreen.btnAdminister.Refresh()
        frmMapScreen.btnTax.Visible = StateToBecome
        frmMapScreen.btnTax.Refresh()
        frmMapScreen.btnCharterTowns.Visible = StateToBecome
        frmMapScreen.btnCharterTowns.Refresh()
        frmMapScreen.btnLawCode.Visible = StateToBecome
        frmMapScreen.btnLawCode.Refresh()
        frmMapScreen.btnParlement.Visible = StateToBecome
        frmMapScreen.btnParlement.Refresh()
        frmMapScreen.btnInstallBaliff.Visible = StateToBecome
        frmMapScreen.btnInstallBaliff.Refresh()

    End Sub

    Sub ConversionReaction(ByVal Resistance As Integer)
        Dim i As Integer = 0
        Dim Resist As Integer = 0

        Do While Resist < Resistance
            DecrementArmyState(PlayerSide)
            Resist += 1
        Loop
        MsgBox("The morale of the French warriors has declined to " & DescribeArmyState(Government(PlayerSide).ArmyState) & ".")

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = PlayerSide Then
                If Province(i).Religion = PAGAN Then
                    Resist = 0
                    Do While Resist < Resistance
                        DecrementProvincialLoyalty(i)
                        Resist += 1
                    Loop
                    If Province(i).Loyalty = REBELLIOUS Then
                        Province(i).PoliticalAffiliation = LOCAL_CONTROL
                        DecrementSocialState(i, CHAOS)
                        MsgBox("Pagan " & Province(i).Name & " has rebelled against you!")
                        DecrementConquestVPs(i)
                        'ConquestVPs -= PROVINCE_VP_VALUE
                        'RefreshConquestVP_Display()
                    Else
                        MsgBox("Support for your government has decreased in Pagan " & Province(i).Name & ".")
                    End If
                Else
                    'If Government(PlayerSide).Religion = CATHOLIC Then ' COMMENTED OUT THINGS ARE VESTIGES OF ARRIAN VS. CATHOLIC THING
                    If Province(i).Religion = CATHOLIC Then
                        IncrementProvincialLoyalty(i)
                        MsgBox("Support for your government has increased in Catholic " & Province(i).Name & ".")
                        'Else
                        '    MsgBox("The people of " & NameReligion(Province(i).Religion) & " " & Province(i).Name & " are indifferent to your conversion.")
                    End If
                    'Else
                    'If Province(i).Religion = CATHOLIC Or Province(i).Religion = ORTHADOX Then
                    '    DecrementProvincialLoyalty(i)
                    '    If Province(i).Loyalty = REBELLIOUS Then
                    '        Province(i).PoliticalAffiliation = LOCAL_CONTROL
                    '        DecrementSocialState(i, CHAOS)
                    '        MsgBox(NameReligion(Province(i).Religion) & " " & Province(i).Name & " has rebelled against you!")
                    '    Else
                    '        MsgBox("Support for your government has decreased in " & Province(i).Name & NameReligion(Province(i).Religion) & " " & ".")
                    '    End If

                End If 'Province is Pagan
                '    End If 'Franks Became Catholic (else Arian)
                'End If 'Province is Pagan (else other)
            End If 'province is controlled by Franks
        Next

        'Now do Government Reactions ' ALSO A VESTAGE OF ARIAN VS. CATHOLIC THING
        'For i = 1 To TotalGovernments - 1
        '    If i <> PlayerSide Then
        '        If Government(PlayerSide).Religion = CATHOLIC Then
        '            If Government(i).Religion = CATHOLIC Then
        '                MsgBox("The " & GetGovernmentName(i) & " applaud your conversion to the One True Faith, and swear to cooperate more closely in the future.")
        '                ' Increment This government's attitude toward Franks
        '            Else
        '                If Government(i).Religion = ARIAN Then
        '                    MsgBox("The " & GetGovernmentName(i) & " scorn your conversion this false faith, and want nothing to do with you.")
        '                    ' decrement this government's attitude toward Franks
        '                    ' possibly break alliance or whatever, once diplomatic system in 
        '                End If
        '            End If 'other Government is Catholic (else Arian)
        '        Else ' converted to Arian
        '            If Government(i).Religion = ARIAN Then
        '                MsgBox("The " & GetGovernmentName(i) & " applaud your conversion to the One True Faith, and swear to cooperate more closely in the future.")
        '                ' Increment This government's attitude toward Franks
        '            Else
        '                If Government(i).Religion = CATHOLIC Then
        '                    MsgBox("The " & GetGovernmentName(i) & " scorn your conversion this false faith, and want nothing to do with you.")
        '                    ' decrement this government's attitude toward Franks
        '                    ' possibly break alliance or whatever, once diplomatic system in 
        '                End If
        '            End If 'other Government is Catholic (else Arian)

        '        End If ' Player converted to Catholicism (else Arian)

        '    End If 'Government isn't this one
        'Next


        'MsgBox("Determine Reaction to Conversion here.")
    End Sub

    Sub AdjustDiploRelates(ByVal Country1 As Integer, ByVal Country2 As Integer, ByVal NewRelationship As Integer)
        Dim MsgStr As String
        Try
            Government(Country1).DiplomaticRelations(Country2) = NewRelationship
            Government(Country2).DiplomaticRelations(Country1) = NewRelationship
        Catch
            MsgStr = "Problem adjusting Diplomatic Relations: "
            MsgStr &= "Country(1 = " & CStr(Country1) & vbCrLf
            MsgStr &= "Country 2 = " & CStr(Country2) & vbCrLf
            MsgStr &= "New Relationship = " & NewRelationship
            MsgBox(MsgStr)
        End Try

    End Sub

    Sub Negotiate(ByVal ActiveGov As Integer, ByVal Other As Integer)
        Dim MsgStr As String = ""
        Dim CurrentRelates As Integer = -100
        Dim StrongerPower As Integer = -1
        Dim PowerRatio As Integer = -1
        Dim i As Integer = 0
        Dim YesOrNo As MsgBoxResult = MsgBoxResult.No
        Dim ProbabilityOfAccord As Integer = MAXIMUM_ACCORD_PROBABILITY / 2
        Dim SavvyBalance As Integer = 0
        Dim Rand As New Random
        Dim ProbabilityOfAccordPercent As Integer = (MAXIMUM_ACCORD_PROBABILITY / 2) * 5 ' NOTE: x5 may depend of MAX... being 20 specifically
        Dim ProbabilityOfAccordPercentStr As String = ""
        Dim TributeCap As Integer = 1
        Dim Tribute As Integer = 0
        Dim TributeDemand As Integer = 0
        Dim TributeStr As String = ""
        Dim TributeDemandStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        Dim DecisionValue As Integer = -1
        Dim NewRelates As Integer = -100
        Dim Random20 As Integer = -1
        Dim CounterOffer As Integer = -1
        Dim j As Integer = 0
        Dim TributeCapacity As Integer = 0

        CurrentRelates = Government(ActiveGov).DiplomaticRelations(Other)

        'First see if should continue
        If CurrentRelates = FRIENDLY Then  ' ALLIED Then 'NOTE, will need to be switched back to ALLIED when diplomcacy made more complex
            MsgBox("You are already Friendly with " & Government(Other).Name & ".  It doesn't get any better than this.")
            Exit Sub
        Else
            If CurrentRelates = SELF Then
                MsgBox("ERROR: You're trying to negotiate with yourself; something's wrong here.")
                Exit Sub
            Else
                If CurrentRelates = NO_POWER Then
                    MsgBox("ERROR: Can't Negotiate with a Provincial government yet; this form of Diplomacy to be added later.")
                    Exit Sub
                End If
            End If
        End If

        Randomize()

        PowerRatio = CalculatePowerRatio(ActiveGov, Other)

        If PowerRatio > 0 Then
            StrongerPower = ActiveGov
        ElseIf PowerRatio < 0 Then
            StrongerPower = Other
        Else ' if ratio is 0, neither is stronger, so 
            StrongerPower = EQUAL_POWER ' neither
        End If

        ProbabilityOfAccord += PowerRatio

        ' Add in effect of current relationship
        ProbabilityOfAccord += CurrentRelates

        MsgStr = "Your relations with " & Government(Other).Name & " are currently " & DescribeDiploRelations(ActiveGov, Other) & _
               ". " & vbCrLf & vbCrLf & "You are "

        If Abs(PowerRatio) > 3 Then
            MsgStr &= "much "
        End If

        If StrongerPower = ActiveGov Then
            MsgStr &= "more powerful." & vbCrLf & vbCrLf
        Else
            If StrongerPower = Other Then
                MsgStr &= "less powerful." & vbCrLf & vbCrLf
            Else
                MsgStr &= "about equally powerful." & vbCrLf & vbCrLf
            End If
        End If


        'ProbabilityOfAccord += PowerRatio ' moved this up to be with calculations

        SavvyBalance = Government(ActiveGov).PoliticalSavvy - Government(Other).PoliticalSavvy

        MsgStr &= "Your King is a"

        If Abs(SavvyBalance) > 2 Then
            MsgStr &= " much "
        End If

        If SavvyBalance > 0 Then
            MsgStr &= " more skilled negotiator than "
        Else
            If SavvyBalance < 0 Then
                MsgStr &= " more skilled negotiator than "
            Else
                MsgStr &= "n equally skilled negotiator as "
            End If
        End If

        MsgStr &= Government(Other).Name & "'s. " & DOUBLE_SPACE

        ProbabilityOfAccord += SavvyBalance

        MsgStr &= "Your " & NameReputation(Government(PlayerSide).Reputation) & " reputation "

        Select Case Government(PlayerSide).Reputation
            Case HONEST
                MsgStr &= "helps "
            Case DISHONEST
                MsgStr &= "hurts "
            Case UNCERTAIN
                MsgStr &= "neither helps nor hurts "
        End Select

        MsgStr &= "your chances of reaching an accord." & DOUBLE_SPACE

        ProbabilityOfAccord += Government(PlayerSide).Reputation


        ' Keep Probability of accord within bounds 
        If ProbabilityOfAccord > MAXIMUM_ACCORD_PROBABILITY Then
            ProbabilityOfAccord = MAXIMUM_ACCORD_PROBABILITY
        Else
            If ProbabilityOfAccord < 0 Then
                ProbabilityOfAccord = 0
            End If
        End If

        MsgStr &= "The probability of "

        If CurrentRelates = ENEMY Then
            MsgStr &= "making peace "
        Else
            MsgStr &= "improving relations "
        End If

        ProbabilityOfAccordPercent = ProbabilityOfAccord * 5 ' NOTE: this multiplier may depend on MAX_ACCORD_PROBABILITY being 20 specifically !!
        ProbabilityOfAccordPercentStr = CStr(ProbabilityOfAccordPercent)
        MsgStr &= "is " & ProbabilityOfAccordPercentStr & "%." & vbCrLf & vbCrLf

        If ProbabilityOfAccord = MAXIMUM_ACCORD_PROBABILITY Then
            NewRelates = IncrementDiploRelates(CurrentRelates)
            AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
            MsgStr &= "Therefore " & Government(Other).Name & " is ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
            MsgStr &= "Do you want to Accept their offer?"
            Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
            If Decision = MsgBoxResult.No Then
                AdjustDiploRelates(ActiveGov, Other, CurrentRelates)
            End If
            'Exit Sub ' taken out so all exit through ConcludeAction at end of sub
        Else
            If Government(ActiveGov).Treasury > 0 Then
                Tribute = Government(ActiveGov).Treasury \ 10
                If Tribute = 0 Then Tribute = 1
                TributeStr = CStr(Tribute)
                MsgStr &= "You have " & CStr(Government(ActiveGov).Treasury) & ",000 " & CurrencyStr & ". "
                MsgStr &= "You can increase your chances of improving relations by offering to pay some of this to " & Government(Other).Name & "." & vbCrLf & vbCrLf
            Else
                MsgStr &= "Unfortunately, you have no money, so you can't supplement your king's negotiating skills with any payments."
            End If
            If PowerRatio >= 0 Then
                'TributeCap = PowerRatio + 1
                'If TributeCap > 5 Then
                '    TributeCap = 5
                ' End If
                Try
                    TributeCapacity = 0 ' find 
                    For j = 0 To TotalProvinces - 1
                        If Province(j).PoliticalAffiliation = Other Then
                            TributeCapacity += Province(j).Townspeople
                        End If
                    Next
                Catch
                    MsgBox("Problem figuring Tribute request.")
                End Try
                TributeCap = PowerRatio + 1
                If TributeCap > 5 Then
                    TributeCap = 5
                End If
                If TributeCap > TributeCapacity Then
                    TributeCap = TributeCapacity - 1
                End If
                TributeDemand = TributeCapacity \ (6 - TributeCap)
                TributeDemandStr = CStr(TributeDemand)
                MsgStr &= "You have the power to demand that " & Government(Other).Name & " pay you, although this will reduce the chances of improving relations somewhat."
                MsgStr &= vbCrLf & vbCrLf
            End If

            If Tribute > 0 And PowerRatio >= 0 Then ' have money to offer, but also are in a position to demand tribute
                MsgStr &= "To Offer a Payment of " & TributeStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                MsgStr &= "To Demand a Payment of " & TributeDemandStr & ",000 " & CurrencyStr & ", Click NO" & vbCrLf
                MsgStr &= "To Continue the Negotiations Without Offering or Demanding any Payment, Click CANCEL"
                Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate")
                Select Case Decision
                    Case MsgBoxResult.Yes
                        DecisionValue = 1
                    Case MsgBoxResult.No
                        DecisionValue = 2
                    Case MsgBoxResult.Cancel
                        DecisionValue = 3
                End Select
            Else
                If Tribute = 0 And PowerRatio >= 0 Then 'don't have money to offer, but have power to ask for it
                    MsgStr &= "To Demand a Payment of " & TributeDemandStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                    MsgStr &= "To Continue the Negotiations Without Demanding any Payment, Click NO"
                    Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate")
                    If Decision = MsgBoxResult.Yes Then
                        DecisionValue = 2
                    Else
                        DecisionValue = 3
                    End If
                Else
                    If Tribute > 0 And PowerRatio < 0 Then ' have money but are weaker, so can offer tribute but not demand it
                        MsgStr &= "To Offer a Payment of " & TributeStr & ",000 " & CurrencyStr & ", Click YES" & vbCrLf
                        MsgStr &= "To Continue the Negotiations Without Offering any Payment, Click NO"
                        Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate")
                        If Decision = MsgBoxResult.Yes Then
                            DecisionValue = 1
                        Else
                            DecisionValue = 3
                        End If
                    Else 'no money and weaker so can't offer or demand tribute
                        MsgBox(MsgStr)
                        DecisionValue = 3
                    End If
                End If
            End If

            Select Case DecisionValue
                Case 1 'meaning of integer value above, = are offering money
                    ProbabilityOfAccord += 1
                    Random20 = Rand.Next(1, 21)

                    If Random20 < ProbabilityOfAccord Then
                        Government(ActiveGov).Treasury -= Tribute
                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * Tribute) '-1 says you paid

                    Else 'if random num was greater than Probability of Accord
                        If PowerRatio <= 0 Then ' in this case, equal powers will look for money, not just superior ones (
                            TributeCap = -1 * PowerRatio + 1
                            If TributeCap > 5 Then
                                TributeCap = 5
                            End If
                            Try
                                CounterOffer = (Government(ActiveGov).Treasury / (6 - TributeCap))
                                If CounterOffer < 1 Then CounterOffer = 1
                            Catch
                                MsgBox("Problem figuring Tribute request.")
                            End Try
                            If CounterOffer > Tribute Then
                                Decision = MsgBox(Government(Other).Name & " rejects your offer, but will accept " & CStr(CounterOffer) & ",000 " & CurrencyStr & "." _
                                                   & vbCrLf & vbCrLf & "This will leave you with " & CStr(Government(ActiveGov).Treasury - CounterOffer) & ",000." _
                                                   & vbCrLf & vbCrLf _
                                                  & "Will you pay that amount?", MsgBoxStyle.YesNo, "Accept Counteroffer?") 'note this code copied below; changes must be made twice
                                If Decision = MsgBoxResult.Yes Then
                                    Government(ActiveGov).Treasury -= CounterOffer
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * CounterOffer) '-1 says you paid
                                Else
                                    If CurrentRelates > ENEMY Then
                                        If Rand.Next(0, 2) = 1 Then ' chance you pissed them off
                                            NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                        Else
                                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                        End If
                                    Else ' if relations already as low as can go
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    End If
                                End If
                            Else 'you offered more than they would demand
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If ' They mull a counter offer

                        Else 'you're stronger than them and you offered money and they still spurned you
                            If Rand.Next(0, 2) = 1 Then
                                CounterOffer = 2 * Tribute
                                If CounterOffer < 1 Then CounterOffer = 1
                                Decision = MsgBox(Government(Other).Name & " rejects your offer, but will accept " & CStr(CounterOffer) & ",000 " _
                                                   & CurrencyStr & ".  This will leave you with " & CStr(Government(ActiveGov).Treasury - CounterOffer) & ",000." _
                                                   & vbCrLf & vbCrLf _
                                                   & "Will you pay that amount?", MsgBoxStyle.YesNo, "Accept Counteroffer?") 'note this code copied above; changes must be made twice
                                If Decision = MsgBoxResult.Yes Then
                                    Government(ActiveGov).Treasury -= CounterOffer
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * CounterOffer) '-1 signals you paid
                                Else
                                    If CurrentRelates > ENEMY Then
                                        If Rand.Next(0, 2) = 1 Then ' chance you pissed them off
                                            NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                        Else
                                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                        End If
                                    Else ' if relations already as low as can go
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    End If
                                End If

                            Else ' if they don't randomly ask for twice your offer"
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If ' if they randomly ask for more than you offer or not
                        End If 'they're equal or stronger than you or are weaker

                    End If 'Random num was lower or higher than Probabilty threshhold
                Case 2 ' meaning defined above; means decided to demand tribute

                    ProbabilityOfAccord -= Rand.Next(1, TributeCap)
                    Random20 = Rand.Next(1, 21)

                    If Random20 < ProbabilityOfAccord Then
                        Government(ActiveGov).Treasury += TributeDemand
                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, TributeDemand)
                    Else 'if random num was greater than Probability of Accord Percent
                        If Random20 <= ProbabilityOfAccord * 2 Then ' they bargain
                            CounterOffer = TributeDemand \ (6 - TributeCap)
                            If CounterOffer < 1 Then CounterOffer = 1
                            Decision = MsgBox(Government(Other).Name & " protests that it cannot pay " & TributeDemandStr & ",000 " _
                                   & CurrencyStr & ".  It offers to pay " & CStr(CounterOffer) & ",000 instead." & vbCrLf & vbCrLf _
                                   & "Will you accept the counteroffer?", MsgBoxStyle.YesNo, "Accept Counteroffer?")
                            If Decision = MsgBoxResult.Yes Then
                                Government(ActiveGov).Treasury += CounterOffer
                                NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, CounterOffer)
                            Else ' player doesn't accept counteroffer
                                Select Case Rand.Next(0, 3)
                                    Case 0
                                        Government(ActiveGov).Treasury += TributeDemand
                                        NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, TributeDemand)
                                    Case 1
                                        NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                                    Case 2
                                        NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                                End Select
                            End If
                        Else 'they refuse to bargain
                            If Rand.Next(0, 2) = 1 Then
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            Else
                                NewRelates = NegotiationsBackfire(CurrentRelates, ActiveGov, Other, 0)
                            End If
                        End If ' if random > PoA
                    End If 'random is less or more than Probability of Accord
                Case Else 'Cancel or DecisionValue = 3; no payment either way selected

                    If PowerRatio < 0 Then
                        TributeCap = -1 * PowerRatio
                        If TributeCap > 4 Then
                            TributeCap = 4
                        End If
                        Try
                            Tribute = (Government(ActiveGov).Treasury / (5 - TributeCap))
                        Catch
                            MsgBox("Problem figuring Tribute request.")
                        End Try
                        TributeStr = CStr(Tribute)
                        Decision = MsgBox(Government(Other).Name & " demands that you pay tribute of " & TributeStr & ",000 " _
                                          & CurrencyStr & ". This will leave you " & CStr(Government(ActiveGov).Treasury - Tribute) _
                                           & ",000." & vbCrLf & vbCrLf & _
                                          "Will you pay?", MsgBoxStyle.YesNo, "Pay tribute?")
                        If Decision = vbYes Then
                            Government(ActiveGov).Treasury -= Tribute
                            NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, -1 * Tribute) ' -1 signals you paid
                        Else ' won't pay 
                            ProbabilityOfAccord -= 1
                            If ProbabilityOfAccord < 0 Then ProbabilityOfAccord = 0

                            Random20 = Rand.Next(1, 21)

                            If Random20 < ProbabilityOfAccord Then
                                NewRelates = IncrementDiploRelates(CurrentRelates)
                                AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
                                MsgStr = Government(Other).Name & " is ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
                                MsgStr &= "Do you want to Accept the Offer?"
                                Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
                                AdjustDiploRelates(ActiveGov, Other, CurrentRelates) ' go back to current 
                                If Decision = MsgBoxResult.Yes Then
                                    NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, 0)
                                End If
                            Else
                                NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                            End If

                        End If 'will pay 

                    Else ' Power Ratio 0 or greater

                        Random20 = Rand.Next(1, 21)

                        If Random20 < ProbabilityOfAccord Then
                            NewRelates = IncrementDiploRelates(CurrentRelates)
                            AdjustDiploRelates(ActiveGov, Other, NewRelates) ' Provisional, until player confirms
                            MsgStr = Government(Other).Name & " is ready to become " & DescribeDiploRelations(ActiveGov, Other) & " toward you." & vbCrLf & vbCrLf
                            MsgStr &= "Do you want to Accept the Offer?"
                            Decision = MsgBox(MsgStr, vbYesNo, "Improve Relations?")
                            AdjustDiploRelates(ActiveGov, Other, CurrentRelates) ' go back to current
                            If Decision = MsgBoxResult.Yes Then
                                NewRelates = NegotiationsSucceed(CurrentRelates, ActiveGov, Other, 0)
                            End If
                        Else
                            NewRelates = NegotiationsFail(CurrentRelates, ActiveGov, Other, 0)
                        End If
                    End If 'Power Ratio < 0
            End Select ' end case other: 

        End If 'not a sure thing

        ' CancelAction()

        ConcludeAction()

    End Sub

    Function CalculatePowerRatio(ByVal ActiveGov As Integer, ByVal OtherGov As Integer) As Integer
        Dim PwrRatio As Integer = -100
        Dim ActiveArmySize, OtherArmySize, ArmySizeDifferential, Fortifications, LeadershipDifferential, MoraleDifferential As Integer

        ActiveArmySize = Government(ActiveGov).Cavalary + Government(ActiveGov).Infantry
        OtherArmySize = Government(OtherGov).Cavalary + Government(OtherGov).Infantry

        If ActiveArmySize > OtherArmySize Then
            'For i = 0 To TotalProvinces
            '    If Province(i).PoliticalAffiliation = Other Then
            '        Fortifications += Province(i).Forts
            '    End If
            'Next
            ArmySizeDifferential = ActiveArmySize / (OtherArmySize + Fortifications)
        Else
            'For i = 0 To TotalProvinces
            '    If Province(i).PoliticalAffiliation = ActiveGovernment Then
            '        Fortifications += Province(i).Forts
            '    End If
            'Next
            ArmySizeDifferential = -(OtherArmySize / (ActiveArmySize + Fortifications))
        End If
        LeadershipDifferential = (Government(ActiveGov).Generalship - Government(OtherGov).Generalship) \ 2
        MoraleDifferential = (Government(ActiveGov).ArmyState - Government(OtherGov).ArmyState) \ 2

        PwrRatio = ArmySizeDifferential + LeadershipDifferential + MoraleDifferential

        Return PwrRatio

    End Function

    Function NegotiationsSucceed(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = IncrementDiploRelates(RelatesNow)
        AdjustDiploRelates(ActGov, OtherPower, NewRel)
        MsgStr = "The Negotiations succeeded; " & Government(OtherPower).Name & " has become " & DescribeDiploRelations(ActGov, OtherPower) & " towards you."
        If Trib > 0 Then
            MsgStr &= vbCrLf & vbCrLf & "They paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= " You paid it " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function NegotiationsFail(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = RelatesNow
        MsgStr = "The Negotiations failed, and your relationship with " & Government(OtherPower).Name & " remains " & DescribeDiploRelations(ActGov, OtherPower) & "."
        If Trib > 0 Then
            MsgStr &= " It paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= vbCrLf & vbCrLf & " You paid it " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function NegotiationsBackfire(ByVal RelatesNow As Integer, ByVal ActGov As Integer, ByVal OtherPower As Integer, ByVal Trib As Integer) As Integer
        Dim NewRel As Integer = -100
        Dim MsgStr As String = ""

        NewRel = DecrementDiploRelates(RelatesNow)
        AdjustDiploRelates(ActGov, OtherPower, NewRel)
        MsgStr = "The Negotiations angered " & Government(OtherPower).Name & ", and it is now " & DescribeDiploRelations(ActGov, OtherPower) & " towards you."
        If Trib > 0 Then
            MsgStr &= " It paid you " & CStr(Trib) & ",000 " & CurrencyStr & "."
        Else
            If Trib < 0 Then
                MsgStr &= vbCrLf & vbCrLf & " You paid it " & CStr(Abs(Trib)) & ",000 " & CurrencyStr & "."
            End If
        End If

        MsgBox(MsgStr)

        Return NewRel

    End Function

    Function IncrementDiploRelates(ByVal StartingRelates As Integer) As Integer
        Dim EndingRelates As Integer = -100

        If StartingRelates < FRIENDLY Then
            EndingRelates = StartingRelates + 1
        Else
            EndingRelates = StartingRelates
        End If

        Return EndingRelates

    End Function

    Function DecrementDiploRelates(ByVal StartingRelates As Integer) As Integer
        Dim EndingRelates As Integer = -100

        If StartingRelates > HOSTILE Then
            EndingRelates = StartingRelates - 1
        Else
            EndingRelates = StartingRelates
        End If

        Return EndingRelates

    End Function

    Function DetermineIfGovernmentsContiguous(ByVal Gvt1 As Integer, ByVal Gvt2 As Integer) As Boolean
        Dim AreContiguous As Boolean = False
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim PotentialContiguousArea As Integer = -1
        Dim PotentialContiguousProvince As Integer = -1

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = Gvt1 Then
                For j = 0 To MAX_NEIGHBORS_LAND - 1
                    If Province(i).Connectors(j) >= RIVER Then ' if neighbor is land connection
                        PotentialContiguousArea = Province(i).Neighbors(j)
                        PotentialContiguousProvince = Area(PotentialContiguousArea).Province
                        If Province(PotentialContiguousProvince).PoliticalAffiliation = Gvt2 Then
                            AreContiguous = True
                            Exit For
                        End If
                    End If
                Next
                If AreContiguous = True Then
                    Exit For
                End If
            End If
        Next

        Return AreContiguous

    End Function

    Function DetermineIfProvinceContiguous(ByVal Gvt1 As Integer, ByVal ProvID As Integer) As Boolean
        Dim AreContiguous As Boolean = False
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim PotentialContiguousArea As Integer = -1
        Dim PotentialContiguousProvince As Integer = -1

        For i = 0 To TotalProvinces - 1
            If Province(i).PoliticalAffiliation = Gvt1 Then
                For j = 0 To MAX_NEIGHBORS_LAND - 1
                    If Province(i).Connectors(j) >= RIVER Then ' if neighbor is land connection
                        PotentialContiguousArea = Province(i).Neighbors(j)
                        PotentialContiguousProvince = Area(PotentialContiguousArea).Province
                        If PotentialContiguousProvince = ProvID Then
                            AreContiguous = True
                            Exit For
                        End If
                    End If
                Next
                If AreContiguous = True Then
                    Exit For
                End If
            End If
        Next

        Return AreContiguous

    End Function

    Sub ClearOutLoser(ByVal EliminatedGovernment As Integer)
        Dim i As Integer

        Government(EliminatedGovernment).Name = ELIMINATED_POWER_STRING
        Government(EliminatedGovernment).Infantry = 0
        Government(EliminatedGovernment).Cavalary = 0
        Government(EliminatedGovernment).Language = NO_LANGUAGE
        Government(EliminatedGovernment).Religion = NO_RELIGION
        Government(EliminatedGovernment).Generalship = UNDEFINED
        Government(EliminatedGovernment).ArmyState = UNDEFINED
        Government(EliminatedGovernment).LeadershipState = UNDEFINED
        Government(EliminatedGovernment).PoliticalSavvy = UNDEFINED
        Government(EliminatedGovernment).RoyalEstates = 0
        Government(EliminatedGovernment).Support = UNDEFINED
        Government(EliminatedGovernment).Treasury = 0
        Government(EliminatedGovernment).TotalBenefices = 0

        For i = 0 To TotalGovernments - 1
            Government(EliminatedGovernment).DiplomaticRelations(i) = UNDEFINED
        Next

    End Sub

    Sub NewPeoples()
        Dim GovNum As Integer = NO_POWER

        Select Case TurnDate
            Case 560
                GovNum = FindFreeGovNum()
                SetUpAvars(GovNum)
            Case 1075
                'GovNum = FindFreeGovNum()
                SetUpSeljuks(GovNum)
        End Select
    End Sub

    Function FindFreeGovNum()
        Dim FreeNum As Integer = NO_POWER
        For i = 1 To TotalGovernments - 1
            If Government(i).Name = ELIMINATED_POWER_STRING Then
                FreeNum = i
                Exit For
            End If
        Next
        If FreeNum < 0 Then
            If TotalGovernments < MAX_GOVERNMENTS Then
                FreeNum = TotalGovernments
                TotalGovernments += 1
            Else
                MsgBox("Error: too many governments already to add another")
            End If
        End If
        Return FreeNum

    End Function


    'Sub IncrementConquestVPs(ByVal Province As Integer)
    '    'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
    '    ConquestVPs += PROVINCE_VP_VALUE
    '    RefreshConquestVP_Display()
    '    AdjustTotalVPs()
    'End Sub

    'Sub DecrementConquestVPs(ByVal Province As Integer)
    '    'Remember, if give extra value for some provinces over other, will have to adjust Conversion calculations so doen't depend on ConquestVPs to know how many battles you've won
    '    ConquestVPs -= PROVINCE_VP_VALUE
    '    RefreshConquestVP_Display()
    '    AdjustTotalVPs()
    'End Sub

    Sub IncrementSocialVPs(ByVal Amount As Integer)
        ' end state is in case want to give greater values for Golden Age / Chaos
        SocialVPs += SOCIAL_STATE_VP_VALUE
        MsgBox(Government(ActiveGovernment).Name & " just gained 1 Victory Point for improving one of its Province's Social State.")
        RefreshSocialStateVP_Display()
        AdjustTotalVPs()
        RefreshTotalVP_Display()
    End Sub

    Sub DecrementSocialVPs(ByVal Amount As Integer)
        ' end state is in case want to give greater values for Golden Age / Chaos
        SocialVPs -= SOCIAL_STATE_VP_VALUE
        MsgBox(Government(ActiveGovernment).Name & " just lost 1 Social State Victory Point because on of its Province's Social State decline.")
        RefreshSocialStateVP_Display()
        AdjustTotalVPs()
        RefreshTotalVP_Display()
    End Sub

    Sub IncrementCulturalVPs(ByVal Amount As Integer)

        CulturalVPs += Amount
        RefreshCulturalVP_Display()
        MsgBox(Government(ActiveGovernment).Name & " just gained 1 Victory Point for a Cultural Advancement.")
        AdjustTotalVPs()
        RefreshTotalVP_Display()
    End Sub

    Sub DecrementCulturalVPs(ByVal Amount As Integer)

        CulturalVPs -= Amount
        RefreshCulturalVP_Display()
        AdjustTotalVPs()
        RefreshTotalVP_Display()
        MsgBox(Government(ActiveGovernment).Name & " just lost 1  Victory Point for a Cultural Decline.")
    End Sub

    Sub AdjustTotalVPs()
        Dim OldVPs As Integer = 0

        OldVPs = TotalVPs
        TotalVPs = ConquestVPs + SocialVPs + CulturalVPs
        'MsgBox("VP value went from " & CStr(OldVPs) & " to " & CStr(TotalVPs) & ".")
        RefreshTotalVP_Display()

    End Sub

    Sub IncrementReputation(ByVal Power As Integer, ByVal Amount As Integer)
        Dim i As Integer = 0

        For i = 1 To Amount
            If Government(Power).Reputation < MAX_REPUTE Then
                Government(Power).Reputation += 1
            End If
        Next

    End Sub

    Sub DecrementReputation(ByVal Power As Integer, ByVal Amount As Integer)
        Dim i As Integer = 0

        For i = 1 To Amount
            If Government(Power).Reputation > MIN_REPUTE Then
                Government(Power).Reputation -= 1
            End If
        Next

    End Sub

    Sub PatronizeByType(ByVal PatronageType As Integer, Where As Integer)
        Dim CulturalResult As Integer = 0
        Dim PoliticalResult As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim MsgStr1 As String = ""
        Dim Msgstr2 As String = ""
        Dim PatronageTypeStr As String = ""

        Select Case PatronageType
            Case PATRONIZE_CHURCH
                PatronageTypeStr = PATRONIZING_CHURCH_STR
            Case PATRONIZE_LEARNING
                PatronageTypeStr = PATRONIZING_LEARNING_STR
            Case PATRONIZE_ARTS
                PatronageTypeStr = PATRONIZING_ARTS_STR
        End Select

        Government(ActiveGovernment).Treasury -= PATRONIZING_COST

        DieRoll = Rand.Next(1, 7)

        CulturalResult = DieRoll + Government(ActiveGovernment).Refinement

        ' CulturalResult = 3 ' FOR TESTING ONLY !

        MsgStr1 = "Supported by the Monarchy's Patronage of " & PatronageTypeStr & " and "
        If Government(ActiveGovernment).Refinement >= MEDIOCRE Then
            MsgStr1 &= "guided by "
        Else
            MsgStr1 &= "despite "
        End If
        MsgStr1 &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement) & " sensibilities, the French have accomplished a "

        'If CulturalResult >= 6 Then
        '    CulturalVPs += MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE
        '    RefreshCulturalVP_Display()
        '    MsgStr1 &= "Major "
        'Else
        If CulturalResult >= 2 Then
            CulturalVPs += MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE
            RefreshCulturalVP_Display()
            'MsgStr1 &= "Modest "
            MsgStr1 &= "Significant "
        Else
            If Government(ActiveGovernment).Refinement >= MEDIOCRE Then
                MsgStr1 = "Despite the Monarchy's Support of " & PatronageTypeStr & " and the Monarch's "
                MsgStr1 &= GetAbilityNames(Government(ActiveGovernment).Refinement) & " sensibilities, the effort "
            Else
                MsgStr1 = "Given the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement) & " sensibilities, "
                MsgStr1 &= " Patronage of " & PatronageTypeStr
            End If
            MsgStr1 &= " did not yield a Significant "
        End If
        'End If

        MsgStr1 &= "Cultural Achievement"

        If PatronageType <> PATRONIZE_ARTS Then
            MsgStr1 &= " in " & Province(Where).Name
        End If

        MsgStr1 &= "." & DOUBLE_SPACE

        DieRoll = Rand.Next(1, 7)

        PoliticalResult = DieRoll + Government(ActiveGovernment).PoliticalSavvy

        ' PoliticalResult = 3 'FOR TESTING ONLY!

        If PoliticalResult >= 5 Then
            'Need to make these provisional based on can the political thing increase!
            Msgstr2 &= "Bolstered by "
            If Government(ActiveGovernment).PoliticalSavvy > MEDIOCRE Then
                Msgstr2 &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy) & " Political skills and "
            Else
                Msgstr2 &= "the Monarchy's "
            End If
            Msgstr2 &= "Patronage of " & PatronageTypeStr & ", "
            Select Case PatronageType
                Case PATRONIZE_LEARNING
                    IncrementSocialState(Where, BOOMING)
                    IncrementSocialVPs(SOCIAL_STATE_VP_VALUE)
                    Msgstr2 &= Province(Where).Name & "'s Social State to rose to "
                    Msgstr2 &= DescribeSocialState(Province(Where).SocialState) & "."
                Case PATRONIZE_ARTS
                    IncrementProvincialLoyalty(Where)
                    Msgstr2 &= Province(Where).Name & "'s Loyalty to the Monarchy to rose to "
                    Msgstr2 &= NameLoyaltyLevel(Province(Where).Loyalty) & "."
                Case PATRONIZE_CHURCH
                    IncrementDiploRelates(Government(ActiveGovernment).DiplomaticRelations(THE_PAPACY))
                    Msgstr2 &= "France's Relationship to the Church to rose to " & DescribeDiploRelations(FRANCE, THE_PAPACY)
            End Select
        Else
            If PoliticalResult <= 2 Then
                If Government(ActiveGovernment).PoliticalSavvy > MEDIOCRE Then
                    Msgstr2 &= "Despite the Monarch's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy) & " Political skills, c"
                Else
                    Msgstr2 &= "C"
                End If
                Msgstr2 &= "ontroversy stirred by the Monarchy's Patronage of "
                Msgstr2 &= PatronageTypeStr & " reduced "
                Select Case PatronageType
                    Case PATRONIZE_LEARNING
                        DecrementSocialState(Where, CHAOS)
                        Msgstr2 &= Province(Where).Name & "'s Social State to " & DescribeSocialState(Province(Where).SocialState) & "."
                        DecrementSocialVPs(SOCIAL_STATE_VP_VALUE)
                    Case PATRONIZE_ARTS
                        DecrementProvincialLoyalty(Where)
                        Msgstr2 &= Province(Where).Name & "'s Loyalty to the Kingdom to " & NameLoyaltyLevel(Province(Where).Loyalty) & "."
                    Case PATRONIZE_CHURCH
                        DecrementDiploRelates(Government(ActiveGovernment).DiplomaticRelations(THE_PAPACY))
                        Msgstr2 &= "France's Relationship to the Church to declined to " & DescribeDiploRelations(FRANCE, THE_PAPACY)
                End Select
            End If
        End If

        MsgBox(MsgStr1 & Msgstr2, MsgBoxStyle.OkOnly, PatronageTypeStr)


    End Sub

    'Sub PatronizeChurch(ByVal Where As Integer)
    '    Dim CulturalResult As Integer = 0
    '    Dim PoliticalResult As Integer = 0
    '    Dim DieRoll As Integer = 0
    '    Dim PatronageLevel As Integer = 1
    '    Dim Rand As New Random
    '    Dim MsgStr As String = ""
    '    Dim PatronageLevelStr As String = ""

    '    ' Need message box for player to commit limited or extensive patronage

    '    If PatronageLevel = LIMITED_PATRONAGE Then
    '        PatronageLevelStr = LIMITED_PATRONAGE_STR
    '    Else
    '        PatronageLevelStr = EXTENSIVE_PATRONAGE_STR
    '    End If

    '    DieRoll = Rand.Next(1, 7)

    '    CulturalResult = DieRoll + PatronageLevel + Government(ActiveGovernment).Refinement

    '    MsgStr = "Supported by the Monarchy's " & PatronageLevelStr & " Patronage of the Church and "
    '    If Government(ActiveGovernment).Refinement > MEDIOCRE Then
    '        MsgStr &= "guided by "
    '    Else
    '        MsgStr &= "despite "
    '    End If
    '    MsgStr &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement) & " sensibilities, the French have achieved a "

    '    If CulturalResult >= 8 Then
    '        CulturalVPs += MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE
    '        RefreshCulturalVP_Display()
    '        MsgStr &= "Major "
    '    Else
    '        If CulturalResult >= 2 Then
    '            CulturalVPs += MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE
    '            RefreshCulturalVP_Display()
    '            MsgStr &= "Modest "
    '        Else
    '            MsgStr = "Despite the Monarchy's "
    '            If PatronageLevel = MAJOR_PATRONAGE Then
    '                MsgStr &= PatronageLevelStr
    '            End If
    '            MsgStr &= "Support of the Church"
    '            If Government(ActiveGovernment).Refinement > MEDIOCRE Then
    '                MsgStr &= "and the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement) & " sensibilities"
    '            End If
    '            MsgStr &= ", the French effort did not amount to a significant "
    '        End If
    '    End If

    '    MsgStr &= "Cultural Achievement." & DOUBLE_SPACE

    '    DieRoll = Rand.Next(1, 7)

    '    PoliticalResult = DieRoll + PatronageLevel + Government(ActiveGovernment).PoliticalSavvy

    '    If PoliticalResult >= 6 Then
    '        IncrementSocialState(Where, BOOMING)
    '        MsgStr &= "Bolstered by "
    '        If Government(ActiveGovernment).PoliticalSavvy > MEDIOCRE Then
    '            MsgStr &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy) & " Political skills and "
    '        Else
    '            MsgStr &= "the Monarchy's "
    '        End If
    '        MsgStr &= "Patronage of the Church, " & Province(Where).Name & "'s Social State to rose to "
    '        MsgStr &= DescribeSocialState(Province(Where).SocialState) & "."
    '    Else
    '        If CulturalResult <= 1 Then
    '            DecrementSocialState(Where, CHAOS)
    '            If Government(ActiveGovernment).PoliticalSavvy > MEDIOCRE Then
    '                MsgStr &= "Despite the Monarch's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy) & " Political skills, c"
    '            Else
    '                MsgStr &= "C"
    '            End If
    '            MsgStr &= "ontroversy stirred by the Monarchy's patronage of the Church reduced " & Province(Where).Name & "'s Social State to "
    '            MsgStr &= DescribeSocialState(Province(Where).SocialState) & "."
    '        End If
    '    End If

    '    MsgBox(MsgStr)


    '    'PoliticalSkill = Government(ActiveGovernment).PoliticalSavvy


    '    'Select Case Result
    '    '    Case PATRONAGE_BACKFIRES
    '    '        DecrementSocialState(Where, CHAOS)
    '    '    Case PATRONAGE_FLOPS
    '    '    Case MINOR_PATRONAGE_SUCCESS
    '    '        CulturalVPs += MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE
    '    '        IncrementSocialState(Where, BOOMING)
    '    '    Case MAJOR_PATRONAGE_SUCCESS
    '    '        CulturalVPs += MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE
    '    '        IncrementSocialState(Where, BOOMING)
    '    'End Select
    'End Sub

    Sub BuildPalace(ByVal Where As Integer)
        Dim CulturalPossibility As Integer = 0
        Dim Rand As New Random
        Dim DieRoll As Integer = 0
        Dim Msgstr As String = ""

        DieRoll = Rand.Next(1, 7)

        Government(ActiveGovernment).Treasury -= BUILDING_COST

        CulturalPossibility = DieRoll + Government(ActiveGovernment).Refinement

        If CulturalPossibility >= 4 Then
            IncrementCulturalVPs(MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE)
            IncrementProvincialLoyalty(Where)
            If Government(ActiveGovernment).Refinement >= MEDIOCRE Then
                Msgstr = "Guided by "
            Else
                Msgstr = "Despite "
            End If
            Msgstr &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement)
            Msgstr &= " Sensibilities, the new Palace constitutes a Sigificant Cultural Achievement. " & DOUBLE_SPACE
            Msgstr &= "Loyalty to the Kingdom in " & Province(Where).Name & " increased to " & NameLoyaltyLevel(Province(Where).Loyalty) & "."
        Else
            If Government(ActiveGovernment).Refinement >= MEDIOCRE Then
                Msgstr = "Despite "
            Else
                Msgstr = "Guided by "
            End If
            Msgstr &= "the Monarch's " & GetAbilityNames(Government(ActiveGovernment).Refinement)
            Msgstr &= " Sensibilities, the new Palace in " & Province(Where).Name & " lacks Cultural distinction."
        End If

        MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Build Palace")

    End Sub



    Sub BuildForticiations(ByVal Where As Integer)
        Dim BuildResult As Integer = 0
        Dim PoliticalResult As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim Msgstr As String = ""
        Const SUCCESS_THRESHHOLD As Integer = 1

        Government(ActiveGovernment).Treasury -= BUILDING_COST

        DieRoll = Rand.Next(1, 7)

        BuildResult = DieRoll + Government(ActiveGovernment).AdminAbility + Province(Where).SocialState

        If Government(ActiveGovernment).AdminAbility >= MEDIOCRE Then
            If BuildResult >= SUCCESS_THRESHHOLD Then
                Msgstr = "With "
            Else
                Msgstr = "Despite "
            End If
        Else
            If BuildResult >= SUCCESS_THRESHHOLD Then
                Msgstr = "Despite "
            Else
                Msgstr = "With "
            End If
        End If

        Msgstr &= GetAbilityNames(Government(ActiveGovernment).AdminAbility) & " Administrative Ability, and "

        If Province(Where).SocialState >= ORDERLY Then
            If BuildResult >= SUCCESS_THRESHHOLD Then
                Msgstr &= "with "
            Else
                Msgstr &= "despite "
            End If
        Else
            If BuildResult >= SUCCESS_THRESHHOLD Then
                Msgstr &= "despite "
            Else
                Msgstr &= "with "
            End If
        End If
        Msgstr &= " the Province's " & DescribeSocialState(Province(Where).SocialState) & " Social State, "

        If BuildResult >= SUCCESS_THRESHHOLD Then
            Msgstr &= "Fortifications were successfully built in " & Province(Where).Name & "." & DOUBLE_SPACE
            'NEED TO PUT IN ADDITION TO FORTIFICATION LEVEL
            IncrementProvincialLoyalty(Where)
            Msgstr &= "The Province's Loyalty to the Crown increased to " & NameLoyaltyLevel(Province(Where).Loyalty) & "."
        Else
            Msgstr &= "the attempt to build Fortifications in " & Province(Where).Name & " Failed." & DOUBLE_SPACE
            DecrementProvincialLoyalty(Where)
            Msgstr &= "The Province's Loyalty to the Crown declined to " & NameLoyaltyLevel(Province(Where).Loyalty) & "."
        End If

        MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Fortify")

    End Sub


    Sub InstallBaliff(ProvID As Integer)
        'Dim DieRoll As Integer = -1
        'Dim Rand As New Random
        Dim InitialLoyalty As Integer = -3
        Dim LoyaltyHit As Integer = 0
        Dim Msgstr As String = ""

        InitialLoyalty = Province(ProvID).Loyalty

        'DieRoll = Rand.Next(0, 2)

        LoyaltyHit = 2 - Government(ActiveGovernment).PoliticalSavvy ' + Province(ProvID).ControlLevel ' + DieRoll

        If Province(ProvID).Loyalty < SUPPORTIVE Then
            For i = 1 To LoyaltyHit
                DecrementProvincialLoyalty(ProvID)
            Next
        End If


        Msgstr = "Given that your King's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
        Msgstr &= " and Loyalty in " & Province(ProvID).Name & " was " & NameLoyaltyLevel(InitialLoyalty) & ", "
        Msgstr &= "your attempt to Install a Baliff in " & Province(ProvID).Name & " has "

        If Province(ProvID).Loyalty > REBELLIOUS Then
            Province(ProvID).AdminLevel = BALIFF
            Msgstr &= " Succeeded!" & DOUBLE_SPACE & "The Fiscal Cost was " & CStr(BALIFF_COST) & ",000 " & CurrencyStr
            Government(ActiveGovernment).Treasury -= BALIFF_COST
            If LoyaltyHit > 0 Then
                Msgstr &= " and the Political Cost was " & Province(ProvID).Name & "'s Loyalty declined to " & NameLoyaltyLevel(Province(ProvID).Loyalty)
            End If
            Msgstr &= "."
            MsgBox(Msgstr)
        Else
            Msgstr &= " provoked a Rebellion!" & DOUBLE_SPACE
            DecrementControlLevel(ProvID)
            If Province(ProvID).ControlLevel < SUBORDINATE Then
                Msgstr &= "Its relationship to the Crown has declined to " & NameControlLevel(Province(ProvID).ControlLevel) & "."
                If Province(ProvID).ControlLevel = AUTONOMOUS Then
                    Msgstr &= " The Baliff has been installed at a cost of " & CStr(BALIFF_COST) & ",000 " & CurrencyStr & "."
                Else 'is independent
                    Msgstr &= " The Baliff could not be installed.  The cost of the attempt was " & CStr(BALIFF_COST) & ",000 " & CurrencyStr & "."
                End If
            Else
                Msgstr &= "."
            End If
            MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Installing Baliff")
        End If

        Government(ActiveGovernment).Treasury -= BALIFF_COST

    End Sub

    Sub ChangeTextboxControlLevel(ByVal CtrlLevel As Integer)

        If frmMapScreen.rbnDiploRelatesText.Checked Then
            TargetBox.Text = NameControlLevel(CtrlLevel)
            TargetBox.Refresh()
        End If

        If frmMapScreen.rbnDiploRelatesColor.Checked Then
            TargetBox.BackColor = GetControlLevelColor(CtrlLevel) ' should be active player's color !!!!! - set up to be 2/6
            TargetBox.Refresh()
        End If


    End Sub

    Sub CharterTown(ByVal ProvNum As Integer)
        Dim Msgstr As String = ""

        Province(ProvNum).TownCharters += 1
        Government(ActiveGovernment).Treasury += CHARTER_PRICE + Government(ActiveGovernment).PoliticalSavvy + Province(ProvNum).Loyalty

        Msgstr = "You have Chartered a New Town in " & Province(ProvNum).Name & ".  The grateful Citizens paid "
        Msgstr &= CStr(CHARTER_PRICE + Government(ActiveGovernment).PoliticalSavvy + Province(ProvNum).Loyalty) & ",000 " & CurrencyStr & " for the Priveledges it grants them"

        If Government(ActiveGovernment).PoliticalSavvy + Province(ProvNum).ControlLevel < 0 Then
            DecrementProvincialLoyalty(ProvNum)
            Msgstr &= DOUBLE_SPACE
            Msgstr &= "Unfortunately, given that the Nobles there are used to a " & NameControlLevel(Province(ProvNum).ControlLevel)
            Msgstr &= " relationship with the Crown and the King's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
            Msgstr &= ", Loyalty to the Crown declined to " & NameLoyaltyLevel(Province(ProvNum).Loyalty)
            If Province(ProvNum).Loyalty = REBELLIOUS And Province(ProvNum).ControlLevel > INDEPENDENT Then
                DecrementControlLevel(ProvNum)
                Msgstr &= ", and the Province's relationship to it deteriorated to " & NameControlLevel(Province(ProvNum).ControlLevel)
            End If
            Msgstr &= "."
        Else
            If Government(ActiveGovernment).PoliticalSavvy > MEDIOCRE Then
                Msgstr &= DOUBLE_SPACE
                Msgstr &= "Furthermore, as the King's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
                Msgstr &= ", Loyalty to the Crown Rose to " & NameLoyaltyLevel(Province(ProvNum).Loyalty)
                IncrementProvincialLoyalty(ProvNum)
                If Province(ProvNum).Loyalty = ENTHUSIASTIC And Province(ProvNum).ControlLevel < MAX_CONTROL_LEVEL Then
                    IncrementControlLevel(ProvNum)
                    Msgstr &= " and the Province's relationship to it improved to " & NameControlLevel(Province(ProvNum).ControlLevel)
                End If
            End If
            Msgstr &= "."
        End If

        If ActiveGovernment = PlayerSide Then
            MsgBox(Msgstr, MsgBoxStyle.OkOnly, "Town Chartered")
        End If

    End Sub

    Sub TaxProvince(ByVal ProvID As Integer)
        Dim TaxBase As Integer = 0
        Dim TaxReturn As Integer = 0
        'Dim ControlFactor As Integer = 0
        Dim CollectionAbility As Integer = 0
        Dim i As Integer = 0
        Dim Msgstr As String = ""
        Dim Msgstr2 As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.No
        Dim TaxRate As Integer = 2
        Dim AcceptanceLevel As Integer = 0
        Dim LoyaltyHit As Integer = -1
        Dim CollectionPercent As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim GoOn As Boolean = True

        If Province(ProvID).ControlLevel = AUTONOMOUS Then
            Msgstr = "The leaders of " & Province(ProvID).Name
            Msgstr &= " dispute your right to levy Taxes because by tradition "
            Msgstr &= "the King should draw his Revinues from the Provinces he directly Controls." & DOUBLE_SPACE
            Msgstr &= "You can Attempt to impose your Tax, but with your King's " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
            Msgstr &= " Political Skills and the Province's " & NameLoyaltyLevel(Province(ProvID).Loyalty) & " Loyalty,"
            Msgstr &= "there is a "
            If Government(ActiveGovernment).PoliticalSavvy + Province(ProvID).Loyalty > GENIUS Then
                Msgstr &= "slight "
            Else
                If Government(ActiveGovernment).PoliticalSavvy + Province(ProvID).Loyalty < DISASTROUS Then
                    Msgstr &= "strong "
                End If
            End If
            Msgstr &= "chance that the Province will break all ties with the Crown." & DOUBLE_SPACE

            Msgstr2 = Msgstr

            Msgstr &= "Click 'OK' to continue levying the Tax." & vbCrLf
            Msgstr &= "Click 'Cancel' to pick a different Province."

            Decision = MsgBox(Msgstr, MsgBoxStyle.OkCancel, "Tax Autonomous Province?")
            If Decision = MsgBoxResult.Ok Then
                DieRoll = 2 - Rand.Next(0, 5)
                If Government(ActiveGovernment).PoliticalSavvy + Province(ProvID).Loyalty + DieRoll <= 0 Then
                    Do While Province(ProvID).Loyalty > REBELLIOUS
                        DecrementProvincialLoyalty(ProvID)
                    Loop
                    DecrementControlLevel(ProvID)
                    Msgstr2 &= Province(ProvID).Name & " has repudiated its Ties with the Crown.  It is now Independent and will pay No Taxes!"
                    GoOn = False
                Else
                    Msgstr2 &= "The leaders of " & Province(ProvID).Name & " provisinally agree to let you levy a Tax at this Time."
                    GoOn = True
                End If

            Else
                Exit Sub
            End If
        End If

        If GoOn = True Then
            TaxBase = DetermineTaxBase(ProvID)

            If TaxBase < 1 Then
                TaxBase = 1
            End If

            Msgstr = "Given the Size of " & Province(ProvID).Name & "'s urban Population, " & Province(ProvID).Townspeople & ",000 people, its "
            Msgstr &= DescribeSocialState(Province(ProvID).SocialState) & " Social Conditions, its various Trade Connections, "
            Msgstr &= "the Social Conditions in the surrounding Provinces it trades with, and its "
            Msgstr &= DescribeTradeLevel(Province(ProvID).TradeLevel) & " Trading system, "
            Msgstr &= "its Tax Base is " & CStr(TaxBase) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE

            Msgstr &= "Your Treasury currently has " & CStr(Government(ActiveGovernment).Treasury) & ",000 " & CurrencyStr & "."
            Msgstr &= vbCrLf & SPACER_STR & vbCrLf
            Msgstr &= "You can Tax at a Normal or Double Rate." & DOUBLE_SPACE
            Msgstr &= "A Double Rate will increase your potential Income, but is more likely to depress the Province's Economy and decrease its Loyalty to you."
            Msgstr &= vbCrLf & SPACER_STR & vbCrLf
            'Msgstr &= "A Light rate will cause the fewest Problems in the Province, but will also yield the least income." & DOUBLE_SPACE
            Msgstr &= "Your King's Administrative Ability is " & GetAbilityNames(Government(ActiveGovernment).AdminAbility) & " and his Political Skills are "
            Msgstr &= GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy) & "." & DOUBLE_SPACE
            Msgstr &= Province(ProvID).Name
            Msgstr &= " has a " & NameControlLevel(Province(ProvID).ControlLevel) & " Relationship to the Crown, "
            Msgstr &= NameLoyaltyLevel(Province(ProvID).Loyalty) & " Loyalty to it, "
            Msgstr &= "and " & DescribeSocialState(Province(ProvID).SocialState) & " Social Conditions." & DOUBLE_SPACE
            If Province(ProvID).TimesTaxed > 0 Then
                Msgstr &= "Since you have already taxed " & Province(ProvID).Name & " this turn, it's resistance is likely to be particularly high!" & DOUBLE_SPACE
            End If
            Msgstr &= "All of these will affect both your Ability to collect Taxes and the Province's Reaction to your Imposition."
            Msgstr &= vbCrLf & SPACER_STR & vbCrLf
            Msgstr2 &= Msgstr

            Msgstr &= "Click YES to Tax at a Heavy Rate." & vbCrLf
            Msgstr &= "Click NO to Tax at the Normal Rate." & vbCrLf
            Msgstr &= "Click CANCEL if you want to try taxing a different Province instead."

            Decision = MsgBox(Msgstr, MsgBoxStyle.YesNoCancel, "Set Tax Rate in " & Province(ProvID).Name)

            Select Case Decision
                Case MsgBoxResult.Yes
                    TaxRate = HIGH_TAX
                Case MsgBoxResult.No
                    TaxRate = MODERATE_TAX
                Case MsgBoxResult.Cancel
                    Exit Sub
            End Select

            'Msgstr2 &= SPACER_STR & vbCrLf

            AcceptanceLevel = TAX_DIVISOR - (TaxRate + Province(ProvID).TimesTaxed) + Government(ActiveGovernment).PoliticalSavvy + Province(ProvID).ControlLevel + Province(ProvID).Loyalty

            Province(ProvID).TimesTaxed += TaxRate - 1 ' so = 1 or 2 times, depending on how heavy: High rate = 3, etc.
            'AcceptanceLevel = Government(ActiveGovernment).PoliticalSavvy + Province(ProvID).ControlLevel + Province(ProvID).Loyalty

            Msgstr2 &= "Given Your King's Political Skills, "
            If Province(ProvID).TimesTaxed > 0 Then
                Msgstr2 &= "the Tax Rate you imposed, "
            End If
            Msgstr2 &= "and " & Province(ProvID).Name & "'s "
            Msgstr2 &= " Relationship to the Crown and Loyalty, collecting the "
            ' Msgstr &= DescribeTaxRate(TaxRate) & " Taxes caused "
            Msgstr2 &= " Taxes caused "

            If AcceptanceLevel < 0 Then
                LoyaltyHit = Abs(AcceptanceLevel) \ 3

                For i = 0 To LoyaltyHit
                    DecrementProvincialLoyalty(ProvID)
                Next

                Msgstr2 &= "Loyalty in the Province to decline to " & NameLoyaltyLevel(Province(ProvID).Loyalty)

                If Province(ProvID).Loyalty = REBELLIOUS Then
                    DecrementControlLevel(ProvID)
                    If Province(ProvID).ControlLevel > INDEPENDENT Then
                        Msgstr2 &= " and " & Province(ProvID).Name & "'s Relationship to the Crown to decline to " & NameControlLevel(Province(ProvID).ControlLevel)
                    Else
                        Msgstr2 &= " and the Province to become Independent.  It will not pay any Taxes."
                        MsgBox(Msgstr2, MsgBoxStyle.OkOnly, "Tax Revolt in " & Province(ProvID).Name)
                        ConcludeAction()
                        Exit Sub
                    End If
                End If

                Msgstr2 &= "."
            Else
                Msgstr2 &= "no signficant Problems."
            End If
            'End If

            Msgstr2 &= DOUBLE_SPACE '& SPACER_STR & vbCrLf

            If Province(ProvID).ControlLevel > INDEPENDENT Then
                'CollectionAbility = 10 + Government(ActiveGovernment).AdminAbility + (Province(ProvID).ControlLevel * 2) + (Province(ProvID).SocialState * 2) + Province(ProvID).Loyalty
                '' 10 + so that all results are positive
                'Msgstr2 &= "Given your King's " & GetAbilityNames(Government(ActiveGovernment).AdminAbility) & " Administrative Ability and "
                'Msgstr2 &= Province(ProvID).Name & "'s Conditions, Relationship to the Crown, and Loyalty, you were able to collect "

                'TaxReturn = (TaxBase * CollectionAbility) \ 20

                'Government(ActiveGovernment).Treasury += TaxReturn
                'Msgstr2 &= CStr(TaxReturn) & ",000 " & CurrencyStr & "."
                CollectionAbility = 10 + Government(ActiveGovernment).AdminAbility + (Province(ProvID).ControlLevel * 2) + (Province(ProvID).SocialState * 2) + Province(ProvID).Loyalty
                ' 10 + so that all results are positive
                Msgstr2 &= "Given your King's Administrative Ability and "
                Msgstr2 &= Province(ProvID).Name & "'s Conditions, Relationship to the Crown, and "

                'If AcceptanceLevel < 0 Then
                '    Msgstr2 &= NameLoyaltyLevel(Province(ProvID).Loyalty) & " "
                'End If

                Msgstr2 &= "Loyalty, you were able to collect "

                TaxReturn = (TaxBase * CollectionAbility) \ 20

                Government(ActiveGovernment).Treasury += TaxReturn
                Msgstr2 &= CStr(TaxReturn) & ",000 " & CurrencyStr & " in Taxes from it."
            Else
                Msgstr2 &= "Having become Independent, " & Province(ProvID).Name & " refuses to pay any Taxes to you."
            End If

            MsgBox(Msgstr2, MsgBoxStyle.OkOnly, "Tax Return")
        End If ' GoOn after Autonomous Prov objects

        ConcludeAction() '- since  chance to cancel out, this moved from SetActionTarget

    End Sub

    Function DetermineTaxBase(ByVal ProvID As Integer) As Integer
        Dim TaxBase As Integer = 0
        Dim UrbanBase As Integer = 0
        Dim TradeValue As Integer = 0
        Dim i As Integer = 0
        Dim Msgstr As String = ""

        UrbanBase = Province(ProvID).Townspeople * (3 + Province(ProvID).SocialState) \ 2

        For i = 0 To MAX_NEIGHBORS_LAND - 1
            If Province(ProvID).Connectors(i) > -1 Then
                If Province(ProvID).Connectors(i) > SEALANE Then
                    TradeValue += TOTAL_CONNECTOR_TYPES - Province(ProvID).Connectors(i) + (Province(Area(Province(ProvID).Neighbors(i)).Province).SocialState \ 2)
                Else
                    TradeValue += (TOTAL_CONNECTOR_TYPES - Province(ProvID).Connectors(i)) * (Sea(Area(Province(ProvID).Neighbors(i)).Province).Controller + 1)
                End If
            End If
        Next

        TradeValue *= (3 + Province(ProvID).SocialState) \ 2

        'If TradeValue > UrbanBase Then
        '    TradeValue = UrbanBase
        'End If

        TaxBase = (UrbanBase + TradeValue) * Province(ProvID).TradeLevel \ BASE_TRADE_LEVEL

        Return TaxBase

    End Function

    Sub SovereignProvinceNegotiations(ByVal SovProv As Integer)
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        Dim Tribute As Integer = 0
        Dim Payment As Integer = 0
        Dim ResistanceInfluences As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim MsgStr2 As String = ""
        'Dim Msgstr3 As String = ""
        Dim ProbabilityOfSuccess As Integer = 0

        MsgStr = Province(SovProv).Name & " is neither Effectively Controlled by a Larger Kingdom "
        MsgStr &= "nor Formally Affiliated with one." & DOUBLE_SPACE

        Tribute = (DetermineTaxBase(SovProv) + Government(ActiveGovernment).PoliticalSavvy - Province(SovProv).Loyalty) \ 2
        Payment = Province(SovProv).Nobles - Government(ActiveGovernment).PoliticalSavvy + Province(SovProv).Loyalty

        If Tribute < 1 Then Tribute = 1

        If Payment < 1 Then Payment = 1

        ResistanceInfluences = Province(SovProv).Loyalty - Government(ActiveGovernment).PoliticalSavvy - Government(ActiveGovernment).Generalship - Government(ActiveGovernment).ArmyState

        MsgStr &= "You can Demand Tribute (a one-time payment of " & CStr(Tribute) & ",000 " & CurrencyStr & ")." & DOUBLE_SPACE
        MsgStr &= "Or You can Demand an Alliance (Effective Control of the Province)." & DOUBLE_SPACE ' for the Rest of This Turn)." & DOUBLE_SPACE

        MsgStr &= "Given that the existing Government of " & Province(SovProv).Name & " has " & NameLoyaltyLevel(Province(SovProv).Loyalty)
        MsgStr &= " Loyalty, while the Crown's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
        MsgStr &= ", its Generalship is " & GetAbilityNames(Government(ActiveGovernment).Generalship) & ", and its Army is "
        MsgStr &= DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", "

        MsgStr &= "if you Demand Tribute, you have a "
        ProbabilityOfSuccess = ((ResistanceInfluences + 8) + ((ResistanceInfluences + 8) \ 4) \ 2) ' Convert 16 possibilities to positives and then add 4, 3, 2, 1 or 0 to make 0 -20 range, then \ 2 to make 0 -10
        MsgStr &= DescribeChanceOfSuccess(ProbabilityOfSuccess)
        MsgStr &= " of Success, while if you Demand an Alliance you have a " & DescribeChanceOfSuccess(ProbabilityOfSuccess - 4) & "." & DOUBLE_SPACE
        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "To increase your chances of getting an Alliance, you can  Offer " & CStr(Payment) & ",000 " & CurrencyStr
            MsgStr &= " of the " & CStr(Government(ActiveGovernment).Treasury) & ",000 " & CurrencyStr & " in your Treasury to sweeten the Deal." & DOUBLE_SPACE
        End If

        MsgStr2 = MsgStr

        MsgStr &= "Click 'Yes' to Demand Tribute of " & CStr(Tribute) & ",000 " & CurrencyStr & "." & vbCrLf
        MsgStr &= "Click 'No' to Demand an Alliance." & vbCrLf ' for the Rest of This Turn." & vbCrLf
        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "Click 'Cancel' to Offer " & CStr(Payment) & ",000 " & CurrencyStr & " for the Alliance."
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate with Sovereign Province")
        Else
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate with Sovereign Province")
        End If

        DieRoll = 8 - Rand.Next(0, 17)

        MsgStr2 &= vbCrLf & SPACER_STR & vbCrLf

        Select Case Decision
            Case MsgBoxResult.Yes
                MsgStr2 &= "You Demanded Tribute of " & CStr(Tribute) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE
                'MsgStr2 &= Msgstr3 ' add in boilerplate about factors contributing to outcome
                MsgStr2 &= Province(SovProv).Name
                If DieRoll > ResistanceInfluences Then
                    Government(ActiveGovernment).Treasury += Tribute
                    MsgStr2 &= " agreed and paid."
                Else
                    MsgStr2 &= " refused to pay."
                End If

            Case MsgBoxResult.No
                MsgStr2 = "You Demanded an Alliance." & DOUBLE_SPACE
                ResistanceInfluences -= 4
                MsgStr2 &= Province(SovProv).Name
                If DieRoll > ResistanceInfluences Then
                    Province(SovProv).PoliticalAffiliation = ActiveGovernment
                    Province(SovProv).ControlLevel = SUBORDINATE
                    Province(SovProv).Loyalty = Rand.Next(0, 3) - 1

                    If Province(SovProv).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(SovProv)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " agreed."
                Else
                    MsgStr2 &= " refused."
                End If

            Case MsgBoxResult.Cancel
                MsgStr2 = "You Offered " & CStr(Payment) & ",000 " & CurrencyStr & " for an Alliance." & DOUBLE_SPACE
                MsgStr2 &= Province(SovProv).Name
                If DieRoll > ResistanceInfluences Then
                    Government(ActiveGovernment).Treasury -= Payment
                    Province(SovProv).PoliticalAffiliation = ActiveGovernment
                    Province(SovProv).ControlLevel = SUBORDINATE
                    Province(SovProv).Loyalty = Rand.Next(0, 3) - 1
                    If Province(SovProv).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(SovProv)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " agreed."
                Else
                    MsgStr2 &= " refused."
                End If

        End Select

        MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Results of Negotiations with Sovereign Province")

        ConcludeAction()

    End Sub

    Sub ErrantFrenchProvinceNegotiations(ByVal ErrantProv As Integer)
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        Dim Tribute As Integer = 0
        Dim Payment As Integer = 0
        Dim ResistanceInfluences As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim MsgStr2 As String = ""
        Dim ProbabilityOfSuccess As Integer = -1

        MsgStr = Province(ErrantProv).Name & " is a Formally part of the Kingdom of France, but in Practice acts Independently." & DOUBLE_SPACE

        Tribute = (DetermineTaxBase(ErrantProv) - Government(ActiveGovernment).PoliticalSavvy + Province(ErrantProv).Loyalty) \ 2
        Payment = Province(ErrantProv).Nobles - Government(ActiveGovernment).PoliticalSavvy + Province(ErrantProv).Loyalty

        If Tribute < 1 Then
            Tribute = 0
        End If

        If Payment < 1 Then
            Payment = 1
        End If

        ResistanceInfluences = Province(ErrantProv).Loyalty - Government(ActiveGovernment).PoliticalSavvy - Government(ActiveGovernment).Generalship - Government(ActiveGovernment).ArmyState - 1 'last is for Formal tie

        MsgStr &= "You can Demand Tribute (a one-time payment of " & CStr(Tribute) & ",000 " & CurrencyStr & ")." & DOUBLE_SPACE
        MsgStr &= "Or You can Demand that the Leaders of the Province Pay Homage to You and thereby Accept an Autonomous rather than Independent Relationship"
        MsgStr &= "to the Crown." & DOUBLE_SPACE

        MsgStr &= "Given that Loyalty to the existing Government of " & Province(ErrantProv).Name & " is " & NameLoyaltyLevel(Province(ErrantProv).Loyalty)
        MsgStr &= ", while your King's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
        MsgStr &= ", your Generalship is " & GetAbilityNames(Government(ActiveGovernment).Generalship) & ", and your Army is "
        MsgStr &= DescribeArmyState(Government(ActiveGovernment).ArmyState) & ", "

        MsgStr &= "if you Demand Tribute, you have a "
        ProbabilityOfSuccess = ((ResistanceInfluences + 12) + ((ResistanceInfluences + 12) \ 4) \ 2) ' Convert 16 possibilities to positives and then add 4, 3, 2, 1 or 0 to make 0 -20 range, then \ 2 to make 0 -10
        MsgStr &= DescribeChanceOfSuccess(ProbabilityOfSuccess)
        MsgStr &= " of Success, while if you Demand Homage you have a "
        ProbabilityOfSuccess -= 2 ' to reflect no money being offered at this point
        If ProbabilityOfSuccess < 0 Then ProbabilityOfSuccess = 0
        MsgStr &= DescribeChanceOfSuccess(ProbabilityOfSuccess - 4) & "." & DOUBLE_SPACE

        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "To increase your chances of getting Them to Pay Homage, you can to Offer " & CStr(Payment) & ",000 " & CurrencyStr
            MsgStr &= " of the " & CStr(Government(ActiveGovernment).Treasury) & ",000 " & CurrencyStr & " in your Treasury to sweeten the Deal." & DOUBLE_SPACE
        End If

        MsgStr2 = MsgStr

        MsgStr &= "Click 'Yes' to Demand Tribute of " & CStr(Tribute) & ",000 " & CurrencyStr & "." & vbCrLf
        MsgStr &= "Click 'No' to Demand Homage." & vbCrLf
        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "Click 'Cancel' to Offer " & CStr(Payment) & ",000 " & CurrencyStr & " for the Homage."
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate with Errant Province")
        Else
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNo, "Negotiate with Errant Province")
        End If

        DieRoll = 8 - Rand.Next(0, 17)

        MsgStr2 &= vbCrLf & SPACER_STR & vbCrLf

        Select Case Decision
            Case MsgBoxResult.Yes
                MsgStr2 &= "You Demanded Tribute of " & CStr(Tribute) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE
                MsgStr2 &= Province(ErrantProv).Name
                If DieRoll > ResistanceInfluences Then
                    Government(ActiveGovernment).Treasury += Tribute
                    MsgStr2 &= " agreed and paid." & vbCrLf
                    MsgStr2 &= "You now have " & CStr(Government(ActiveGovernment).Treasury) & ",000 " & CurrencyStr & " in your Treasury."
                Else
                    MsgStr2 &= " refused."
                End If

            Case MsgBoxResult.No
                MsgStr2 &= "You Demanded Homage." & DOUBLE_SPACE
                ResistanceInfluences -= 4
                MsgStr2 &= Province(ErrantProv).Name
                If DieRoll > ResistanceInfluences Then
                    'Province(ErrantProv).PoliticalAffiliation = ActiveGovernment

                    IncrementControlLevel(ErrantProv)

                    'Province(ErrantProv).ControlLevel = SUBORDINATE
                    'If Province(ErrantProv).PoliticalAffiliation = PlayerSide Then
                    '    ConquestVPs += 1
                    '    RefreshConquestVP_Display()
                    'End If
                    MsgStr2 &= " agreed.  " & Province(ErrantProv).Name & " now has an Autonomous rather than Independent Relationship to You."
                Else
                    MsgStr2 &= " refused.  It remains Effectively Independent despite it's Formal membership in your Kingdom."
                End If

            Case MsgBoxResult.Cancel
                MsgStr2 &= "You Offered " & CStr(Payment) & ",000 " & CurrencyStr & " for Homage." & DOUBLE_SPACE
                MsgStr2 &= Province(ErrantProv).Name
                If DieRoll > ResistanceInfluences Then
                    Government(ActiveGovernment).Treasury -= Payment

                    IncrementControlLevel(ErrantProv)

                    'Province(ErrantProv).PoliticalAffiliation = ActiveGovernment
                    'Province(ErrantProv).ControlLevel = SUBORDINATE
                    ''If Province(ErrantProv).PoliticalAffiliation = PlayerSide Then
                    '    ConquestVPs += 1
                    '    RefreshConquestVP_Display()
                    'End If
                    MsgStr2 &= " agreed.  " & Province(ErrantProv).Name & " now has an Autonomous rather than Independent Relationship to You."
                Else
                    MsgStr2 &= " refused.  It remains Effectively Independent despite it's Formal membership in your Kingdom."
                End If

        End Select

        MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Results of Negotiations with Errant Province")

        ConcludeAction()

    End Sub

    Sub ClientStateNegotiations(ByVal Client As Integer)
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        'Dim Tribute As Integer = 0
        Dim Payment As Integer = 0
        Dim ResistanceInfluences As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim MsgStr2 As String = ""
        Dim NewRel As Integer = 0
        Dim RelNow As Integer = 0
        Dim OldController As Integer = -1
        Dim DecisionValue As Integer = 0
        Dim ProbabilityOfSuccess As Integer = -1

        MsgStr = Province(Client).Name & " is Controlled by " & Government(Province(Client).PoliticalAffiliation).Name
        If Province(Client).FormalAffiliation = FRANCE Then
            MsgStr &= " althought it is Formally Affliated with France." & DOUBLE_SPACE
        Else
            MsgStr &= " although it is not Formally Affiliated with it." & DOUBLE_SPACE
        End If

        'Tribute = (DetermineTaxBase(Client) - Government(ActiveGovernment).PoliticalSavvy + Province(Client).Loyalty) \ 2

        Payment = Province(Client).Nobles - Government(ActiveGovernment).PoliticalSavvy + Province(Client).Loyalty

        'If Tribute < 1 Then
        '    Tribute = 0
        'End If

        ResistanceInfluences = Province(Client).Loyalty
        ResistanceInfluences -= Government(ActiveGovernment).Reputation
        ResistanceInfluences -= Government(ActiveGovernment).PoliticalSavvy
        ResistanceInfluences += Government(Province(Client).PoliticalAffiliation).PoliticalSavvy
        ResistanceInfluences -= Government(ActiveGovernment).Generalship
        ResistanceInfluences += Government(Province(Client).PoliticalAffiliation).Generalship
        ResistanceInfluences -= Government(ActiveGovernment).ArmyState
        ResistanceInfluences += Government(Province(Client).PoliticalAffiliation).ArmyState
        If Province(Client).FormalAffiliation = FRANCE Then
            ResistanceInfluences -= (3 + Government(ActiveGovernment).PoliticalSavvy) ' bonus because Province should be France's
        End If

        RelNow = Government(Province(Client).PoliticalAffiliation).DiplomaticRelations(ActiveGovernment)
        OldController = Province(Client).PoliticalAffiliation

        ' just put in old Controller, so can fix up messages below (so remembers who was who after changes made to report on them

        MsgStr &= "You can Demand that " & Province(Client).Name & " break its Relationship with "
        MsgStr &= Government(Province(Client).PoliticalAffiliation).Name & " and Join with You." & DOUBLE_SPACE

        MsgStr &= "Given that " & Province(Client).Name & " has " & NameLoyaltyLevel(Province(Client).Loyalty) & " Loyalty to "
        MsgStr &= Government(Province(Client).PoliticalAffiliation).Name
        MsgStr &= " and your King's Reputation is " & NameReputation(Government(ActiveGovernment).Reputation)
        MsgStr &= ", while your Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
        MsgStr &= " vs. " & Government(Province(Client).PoliticalAffiliation).Name & "'s " & GetAbilityNames(Government(Province(Client).PoliticalAffiliation).PoliticalSavvy)
        MsgStr &= ", your Generalship is " & GetAbilityNames(Government(ActiveGovernment).Generalship)
        MsgStr &= "vs. its " & GetAbilityNames(Government(Province(Client).PoliticalAffiliation).Generalship) & " Generalship, "
        MsgStr &= "and the Morale of your Army is " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & " vs. its "
        MsgStr &= DescribeArmyState(Government(Province(Client).PoliticalAffiliation).ArmyState) & " Morale, "

        MsgStr &= "if you Demand an Alliance you have a "
        ProbabilityOfSuccess = ((ResistanceInfluences + 8) + ((ResistanceInfluences + 8) \ 4) \ 2) ' Convert 16 possibilities to positives and then add 4, 3, 2, 1 or 0 to make 0 -20 range, then \ 2 to make 0 -10

        If Province(Client).FormalAffiliation = FRANCE Then
            ProbabilityOfSuccess += (3 + Government(ActiveGovernment).PoliticalSavvy) \ 2
            If ProbabilityOfSuccess > 10 Then ProbabilityOfSuccess = 0
        End If

        MsgStr &= DescribeChanceOfSuccess(ProbabilityOfSuccess) & " of Success." & DOUBLE_SPACE

        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "To increase the Chances that " & Province(Client).Name & " will agree, you can Offer " & CStr(Payment) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE
        Else
            MsgStr &= "Unfortunately, you don't have enough money in your Treasury to offer a Payment to influence " & Province(Client).Name & "'s Decision." & DOUBLE_SPACE
        End If
        If RelNow > HOSTILE Then
            MsgStr &= "If Unsuccessful, this Action may cause your Relations with " & Government(Province(Client).PoliticalAffiliation).Name
            MsgStr &= " to Worsen; if Successful, it definitely will." & DOUBLE_SPACE
        End If

        If Government(ActiveGovernment).Reputation > DISHONEST And RelNow > HOSTILE And Province(Client).FormalAffiliation <> FRANCE Then
            MsgStr &= "An unsuccessful Attempt may also cause your " & NameReputation(Government(ActiveGovernment).Reputation) & " Reputation to become "
            MsgStr &= NameReputation(Government(ActiveGovernment).Reputation - 1) & ", and a Successful one definitely will." & DOUBLE_SPACE
        End If

        MsgStr2 = MsgStr

        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "Click 'Yes' to Demand that " & Province(Client).Name & " Switch to Allegiance to You." & vbCrLf
            MsgStr &= "Click 'No'  to Offer " & CStr(Payment) & ",000 " & CurrencyStr & " for It to do This." & vbCrLf
            MsgStr &= "Click 'Cancel' to Negotiate with Someone Else."
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate with Client Province")
        Else
            MsgStr &= "Click 'OK' to Demand that " & Province(Client).Name & " Switch to an Alliance with You." & vbCrLf
            MsgStr &= "Click 'Cancel' to Negotiate with Someone Else."
            Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Negotiate with Client Province")
        End If

        DieRoll = 8 - Rand.Next(0, 17)

        If Decision = MsgBoxResult.No Then
            ResistanceInfluences -= (2 + Government(ActiveGovernment).PoliticalSavvy)
        End If

        MsgStr2 &= vbCrLf & SPACER_STR & vbCrLf

        Select Case Decision
            Case MsgBoxResult.Yes
                DecisionValue = 1
            Case MsgBoxResult.Ok
                DecisionValue = 1
            Case MsgBoxResult.No
                DecisionValue = 2
            Case MsgBoxResult.Cancel
                DecisionValue = 3
            Case Else
                MsgBox("Problem with Capturing Decision.")
        End Select

        Select Case DecisionValue
            Case 1 'Yes or OK: Straight demand; no payment offered
                MsgStr2 &= "You Demanded that " & Province(Client).Name & " Break its Ties with " & Government(Province(Client).PoliticalAffiliation).Name & "." & DOUBLE_SPACE
                MsgStr2 &= Province(Client).Name
                If DieRoll > ResistanceInfluences Then
                    Province(Client).PoliticalAffiliation = ActiveGovernment
                    Province(Client).ControlLevel = SUBORDINATE
                    Province(Client).Loyalty = Rand.Next(0, 3) - 1
                    If Province(Client).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(Client)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " agreed to Break its Ties with " & Government(OldController).Name
                    MsgStr2 &= " and form Them with You." & DOUBLE_SPACE
                    If RelNow > HOSTILE Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, OldController, NewRel)
                        MsgStr2 &= "Your Relations with " & Government(OldController).Name & " deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, OldController)
                        If Government(ActiveGovernment).Reputation > DISHONEST Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", while your Reputation declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                Else
                    MsgStr2 &= " Refused." & DOUBLE_SPACE
                    If RelNow > HOSTILE And Government(ActiveGovernment).PoliticalSavvy + _
                        Government(Province(Client).PoliticalAffiliation).PoliticalSavvy < 0 Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Client).PoliticalAffiliation, NewRel)
                        MsgStr2 &= "Word of your Negotiations has spread, though, so your "
                        MsgStr2 &= "Relations with " & Government(Province(Client).PoliticalAffiliation).Name & " have deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Client).PoliticalAffiliation)
                        If Government(ActiveGovernment).Reputation > DISHONEST Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", and your Reputation has declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                End If

            Case 2 'No, pay; only possible if has $
                MsgStr2 &= "You Offered " & Province(Client).Name & " " & CStr(Payment) & ",000 " & CurrencyStr
                MsgStr2 &= " to Break its Ties and Join with You." & DOUBLE_SPACE
                MsgStr2 &= Province(Client).Name
                If DieRoll > ResistanceInfluences Then
                    Province(Client).PoliticalAffiliation = ActiveGovernment
                    Province(Client).ControlLevel = SUBORDINATE
                    Province(Client).Loyalty = Rand.Next(0, 3) - 1
                    Government(ActiveGovernment).Treasury -= Payment
                    If Province(Client).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(Client)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " agreed." & DOUBLE_SPACE
                    MsgStr2 &= "You now have " & Government(ActiveGovernment).Treasury & ",000 " & CurrencyStr & " in your Treasury." & DOUBLE_SPACE
                    If RelNow > HOSTILE Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, OldController, NewRel)
                        MsgStr2 &= "Your Relations with " & Government(OldController).Name & " deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, OldController)
                        If Government(ActiveGovernment).Reputation > DISHONEST Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", while your Reputation declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                Else
                    MsgStr2 &= " declined your Offer."
                    If RelNow > HOSTILE And Government(ActiveGovernment).PoliticalSavvy + _
                        Government(Province(Client).PoliticalAffiliation).PoliticalSavvy < 0 Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Client).PoliticalAffiliation, NewRel)
                        MsgStr2 &= DOUBLE_SPACE & "Word of your Negotiations has spread, though, so your "
                        MsgStr2 &= "Relations with " & Government(Province(Client).PoliticalAffiliation).Name & " have deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Client).PoliticalAffiliation)
                        If Government(ActiveGovernment).Reputation > DISHONEST Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", and your Reputation has declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                End If

            Case 3 'Cancel
                Exit Sub
        End Select

        MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Results of Negotiations with Client Province")

        ConcludeAction()


    End Sub

    Sub OthersVasselNegotiations(ByVal Vassel As Integer)
        Dim MsgStr As String = ""
        Dim Decision As MsgBoxResult = MsgBoxResult.Cancel
        'Dim Tribute As Integer = 0
        Dim Payment As Integer = 0
        Dim ResistanceInfluences As Integer = 0
        Dim DieRoll As Integer = 0
        Dim Rand As New Random
        Dim MsgStr2 As String = ""
        Dim NewRel As Integer = 0
        Dim RelNow As Integer = 0
        Dim DecisionValue As Integer = 0
        Dim ProbabilityOfSuccess As Integer = -1

        MsgStr = Province(Vassel).Name & " is Formally a part of " & Government(Province(Vassel).FormalAffiliation).Name
        MsgStr &= " but it is Effectively Independent "
        If Province(Vassel).ControlLevel = AUTONOMOUS Then
            MsgStr &= "(" & NameControlLevel(Province(Vassel).ControlLevel) & ")."
        End If

        'MsgStr &= "This means that " & Government(Province(Vassel).PoliticalAffiliation).Name & " will resist"
        MsgStr &= DOUBLE_SPACE

        'Tribute = (DetermineTaxBase(Vassel) - Government(ActiveGovernment).PoliticalSavvy + Province(Vassel).Loyalty)
        Payment = Province(Vassel).Nobles - Government(ActiveGovernment).PoliticalSavvy + Province(Vassel).Loyalty

        'If Tribute < 1 Then
        '    Tribute = 0
        'End If

        ResistanceInfluences = Province(Vassel).Loyalty
        ResistanceInfluences -= Government(ActiveGovernment).Reputation
        ResistanceInfluences -= Government(ActiveGovernment).PoliticalSavvy
        ResistanceInfluences -= Government(ActiveGovernment).Generalship
        ResistanceInfluences -= Government(ActiveGovernment).ArmyState

        ResistanceInfluences += Government(Province(Vassel).FormalAffiliation).PoliticalSavvy
        ResistanceInfluences += Government(Province(Vassel).FormalAffiliation).Generalship
        ResistanceInfluences += Government(Province(Vassel).FormalAffiliation).ArmyState

        RelNow = Government(Province(Vassel).PoliticalAffiliation).DiplomaticRelations(FRANCE)

        'MsgStr &= "You can Demand Tribute (a one-time payment of " & CStr(Tribute) & ",000 " & CurrencyStr & ")." & DOUBLE_SPACE
        MsgStr &= "You can Demand that " & Province(Vassel).Name & " ally with You despite its Ties with "
        MsgStr &= Government(Province(Vassel).FormalAffiliation).Name & DOUBLE_SPACE

        MsgStr &= "Given that Loyalty to its Present Government is " & NameLoyaltyLevel(Province(Vassel).Loyalty)
        MsgStr &= ", while your King's Political Savvy is " & GetAbilityNames(Government(ActiveGovernment).PoliticalSavvy)
        MsgStr &= " vs. " & Government(Province(Vassel).FormalAffiliation).Name & "'s " & GetAbilityNames(Government(Province(Vassel).FormalAffiliation).PoliticalSavvy)
        MsgStr &= ", your King's Generalship is " & GetAbilityNames(Government(ActiveGovernment).Generalship)
        MsgStr &= " vs. its " & GetAbilityNames(Government(Province(Vassel).FormalAffiliation).Generalship) & " Generalship, and "
        MsgStr &= "your Army's " & DescribeArmyState(Government(ActiveGovernment).ArmyState) & " Morale vs. its Army's "
        MsgStr &= DescribeArmyState(Government(Province(Vassel).FormalAffiliation).ArmyState) & " Morale, "

        MsgStr &= "if you Demand an Alliance you have a "
        ProbabilityOfSuccess = ((ResistanceInfluences + 8) + ((ResistanceInfluences + 8) \ 4) \ 2) ' Convert 16 possibilities to positives and then add 4, 3, 2, 1 or 0 to make 0 -20 range, then \ 2 to make 0 -10
        MsgStr &= DescribeChanceOfSuccess(ProbabilityOfSuccess - 2) & " of Success." & DOUBLE_SPACE

        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "To increase the Chances that " & Province(Vassel).Name & " will agree, you can Offer " & CStr(Payment) & ",000 " & CurrencyStr & "." & DOUBLE_SPACE
        Else
            MsgStr &= "Unfortunately, you don't have enough money in your Treasury to offer a Payment to influence " & Province(Vassel).Name & "'s Decision." & DOUBLE_SPACE
        End If

        If RelNow > NEUTRAL Then
            MsgStr &= "This Action may cause your Relations with " & Government(Province(Vassel).FormalAffiliation).Name
            MsgStr &= " and your Reputation overall to Worsen." & DOUBLE_SPACE
        End If

        'If Government(ActiveGovernment).Reputation > UNCERTAIN And RelNow > NEUTRAL Then
        '    MsgStr &= "It may also cause your " & NameReputation(Government(ActiveGovernment).Reputation) & " Reputation to become "
        '    MsgStr &= NameReputation(Government(ActiveGovernment).Reputation - 1) & "." & DOUBLE_SPACE
        'End If

        MsgStr2 = MsgStr

        If Government(ActiveGovernment).Treasury >= Payment Then
            MsgStr &= "Click 'Yes' to Demand that " & Province(Vassel).Name & " ally with You." & vbCrLf
            MsgStr &= "Click 'No'  to Offer " & CStr(Payment) & ",000 " & CurrencyStr & " for it to do this." & vbCrLf
            MsgStr &= "Click 'Cancel' to Negotiate with Someone Else."
            Decision = MsgBox(MsgStr, MsgBoxStyle.YesNoCancel, "Negotiate with Loose Vassel")
        Else
            MsgStr &= "Click 'OK' to Demand that " & Province(Vassel).Name & " Ally with You." & vbCrLf
            MsgStr &= "Click 'Cancel' to Negotiate with Someone Else."
            Decision = MsgBox(MsgStr, MsgBoxStyle.OkCancel, "Negotiate with Loose Vassel")
        End If

        DieRoll = 4 - Rand.Next(0, 9)

        If Decision = MsgBoxResult.No Then
            ResistanceInfluences -= (2 - Government(ActiveGovernment).PoliticalSavvy)
        End If

        MsgStr2 &= vbCrLf & SPACER_STR & vbCrLf

        Select Case Decision
            Case MsgBoxResult.Yes
                DecisionValue = 1
            Case MsgBoxResult.Ok
                DecisionValue = 1
            Case MsgBoxResult.No
                DecisionValue = 2
            Case MsgBoxResult.Cancel
                DecisionValue = 3
            Case Else
                MsgBox("Problem with Capturing Decision.")
        End Select

        Select Case DecisionValue
            Case 1 'Yes or OK: Straight demand; no payment offered
                MsgStr2 = "You Demanded that " & Province(Vassel).Name & " Ally with You "
                MsgStr2 &= "despite its Ties to " & Government(Province(Vassel).FormalAffiliation).Name & DOUBLE_SPACE
                MsgStr2 &= Province(Vassel).Name
                If DieRoll > ResistanceInfluences Then
                    Province(Vassel).PoliticalAffiliation = ActiveGovernment
                    Province(Vassel).ControlLevel = SUBORDINATE
                    Province(Vassel).Loyalty = Rand.Next(0, 3) - 1
                    If Province(Vassel).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(Vassel)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " has Agreed."
                    If RelNow > NEUTRAL Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Vassel).FormalAffiliation, NewRel)
                        MsgStr2 &= "Your Relations with " & Government(Province(Vassel).FormalAffiliation).Name & " deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Vassel).FormalAffiliation)
                        If Government(ActiveGovernment).Reputation > UNCERTAIN Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", while your Reputation declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                Else
                    MsgStr2 &= " Refused." & DOUBLE_SPACE
                    If RelNow > NEUTRAL And Government(ActiveGovernment).PoliticalSavvy + _
                        Government(Province(Vassel).FormalAffiliation).PoliticalSavvy < 0 Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Vassel).FormalAffiliation, NewRel)
                        MsgStr2 &= "Word of your Negotiations has spread, though, so your "
                        MsgStr2 &= "Relations with " & Government(Province(Vassel).FormalAffiliation).Name & " have deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Vassel).FormalAffiliation)
                        If Government(ActiveGovernment).Reputation > UNCERTAIN Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", and your Reputation has declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                End If

            Case 2 'No, pay; only possible if has $
                MsgStr2 = "You Offered " & Province(Vassel).Name & " " & CStr(Payment) & ",000 " & CurrencyStr & " to Ally with You"
                MsgStr2 &= " despite its Ties to " & Government(Province(Vassel).FormalAffiliation).Name & DOUBLE_SPACE
                MsgStr2 &= Province(Vassel).Name
                If DieRoll > ResistanceInfluences Then
                    Province(Vassel).PoliticalAffiliation = ActiveGovernment
                    Province(Vassel).ControlLevel = SUBORDINATE
                    Government(ActiveGovernment).Treasury -= Payment
                    Province(Vassel).Loyalty = Rand.Next(0, 3) - 1
                    If Province(Vassel).PoliticalAffiliation = PlayerSide Then
                        IncrementConquestVPs(Vassel)
                        'ConquestVPs += 1
                        'RefreshConquestVP_Display()
                        'AdjustTotalVPs()
                        'RefreshTotalVP_Display()
                    End If
                    MsgStr2 &= " agreed to your Offer." & DOUBLE_SPACE
                    MsgStr2 &= "You now have " & Government(ActiveGovernment).Treasury & ",000 " & CurrencyStr & " in your Treasury." & DOUBLE_SPACE
                    If RelNow > NEUTRAL Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Vassel).FormalAffiliation, NewRel)
                        MsgStr2 &= "Your Relations with " & Government(Province(Vassel).FormalAffiliation).Name & " deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Vassel).FormalAffiliation)
                        If Government(ActiveGovernment).Reputation > UNCERTAIN Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", while your Reputation declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                Else
                    MsgStr2 &= " declined your Offer."
                    If RelNow > NEUTRAL And Government(ActiveGovernment).PoliticalSavvy + _
                        Government(Province(Vassel).FormalAffiliation).PoliticalSavvy < 0 Then
                        NewRel = DecrementDiploRelates(RelNow)
                        AdjustDiploRelates(ActiveGovernment, Province(Vassel).FormalAffiliation, NewRel)
                        MsgStr2 &= DOUBLE_SPACE & "Word of your Negotiations has spread, though, so your "
                        MsgStr2 &= "Relations with " & Government(Province(Vassel).FormalAffiliation).Name & " have deteriorated to "
                        MsgStr2 &= DescribeDiploRelations(ActiveGovernment, Province(Vassel).FormalAffiliation)
                        If Government(ActiveGovernment).Reputation > UNCERTAIN Then
                            DecrementReputation(ActiveGovernment, 1)
                            MsgStr2 &= ", and your Reputation has declined to " & NameReputation(Government(ActiveGovernment).Reputation)
                        End If
                        MsgStr2 &= "."
                    End If
                End If

            Case 3 'Cancel
                Exit Sub
        End Select

        MsgBox(MsgStr2, MsgBoxStyle.OkOnly, "Results of Negotiations with Vassel Province")

        ConcludeAction()

    End Sub

End Module
